/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.BackendScr");

dojo.require("rmps.core.Document");
dojo.require("dojox.xml.DomParser");
dojo.require("jazz.client.xhr");

dojo.require("net.jazz.ajax.viewletServiceRoot");

dojo.setObject("rmps.core.__BackendScr", {});

dojo.declare("rmps.core._BackendScr", rmps.core.Document, {
	
	getError: function(namespace,name){
		return "JTS SCR document has no entry for: " + namespace + name;
	}
	
});

/*We use a getter for the backend SCR as it is required to avoid making a require statement before the context is still being fetched, as we get the SCR url
 * from the data server root. Do not use the instance directly. We have to use the get() singleton method all the time */
rmps.core.BackendScr.get= function(){
	if(rmps.core.__BackendScr._doc!= null){
		return rmps.core.__BackendScr;
	}
	
	jazz.client.xhrGet({
		url: net.jazz.ajax.viewletServiceRoot() + "/scr",
		//url: net.jazz.ajax._sharedJtsServerUrl + "/scr",
		//url: net.jazz.ajax._dataServerRoot + "/scr",
		handleAs: "text",
		load: function(response, ioArgs) {
			rmps.core.__BackendScr = new rmps.core._BackendScr(dojox.xml.DomParser.parse(response));
		},
		sync: true
	});	
	return rmps.core.__BackendScr;
};

})();