/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2012. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("rmps.ui.DescriptionArea");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.Button");
dojo.require("jazz.ui.StyledBox");
dojo.require("rmps.ui.util.UIUtil");

var TrimStyles = jazz.ui.StyledBox.TrimStyles;
var UIUtil=rmps.ui.util.UIUtil;

/* 
 * Requiered:
 * 		instructions: the instructions for the context
 * 		title: the title for the current context
 * Optional:
 * 		introTitle: a sub title (required for numbering the title)
 *		trimStyle: The used trim style for the current context styled box. It would be TrimStyles.EDITOR by default
 * 
 * 
 * 
 * Description: Provide a boxed area shows provided instructiond and title.
 *  
 */
dojo.declare("rmps.ui.DescriptionArea", [dijit._Widget, dijit._Templated], {

	templateString: dojo.cache("rmps.ui", "templates/DescriptionArea.html"),
	widgetsInTemplate: true,
	
	"class": "rmps-description-area",
	
	constructor: function(params) {
		if(!params){
			console.warn("No paramaters specified");
			params= {};
		}
		
		/*Extract Parameters */
		
		/*If the user did not specify a trim style, then we assume it to be editor as defualt */
		this.trimStyle= UIUtil.associateParamValue(params.trimStyle, null, TrimStyles.EDITOR);
		this.instructions= UIUtil.associateParamValue(params.instructions, 
						"You have to provide instructions for your action");	//$NON-NLS-1$
		this.introTitle= UIUtil.associateParamValue(params.introTitle, null); /*Intro title is optional */
		this.title= UIUtil.associateParamValue(params.title, 
						"You have to provide title for your description");	//$NON-NLS-1$
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this.area.setTitle(this.title);
	},
	
	showStatusMessage: function() {
		this.statusNode.innerHTML = "";
		if (dojo.isString(this.statusMessage)) {
			this.statusNode.appendChild(dojo.doc.createTextNode(this.statusMessage));
			this.statusNode.style.display= "inline";
		}else {
			this.statusNode.style.display= "none";
		}
	},
	
	hideStatusMessage: function() {
		this.statusNode.innerHTML = "";
		this.statusNode.style.display= "none";
	},
	

});

})();