/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("rmps.ui.DescriptionAreaButton");
dojo.require("rmps.ui.DescriptionArea");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.ui.Button");
dojo.require("jazz.ui.StyledBox");
dojo.require("rmps.ui.util.UIUtil");

var TrimStyles = jazz.ui.StyledBox.TrimStyles;
var UIUtil=rmps.ui.util.UIUtil;

/* 
 * Requiered:
 * 		buttonTitle: the title for the action button
 * 		instructions: the instructions for the context
 * 		title: the title for the current context
 * Optional:
 * 		introTitle: a sub title (required for numbering the title)
 *		trimStyle: The used trim style for the current context styled box. It would be TrimStyles.EDITOR by default
 * 
 * 
 * Used dojo attachpoint for the action button is this.actionButton, and it click action is onExecute
 * 
 * Description: Provide a boxed area shows provided instructiond and title, in addiiton to a button action.
 *  
 */
dojo.declare("rmps.ui.DescriptionAreaButton", rmps.ui.DescriptionArea, {
	
	"class": "rmps-description-area-button",
	
	statusMessage: null,

	constructor: function(params) {
		if(!params){
			console.warn("No paramaters specified");
			params= {};
		}
		
		this.buttonTitle= UIUtil.associateParamValue(params.buttonTitle, 
						"You have to provide a title for your action button");	//$NON-NLS-1$
	},
	
	postCreate: function() {
		this.inherited(arguments);
		this.createActionButton();
	},
	
	createActionButton: function(){
		this.actionButton = dojo.create("button");
		this.actionButton.appendChild(dojo.doc.createTextNode(this.buttonTitle));
		this.contents.appendChild(this.actionButton);
		this.connect(this.actionButton, "onclick", this._onExecute);
	},
	
	/*To be called by other places to disable/enable the action button */
	setEnablement: function(isEnabled){
		this.actionButton.disabled= !isEnabled;
	},
	
	_onExecute: function(e){
		this.setEnablement(false);	/*disable the button to avoid multiple presses */
		this.onExecute(e);
	},
	
	/*To be connected or implemented by caller */	
	onExecute: function(e){}

});

})();