/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.DiagramLayer");

dojo.require("rmpw.panner.EditPartTrackedItem");
dojo.require("rmpw.panner.Tracker");
dojo.require("rmpw.panner.Layer");
// dojo.require("rmps.draw2d.DiagramViewer");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmpw.panner", "DiagramLayerMessages");

var messages = dojo.i18n.getLocalization("rmpw.panner", "DiagramLayerMessages");

dojo.declare("rmpw.panner.DiagramLayer", rmpw.panner.Layer, {
	
	// properties
	diagram: null,
	
	postCreate: function() {
		this.inherited(arguments);
		this.containerNode = dojo.doc.createElement("div");
		this.domNode.appendChild(this.containerNode);
		
		this.diagram = this._createDiagram();
		
		dojo.style(this.domNode, "height", "100%");
	},
	
	startup: function() {
		this.inherited(arguments);
		this.diagram.initialize(this.containerNode);
		this._startTracking();
	},
	
	destroy: function() {
		this.diagram.destroy();
		this.inherited(arguments);
	},
	
	resize: function(size) {
		// Intentionally blank.  See WI33654
	},
	
	_createDiagram: function() {
		// return new rmps.draw2d.DiagramViewer();
	},
	
	_startTracking: function() {
		var osTracker = this.getRoot().viewer.offScreenTracker;
		var tracker = new rmpw.panner.Tracker(messages.selection);
		osTracker.addTracker(tracker, {color: "#4C7399"});
		this.connect(this.diagram.getSelectionManager(), "selectionChanged", dojo.hitch(this, function(selected, added, removed) {
			for (var i = 0, len = added.length; i < len; ++i) {
				var item = new rmpw.panner.EditPartTrackedItem({
					editPart: added[i],
					label: messages.selection
				});
				added[i].__selectionTrackedItem = item;
				tracker.addItem(item);
			}
			
			for (var i = 0, len = removed.length; i < len; ++i) {
				tracker.removeItem(removed[i].__selectionTrackedItem);
				delete removed[i].__selectionTrackedItem;
			}
		}));
	},
	
	getScale: function() {
		return this.diagram.getScale();
	},
	
	setScale: function(scale) {
		this.diagram.zoom(scale);
	},
	
	setLocation: function(x, y) {
		this.diagram.scrollTo(x, y);
	},
	
	getLocation: function() {
		return this.diagram.getLocation();
	}
	
});

})();