/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.DialogForm");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.ui.Dialog");

dojo.requireLocalization("rmps.ui", "DialogForm");

var messages = dojo.i18n.getLocalization("rmps.ui", "DialogForm");


dojo.declare("rmps.ui.DialogForm",[dijit._Widget, dijit._Templated],{

	templateString: dojo.cache("rmps.ui", "templates/DialogForm.html"),
	widgetsInTemplate: true,

	_dialog: null,
	_okInProgress: null,
	_cancelInProgress: null,

	show: function(){
		if(this._dialog){
			return;
		}
		this._dialog = new jazz.ui.Dialog(this.getDialogArguments());
	},

	hide: function() {
		if (this._dialog) {
			this._dialog.close();
		}
	},

	uninitialize: function(){
		this._dialog.destroy();
		this.inherited(arguments);		
	},

	_onOk: function(e) {
		dojo.stopEvent(e);
		if (this._okInProgress) {
			return;
		}
		this._okInProgress = true;
		this.onOk(this.getOkParamaters());
		this.hide();
	},

	_onCancel: function(event) {
		dojo.stopEvent(event);
		if (this._cancelInProgress) {
			return;
		}
		this._cancelInProgress = true;
		this.onCancel(this.getCancelParameters());
		this.hide();
	},

	getOkParamaters: function(){/*To be implemnted by subclasses */},
	
	getDialogArguments: function(){/*To be implemnted by subclasses */},

	getCancelParameters: function(){/*To be implemnted by subclasses */},

	onOk: function(args) {/*To be implemnted by subclasses */},

	onCancel: function(args) {/*To be implemnted by subclasses */}

});


})();
