/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.EcoreExportClient");

dojo.require("rmpw.dsv.exporter.EcoreExportStatus");
dojo.require("jazz.app.context");
dojo.require("rmps.core.RootServices");

var EXPORT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "ecore-exporter");
var EXPORT_STATUS_PATH = EXPORT_PATH + "/statuses";
var BASELINE_PARAM = "rmps.context=";

rmpw.dsv.exporter.EcoreExportClient = {
	
	getStatuses: function() {
	   var args = {
			url: EXPORT_STATUS_PATH + "?" + "&" + BASELINE_PARAM + jazz.app.context.get().baseline,
			headers: {
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			load: function(response, ioArgs) {
				var statuses = [];
				for (var uri in response) {
					var status = new rmpw.dsv.exporter.EcoreExportStatus();
					status.parseRdfJson(uri, response[uri]);
					statuses.push(status);
				}
				return statuses;
			}
		};
		return jazz.client.xhrGet(args);
	},		
		
	getStatus: function(uri) {
		var args = {
			url: uri + "?" + BASELINE_PARAM + jazz.app.context.get().baseline,
			headers: {
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			load: function(response, ioArgs) {
				for (var uri in response) {
					var status = new rmpw.dsv.exporter.EcoreExportStatus();
					status.parseRdfJson(uri, response[uri]);
					return status;
				}
			}
		};
		return jazz.client.xhrGet(args);
	},
		
	deleteStatus: function(statusUri) {
		var args = {
			url: statusUri + "?cancel=false" + "&" + BASELINE_PARAM + jazz.app.context.get().baseline,
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			load: function(response, ioArgs) {
				return null;
			}
		};
		return jazz.client.xhrDelete(args);
	},
	
	cancelExport: function(statusUri) {
		var args = {
			url: statusUri + "?cancel=true" + "&" + BASELINE_PARAM + jazz.app.context.get().baseline,
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			load: function(response, ioArgs) {
				return null;
			}
		};
		return jazz.client.xhrDelete(args);
	}
};

})();