/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.EcoreExportEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmpw.dsv.exporter", "EcoreExportEditorMessages");
var messages = dojo.i18n.getLocalization("rmpw.dsv.exporter", "EcoreExportEditorMessages");

dojo.declare("rmpw.dsv.exporter.EcoreExportEditorInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',ecoreExportEditorInput');
	},
	
	getName: function() {
		return messages.ecoreExport;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmpw.dsv.exporter", "graphics/icons/ecoreExport.gif");
	},	
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		return rmps.core.util.IRmpsConstants.ADMIN_ECORE_EXPORT;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	}
	
});

}());
