/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.EditPartTrackedItem");

dojo.require("rmpw.panner.Tracker");

dojo.require("rmpw.panner.Utils");

dojo.declare("rmpw.panner.EditPartTrackedItem", rmpw.panner.Tracker.TrackedItem, {
	
	editPart: null,
	
	_moveHandle: null,
	
	getBoundingBox: function() {
		return rmps.draw2d.Utils.getTransformedBounds(this.editPart.getFigure());
	},
	
	activate: function() {
		this._moveHandle = dojo.connect(this.editPart.getFigure(), "fireFigureMoved", this, function() {
			this.boundsChanged();
		});
	},
	
	deactivate: function() {
		dojo.disconnect(this._moveHandle);
		delete this._moveHandle;
	}
});

})();