/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.EllipsisDetails");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.html");


dojo.declare("rmps.ui.EllipsisDetails", [dijit._Widget, dijit._Templated], {
	
	templateString: dojo.cache("rmps.ui", "templates/EllipsisDetails.html"),
	
	
	target: null,
	text: null,
	style: null,
	
	link : null,
	_handle: null,
	_offset: null,
	_truncatedText: null,
	_length: 0,
	_state: 0,
	_expanded: false,
	_linkLength: 100,
	
	constructor: function() {
		/*Empty Block */
	},
	
	truncate: function(txt,max_width, style) {
    	var span = document.createElement('span');
    	span.style.visibility = 'hidden';
    	document.body.appendChild(span);
    	var newtxt = txt;
    	span.innerHTML = newtxt;
    	if (max_width > 0) {
			while (span.offsetWidth > max_width) {
				newtxt = newtxt.substring(0, newtxt.length - 1);
				span.innerHTML = newtxt;
			}
		}
    	document.body.removeChild(span);
    	return span.innerHTML;
	},
	
	createLink: function() {
		this.link = dojo.doc.createElement("a");
		this.link.style.cursor = "pointer";
		if (this._handle) {
			this.disconnect(this._handle);
		}
		dojo.connect(this.link, "onclick", dojo.hitch(this, this.toggleState));
		dojo.html._setNodeContent(this.linkNode, this.link, true);
	},
	
	toggleState: function() {
		if(!this._isVisilbe(this._truncatedText, this.text)) {
			this.linkNode.style.visibility = "hidden";
		} else { 
			this.linkNode.style.visibility = "";
		}
		if(this._expanded) {
			this.link.innerHTML = "Less<<";
			 
			this.containerNode.innerHTML = this.text+"&nbsp;&nbsp;&nbsp;&nbsp;";
			this._expanded = false;
		} else {
			this.link.innerHTML = "More>>";
			this.containerNode.innerHTML = this._truncatedText+"&nbsp;&nbsp;&nbsp;&nbsp;";
			this._expanded = true;
		}
	},
	
	_isVisilbe: function(){
		/*Required for comparing strings with whitespaces in IE */
		var span= document.createElement('span');
		span.innerHTML= this.text;
		return this.stringCompare(span.innerHTML, this._truncatedText); 
	},
	
	stringCompare: function(string1, string2){
			return string1.toLocaleLowerCase().localeCompare(string2.toLocaleLowerCase());
	},
	
	postCreate: function() {
		if(this.text && this.target) {
			var offsetWidth = this.target.offsetWidth;
			if(offsetWidth != this._offset ) {
				this._offset = offsetWidth;
				this._truncatedText =  this.truncate(this.text ,this._offset - this._linkLength);
				this.details = this._truncatedText;
				this.createLink();
				this.toggleState();
			}
		}
		
	},
	
	updateSize: function() {
		var offsetWidth = this.target.offsetWidth;
		if(offsetWidth != this._offset ) {
			this._offset = offsetWidth;
			this._truncatedText =  this.truncate(this.text ,this._offset - this._linkLength);
		}
	},
	
	destroy: function(){
		delete this._truncatedText;
		this._truncatedText= null;
		
		if (this._handle) {
			this.disconnect(this._handle);
			delete this._handle;
			this._handle= null;
		}
		
		delete this.target;
		this.target= null;
		
		this.inherited(arguments);
	}
	
	
});

})();
