/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.ExportAdminMenuInitializer");

dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("rmps.app.ui.internal.util.DomainRegistryUtil");

dojo.requireLocalization("rmpw.dsv.exporter", "ExportCommonMessages");
var messages = dojo.i18n.getLocalization("rmpw.dsv.exporter", "ExportCommonMessages");

/*Add export menu items to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminComponentMenu, "addExtendedCapabilityComponentMenuItems", {
	after: function() {
		var menu = dojox.lang.aspect.getContext().instance;
		var projectId = jazz.app.context.get().itemId;
		var dspDef = new dojo.Deferred();
		
		rmps.app.ui.internal.util.DomainRegistryUtil.isCurrentProjectDSP(
				dojo.hitch(this, function(isDsp, isSystem) {
					dspDef.callback();
					if (isDsp && !isSystem) {
					    menu.addTitle(messages.exportTitle);
						menu.addItemByArgs({
							label: messages.exportEcores,
							href: rmps.core.util.IRmpsConstants.ADMIN_ECORE_EXPORT,
							icon: "rmpw.dsv.exporter/graphics/icons/ecoreExport.gif"
						});
						menu.addItemByArgs({
							label: messages.exportStatus,
							href: rmps.core.util.IRmpsConstants.ADMIN_EXPORT_STATUS,
							icon: "rmpw.dsv.exporter/graphics/icons/exportStatus.gif"
						});
					} 
				})
		);		
	}
});

})();