/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.ExportAdminPageInitializer");
dojo.require("rmpw.dsv.exporter.pages.ExportPageController");
dojo.require("dojox.lang.aspect");

var EXPORT_ACTIONS_LIST= ["ecoreExport", "exportStatus"];

rmps.ui.editor.EditorRegistry.register("rmpw.dsv.exporter.EcoreExportEditor", function(editorInput) {
	return editorInput.declaredClass === "rmpw.dsv.exporter.EcoreExportEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmpw.dsv.exporter.ExportStatusEditor", function(editorInput) {
	return editorInput.declaredClass === "rmpw.dsv.exporter.ExportStatusEditorInput";
});

/*Register the export actions to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "registerExtendedActions", {
	after: function() {
		 dojox.lang.aspect.getContext().instance.registerActionsList(EXPORT_ACTIONS_LIST);
	}
});

/*Use export controller to invoke the export registered actions */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "subscribeExtendedActions", {
	after: function() {
		var self = dojox.lang.aspect.getContext().instance;
		self.exportController= new rmpw.dsv.exporter.pages.ExportPageController(self);
		self.subscribeAllActions(self.exportController);
		
	}
});
})();