/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.ExportStatusEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");
dojo.require("rmps.core.util.IRmpsConstants");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmpw.dsv.exporter", "ExportCommonMessages");

var messages = dojo.i18n.getLocalization("rmpw.dsv.exporter", "ExportCommonMessages");

dojo.declare("rmpw.dsv.exporter.ExportStatusEditorInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmpw.dsv.exporter", "graphics/icons/exportStatus.gif");
	},
	
	getName: function() {
		return messages.exportStatus;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		return rmps.core.util.IRmpsConstants.ADMIN_EXPORT_STATUS;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	}
});

})();
