/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.Footer"); 

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");

/*
* Used as a mixing or dojo type to provide ok/cancel footer for dialogs. We can also manage the
* set labels for buttons 
*/
dojo.declare("rmps.ui.Footer", [dijit._Widget, dijit._Templated], {
	
	"class": "rmps-ui-footer",
	
	widgetsInTemplate: true,
	tableArgs: null,
	table: null,
	containerDialog: null,
	okMessage: null,
	cancelMessage: null,
	
	//private
	_selection: null,
	_footerMessages: null,
	
	templateString: dojo.cache("rmps.ui", "templates/Footer.html"),
	
	postMixInProperties: function(){
		this.inherited(arguments);
		
		dojo.requireLocalization("rmps.ui", "FooterMessages");
		this._footerMessages = dojo.i18n.getLocalization("rmps.ui", "FooterMessages");
		
		//Can be extended by callers
		if(!this.okMessage){
			this.okMessage= this._footerMessages.ok;			
		}
		
		//Can be extended by callers
		if(!this.cancelMessage){
			this.cancelMessage= this._footerMessages.cancel;			
		}
	},
	
	setOKEnablement: function(enabled){
		this.okCmd.disabled= enabled ? false: true;
	},
	
	setOKHidden: function(hidden){
		if (hidden) {
			this.okCmd.style.display = "none";
		} else {
			this.okCmd.style.display = "";
		}
	},
	
	setCancelHidden: function(hidden){
		if (hidden) {
			this.cancelCmd.style.display = "none";
		} else {
			this.cancelCmd.style.display = "";
		}
	},
	
	_onOK: function(e) {
		this.onOK(e);
	},

	_onCancel: function(e) {
		this.onCancel(e);
	},
	
	onOK: function(e) {
		//Null Implementation
	},

	onCancel: function(e) {
		//Null Implementation
	},
	
	setFocusOnOK: function() {
		this.okCmd.focus();
	}
});
})();