/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.layout.graph.GMFDirectedGraphLayout");
dojo.require("rmpw.diagrams.layout.graph.AbstractGraphLayout");

dojo.require("rmpw.diagrams.layout.client.routers.ShortestPathRouter");
dojo.require("rmpw.diagrams.layout.client.routers.Obstacle");
dojo.require("rmpw.diagrams.layout.client.Node");
dojo.require("rmpw.diagrams.layout.client.Edge");
dojo.require("rmpw.diagrams.layout.client.EdgeList");
dojo.require("rmpw.diagrams.layout.client.NodeList");
dojo.require("rmpw.diagrams.layout.client.Graph");

dojo.require("rmpw.diagrams.render.util.Insets");
dojo.require("rmpw.diagrams.render.util.Rectangle");
dojo.require("rmpw.diagrams.render.util.Ray");
dojo.require("rmpw.diagrams.render.util.LineSeg");
dojo.require("rmpw.diagrams.render.util.Dimension");
dojo.require("rmpw.diagrams.render.util.PointList");

dojo.require("rmpw.diagrams.layout.graph.JavaUtil");

getClass_101 = function(){
  return Lorg_eclipse_draw2d_graph_GraphVisitor_2_classLit;
};

revisit_0 = function(g){
};

visit_0 = function(g){
};

GraphVisitor = function(){
};

_ = GraphVisitor.prototype = new Object_0();
_.getClass$ = getClass_101;
_.revisit = revisit_0;
_.visit = visit_0;
_.typeId$ = 71;
$BreakCycles = function(this$static){
  this$static.graphNodes = $NodeList(new NodeList());
  return this$static;
};

$allNodesFlagged = function(this$static){
  var i;
  for (i = 0; i < this$static.graphNodes.size; ++i) {
    if (!dynamicCast($get_0(this$static.graphNodes, i), 21).flag)
      return false;
  }
  return true;
};

$containsCycles = function(this$static){
  var i, noLefts, node, right;
  noLefts = $ArrayList(new ArrayList());
  for (i = 0; i < this$static.graphNodes.size; ++i) {
    node = dynamicCast($get_0(this$static.graphNodes, i), 21);
    if (node.workingInts[0] == 0)
      $sortedInsert(noLefts, node);
  }
  while (noLefts.size > 0) {
    node = dynamicCast($remove_2(noLefts, noLefts.size - 1), 21);
    node.flag = true;
    for (i = 0; i < node.outgoing.size; ++i) {
      right = dynamicCast($get_0(node.outgoing, i), 18).target;
      $setIncomingCount(right, right.workingInts[0] - 1);
      if (right.workingInts[0] == 0)
        $sortedInsert(noLefts, right);
    }
  }
  if ($allNodesFlagged(this$static))
    return false;
  return true;
};

$findNodeWithMaxDegree = function(this$static){
  var i, max, maxNode, node;
  max = -2147483648;
  maxNode = null;
  for (i = 0; i < this$static.graphNodes.size; ++i) {
    node = dynamicCast($get_0(this$static.graphNodes, i), 21);
    if (node.workingInts[3] >= max && !node.flag) {
      max = node.workingInts[3];
      maxNode = node;
    }
  }
  return maxNode;
};

$greedyCycleRemove = function(this$static){
  var hasSink, hasSource, i, max, node, orderIndex, sL, sR;
  sL = $NodeList(new NodeList());
  sR = $NodeList(new NodeList());
  do {
    do {
      hasSink = false;
      for (i = 0; i < this$static.graphNodes.size; ++i) {
        node = dynamicCast($get_0(this$static.graphNodes, i), 21);
        if (node.workingInts[2] == 0 && !node.flag) {
          hasSink = true;
          node.flag = true;
          $updateIncoming(node);
          setCheck(sR.array, sR.size++, node);
          break;
        }
      }
    }
     while (hasSink);
    do {
      hasSource = false;
      for (i = 0; i < this$static.graphNodes.size; ++i) {
        node = dynamicCast($get_0(this$static.graphNodes, i), 21);
        if (node.workingInts[1] == 0 && !node.flag) {
          hasSource = true;
          node.flag = true;
          $updateOutgoing(node);
          setCheck(sL.array, sL.size++, node);
          break;
        }
      }
    }
     while (hasSource);
    max = $findNodeWithMaxDegree(this$static);
    if (max) {
      setCheck(sL.array, sL.size++, max);
      max.flag = true;
      $updateIncoming(max);
      $updateOutgoing(max);
    }
  }
   while (!$allNodesFlagged(this$static));
  orderIndex = 0;
  for (i = 0; i < sL.size; ++i) {
	checkIndex(i, sL.size);
    dynamicCast( sL.array[i], 21).workingInts[0] = orderIndex++;
  }
  for (i = sR.size - 1; i >= 0; --i) {
	checkIndex(i, sR.size);  
    dynamicCast( sR.array[i], 21).workingInts[0] = orderIndex++;
  }
};

$initializeDegrees = function(this$static, g){
  var i, n;
  $resetFlags_0(this$static.graphNodes);
  for (i = 0; i < g.nodes.size; ++i) {
    n = dynamicCast($get_0(this$static.graphNodes, i), 21);
    n.workingInts[1] = n.incoming.size;
    n.workingInts[2] = n.outgoing.size;
    n.workingInts[3] = n.outgoing.size - n.incoming.size;
  }
};

$invertEdges = function(g){
  var e, i;
  for (i = 0; i < g.edges.size; ++i) {
    e = dynamicCast($get_0(g.edges, i), 18);
    if (e.source.workingInts[0] > e.target.workingInts[0]) {
      $invert(e);
      e.isInvert = true;
    }
  }
};

$setDegree = function(n, deg){
  n.workingInts[3] = deg;
};

$setInDegree = function(n, deg){
  n.workingInts[1] = deg;
};

$setIncomingCount = function(n, count){
  n.workingInts[0] = count;
};

$setOutDegree = function(n, deg){
  n.workingInts[2] = deg;
};

$sortedInsert = function(list, node){
  var insert;
  insert = 0;
  while (insert < list.size && dynamicCast(list.array[insert], 21).sortValue > node.sortValue)
    ++insert;
  $add(list, insert, node);
};

$updateIncoming = function(n){
  var i, in_$;
  for (i = 0; i < n.incoming.size; ++i) {
    in_$ = dynamicCast($get_0(n.incoming, i), 18).source;
    if (!in_$.flag) {
      $setOutDegree(in_$, in_$.workingInts[2] - 1);
      $setDegree(in_$, in_$.workingInts[2] - in_$.workingInts[1]);
    }
  }
};

$updateOutgoing = function(n){
  var i, out;
  for (i = 0; i < n.outgoing.size; ++i) {
    out = dynamicCast($get_0(n.outgoing, i), 18).target;
    if (!out.flag) {
      $setInDegree(out, out.workingInts[1] - 1);
      $setDegree(out, out.workingInts[2] - out.workingInts[1]);
    }
  }
};

getClass_95 = function(){
  return Lorg_eclipse_draw2d_graph_BreakCycles_2_classLit;
};

revisit = function(g){
  var e, i;
  for (i = 0; i < g.edges.size; ++i) {
    e = dynamicCast($get_0(g.edges, i), 18);
    if (e.isInvert)
      $invert(e);
  }
};

visit = function(g){
  var i, n;
  $resetFlags_0(this.graphNodes);
  for (i = 0; i < g.nodes.size; ++i) {
    n = dynamicCast($get_0(g.nodes, i), 21);
    n.workingInts[0] = n.incoming.size;
    $add_0(this.graphNodes, n);
  }
  if ($containsCycles(this)) {
    $initializeDegrees(this, g);
    $greedyCycleRemove(this);
    $invertEdges(g);
  }
};

BreakCycles = function(){
};

_ = BreakCycles.prototype = new GraphVisitor();
_.getClass$ = getClass_95;
_.revisit = revisit;
_.visit = visit;
_.typeId$ = 72;
$CollapsedEdges = function(this$static, edge){
  this$static.tightestEdge = edge;
  this$static.collapsedWeight = edge.weight;
  ++this$static.collapsedCount;
  return this$static;
};

$processEdge = function(this$static, candidate){
  var over, temp;
  ++this$static.collapsedCount;
  if (candidate.target.rank - candidate.source.rank - candidate.delta < $getSlack(this$static.tightestEdge)) {
    this$static.overage += this$static.collapsedWeight * ($getSlack(this$static.tightestEdge) - (candidate.target.rank - candidate.source.rank - candidate.delta));
    temp = this$static.tightestEdge;
    this$static.tightestEdge = candidate;
    this$static.collapsedWeight += candidate.weight;
    return temp;
  }
   else {
    over = candidate.target.rank - candidate.source.rank - candidate.delta - $getSlack(this$static.tightestEdge);
    this$static.unOverage += over;
    this$static.overage += candidate.weight * over;
    this$static.collapsedWeight += candidate.weight;
    return candidate;
  }
};

getClass_96 = function(){
  return Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit;
};

CollapsedEdges = function(){
};

_ = CollapsedEdges.prototype = new Object_0();
_.getClass$ = getClass_96;
_.typeId$ = 73;
_.collapsedCount = 0;
_.collapsedWeight = 0;
_.overage = 0;
_.tightestEdge = null;
_.unOverage = 0;

$visit = function(this$static, graph){
  var i, visitor;
  if (graph.nodes.size == 0)
    return;
  for (i = 0; i < this$static.steps.size; ++i) {
    visitor = dynamicCast($get_0(this$static.steps, i), 46);
    visitor.visit(graph);
  }
  for (i = this$static.steps.size - 1; i >= 0; --i) {
    visitor = dynamicCast($get_0(this$static.steps, i), 46);
    visitor.revisit(graph);
  }
};

getClass_97 = function(){
  return Lorg_eclipse_draw2d_graph_DirectedGraphLayout_2_classLit;
};

DirectedGraphLayout = function(){
};

_ = DirectedGraphLayout.prototype = new Object_0();
_.getClass$ = getClass_97;
_.typeId$ = 0;

$getIndexForRank = function(this$static, rank){
  if (this$static.source.rank == rank)
    return this$static.source.index;
  if (this$static.target.rank == rank)
    return this$static.target.index;
  if (this$static.vNodes)
    return dynamicCast($get_0(this$static.vNodes, rank - this$static.source.rank - 1), 21).index;
  return -1;
};

$getSlack = function(this$static){
  return this$static.target.rank - this$static.source.rank - this$static.delta;
};

$getSourceOffset = function(this$static){
  if (this$static.offsetSource != -1)
    return this$static.offsetSource;
  return $getOffsetOutgoing(this$static.source);
};

$getTargetOffset = function(this$static){
  if (this$static.offsetTarget != -1)
    return this$static.offsetTarget;
  return $getOffsetIncoming(this$static.target);
};

$invert = function(this$static){
  var j, newVNodes, oldTarget, pt, temp;
  $remove_3(this$static.source.outgoing, this$static);
  $remove_3(this$static.target.incoming, this$static);
  oldTarget = this$static.target;
  this$static.target = this$static.source;
  this$static.source = oldTarget;
  temp = this$static.offsetSource;
  this$static.offsetSource = this$static.offsetTarget;
  this$static.offsetTarget = temp;
  $add_0(this$static.target.incoming, this$static);
  $add_0(this$static.source.outgoing, this$static);
  if (this$static.points)
	  this$static.points.reverse();
  if (this$static.vNodes) {
    newVNodes = $NodeList(new NodeList());
    for (j = this$static.vNodes.size - 1; j >= 0; --j) {
      $add_0(newVNodes, dynamicCast($get_0(this$static.vNodes, j), 21));
    }
    this$static.vNodes = newVNodes;
  }
  if (this$static.start) {
    pt = this$static.start;
    this$static.start = this$static.end;
    this$static.end = pt;
  }
};

$opposite = function(this$static, end){
  if (this$static.source == end)
    return this$static.target;
  return this$static.source;
};

$setPoints_0 = function(this$static, points){
  this$static.points = points;
  this$static.start = points.getPoint( 0);
  this$static.end = points.getPoint( points.size - 1);
};

$getTreeHead = function(edge){
  if (dynamicCast(edge.source.workingData[1], 18) == edge)
    return edge.target;
  return edge.source;
};

$getTreeParent = function(node){
  var e;
  e = dynamicCast(node.workingData[1], 18);
  if (!e)
    return null;
  return $opposite(e, node);
};

$getTreeTail = function(edge){
  if (dynamicCast(edge.source.workingData[1], 18) == edge)
    return edge.source;
  return edge.target;
};

getClass_126 = function(){
  return Lorg_eclipse_draw2d_graph_SpanningTreeVisitor_2_classLit;
};

SpanningTreeVisitor = function(){
};

_ = SpanningTreeVisitor.prototype = new GraphVisitor();
_.getClass$ = getClass_126;
_.typeId$ = 76;
$HorizontalPlacement = function(this$static){
  this$static.clusterMap = $HashMap(new HashMap());
  this$static.clusterset = $HorizontalPlacement$ClusterSet(new HorizontalPlacement$ClusterSet(), this$static);
  this$static.dirtyClusters = $HashSet(new HashSet());
  this$static.map = $HashMap(new HashMap());
  return this$static;
};

$addEdge = function(this$static, u, v, e, weight){
  var dw, eu, ev, ne, uOffset, uPrime, vOffset, vPrime;
  ne = $Node(new Node(), $NodePair(new NodePair(), u, v));
  $add_0(this$static.prime.nodes, ne);
  ne.y = ~~((u.y + u.height + v.y) / 2);
  uPrime = dynamicCast($get(this$static.map, u), 21);
  vPrime = dynamicCast($get(this$static.map, v), 21);
  uOffset = $getSourceOffset(e);
  vOffset = $getTargetOffset(e);
  eu = $Edge_1(new Edge(), ne, uPrime, 0, e.weight * weight);
  ev = $Edge_1(new Edge(), ne, vPrime, 0, e.weight * weight);
  dw = uOffset - vOffset;
  if (dw < 0)
    eu.delta = -dw;
  else 
    ev.delta = dw;
  $add_0(this$static.prime.edges, eu);
  $add_0(this$static.prime.edges, ev);
};

$addEdges = function(this$static, n){
  var e, i;
  for (i = 0; i < n.incoming.size; ++i) {
    e = $getEdge(n.incoming, i);
    $addEdge(this$static, e.source, n, e, 1);
  }
};

$applyGPrime = function(this$static){
  var n, node;
  for (n = 0; n < this$static.prime.nodes.size; ++n) {
    node = dynamicCast($get_0(this$static.prime.nodes, n), 21);
    if (instanceOf(node.data, 21))
      dynamicCast(node.data, 21).x = node.rank;
  }
};

$balanceClusters = function(this$static){
  var c, delta, i, somethingMoved;
  $findAllClusters(this$static);
  this$static.step = 0;
  somethingMoved = false;
  for (i = 0; i < this$static.allClusters.size;) {
    c = dynamicCast($get_0(this$static.allClusters, i), 19);
    delta = c.effectivePull;
    if (delta < 0) {
      if (c.leftFreedom > 0) {
        $adjustRank(c, max_2(delta, -c.leftFreedom), this$static.dirtyClusters);
        $refreshDirtyClusters(this$static);
        $moveClusterForward(this$static, i, c);
        somethingMoved = true;
        ++this$static.step;
      }
       else if ($build(this$static.clusterset, c)) {
        ++this$static.step;
        $moveClusterForward(this$static, i, c);
        somethingMoved = true;
      }
    }
     else if (delta > 0) {
      if (c.rightFreedom > 0) {
        $adjustRank(c, min_0(delta, c.rightFreedom), this$static.dirtyClusters);
        $refreshDirtyClusters(this$static);
        $moveClusterForward(this$static, i, c);
        somethingMoved = true;
        ++this$static.step;
      }
       else if ($build(this$static.clusterset, c)) {
        ++this$static.step;
        $moveClusterForward(this$static, i, c);
        somethingMoved = true;
      }
    }
    ++i;
    if (i == this$static.allClusters.size && somethingMoved) {
      i = 0;
      somethingMoved = false;
    }
  }
};

$buildGPrime = function(this$static){
  var i, n, r, rank, ranks;
  ranks = this$static.graph.ranks;
  $buildRankSeparators(this$static, ranks);
  for (r = 1; r < ranks.ranks.size; ++r) {
    rank = $getRank(ranks, r);
    for (i = 0; i < rank.size; ++i) {
      checkIndex(i, rank.size);
      n = dynamicCast(rank.array[i], 21);
      $addEdges(this$static, n);
    }
  }
};

$buildRankSeparators = function(this$static, ranks){
  var e, i, n, nPrime, prevNPrime, r, rank, source, target;
  for (r = 0; r < ranks.ranks.size; ++r) {
    rank = $getRank(ranks, r);
    prevNPrime = null;
    for (i = 0; i < rank.size; ++i) {
      checkIndex(i, rank.size);
      n = dynamicCast(rank.array[i], 21);
      nPrime = $Node(new Node(), n);
      if (i == 0) {
        e = $Edge_1(new Edge(), this$static.graphLeft, nPrime, 0, 0);
        $add_0(this$static.prime.edges, e);
        e.delta = $getPadding(this$static.graph, n).left + this$static.graph.margin.left;
      }
       else {
        e = $Edge_0(new Edge(), prevNPrime, nPrime);
        e.weight = 0;
        $add_0(this$static.prime.edges, e);
        source = dynamicCast(e.source.data, 21);
        target = dynamicCast(e.target.data, 21);
        e.delta = source.width + $getPadding(this$static.graph, source).right + $getPadding(this$static.graph, target).left;
      }
      prevNPrime = nPrime;
      $add_0(this$static.prime.nodes, nPrime);
      $put(this$static.map, n, nPrime);
      if (i == rank.size - 1) {
        e = $Edge_1(new Edge(), nPrime, this$static.graphRight, 0, 0);
        e.delta = n.width + $getPadding(this$static.graph, n).right + this$static.graph.margin.right;
        $add_0(this$static.prime.edges, e);
      }
    }
  }
};

$calculateCellLocations = function(this$static){
  var cell, locations, node, rank, row;
  this$static.graph.cellLocations = initDim(_3_3I_classLit, 128, 23, this$static.graph.ranks.ranks.size + 1, 0);
  for (row = 0; row < this$static.graph.ranks.ranks.size; ++row) {
    rank = $getRank(this$static.graph.ranks, row);
    locations = this$static.graph.cellLocations[row] = initDim(_3I_classLit, 110, -1, rank.size + 1, 1);
    node = null;
    for (cell = 0; cell < rank.size; ++cell) {
      checkIndex(cell, rank.size);
      node = dynamicCast(rank.array[cell], 21);
      locations[cell] = node.x - $getPadding(this$static.graph, node).left;
    }
    locations[cell] = node.x + node.width + $getPadding(this$static.graph, node).right;
  }
};

$findAllClusters = function(this$static){
  var cluster, e, i, link, root, sourceCluster, targetCluster;
  root = dynamicCast($get_0(this$static.prime.nodes, 0), 21);
  cluster = $NodeCluster(new NodeCluster());
  this$static.allClusters = $ArrayList(new ArrayList());
  $add_0(this$static.allClusters, cluster);
  $growCluster(this$static, root, cluster);
  for (i = 0; i < this$static.prime.edges.size; ++i) {
    e = $getEdge(this$static.prime.edges, i);
    sourceCluster = dynamicCast($get(this$static.clusterMap, e.source), 19);
    targetCluster = dynamicCast($get(this$static.clusterMap, e.target), 19);
    if (targetCluster == sourceCluster)
      continue;
    link = $getRightNeighbor(sourceCluster, targetCluster);
    if (!link) {
      link = $CollapsedEdges(new CollapsedEdges(), e);
      $addRightNeighbor(sourceCluster, targetCluster, link);
      $addLeftNeighbor(targetCluster, sourceCluster, link);
    }
     else {
      $removeEdge(this$static.prime, $processEdge(link, e));
      --i;
    }
  }
  for (i = 0; i < this$static.allClusters.size; ++i)
    $initValues(dynamicCast($get_0(this$static.allClusters, i), 19));
};

$growCluster = function(this$static, root, cluster){
  var e, i, newCluster, treeChildren;
  setCheck(cluster.array, cluster.size++, root);
  $put(this$static.clusterMap, root, cluster);
  treeChildren = dynamicCast(root.workingData[0], 47);
  for (i = 0; i < treeChildren.size; ++i) {
	checkIndex(i, treeChildren.size);
    e = dynamicCast(treeChildren.array[i], 18);
    if (e.cut != 0)
      $growCluster(this$static, $getTreeTail(e), cluster);
    else {
      newCluster = $NodeCluster(new NodeCluster());
      $add_0(this$static.allClusters, newCluster);
      $growCluster(this$static, $getTreeTail(e), newCluster);
    }
  }
};

$moveClusterForward = function(this$static, i, c){
  var swapIndex, temp;
  if (i == 0)
    return;
  swapIndex = ~~(i / 2);
  temp = $get_0(this$static.allClusters, swapIndex);
  $set_0(this$static.allClusters, swapIndex, c);
  $set_0(this$static.allClusters, i, temp);
};

$refreshDirtyClusters = function(this$static){
  var iter, outerIter, entry;
  outerIter = $AbstractHashMap$EntrySetIterator(new AbstractHashMap$EntrySetIterator(), $keySet(this$static.dirtyClusters.map).val$entrySet.this$0);
  for (iter = $AbstractMap$1$1(new AbstractMap$1$1(), outerIter); $hasNext(iter.val$outerIter.iter);) {
	  entry = $next(iter.val$outerIter);
	  $refreshValues(dynamicCast(entry.getKey(), 19));
  }
  $clearImpl(this$static.dirtyClusters.map);
};

getClass_103 = function(){
  return Lorg_eclipse_draw2d_graph_HorizontalPlacement_2_classLit;
};

visit_1 = function(g){
  var solver;
  this.graph = g;
  this.prime = $DirectedGraph(new DirectedGraph());
  $add_0(this.prime.nodes, this.graphLeft = $Node_0(new Node()));
  $add_0(this.prime.nodes, this.graphRight = $Node_0(new Node()));
  if (g.tensorStrength != 0)
    $add_0(this.prime.edges, $Edge_1(new Edge(), this.graphLeft, this.graphRight, g.tensorSize, g.tensorStrength));
  $buildGPrime(this);
  $visit_0($InitialRankSolver(new InitialRankSolver()), this.prime);
  $visit_2($TightSpanningTreeSolver(new TightSpanningTreeSolver()), this.prime);
  solver = new RankAssignmentSolver();
  $visit_1(solver, this.prime);
  this.graph.size.width = this.graphRight.rank;
  $balanceClusters(this);
  $adjustRank_0(this.prime.nodes, -this.graphLeft.rank);
  $applyGPrime(this);
  $calculateCellLocations(this);
};

HorizontalPlacement = function(){
};

_ = HorizontalPlacement.prototype = new SpanningTreeVisitor();
_.getClass$ = getClass_103;
_.visit = visit_1;
_.typeId$ = 77;
_.allClusters = null;
_.graph = null;
_.graphLeft = null;
_.graphRight = null;
_.prime = null;
_.step = 0;
$HorizontalPlacement$ClusterSet = function(this$static, this$0){
  this$static.this$0 = this$0;
  this$static.members = $ArrayList(new ArrayList());
  return this$static;
};

$addCluster = function(this$static, seed){
  $add_0(this$static.members, seed);
  seed.isSetMember = true;
  this$static.rawPull += seed.weightedTotal;
  this$static.pullWeight += seed.weightedDivisor;
  if (this$static.isRight) {
    this$static.freedom = min_0(this$static.freedom, seed.rightNonzero);
    if (this$static.freedom == 0 || this$static.rawPull <= 0)
      return true;
    $addIncomingClusters(this$static, seed);
    if ($addOutgoingClusters(this$static, seed))
      return true;
  }
   else {
    this$static.freedom = min_0(this$static.freedom, seed.leftNonzero);
    if (this$static.freedom == 0 || this$static.rawPull >= 0)
      return true;
    $addOutgoingClusters(this$static, seed);
    if ($addIncomingClusters(this$static, seed))
      return true;
  }
  return false;
};

$addIncomingClusters = function(this$static, seed){
  var edges, i, neighbor;
  for (i = 0; i < seed.leftCount; ++i) {
    neighbor = seed.leftNeighbors[i];
    if (neighbor.isSetMember)
      continue;
    edges = seed.leftLinks[i];
    if ($getSlack(edges.tightestEdge) != 0)
      continue;
    if ((!this$static.isRight || neighbor.effectivePull > 0) && $addCluster(this$static, neighbor))
      return true;
  }
  return false;
};

$addOutgoingClusters = function(this$static, seed){
  var edges, i, neighbor;
  for (i = 0; i < seed.rightCount; ++i) {
    neighbor = seed.rightNeighbors[i];
    if (neighbor.isSetMember)
      continue;
    edges = seed.rightLinks[i];
    if ($getSlack(edges.tightestEdge) != 0)
      continue;
    if ((this$static.isRight || neighbor.effectivePull < 0) && $addCluster(this$static, neighbor))
      return true;
  }
  return false;
};

$build = function(this$static, seed){
  var c, delta, i;
  this$static.isRight = seed.weightedTotal > 0;
  if (!$addCluster(this$static, seed)) {
    delta = ~~(this$static.rawPull / this$static.pullWeight);
    if (delta < 0)
      delta = max_2(delta, -this$static.freedom);
    else 
      delta = min_0(delta, this$static.freedom);
    if (delta != 0) {
      for (i = 0; i < this$static.members.size; ++i) {
        c = dynamicCast($get_0(this$static.members, i), 19);
        $adjustRank(c, delta, this$static.this$0.dirtyClusters);
      }
      $refreshDirtyClusters(this$static.this$0);
      $reset(this$static);
      return true;
    }
  }
  $reset(this$static);
  return false;
};

$reset = function(this$static){
  var i;
  this$static.rawPull = this$static.pullWeight = 0;
  for (i = 0; i < this$static.members.size; ++i)
    dynamicCast($get_0(this$static.members, i), 19).isSetMember = false;
  $clear(this$static.members);
  this$static.freedom = 2147483647;
};

getClass_102 = function(){
  return Lorg_eclipse_draw2d_graph_HorizontalPlacement$ClusterSet_2_classLit;
};

HorizontalPlacement$ClusterSet = function(){
};

_ = HorizontalPlacement$ClusterSet.prototype = new Object_0();
_.getClass$ = getClass_102;
_.typeId$ = 0;
_.freedom = 2147483647;
_.isRight = false;
_.pullWeight = 0;
_.rawPull = 0;
_.this$0 = null;
$InitialRankSolver = function(this$static){
  $ArrayList(new EdgeList());
  $ArrayList(new NodeList());
  return this$static;
};

$assignMinimumRank = function(node){
  var e, i1, rank;
  rank = 0;
  for (i1 = 0; i1 < node.incoming.size; ++i1) {
    e = $getEdge(node.incoming, i1);
    rank = max_2(rank, e.delta + e.source.rank);
  }
  node.rank = rank;
};

$connectForest = function(this$static){
  var forest, i, n, neighbor, s, stack, tree;
  forest = $ArrayList(new ArrayList());
  stack = $Stack(new Stack());
  $resetFlags_0(this$static.graph.nodes);
  for (i = 0; i < this$static.graph.nodes.size; ++i) {
    n = dynamicCast($get_0(this$static.graph.nodes, i), 21);
    if (n.flag)
      continue;
    tree = $NodeList(new NodeList());
    $add_0(stack.arrayList, n);
    while (stack.arrayList.size != 0) {
      n = dynamicCast($pop(stack), 21);
      n.flag = true;
      setCheck(tree.array, tree.size++, n);
      for (s = 0; s < n.incoming.size; ++s) {
        neighbor = $getEdge(n.incoming, s).source;
        if (!neighbor.flag)
          $add_0(stack.arrayList, neighbor);
      }
      for (s = 0; s < n.outgoing.size; ++s) {
        neighbor = $getEdge(n.outgoing, s).target;
        if (!neighbor.flag)
          $add_0(stack.arrayList, neighbor);
      }
    }
    setCheck(forest.array, forest.size++, tree);
  }
  if (forest.size > 1) {
    this$static.graph.forestRoot = $Node(new Node(), 'the forest root');
    $add_0(this$static.graph.nodes, this$static.graph.forestRoot);
    for (i = 0; i < forest.size; ++i) {
      checkIndex(i, forest.size);	
      tree = dynamicCast(forest.array[i], 20);
      checkIndex(0, tree.size);
      $add_0(this$static.graph.edges, $Edge_1(new Edge(), this$static.graph.forestRoot, dynamicCast(tree.array[0], 21), 0, 0));
    }
  }
};

$solve = function(this$static){
  var i, node, rankMe, unranked;
  if (this$static.graph.nodes.size == 0)
    return;
  unranked = $NodeList_0(new NodeList(), this$static.graph.nodes);
  rankMe = $NodeList(new NodeList());
  while (unranked.size != 0) {
    rankMe.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
    rankMe.size = 0;
    for (i = 0; i < unranked.size;) {
      checkIndex(i, unranked.size);
      node = dynamicCast(unranked.array[i], 21);
      if ($isCompletelyFlagged(node.incoming)) {
        setCheck(rankMe.array, rankMe.size++, node);
        $remove_2(unranked, i);
      }
       else 
        ++i;
    }
    if (rankMe.size == 0)
      throw $RuntimeException(new RuntimeException(), 'Cycle detected in graph');
    for (i = 0; i < rankMe.size; ++i) {
      checkIndex(i, rankMe.size);
      node = dynamicCast(rankMe.array[i], 21);
      $assignMinimumRank(node);
      $setFlags(node.outgoing, true);
    }
  }
  $connectForest(this$static);
};

$visit_0 = function(this$static, graph){
  this$static.graph = graph;
  $resetFlags(graph.edges, false);
  $resetFlags_0(graph.nodes);
  $solve(this$static);
};

getClass_104 = function(){
  return Lorg_eclipse_draw2d_graph_InitialRankSolver_2_classLit;
};

visit_2 = function(graph){
  $visit_0(this, graph);
};

InitialRankSolver = function(){
};

_ = InitialRankSolver.prototype = new GraphVisitor();
_.getClass$ = getClass_104;
_.visit = visit_2;
_.typeId$ = 78;
_.graph = null;
$shouldSwap = function(current, next){
  var crossCount, currentEdge, currentEdges, i, iCurrent, iNext, invertedCrossCount, j, nextEdges, offsetDiff, rank;
  crossCount = 0;
  invertedCrossCount = 0;
  currentEdges = current.incoming;
  nextEdges = next.incoming;
  rank = current.rank - 1;
  for (i = 0; i < currentEdges.size; ++i) {
	checkIndex(i, currentEdges.size);
    currentEdge = dynamicCast(currentEdges.array[i], 18);
    iCurrent = $getIndexForRank(currentEdge, rank);
    for (j = 0; j < nextEdges.size; ++j) {
      checkIndex(j, nextEdges.size);
      iNext = $getIndexForRank(dynamicCast(nextEdges.array[j], 18), rank);
      if (iNext < iCurrent)
        ++crossCount;
      else if (iNext > iCurrent)
        ++invertedCrossCount;
      else {
    	checkIndex(j, nextEdges.size);
        offsetDiff = $getSourceOffset(dynamicCast(nextEdges.array[j], 18)) - $getSourceOffset(currentEdge);
        if (offsetDiff < 0)
          ++crossCount;
        else if (offsetDiff > 0)
          ++invertedCrossCount;
      }
    }
  }
  currentEdges = current.outgoing;
  nextEdges = next.outgoing;
  rank = current.rank + 1;
  for (i = 0; i < currentEdges.size; ++i) {
	checkIndex(i, currentEdges.size);
    currentEdge = dynamicCast(currentEdges.array[i], 18);
    iCurrent = $getIndexForRank(currentEdge, rank);
    for (j = 0; j < nextEdges.size; ++j) {
      checkIndex(j, nextEdges.size);
      iNext = $getIndexForRank(dynamicCast(nextEdges.array[j], 18), rank);
      if (iNext < iCurrent)
        ++crossCount;
      else if (iNext > iCurrent)
        ++invertedCrossCount;
      else {
    	checkIndex(j, nextEdges.size);
        offsetDiff = $getTargetOffset(dynamicCast(nextEdges.array[j], 18)) - $getTargetOffset(currentEdge);
        if (offsetDiff < 0)
          ++crossCount;
        else if (offsetDiff > 0)
          ++invertedCrossCount;
      }
    }
  }
  if (invertedCrossCount < crossCount)
    return true;
  return false;
};

getClass_105 = function(){
  return Lorg_eclipse_draw2d_graph_LocalOptimizer_2_classLit;
};

visit_3 = function(g){
  var currentNode, flag, n, nextNode, r, rank, index, previous, previous_0;
  do {
    flag = false;
    for (r = 0; r < g.ranks.ranks.size; ++r) {
      rank = $getRank(g.ranks, r);
      for (n = 0; n < rank.size - 1; ++n) {
    	checkIndex(n, rank.size);
        currentNode = dynamicCast(rank.array[n], 21);
        checkIndex(n + 1, rank.size);
        nextNode = dynamicCast(rank.array[n + 1], 21);
        if ($shouldSwap(currentNode, nextNode)) {
          index = $indexOf(rank, currentNode, 0);
          checkIndex(index + 1, rank.size);
          previous = rank.array[index + 1];
          setCheck(rank.array, index + 1, currentNode);
          checkIndex(index, rank.size);
          previous_0 = rank.array[index];
          setCheck(rank.array, index, nextNode);
          index = currentNode.index;
          currentNode.index = nextNode.index;
          nextNode.index = index;
          flag = true;
          n = 0 > n - 2?0:n - 2;
        }
      }
    }
  }
   while (flag);
};

LocalOptimizer = function(){
};

_ = LocalOptimizer.prototype = new GraphVisitor();
_.getClass$ = getClass_105;
_.visit = visit_3;
_.typeId$ = 79;
$MinCross = function(this$static){
  this$static.sorter = new RankSorter();
  return this$static;
};

$solve_0 = function(this$static){
  var loop, rank, row;
  for (loop = 0; loop < 45; ++loop) {
    for (row = 1; row < this$static.g.ranks.ranks.size; ++row) {
      rank = $getRank(this$static.g.ranks, row);
      $sortRankIncoming(this$static.sorter, rank, row, loop / 45);
    }
    if (loop == 44)
      continue;
    for (row = this$static.g.ranks.ranks.size - 2; row >= 0; --row) {
      rank = $getRank(this$static.g.ranks, row);
      $sortRankOutgoing(this$static.sorter, rank, row, loop / 45);
    }
  }
};

getClass_106 = function(){
  return Lorg_eclipse_draw2d_graph_MinCross_2_classLit;
};

visit_4 = function(g){
  $init_2(this.sorter, g);
  this.g = g;
  $solve_0(this);
};

MinCross = function(){
};

_ = MinCross.prototype = new GraphVisitor();
_.getClass$ = getClass_106;
_.visit = visit_4;
_.typeId$ = 80;
_.g = null;

$NodeCluster = function(this$static){
  $ArrayList(this$static);
  this$static.hashCode = hashCode__devirtual$(new Object_0());
  this$static.leftLinks = initDim(_3Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit, 122, 17, 10, 0);
  this$static.rightLinks = initDim(_3Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit, 122, 17, 10, 0);
  this$static.leftNeighbors = initDim(_3Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit, 124, 19, 10, 0);
  this$static.rightNeighbors = initDim(_3Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit, 124, 19, 10, 0);
  return this$static;
};

$addLeftNeighbor = function(this$static, neighbor, link){
  var newLinks, newNeighbors, newSize;
  if (this$static.leftNeighbors.length == this$static.leftCount) {
    newSize = this$static.leftNeighbors.length * 2;
    newNeighbors = initDim(_3Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit, 124, 19, newSize, 0);
    newLinks = initDim(_3Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit, 122, 17, newSize, 0);
    arraycopy(this$static.leftNeighbors, 0, newNeighbors, 0, this$static.leftNeighbors.length);
    arraycopy(this$static.leftLinks, 0, newLinks, 0, this$static.leftLinks.length);
    this$static.leftNeighbors = newNeighbors;
    this$static.leftLinks = newLinks;
  }
  this$static.leftNeighbors[this$static.leftCount] = neighbor;
  this$static.leftLinks[this$static.leftCount++] = link;
};

$addRightNeighbor = function(this$static, neighbor, link){
  var newLinks, newNeighbors, newSize;
  if (this$static.rightNeighbors.length == this$static.rightCount) {
    newSize = this$static.rightNeighbors.length * 2;
    newNeighbors = initDim(_3Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit, 124, 19, newSize, 0);
    newLinks = initDim(_3Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit, 122, 17, newSize, 0);
    arraycopy(this$static.rightNeighbors, 0, newNeighbors, 0, this$static.rightNeighbors.length);
    arraycopy(this$static.rightLinks, 0, newLinks, 0, this$static.rightLinks.length);
    this$static.rightNeighbors = newNeighbors;
    this$static.rightLinks = newLinks;
  }
  this$static.rightNeighbors[this$static.rightCount] = neighbor;
  this$static.rightLinks[this$static.rightCount++] = link;
};

$adjustRank = function(this$static, delta, affected){
  var edges, i, neighbor, old, old_0, old_1;
  $adjustRank_0(this$static, delta);
  for (i = 0; i < this$static.leftCount; ++i) {
    neighbor = this$static.leftNeighbors[i];
    if (neighbor.isSetMember)
      continue;
    edges = this$static.leftLinks[i];
    neighbor.weightedTotal += delta * edges.collapsedWeight;
    neighbor.unweightedTotal += delta * edges.collapsedCount;
    this$static.weightedTotal -= delta * edges.collapsedWeight;
    this$static.unweightedTotal -= delta * edges.collapsedCount;
    neighbor.rightDirty = this$static.leftDirty = true;
    if (!neighbor.isDirty) {
      neighbor.isDirty = true;
      old = $put(affected.map, neighbor, affected);
    }
  }
  for (i = 0; i < this$static.rightCount; ++i) {
    neighbor = this$static.rightNeighbors[i];
    if (neighbor.isSetMember)
      continue;
    edges = this$static.rightLinks[i];
    neighbor.weightedTotal += delta * edges.collapsedWeight;
    neighbor.unweightedTotal += delta * edges.collapsedCount;
    this$static.weightedTotal -= delta * edges.collapsedWeight;
    this$static.unweightedTotal -= delta * edges.collapsedCount;
    neighbor.leftDirty = this$static.rightDirty = true;
    if (!neighbor.isDirty) {
      neighbor.isDirty = true;
      old_0 = $put(affected.map, neighbor, affected);
    }
  }
  this$static.isDirty = true;
  old_1 = $put(affected.map, this$static, affected);
};

$getRightNeighbor = function(this$static, neighbor){
  var i;
  for (i = 0; i < this$static.rightCount; ++i) {
    if (this$static.rightNeighbors[i] == neighbor)
      return this$static.rightLinks[i];
  }
  return null;
};

$initValues = function(this$static){
  var edges, i, slack;
  this$static.weightedTotal = 0;
  this$static.weightedDivisor = 0;
  this$static.unweightedTotal = 0;
  this$static.leftNonzero = this$static.rightNonzero = this$static.leftFreedom = this$static.rightFreedom = 2147483647;
  for (i = 0; i < this$static.leftCount; ++i) {
    edges = this$static.leftLinks[i];
    this$static.weightedTotal -= $getSlack(edges.tightestEdge) * edges.collapsedWeight + edges.overage;
    this$static.unweightedTotal -= $getSlack(edges.tightestEdge);
    this$static.unweightedDivisor += edges.collapsedCount;
    this$static.weightedDivisor += edges.collapsedWeight;
    slack = $getSlack(edges.tightestEdge);
    this$static.leftFreedom = min_0(slack, this$static.leftFreedom);
    if (slack > 0)
      this$static.leftNonzero = min_0(slack, this$static.leftNonzero);
  }
  for (i = 0; i < this$static.rightCount; ++i) {
    edges = this$static.rightLinks[i];
    this$static.weightedTotal += $getSlack(edges.tightestEdge) * edges.collapsedWeight + edges.overage;
    this$static.unweightedDivisor += edges.collapsedCount;
    this$static.unweightedTotal += $getSlack(edges.tightestEdge);
    this$static.weightedDivisor += edges.collapsedWeight;
    slack = $getSlack(edges.tightestEdge);
    this$static.rightFreedom = min_0(slack, this$static.rightFreedom);
    if (slack > 0)
      this$static.rightNonzero = min_0(slack, this$static.rightNonzero);
  }
  $updateEffectivePull(this$static);
};

$refreshValues = function(this$static){
  var edges, i, slack;
  this$static.isDirty = false;
  if (this$static.leftDirty) {
    this$static.leftDirty = false;
    this$static.leftNonzero = this$static.leftFreedom = 2147483647;
    for (i = 0; i < this$static.leftCount; ++i) {
      edges = this$static.leftLinks[i];
      slack = $getSlack(edges.tightestEdge);
      this$static.leftFreedom = min_0(slack, this$static.leftFreedom);
      if (slack > 0)
        this$static.leftNonzero = min_0(slack, this$static.leftNonzero);
    }
  }
  if (this$static.rightDirty) {
    this$static.rightDirty = false;
    this$static.rightNonzero = this$static.rightFreedom = 2147483647;
    for (i = 0; i < this$static.rightCount; ++i) {
      edges = this$static.rightLinks[i];
      slack = $getSlack(edges.tightestEdge);
      this$static.rightFreedom = min_0(slack, this$static.rightFreedom);
      if (slack > 0)
        this$static.rightNonzero = min_0(slack, this$static.rightNonzero);
    }
  }
  $updateEffectivePull(this$static);
};

$updateEffectivePull = function(this$static){
  if (this$static.weightedDivisor != 0)
    this$static.effectivePull = ~~(this$static.weightedTotal / this$static.weightedDivisor);
  else if (this$static.unweightedDivisor != 0)
    this$static.effectivePull = ~~(this$static.unweightedTotal / this$static.unweightedDivisor);
  else 
    this$static.effectivePull = 0;
};

equals_22 = function(o){
  return (o == null?null:o) === this;
};

getClass_108 = function(){
  return Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit;
};

hashCode_21 = function(){
  return this.hashCode;
};

NodeCluster = function(){
};

_ = NodeCluster.prototype = new NodeList();
_.equals$ = equals_22;
_.getClass$ = getClass_108;
_.hashCode$ = hashCode_21;
_.typeId$ = 83;
_.effectivePull = 0;
_.isDirty = false;
_.isSetMember = false;
_.leftCount = 0;
_.leftDirty = false;
_.leftFreedom = 0;
_.leftNonzero = 0;
_.rightCount = 0;
_.rightDirty = false;
_.rightFreedom = 0;
_.rightNonzero = 0;
_.unweightedDivisor = 0;
_.unweightedTotal = 0;
_.weightedDivisor = 0;
_.weightedTotal = 0;
$NodePair = function(this$static, n1, n2){
  this$static.n1 = n1;
  this$static.n2 = n2;
  return this$static;
};

equals_23 = function(obj){
  var np;
  if (obj != null && canCast(obj.typeId$, 48)) {
    np = dynamicCast(obj, 48);
    return np.n1 == this.n1 && np.n2 == this.n2;
  }
  return false;
};

getClass_110 = function(){
  return Lorg_eclipse_draw2d_graph_NodePair_2_classLit;
};

hashCode_22 = function(){
  return getHashCode(this.n1) ^ getHashCode(this.n2);
};

toString_21 = function(){
  return '[' + this.n1 + ', ' + this.n2 + ']';
};

NodePair = function(){
};

_ = NodePair.prototype = new Object_0();
_.equals$ = equals_23;
_.getClass$ = getClass_110;
_.hashCode$ = hashCode_22;
_.toString$ = toString_21;
_.typeId$ = 84;
_.n1 = null;
_.n2 = null;

$PopulateRanks = function(this$static){
  this$static.changes = $Stack(new Stack());
  return this$static;
};

getClass_115 = function(){
  return Lorg_eclipse_draw2d_graph_PopulateRanks_2_classLit;
};

revisit_1 = function(g){
  var change, cur, i, n, prev, r, rank;
  for (r = 0; r < g.ranks.ranks.size; ++r) {
    rank = $getRank(g.ranks, r);
    prev = null;
    for (n = 0; n < rank.size; ++n) {
      checkIndex(n, rank.size);
      cur = dynamicCast(rank.array[n], 21);
      cur.left = prev;
      if (prev) {
        prev.right = cur;
      }
      prev = cur;
    }
  }
  for (i = 0; i < this.changes.arrayList.size; ++i) {
    change = dynamicCast($get_0(this.changes.arrayList, i), 52);
    change.revert();
  }
};

visit_5 = function(g){
  var e, i, j, node;
  if (g.forestRoot) {
    for (i = g.forestRoot.outgoing.size - 1; i >= 0; --i)
      $removeEdge(g, $getEdge(g.forestRoot.outgoing, i));
    $removeNode(g, g.forestRoot);
  }
  g.ranks = $RankList(new RankList());
  for (i = 0; i < g.nodes.size; ++i) {
    node = $getNode(g.nodes, i);
    $add_0($getRank(g.ranks, node.rank), node);
  }
  for (i = 0; i < g.nodes.size; ++i) {
    node = $getNode(g.nodes, i);
    for (j = 0; j < node.outgoing.size;) {
      e = $getEdge(node.outgoing, j);
      if (e.target.rank - e.source.rank > 1)
        $push(this.changes, $VirtualNodeCreation(new VirtualNodeCreation(), e, g));
      else 
        ++j;
    }
  }
};

PopulateRanks = function(){
};

_ = PopulateRanks.prototype = new GraphVisitor();
_.getClass$ = getClass_115;
_.revisit = revisit_1;
_.visit = visit_5;
_.typeId$ = 88;

$depthFirstCutValue = function(this$static, edge, count){
  var cutvalue, e, i, list, multiplier, n;
  n = $getTreeTail(edge);
  n.workingInts[0] = count;
  cutvalue = 0;
  multiplier = edge.target == n?1:-1;
  list = n.outgoing;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.tree && e != edge) {
      count = $depthFirstCutValue(this$static, e, count);
      cutvalue += (e.cut - e.weight) * multiplier;
    }
     else {
      cutvalue -= e.weight * multiplier;
    }
  }
  list = n.incoming;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.tree && e != edge) {
      count = $depthFirstCutValue(this$static, e, count);
      cutvalue -= (e.cut - e.weight) * multiplier;
    }
     else {
      cutvalue += e.weight * multiplier;
    }
  }
  edge.cut = cutvalue;
  if (cutvalue < 0)
    $add_0(this$static.spanningTree, edge);
  n.workingInts[1] = count;
  return count + 1;
};

$enter = function(this$static, branch){
  var e, edges, i, incoming, j, minSlack, n, result;
  result = null;
  minSlack = 2147483647;
  incoming = dynamicCast(branch.workingData[1], 18).target != branch;
  for (i = 0; i < this$static.graph.nodes.size; ++i) {
    if (this$static.searchDirection)
      n = $getNode(this$static.graph.nodes, i);
    else 
      n = $getNode(this$static.graph.nodes, this$static.graph.nodes.size - 1 - i);
    if (branch.workingInts[0] <= n.workingInts[1] && n.workingInts[1] <= branch.workingInts[1]) {
      if (incoming)
        edges = n.incoming;
      else 
        edges = n.outgoing;
      for (j = 0; j < edges.size; ++j) {
    	checkIndex(j, edges.size);
        e = dynamicCast(edges.array[j], 18);
        if (!$subtreeContains(branch, $opposite(e, n)) && !e.tree && e.target.rank - e.source.rank - e.delta < minSlack) {
          result = e;
          minSlack = e.target.rank - e.source.rank - e.delta;
        }
      }
    }
  }
  return result;
};

$initCutValues = function(this$static){
  var e, i, root;
  root = $getNode(this$static.graph.nodes, 0);
  this$static.spanningTree = $EdgeList(new EdgeList());
  root.workingInts[0] = 1;
  root.workingInts[1] = 1;
  for (i = 0; i < root.outgoing.size; ++i) {
    e = $getEdge(root.outgoing, i);
    if ($indexOf(dynamicCast(root.workingData[0], 47), e, 0) == -1)
      continue;
    $setTreeMax(root, $depthFirstCutValue(this$static, e, root.workingInts[1]));
  }
  for (i = 0; i < root.incoming.size; ++i) {
    e = $getEdge(root.incoming, i);
    if ($indexOf(dynamicCast(root.workingData[0], 47), e, 0) == -1)
      continue;
    $setTreeMax(root, $depthFirstCutValue(this$static, e, root.workingInts[1]));
  }
};

$leave = function(this$static){
  var e, i, minCut, result, weight;
  result = null;
  minCut = 0;
  weight = -1;
  for (i = 0; i < this$static.spanningTree.size; ++i) {
    e = $getEdge(this$static.spanningTree, i);
    if (e.cut < minCut) {
      result = e;
      minCut = result.cut;
      weight = result.weight;
    }
     else if (e.cut == minCut && e.weight > weight) {
      result = e;
      weight = result.weight;
    }
  }
  return result;
};

$networkSimplexLoop = function(this$static){
  var commonAncestor, count, enter, enterHead, enterTail, leave, leaveHead, leaveTail;
  count = 0;
  while (!!(leave = $leave(this$static)) && count < 900) {
    ++count;
    leaveTail = $getTreeTail(leave);
    leaveHead = $getTreeHead(leave);
    enter = $enter(this$static, leaveTail);
    if (!enter)
      break;
    $remove_3(dynamicCast(leaveHead.workingData[0], 47), leave);
    setCheck(leaveTail.workingData, 1, null);
    leave.tree = false;
    $remove_3(this$static.spanningTree, leave);
    enterTail = enter.source;
    if (!(leaveTail.workingInts[0] <= enterTail.workingInts[1] && enterTail.workingInts[1] <= leaveTail.workingInts[1]))
      enterTail = enter.target;
    enterHead = $opposite(enter, enterTail);
    $updateSubgraph(this$static, enterTail);
    $add_0(dynamicCast(enterHead.workingData[0], 47), enter);
    setCheck(enterTail.workingData, 1, enter);
    enter.tree = true;
    $repairCutValues(this$static, enter);
    commonAncestor = enterHead;
    while (!(commonAncestor.workingInts[0] <= leaveHead.workingInts[1] && leaveHead.workingInts[1] <= commonAncestor.workingInts[1])) {
      $repairCutValues(this$static, dynamicCast(commonAncestor.workingData[1], 18));
      commonAncestor = $getTreeParent(commonAncestor);
    }
    while (leaveHead != commonAncestor) {
      $repairCutValues(this$static, dynamicCast(leaveHead.workingData[1], 18));
      leaveHead = $getTreeParent(leaveHead);
    }
    $updateMinMax(this$static, commonAncestor, commonAncestor.workingInts[0]);
    $tightenEdge(this$static, enter);
  }
};

$normalizeForest = function(this$static){
  var i, neighbor, neighbors, node, rootEdges, stack, tree;
  tree = $NodeList(new NodeList());
  $resetFlags_0(this$static.graph.nodes);
  this$static.graph.forestRoot.flag = true;
  rootEdges = this$static.graph.forestRoot.outgoing;
  stack = $Stack(new Stack());
  for (i = 0; i < rootEdges.size; ++i) {
	checkIndex(i, rootEdges.size);
    node = dynamicCast(rootEdges.array[i], 18).target;
    node.flag = true;
    $add_0(stack.arrayList, node);
    while (stack.arrayList.size != 0) {
      node = dynamicCast($pop(stack), 21);
      setCheck(tree.array, tree.size++, node);
      neighbors = $Node$1(new Node$1(), node);
      while ($hasNext_1(neighbors)) {
        neighbor = $next_4(neighbors);
        if (!neighbor.flag) {
          neighbor.flag = true;
          $add_0(stack.arrayList, neighbor);
        }
      }
    }
    $normalizeRanks(tree);
    tree.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
    tree.size = 0;
  }
};

$repairCutValues = function(this$static, edge){
  var cutvalue, e, i, list, multiplier, n;
  $remove_3(this$static.spanningTree, edge);
  n = $getTreeTail(edge);
  cutvalue = 0;
  multiplier = edge.target == n?1:-1;
  list = n.outgoing;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.tree && e != edge)
      cutvalue += (e.cut - e.weight) * multiplier;
    else 
      cutvalue -= e.weight * multiplier;
  }
  list = n.incoming;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.tree && e != edge)
      cutvalue -= (e.cut - e.weight) * multiplier;
    else 
      cutvalue += e.weight * multiplier;
  }
  edge.cut = cutvalue;
  if (cutvalue < 0)
    $add_0(this$static.spanningTree, edge);
};

$setTreeMax = function(n, value){
  n.workingInts[1] = value;
};

$subtreeContains = function(parent_0, child){
  return parent_0.workingInts[0] <= child.workingInts[1] && child.workingInts[1] <= parent_0.workingInts[1];
};

$tightenEdge = function(this$static, edge){
  var delta, i, n, tail;
  tail = $getTreeTail(edge);
  delta = edge.target.rank - edge.source.rank - edge.delta;
  if (tail == edge.target)
    delta = -delta;
  for (i = 0; i < this$static.graph.nodes.size; ++i) {
    n = $getNode(this$static.graph.nodes, i);
    if (tail.workingInts[0] <= n.workingInts[1] && n.workingInts[1] <= tail.workingInts[1])
      n.rank += delta;
  }
};

$updateMinMax = function(this$static, root, count){
  var edges, i;
  root.workingInts[0] = count;
  edges = dynamicCast(root.workingData[0], 47);
  for (i = 0; i < edges.size; ++i) {
	checkIndex(i, edges.size);
    count = $updateMinMax(this$static, $getTreeTail(dynamicCast(edges.array[i], 18)), count);
  }
  root.workingInts[1] = count;
  return count + 1;
};

$updateSubgraph = function(this$static, root){
  var flip, rootParent;
  flip = dynamicCast(root.workingData[1], 18);
  if (flip) {
    rootParent = $getTreeParent(root);
    $remove_3(dynamicCast(rootParent.workingData[0], 47), flip);
    $updateSubgraph(this$static, rootParent);
    setCheck(root.workingData, 1, null);
    setCheck(rootParent.workingData, 1, flip);
    $repairCutValues(this$static, flip);
    $add_0(dynamicCast(root.workingData[0], 47), flip);
  }
};

$visit_1 = function(this$static, graph){
  this$static.graph = graph;
  $initCutValues(this$static);
  $networkSimplexLoop(this$static);
  if (!graph.forestRoot)
    $normalizeRanks(graph.nodes);
  else 
    $normalizeForest(this$static);
};

getClass_116 = function(){
  return Lorg_eclipse_draw2d_graph_RankAssignmentSolver_2_classLit;
};

visit_6 = function(graph){
  $visit_1(this, graph);
};

RankAssignmentSolver = function(){
};

_ = RankAssignmentSolver.prototype = new SpanningTreeVisitor();
_.getClass$ = getClass_116;
_.visit = visit_6;
_.typeId$ = 90;
_.graph = null;
_.searchDirection = false;
_.spanningTree = null;

$assignIncomingSortValues = function(this$static){
  var n;
  this$static.rankSize = this$static.rank.total;
  this$static.prevRankSize = $getRank(this$static.g.ranks, this$static.currentRow - 1).total;
  if (this$static.currentRow < this$static.g.ranks.ranks.size - 1)
    this$static.nextRankSize = $getRank(this$static.g.ranks, this$static.currentRow + 1).total;
  for (n = 0; n < this$static.rank.size; ++n) {
    this$static.node = $getNode(this$static.rank, n);
    $sortValueIncoming(this$static);
  }
};

$assignOutgoingSortValues = function(this$static){
  var n;
  this$static.rankSize = this$static.rank.total;
  this$static.prevRankSize = $getRank(this$static.g.ranks, this$static.currentRow + 1).total;
  if (this$static.currentRow > 1)
    this$static.nextRankSize = $getRank(this$static.g.ranks, this$static.currentRow - 1).total;
  for (n = 0; n < this$static.rank.size; ++n) {
    this$static.node = $getNode(this$static.rank, n);
    $sortValueOutgoing(this$static);
  }
};

$evaluateNodeIncoming = function(this$static){
  var change, dl, dr, e, i, incoming, l, n, r, previous;
  change = false;
  incoming = this$static.node.incoming;
  do {
    change = false;
    for (i = 0; i < incoming.size - 1; ++i) {
      checkIndex(i, incoming.size);
      var index1 = dynamicCast(incoming.array[i], 18).source.index;
      checkIndex(i + 1, incoming.size);
      var index2 = dynamicCast(incoming.array[i + 1], 18).source.index;
      if (index1 > index2) {
    	checkIndex(i, incoming.size);
    	e = dynamicCast(incoming.array[i], 18);
    	checkIndex(i + 1, incoming.size);
        $set_0(incoming, i, incoming.array[i + 1]);
        checkIndex(i + 1, incoming.size);
        previous = incoming.array[i + 1];
        setCheck(incoming.array, i + 1, e);
        change = true;
      }
    }
  }
   while (change);
  n = incoming.size;
  if (n == 0) {
    return this$static.node.index * this$static.prevRankSize / this$static.rankSize;
  }
  if (n % 2 == 1) {
	checkIndex(~~(n / 2), incoming.size);
    return dynamicCast(incoming.array[~~(n / 2)], 18).source.index;
  }
  checkIndex(~~(n / 2) - 1, incoming.size);
  l = dynamicCast(incoming.array[~~(n / 2) - 1], 18).source.index;
  checkIndex(~~(n / 2), incoming.size);
  r = dynamicCast(incoming.array[~~(n / 2)], 18).source.index;
  if (this$static.progress >= 0.8 && n > 2) {
	checkIndex(0, incoming.size);
    dl = l - dynamicCast(incoming.array[0], 18).source.index;
    checkIndex(n - 1, incoming.size);
    dr = dynamicCast(incoming.array[n - 1], 18).source.index - r;
    if (dl < dr)
      return l;
    if (dl > dr)
      return r;
  }
  if (this$static.progress > 0.25 && this$static.progress < 0.75) {
    if (Math.random() < 0.5)
      return (l + l + r) / 3;
    else 
      return (r + r + l) / 3;
  }
  return (l + r) / 2;
};

$evaluateNodeOutgoing = function(this$static){
  var change, dl, dr, e, i, l, n, outgoing, r, previous;
  change = false;
  outgoing = this$static.node.outgoing;
  do {
    change = false;
    for (i = 0; i < outgoing.size - 1; ++i) {
      checkIndex(i, outgoing.size);
      var index1 = dynamicCast(outgoing.array[i], 18).target.index;
      checkIndex(i + 1, outgoing.size);
      var index2 = dynamicCast(outgoing.array[i + 1], 18).target.index;
      if (index1 > index2) {
    	checkIndex(i, outgoing.size);
    	e = dynamicCast(outgoing.array[i], 18);
    	checkIndex(i + 1, outgoing.size);
        $set_0(outgoing, i, outgoing.array[i + 1]);
        checkIndex(i + 1, outgoing.size);
        previous = outgoing.array[i + 1];
        setCheck(outgoing.array, i + 1, e);
        change = true;
      }
    }
  }
   while (change);
  n = outgoing.size;
  if (n == 0)
    return this$static.node.index * this$static.prevRankSize / this$static.rankSize;
  if (n % 2 == 1) {
	checkIndex(~~(n / 2), outgoing.size);
    return dynamicCast(outgoing.array[~~(n / 2)], 18).target.index;
  }
  checkIndex(~~(n / 2) - 1, outgoing.size);
  l = dynamicCast(outgoing.array[~~(n / 2) - 1], 18).target.index;
  checkIndex(~~(n / 2), outgoing.size);
  r = dynamicCast(outgoing.array[~~(n / 2)], 18).target.index;
  if (this$static.progress >= 0.8 && n > 2) {
	checkIndex(0, outgoing.size);
    dl = l - dynamicCast(outgoing.array[0], 18).target.index;
    checkIndex(n - 1, outgoing.size);
    dr = dynamicCast(outgoing.array[n - 1], 18).target.index - r;
    if (dl < dr)
      return l;
    if (dl > dr)
      return r;
  }
  if (this$static.progress > 0.25 && this$static.progress < 0.75) {
    if (Math.random() < 0.5)
      return (l + l + r) / 3;
    else 
      return (r + r + l) / 3;
  }
  return (l + r) / 2;
};

$init_2 = function(this$static, g){
  var i;
  this$static.g = g;
  for (i = 0; i < g.ranks.ranks.size; ++i) {
    this$static.rank = $getRank(g.ranks, i);
    sort(this$static.rank, new RankSorter$1());
    $assignIndices(this$static.rank);
  }
};

$sort = function(this$static){
  var change, i;
  do {
    change = false;
    for (i = 0; i < this$static.rank.size - 1; ++i)
      change |= $swap(this$static, i);
    if (!change)
      break;
    change = false;
    for (i = this$static.rank.size - 2; i >= 0; --i)
      change |= $swap(this$static, i);
  }
   while (change);
};

$sortRankIncoming = function(this$static, rank, row, progress){
  this$static.currentRow = row;
  this$static.rank = rank;
  this$static.progress = progress;
  $assignIncomingSortValues(this$static);
  $sort(this$static);
  $assignIndices(this$static.rank);
};

$sortRankOutgoing = function(this$static, rank, row, progress){
  this$static.currentRow = row;
  this$static.rank = rank;
  this$static.progress = progress;
  $assignOutgoingSortValues(this$static);
  $sort(this$static);
  $assignIndices(this$static.rank);
};

$sortValueIncoming = function(this$static){
  var value;
  this$static.node.sortValue = $evaluateNodeIncoming(this$static);
  value = $evaluateNodeOutgoing(this$static);
  if (value < 0)
    value = this$static.node.index * this$static.nextRankSize / this$static.rankSize;
  this$static.node.sortValue += value * this$static.progress;
};

$sortValueOutgoing = function(this$static){
  var value;
  this$static.node.sortValue = $evaluateNodeOutgoing(this$static);
  value = $evaluateNodeIncoming(this$static);
  if (value < 0)
    value = this$static.node.index * this$static.nextRankSize / this$static.rankSize;
  this$static.node.sortValue += value * this$static.progress;
};

$swap = function(this$static, i){
  var left, right;
  left = $getNode(this$static.rank, i);
  right = $getNode(this$static.rank, i + 1);
  if (left.sortValue <= right.sortValue)
    return false;
  $set_0(this$static.rank, i, right);
  $set_0(this$static.rank, i + 1, left);
  return true;
};

getClass_119 = function(){
  return Lorg_eclipse_draw2d_graph_RankSorter_2_classLit;
};

RankSorter = function(){
};

_ = RankSorter.prototype = new Object_0();
_.getClass$ = getClass_119;
_.typeId$ = 0;
_.currentRow = 0;
_.g = null;
_.nextRankSize = 0;
_.node = null;
_.prevRankSize = 0;
_.progress = 0;
_.rank = null;
_.rankSize = 0;
compare_2 = function(left, right){
  var leftNode = dynamicCast(left, 21);
  var rightNode = dynamicCast(right, 21);
  return -1 - -1;
};

getClass_118 = function(){
  return Lorg_eclipse_draw2d_graph_RankSorter$1_2_classLit;
};

RankSorter$1 = function(){
};

_ = RankSorter$1.prototype = new Object_0();
_.compare = compare_2;
_.getClass$ = getClass_118;
_.typeId$ = 0;
getClass_121 = function(){
  return Lorg_eclipse_draw2d_graph_RevertableChange_2_classLit;
};

revert = function(){
};

RevertableChange = function(){
};

_ = RevertableChange.prototype = new Object_0();
_.getClass$ = getClass_121;
_.revert = revert;
_.typeId$ = 91;
getClass_122 = function(){
  return Lorg_eclipse_draw2d_graph_RouteEdges_2_classLit;
};

revisit_2 = function(g){
  var edge, i, list;
  for (i = 0; i < g.edges.size; ++i) {
    edge = dynamicCast($get_0(g.edges, i), 18);
    edge.start = new rmpw.diagrams.render.util.Point( $getSourceOffset(edge) + edge.source.x, edge.source.y + edge.source.height);
    edge.end = new rmpw.diagrams.render.util.Point( $getTargetOffset(edge) + edge.target.x, edge.target.y);
    if (edge.vNodes)
      routeLongEdge(edge, g);
    else {
      list = new rmpw.diagrams.render.util.PointList();
      list.addPoint_1(edge.start);
      list.addPoint_1(edge.end);
      $setPoints_0(edge, list);
    }
  }
};

routeLongEdge = function(edge, g){
  var i, neighbor, node, o, padding, path, router;
  router = new rmpw.diagrams.layout.client.routers.ShortestPathRouter();
  
  path = new rmpw.diagrams.layout.client.routers.Path(
		  new rmpw.diagrams.layout.client.routers.Vertex(edge.start.x, edge.start.y, null), 
		  new rmpw.diagrams.layout.client.routers.Vertex(edge.end.x, edge.end.y, null), null);
  
  $add_0(router.userPaths, path);
  $add_0(router.workingPaths, path);
  for (i = 0; i < edge.vNodes.size; ++i) {
    node = dynamicCast($get_0(edge.vNodes, i), 54);
    if (node.left) {
      neighbor = node.left;
      o = new rmpw.diagrams.render.util.Rectangle(neighbor.x, neighbor.y, neighbor.width, neighbor.height);
      padding = $getPadding(g, neighbor);
      o.width += padding.right + padding.left;
      o.width += 20;
      o.x -= padding.left + 10;
      o.union(new rmpw.diagrams.render.util.Point(o.x, o.y).translate(-100000, 2));
      router.internalAddObstacle(new rmpw.diagrams.layout.client.routers.Obstacle(o.x, o.y, o.width, o.height, router));
    }
    if (node.right) {
      neighbor = node.right;
      o = new rmpw.diagrams.render.util.Rectangle(neighbor.x, neighbor.y, neighbor.width, neighbor.height);
      padding = $getPadding(g, neighbor);
      o.width += padding.right + padding.left;
      o.width += 20;
      o.x -= padding.left + 10;
      o.union(new rmpw.diagrams.render.util.Point(o.x, o.y).translate(100000, 2));
      router.internalAddObstacle(new rmpw.diagrams.layout.client.routers.Obstacle(o.x, o.y, o.width, o.height, router));
    }
  }
  router.spacing = 0;
  router.solve_1();
  $setPoints_0(edge, path.points);
};

RouteEdges = function(){
};

_ = RouteEdges.prototype = new GraphVisitor();
_.getClass$ = getClass_122;
_.revisit = revisit_2;
_.typeId$ = 92;


$TightSpanningTreeSolver = function(this$static){
  this$static.candidates = $TightSpanningTreeSolver$CandidateList(new TightSpanningTreeSolver$CandidateList());
  this$static.members = $NodeList(new NodeList());
  return this$static;
};

$addEdge_0 = function(this$static, edge){
  var delta, node;
  delta = edge.target.rank - edge.source.rank - edge.delta;
  edge.tree = true;
  if (edge.target.flag) {
    delta = -delta;
    node = edge.source;
    setCheck(node.workingData, 1, edge);
    $add_0(dynamicCast(edge.target.workingData[0], 47), edge);
  }
   else {
    node = edge.target;
    setCheck(node.workingData, 1, edge);
    $add_0(dynamicCast(edge.source.workingData[0], 47), edge);
  }
  $adjustRank_0(this$static.members, delta);
  $addNode(this$static, node);
  return node;
};

$addNode = function(this$static, node){
  var e, i, list;
  node.flag = true;
  list = node.incoming;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.source.flag) {
      $remove_8(this$static.candidates, e);
    }
     else {
      if (!e.flag) {
        e.flag = true;
        $add_4(this$static.candidates, e);
      }
    }
  }
  list = node.outgoing;
  for (i = 0; i < list.size; ++i) {
	checkIndex(i, list.size);
    e = dynamicCast(list.array[i], 18);
    if (e.target.flag) {
      $remove_8(this$static.candidates, e);
    }
     else {
      if (!e.flag) {
        e.flag = true;
        $add_4(this$static.candidates, e);
      }
    }
  }
  $add_0(this$static.members, node);
};

$init_3 = function(this$static){
  var i, node;
  $resetFlags(this$static.graph.edges, true);
  $resetFlags_0(this$static.graph.nodes);
  for (i = 0; i < this$static.graph.nodes.size; ++i) {
    node = dynamicCast($get_0(this$static.graph.nodes, i), 21);
    setCheck(node.workingData, 0, $EdgeList(new EdgeList()));
  }
};

$solve_2 = function(this$static){
  var edge, i, minEdge, minSlack, root, slack;
  root = $getNode(this$static.graph.nodes, 0);
  setCheck(root.workingData, 1, null);
  $addNode(this$static, root);
  while (this$static.members.size < this$static.graph.nodes.size) {
    if (this$static.candidates.size == 0)
      throw $RuntimeException(new RuntimeException(), 'graph is not fully connected');
    minSlack = 2147483647;
    minEdge = null;
    for (i = 0; i < this$static.candidates.size && minSlack > 0; ++i) {
      edge = this$static.candidates.edges[i];
      slack = edge.target.rank - edge.source.rank - edge.delta;
      if (slack < minSlack) {
        minSlack = slack;
        minEdge = edge;
      }
    }
    $addEdge_0(this$static, minEdge);
  }
  $normalizeRanks(this$static.graph.nodes);
};

$visit_2 = function(this$static, graph){
  this$static.graph = graph;
  $init_3(this$static);
  $solve_2(this$static);
};

getClass_128 = function(){
  return Lorg_eclipse_draw2d_graph_TightSpanningTreeSolver_2_classLit;
};

visit_7 = function(graph){
  this.graph = graph;
  $init_3(this);
  $solve_2(this);
};

TightSpanningTreeSolver = function(){
};

_ = TightSpanningTreeSolver.prototype = new SpanningTreeVisitor();
_.getClass$ = getClass_128;
_.visit = visit_7;
_.typeId$ = 95;
_.graph = null;
$TightSpanningTreeSolver$CandidateList = function(this$static){
  this$static.edges = initDim(_3Lorg_eclipse_draw2d_graph_Edge_2_classLit, 123, 18, 10, 0);
  return this$static;
};

$add_4 = function(this$static, edge){
  var newEdges;
  if (this$static.size == this$static.edges.length - 1) {
    newEdges = initDim(_3Lorg_eclipse_draw2d_graph_Edge_2_classLit, 123, 18, this$static.edges.length * 2, 0);
    arraycopy(this$static.edges, 0, newEdges, 0, this$static.edges.length);
    this$static.edges = newEdges;
  }
  this$static.edges[this$static.size++] = edge;
};

$remove_8 = function(this$static, edge){
  var i;
  for (i = 0; i < this$static.size; ++i) {
    if (this$static.edges[i] == edge) {
      this$static.edges[i] = this$static.edges[this$static.size - 1];
      --this$static.size;
      return;
    }
  }
  throw $RuntimeException(new RuntimeException(), 'Remove called on invalid Edge');
};

getClass_127 = function(){
  return Lorg_eclipse_draw2d_graph_TightSpanningTreeSolver$CandidateList_2_classLit;
};

TightSpanningTreeSolver$CandidateList = function(){
};

_ = TightSpanningTreeSolver$CandidateList.prototype = new Object_0();
_.getClass$ = getClass_127;
_.typeId$ = 0;
_.size = 0;
getClass_129 = function(){
  return Lorg_eclipse_draw2d_graph_TransposeMetrics_2_classLit;
};

revisit_3 = function(g){
  return;
};

visit_8 = function(g){
  return;
};

TransposeMetrics = function(){
};

_ = TransposeMetrics.prototype = new GraphVisitor();
_.getClass$ = getClass_129;
_.revisit = revisit_3;
_.visit = visit_8;
_.typeId$ = 96;

getClass_131 = function(){
  return Lorg_eclipse_draw2d_graph_VerticalPlacement_2_classLit;
};

visit_9 = function(g){
  var currentY, n, node, pad, rank, row, rowHeight;
  currentY = g.margin.top;
  g.rankLocations = initDim(_3I_classLit, 110, -1, g.ranks.ranks.size + 1, 1);
  for (row = 0; row < g.ranks.ranks.size; ++row) {
    g.rankLocations[row] = currentY;
    rank = $getRank(g.ranks, row);
    rowHeight = 0;
    rank.topPadding = rank.bottomPadding = 0;
    for (n = 0; n < rank.size; ++n) {
      checkIndex(n, rank.size);
      node = dynamicCast(rank.array[n], 21);
      pad = $getPadding(g, node);
      rowHeight = max_2(node.height, rowHeight);
      rank.topPadding = max_2(pad.top_0, rank.topPadding);
      rank.bottomPadding = max_2(pad.bottom, rank.bottomPadding);
    }
    currentY += rank.topPadding;
    $setDimensions(rank, currentY, rowHeight);
    currentY += rank.height + rank.bottomPadding;
  }
  g.rankLocations[row] = currentY;
  g.size.height = currentY;
};

VerticalPlacement = function(){
};

_ = VerticalPlacement.prototype = new GraphVisitor();
_.getClass$ = getClass_131;
_.visit = visit_9;
_.typeId$ = 98;
$VirtualNode = function(this$static, o){
  $$init_26(this$static);
  this$static.data = o;
  return this$static;
};

getClass_133 = function(){
  return Lorg_eclipse_draw2d_graph_VirtualNode_2_classLit;
};

toString_26 = function(){
  if (instanceOf(this.data, 18))
    return 'VN[' + ($indexOf(dynamicCast(this.data, 18).vNodes, this, 0) + 1) + '](' + this.data + ')';
  return 'N(' + this.data + ')';
};

VirtualNode = function(){
};

_ = VirtualNode.prototype = new Node();
_.getClass$ = getClass_133;
_.toString$ = toString_26;
_.typeId$ = 99;
$VirtualNodeCreation = function(this$static, edge, graph){
  var currentEdge, currentNode, i, offset, padding, prevNode, size;
  this$static.edge = edge;
  this$static.graph = graph;
  size = edge.target.rank - edge.source.rank - 1;
  offset = edge.source.rank + 1;
  prevNode = edge.source;
  this$static.nodes = initDim(_3Lorg_eclipse_draw2d_graph_Node_2_classLit, 126, 21, size, 0);
  this$static.edges = initDim(_3Lorg_eclipse_draw2d_graph_Edge_2_classLit, 123, 18, size + 1, 0);
  padding = new rmpw.diagrams.render.util.Insets(0, 10, 0, 10);
  for (i = 0; i < size; ++i) {
    setCheck(this$static.nodes, i, currentNode = $VirtualNode(new VirtualNode(), 'Virtual' + i + ':' + edge));
    currentNode.width = 1;
    currentNode.height = 0;
    currentNode.padding = padding;
    currentNode.rank = offset + i;
    $add_3($getRank(graph.ranks, offset + i), currentNode);
    currentEdge = $Edge_1(new Edge(), prevNode, currentNode, 1, edge.weight * 8);
    if (i == 0) {
      currentEdge.weight = edge.weight * 2;
      currentEdge.offsetSource = edge.offsetSource;
    }
    $add_0(graph.edges, this$static.edges[i] = currentEdge);
    $add_0(graph.nodes, currentNode);
    prevNode = currentNode;
  }
  currentEdge = $Edge_1(new Edge(), prevNode, edge.target, 1, edge.weight * 2);
  currentEdge.offsetTarget = edge.offsetTarget;
  $add_0(graph.edges, this$static.edges[this$static.edges.length - 1] = currentEdge);
  $removeEdge(graph, edge);
  return this$static;
};

getClass_132 = function(){
  return Lorg_eclipse_draw2d_graph_VirtualNodeCreation_2_classLit;
};

revert_0 = function(){
  var i;
  this.edge.start = this.edges[0].start;
  this.edge.end = this.edges[this.edges.length - 1].end;
  this.edge.vNodes = $NodeList(new NodeList());
  for (i = 0; i < this.edges.length; ++i) {
    $removeEdge(this.graph, this.edges[i]);
  }
  for (i = 0; i < this.nodes.length; ++i) {
    $add_0(this.edge.vNodes, this.nodes[i]);
    $removeNode(this.graph, this.nodes[i]);
  }
  $add_0(this.edge.source.outgoing, this.edge);
  $add_0(this.edge.target.incoming, this.edge);
  $add_0(this.graph.edges, this.edge);
};

VirtualNodeCreation = function(){
};

_ = VirtualNodeCreation.prototype = new RevertableChange();
_.getClass$ = getClass_132;
_.revert = revert_0;
_.typeId$ = 100;
_.edge = null;
_.edges = null;
_.graph = null;
_.nodes = null;

containsPoint = function(points, point){
	  var i, isOdd, n, pointsxy, x0, x1, y0, y1;
	  isOdd = false;
	  pointsxy = points.toIntArray();
	  n = pointsxy.length;
	  if (n > 3) {
	    x0 = pointsxy[n - 2];
	    y0 = pointsxy[n - 1];
	    for (i = 0; i < n; x0 = x1 , y0 = y1) {
	      x1 = pointsxy[i++];
	      y1 = pointsxy[i++];
	      if (y0 <= point.y && point.y < y1 && crossProduct_0(x1, y1, x0, y0, point.x, point.y) > 0)
	        isOdd = !isOdd;
	      if (y1 <= point.y && point.y < y0 && crossProduct_0(x0, y0, x1, y1, point.x, point.y) > 0)
	        isOdd = !isOdd;
	    }
	    if (isOdd)
	      return true;
	  }
	  return false;
	};

	crossProduct_0 = function(ax, ay, bx, by, cx, cy){
	  return (ax - cx) * (by - cy) - (ay - cy) * (bx - cx);
	};

	flattenSegments = function(points, straightLineTolerance){
	  var changed, i, ptNext, ptStart, ptTerm, seg, line, pt;
	  changed = false;
	  for (i = 0; i < points.size - 1; ++i) {
	    ptStart = points.getPoint( i);
	    ptTerm = null;
	    if (i + 1 < points.size)
	      ptTerm = points.getPoint( i + 1);
	    ptNext = null;
	    if (i + 2 < points.size)
	      ptNext = points.getPoint( i + 2);
	    if (points.size <= 2 || !ptTerm || !ptNext) {
	      return changed;
	    }
	    if (line = new rmpw.diagrams.render.util.LineSeg(ptStart, ptNext) , pt = line.perpIntersect(ptTerm.x, ptTerm.y) , compare_0(fromDouble(round0(Math.sqrt(pt.getPreciseDistance2(new rmpw.diagrams.render.util.Point( ptTerm.x, ptTerm.y))))), fromInt(straightLineTolerance)) < 0) {
	      removePoint(points, i + 1);
	      seg = new rmpw.diagrams.render.util.Ray(ptStart, ptTerm);
	      if (abs_0(seg.y) < straightLineTolerance) {
	    	  points.setPoint(new rmpw.diagrams.render.util.Point( ptNext.x, ptStart.y), i + 1);
	      }
	       else if (abs_0(seg.x) < straightLineTolerance) {
	    	   points.setPoint(new rmpw.diagrams.render.util.Point( ptStart.x, ptNext.y), i + 1);
	      }
	      changed = true;
	    }
	  }
	  return changed;
	};

	normalizeSegments = function(points, straightLineTolerance){
	  var diffX, diffY, hasChanged, i, nextLength, pt1, pt2;
	  hasChanged = false;
	  for (i = 1; i < points.size - 1; ++i) {
	    pt1 = points.getPoint( i);
	    pt2 = points.getPoint( i - 1);
	    diffX = pt1.x - pt2.x;
	    diffY = pt1.y - pt2.y;
	    nextLength = Math.sqrt(diffX * diffX + diffY * diffY);
	    if (nextLength <= straightLineTolerance) {
	    	points.removePoint(i--);
	      hasChanged = true;
	    }
	  }
	  hasChanged |= flattenSegments(points, straightLineTolerance);
	  if (hasChanged)
	    normalizeSegments(points, straightLineTolerance);
	  return hasChanged;
	};

	removePoint = function(points, index){
	  var i, removedPt;
	  removedPt = points.getPoint( index);
	  for (i = index; i < points.size - 1; ++i) {
		  points.setPoint(points.getPoint( i + 1), i);
	  }
	  points.setSize(points.size - 1);
	  return removedPt;
	};

	$CleanupBorderNodeEdges = function(this$static, g){
	  this$static.g = g;
	  return this$static;
	};

	$cleanup_0 = function(this$static){
	  var i;
	  for (i = 0; i < this$static.g.edges.size; ++i) {
	    $getEdge(this$static.g.edges, i);
	  }
	};

	getClass_135 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_CleanupBorderNodeEdges_2_classLit;
	};

	CleanupBorderNodeEdges = function(){
	};

	_ = CleanupBorderNodeEdges.prototype = new Object_0();
	_.getClass$ = getClass_135;
	_.typeId$ = 0;
	_.g = null;
	$EdgeEndPointsAssignment = function(this$static, g){
	  this$static.graph = g;
	  return this$static;
	};

	$assignEdgesEndPoints = function(this$static){
	  var e, i, node;
	  for (i = 0; i < this$static.graph.edges.size; ++i) {
	    e = $getEdge(this$static.graph.edges, i);
	    e.start = null;
	    e.end = null;
	  }
	  sort(this$static.graph.nodes, new EdgeEndPointsAssignment$1());
	  for (i = 0; i < this$static.graph.nodes.size; ++i) {
	    node = $getNode(this$static.graph.nodes, i);
	    $assignEndPointsForEdgesFromNode(node);
	  }
	};

	$assignEndPointsForEdgesFromNode = function(node){
	  var i, incoming, outgoing;
	  incoming = $EdgeList(new EdgeList());
	  outgoing = $EdgeList(new EdgeList());
	  $ArrayList(new ArrayList());
	  incoming = node.incoming;
	  outgoing = node.outgoing;
	  for (i = 0; i < incoming.size; ++i) {
		checkIndex(i, incoming.size);
	    $setEndPoint_0(dynamicCast(incoming.array[i], 18), new rmpw.diagrams.render.util.Point( node.x + $getOffsetIncoming(node), node.y));
	  }
	  for (i = 0; i < outgoing.size; ++i) {
		checkIndex(i, outgoing.size);
	    $setStartPoint_0(dynamicCast(outgoing.array[i], 18), new rmpw.diagrams.render.util.Point( node.x + $getOffsetOutgoing(node), node.y + node.height));
	  }
	};

	$setEndPoint_0 = function(e, p){
	  if (!p) {
	    p = new rmpw.diagrams.render.util.Point( e.target.x + $getOffsetIncoming(e.target), e.target.y);
	  }
	  e.end = p;
	};

	$setStartPoint_0 = function(e, p){
	  if (!p) {
	    p = new rmpw.diagrams.render.util.Point( e.source.x + $getOffsetOutgoing(e.source), e.source.y + e.source.height);
	  }
	  e.start = p;
	};

	getClass_137 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgeEndPointsAssignment_2_classLit;
	};

	EdgeEndPointsAssignment = function(){
	};

	_ = EdgeEndPointsAssignment.prototype = new Object_0();
	_.getClass$ = getClass_137;
	_.typeId$ = 0;
	_.graph = null;
	compare_3 = function(arg0, arg1){
	  return arg0.width - arg1.width;
	};

	getClass_136 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgeEndPointsAssignment$1_2_classLit;
	};

	EdgeEndPointsAssignment$1 = function(){
	};

	_ = EdgeEndPointsAssignment$1.prototype = new Object_0();
	_.compare = compare_3;
	_.getClass$ = getClass_136;
	_.typeId$ = 0;
	$EdgesRouter = function(this$static, g){
	  this$static.g = g;
	  return this$static;
	};

	$getPathEndPoint = function(e){
	  if (!e.end) {
	    e.end = new rmpw.diagrams.render.util.Point( e.target.x + $getOffsetIncoming(e.target), e.target.y);
	  }
	  return e.end;
	};

	$getPathStartPoint = function(e){
	  if (!e.start) {
	    e.start = new rmpw.diagrams.render.util.Point( e.source.x + $getOffsetOutgoing(e.source), e.source.y + e.source.height);
	  }
	  return e.start;
	};

	$routeDefaultEdge = function(this$static, edge, extraObstacle){
	  var height, i, left, node, path, rankHeight, right, router, width;
	  router = new rmpw.diagrams.layout.client.routers.ShortestPathRouter();
	  
	  var start = $getPathStartPoint(edge);
	  var end = $getPathEndPoint(edge);
	  path = new rmpw.diagrams.layout.client.routers.Path(
			  new rmpw.diagrams.layout.client.routers.Vertex(start.x, start.y, null), 
			  new rmpw.diagrams.layout.client.routers.Vertex(end.x, end.y, null), null);
	  
	  $add_0(router.userPaths, path);
	  $add_0(router.workingPaths, path);
	  if (extraObstacle) {
		  router.internalAddObstacle(new rmpw.diagrams.layout.client.routers.Obstacle(extraObstacle.x, extraObstacle.y, extraObstacle.width, extraObstacle.height, router));
	  }
	  if (edge.vNodes) {
	    for (i = 0; i < edge.vNodes.size; ++i) {
	      node = $getNode(edge.vNodes, i);
	      rankHeight = getRankHeightFromNode(node, this$static.g);
	      if (node.left) {
	        right = node.left.x + node.left.width + $getPadding(this$static.g, node.left).right + 10;
	        width = right > 10000?right:10000;
	        height = rankHeight > 2?rankHeight:2;
	        router.addObstacle_0(new rmpw.diagrams.render.util.Rectangle(right - width, node.left.y, width, height));
	      }
	      if (node.right) {
	        left = node.right.x - $getPadding(this$static.g, node.right).left - 10;
	        width = max_2(this$static.g.size.width - left, 10000);
	        height = rankHeight > 2?rankHeight:2;
	        router.addObstacle_0(new rmpw.diagrams.render.util.Rectangle(left, node.right.y, width, height));
	      }
	    }
	  }
	  router.spacing = 0;
	  router.solve_1();
	  edge.points.removeAllPoints();
	  edge.points.addAll(path.points);
	  
	  // reset ends to center
	  var pt = new rmpw.diagrams.render.util.Point(edge.source.x + (edge.source.width / 2), edge.source.y + (edge.source.height / 2));
	  edge.points.setPoint(pt, 0);
	  pt = new rmpw.diagrams.render.util.Point(edge.target.x + (edge.target.width / 2), edge.target.y + (edge.target.height / 2));
	  edge.points.setPoint(pt, edge.points.size - 1);
	};

	$routeEdges = function(this$static){
	  var i;
	  for (i = 0; i < this$static.g.nodes.size; ++i) {
	    $routeEdgesFromNode(this$static, $getNode(this$static.g.nodes, i));
	  }
	};

	$routeEdgesFromNode = function(this$static, n){
	  var diff, e, guideNode, i, leftEdges, rankHeight, rightEdges;
	  leftEdges = $ArrayList(new ArrayList());
	  rightEdges = $ArrayList(new ArrayList());
	  rankHeight = getRankHeightFromNode(n, this$static.g);
	  for (i = 0; i < n.outgoing.size; ++i) {
	    e = $getEdge(n.outgoing, i);
	    if ($shouldAccountForObstaclesInSourceRank(e, rankHeight)) {
	      guideNode = !e.vNodes?e.target:$getNode(e.vNodes, 0);
	      diff = guideNode.x + $getOffsetIncoming(guideNode) - e.source.x - $getOffsetOutgoing(e.source);
	      if (!!n.left && diff < 0) {
	        setCheck(leftEdges.array, leftEdges.size++, e);
	      }
	       else if (!!n.right && diff > 0) {
	        setCheck(rightEdges.array, rightEdges.size++, e);
	      }
	       else {
	        $routeDefaultEdge(this$static, e, null);
	      }
	    }
	     else {
	      $routeDefaultEdge(this$static, e, null);
	    }
	  }
	  sort(leftEdges, $EdgesRouter$EdgeComparator(new EdgesRouter$EdgeComparator(), false));
	  sort(rightEdges, $EdgesRouter$EdgeComparator(new EdgesRouter$EdgeComparator(), true));
	  $routeLeftEdges(this$static, leftEdges, n);
	  $routeRightEdges(this$static, rightEdges, n);
	};

	$routeLeftEdges = function(this$static, edges, n){
	  var e, height, i, median, obstacleX, offset, rankHeight, width;
	  if (edges.size == 0) {
	    return;
	  }
	  rankHeight = getRankHeightFromNode(n, this$static.g);
	  obstacleX = n.left.x + n.left.width + $getPadding(this$static.g, n.left).right;
	  median = n.x + $getOffsetOutgoing(n);
	  for (i = 0; i < edges.size; ++i) {
		checkIndex(i, edges.size);
	    e = dynamicCast(edges.array[i], 18);
	    offset = min_0(10, ~~((obstacleX - median < 0?-(obstacleX - median):obstacleX - median) / (edges.size + 1 - i)));
	    obstacleX = min_0(obstacleX + offset, e.start.x - 1);
	    width = obstacleX > 10000?obstacleX:10000;
	    height = rankHeight > 2?rankHeight:2;
	    $routeDefaultEdge(this$static, e, new rmpw.diagrams.render.util.Rectangle(obstacleX - width, e.source.left.y, width, height));
	  }
	};

	$routeRightEdges = function(this$static, edges, n){
	  var e, height, i, median, obstacleX, offset, rankHeight, width;
	  if (edges.size == 0) {
	    return;
	  }
	  rankHeight = getRankHeightFromNode(n, this$static.g);
	  obstacleX = n.right.x - $getPadding(this$static.g, n.right).left;
	  median = n.x + $getOffsetOutgoing(n);
	  for (i = 0; i < edges.size; ++i) {
		checkIndex(i, edges.size);
	    e = dynamicCast(edges.array[i], 18);
	    offset = min_0(10, ~~((obstacleX - median < 0?-(obstacleX - median):obstacleX - median) / (edges.size + 1 - i)));
	    obstacleX = max_2(obstacleX - offset, e.start.x + 1);
	    width = max_2(this$static.g.size.width - obstacleX, 10000);
	    height = rankHeight > 2?rankHeight:2;
	    $routeDefaultEdge(this$static, e, new rmpw.diagrams.render.util.Rectangle(obstacleX, e.source.right.y, width, height));
	  }
	};

	$shouldAccountForObstaclesInSourceRank = function(e, rankHeight){
	  if (rankHeight == e.source.height) {
	    return false;
	  }
	  return true;
	};

	getClass_139 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgesRouter_2_classLit;
	};

	EdgesRouter = function(){
	};

	_ = EdgesRouter.prototype = new Object_0();
	_.getClass$ = getClass_139;
	_.typeId$ = 0;
	_.g = null;
	$EdgesRouter$EdgeComparator = function(this$static, reverse){
	  this$static.reverse = reverse;
	  return this$static;
	};

	compare_4 = function(e1, e2){
	  var diff, guideNode1, guideNode2;
	  guideNode1 = !e1.vNodes?e1.target:$getNode(e1.vNodes, 0);
	  guideNode2 = !e2.vNodes?e2.target:$getNode(e2.vNodes, 0);
	  diff = guideNode1.x + $getOffsetIncoming(guideNode1) - guideNode2.x - $getOffsetIncoming(guideNode2);
	  return this.reverse?-diff:diff;
	};

	getClass_138 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgesRouter$EdgeComparator_2_classLit;
	};

	EdgesRouter$EdgeComparator = function(){
	};

	_ = EdgesRouter$EdgeComparator.prototype = new Object_0();
	_.compare = compare_4;
	_.getClass$ = getClass_138;
	_.typeId$ = 0;
	_.reverse = false;
	$GMFDirectedGraphLayout = function(this$static){
	  this$static.steps = $ArrayList(new ArrayList());
	  $add_0(this$static.steps, new TransposeMetrics());
	  $add_0(this$static.steps, $BreakCycles(new BreakCycles()));
	  $add_0(this$static.steps, new RouteEdges());
	  $add_0(this$static.steps, $InitialRankSolver(new InitialRankSolver()));
	  $add_0(this$static.steps, $TightSpanningTreeSolver(new TightSpanningTreeSolver()));
	  $add_0(this$static.steps, new RankAssignmentSolver());
	  $add_0(this$static.steps, $PopulateRanks(new PopulateRanks()));
	  $add_0(this$static.steps, new VerticalPlacement());
	  $add_0(this$static.steps, $MinCross(new MinCross()));
	  $add_0(this$static.steps, new LocalOptimizer());
	  $add_0(this$static.steps, $HorizontalPlacement(new HorizontalPlacement()));
	  return this$static;
	};

	$visit_3 = function(this$static, graph){
	  storeNodesSizes(graph);
	  $visit(this$static, graph);
	  recallNodesSizes(graph);
	  invertEdges(graph);
	  $assignEdgesEndPoints($EdgeEndPointsAssignment(new EdgeEndPointsAssignment(), graph));
	  $preRouteEdges($PreRouteEdges(new PreRouteEdges(), graph));
	  $routeEdges($EdgesRouter(new EdgesRouter(), graph));
	  invertEdges(graph);
	  $cleanup_0($CleanupBorderNodeEdges(new CleanupBorderNodeEdges(), graph));
	};

	getClass_140 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_GMFDirectedGraphLayout_2_classLit;
	};

	GMFDirectedGraphLayout = function(){
	};

	_ = GMFDirectedGraphLayout.prototype = new DirectedGraphLayout();
	_.getClass$ = getClass_140;
	_.typeId$ = 0;
	getNodeRank = function(n, g){
	  var i, rank;
	  for (i = 0; i < g.ranks.ranks.size; ++i) {
	    rank = $getRank(g.ranks, i);
	    if (rank.size != 0) {
	      checkIndex(0, rank.size);
	      if (n.y == dynamicCast(rank.array[0], 21).y) {
	        return rank;
	      }
	    }
	  }
	  return null;
	};

	getRankHeightFromNode = function(n, g){
	  var i, rank, rankHeight;
	  rankHeight = -1;
	  rank = getNodeRank(n, g);
	  if (rank) {
	    for (i = 0; i < rank.size; ++i) {
	      checkIndex(i, rank.size);
	      rankHeight = max_2(rankHeight, dynamicCast(rank.array[i], 21).height);
	    }
	  }
	  return rankHeight;
	};

	invertEdges = function(g){
	  var e, i;
	  for (i = 0; i < g.edges.size; ++i) {
	    e = $getEdge(g.edges, i);
	    if (e.isInvert) {
	      $invert(e);
	    }
	  }
	};

	recallNodesSizes = function(g){
	  var i;
	  for (i = 0; i < g.nodes.size; ++i) {
	    $getNode(g.nodes, i);
	  }
	};

	storeNodesSizes = function(g){
	  var i;
	  for (i = 0; i < g.nodes.size; ++i) {
	    $getNode(g.nodes, i);
	  }
	};

	$PreRouteEdges = function(this$static, g){
	  this$static.g = g;
	  return this$static;
	};

	$preRouteEdges = function(this$static){
	  var i;
	  for (i = 0; i < this$static.g.nodes.size; ++i) {
	    $getNode(this$static.g.nodes, i);
	  }
	};

	getClass_141 = function(){
	  return Lorg_eclipse_gmf_runtime_draw2d_ui_graph_PreRouteEdges_2_classLit;
	};

	PreRouteEdges = function(){
	};

	_ = PreRouteEdges.prototype = new Object_0();
	_.getClass$ = getClass_141;
	_.typeId$ = 0;
	_.g = null;

Lorg_eclipse_draw2d_graph_GraphVisitor_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'GraphVisitor'), Lorg_eclipse_draw2d_graph_BreakCycles_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'BreakCycles'), Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'CollapsedEdges'), Lorg_eclipse_draw2d_graph_DirectedGraphLayout_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'DirectedGraphLayout'), Lorg_eclipse_draw2d_graph_Edge_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'Edge'), Lorg_eclipse_draw2d_graph_EdgeList_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'EdgeList'), _3_3I_classLit = createForArray('', '[[I'), Lorg_eclipse_draw2d_graph_SpanningTreeVisitor_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'SpanningTreeVisitor'), Lorg_eclipse_draw2d_graph_HorizontalPlacement_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'HorizontalPlacement'), Lorg_eclipse_draw2d_graph_HorizontalPlacement$ClusterSet_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'HorizontalPlacement$ClusterSet'), Lorg_eclipse_draw2d_graph_InitialRankSolver_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'InitialRankSolver'), Lorg_eclipse_draw2d_graph_LocalOptimizer_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'LocalOptimizer'), Lorg_eclipse_draw2d_graph_MinCross_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'MinCross'), Lorg_eclipse_draw2d_graph_Node_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'Node'), Lorg_eclipse_draw2d_graph_Node$1_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'Node$1'), _3Lorg_eclipse_draw2d_graph_CollapsedEdges_2_classLit = createForArray('[Lorg.eclipse.draw2d.graph.', 'CollapsedEdges;'), _3Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit = createForArray('[Lorg.eclipse.draw2d.graph.', 'NodeCluster;'), Lorg_eclipse_draw2d_graph_NodeList_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'NodeList'), Lorg_eclipse_draw2d_graph_NodeCluster_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'NodeCluster'), Lorg_eclipse_draw2d_graph_NodePair_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'NodePair');
Lorg_eclipse_draw2d_graph_PopulateRanks_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'PopulateRanks'), Lorg_eclipse_draw2d_graph_Rank_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'Rank'), Lorg_eclipse_draw2d_graph_RankAssignmentSolver_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RankAssignmentSolver'), Lorg_eclipse_draw2d_graph_RankList_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RankList'), Lorg_eclipse_draw2d_graph_RankSorter_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RankSorter'), Lorg_eclipse_draw2d_graph_RankSorter$1_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RankSorter$1'), Lorg_eclipse_draw2d_graph_RevertableChange_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RevertableChange'), Lorg_eclipse_draw2d_graph_RouteEdges_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'RouteEdges');
Lorg_eclipse_draw2d_graph_TightSpanningTreeSolver_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'TightSpanningTreeSolver'), _3Lorg_eclipse_draw2d_graph_Edge_2_classLit = createForArray('[Lorg.eclipse.draw2d.graph.', 'Edge;'), Lorg_eclipse_draw2d_graph_TightSpanningTreeSolver$CandidateList_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'TightSpanningTreeSolver$CandidateList'), Lorg_eclipse_draw2d_graph_TransposeMetrics_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'TransposeMetrics');
Lorg_eclipse_draw2d_graph_VerticalPlacement_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'VerticalPlacement'), Lorg_eclipse_draw2d_graph_VirtualNode_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'VirtualNode'), _3Lorg_eclipse_draw2d_graph_Node_2_classLit = createForArray('[Lorg.eclipse.draw2d.graph.', 'Node;'), Lorg_eclipse_draw2d_graph_VirtualNodeCreation_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'VirtualNodeCreation');
Lorg_eclipse_gmf_runtime_draw2d_ui_graph_CleanupBorderNodeEdges_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'CleanupBorderNodeEdges'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgeEndPointsAssignment_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'EdgeEndPointsAssignment'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgeEndPointsAssignment$1_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'EdgeEndPointsAssignment$1'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgesRouter_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'EdgesRouter'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_EdgesRouter$EdgeComparator_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'EdgesRouter$EdgeComparator'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_GMFDirectedGraphLayout_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'GMFDirectedGraphLayout'), Lorg_eclipse_gmf_runtime_draw2d_ui_graph_PreRouteEdges_2_classLit = createForClass('org.eclipse.gmf.runtime.draw2d.ui.graph.', 'PreRouteEdges');

dojo.declare("rmpw.diagrams.layout.graph.GMFDirectedGraphLayout", rmpw.diagrams.layout.graph.AbstractGraphLayout, {
	
	runLayoutAlgorithm: function(graph) {
		$add(graph.nodes, 0, $Node(new Node(), 'Head'));
		$visit_3($GMFDirectedGraphLayout(new GMFDirectedGraphLayout()), graph);
		return true;
	}
});