/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2013. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.Graph");

dojo.require("rmpw.diagrams.layout.client.EdgeList");
dojo.require("rmpw.diagrams.layout.client.NodeList");

dojo.require("rmpw.diagrams.render.util.Insets");
dojo.require("rmpw.diagrams.render.util.Dimension");

$Rank = function(this$static){
	  $ArrayList(this$static);
	  this$static.hash = hashCode__devirtual$(new Object_0());
	  return this$static;
	};

	$add_3 = function(this$static, n){
	  setCheck(this$static.array, this$static.size++, n);
	};

	$assignIndices = function(this$static){
	  var i, mag, node;
	  this$static.total = 0;
	  for (i = 0; i < this$static.size; ++i) {
		checkIndex(i, this$static.size);
	    node = dynamicCast(this$static.array[i], 21);
	    mag = max_2(1, node.incoming.size + node.outgoing.size);
	    mag = mag < 5?mag:5;
	    this$static.total += mag;
	    node.index = this$static.total;
	    this$static.total += mag;
	  }
	};

	$setDimensions = function(this$static, location_0, rowHeight){
	  var i, n;
	  this$static.height = rowHeight;
	  for (i = 0; i < this$static.size; ++i) {
		checkIndex(i, this$static.size);
	    n = dynamicCast(this$static.array[i], 21);
	    n.y = location_0;
	    n.height = rowHeight;
	  }
	};

	equals_24 = function(o){
	  return (o == null?null:o) === this;
	};

	getClass_120 = function(){
	  return Lorg_eclipse_draw2d_graph_Rank_2_classLit;
	};

	hashCode_23 = function(){
	  return this.hash;
	};

	Rank = function(){
	};

	_ = Rank.prototype = new NodeList();
	_.equals$ = equals_24;
	_.getClass$ = getClass_120;
	_.hashCode$ = hashCode_23;
	_.typeId$ = 89;
	_.bottomPadding = 0;
	_.height = 0;
	_.topPadding = 0;
	_.total = 0;
	
$RankList = function(this$static){
	  this$static.ranks = $ArrayList(new ArrayList());
	  return this$static;
	};

	$getRank = function(this$static, rank){
	  while (this$static.ranks.size <= rank)
	    $add_0(this$static.ranks, $Rank(new Rank()));
	  return dynamicCast($get_0(this$static.ranks, rank), 53);
	};

	getClass_117 = function(){
	  return Lorg_eclipse_draw2d_graph_RankList_2_classLit;
	};

	RankList = function(){
	};

	_ = RankList.prototype = new Object_0();
	_.getClass$ = getClass_117;
	_.typeId$ = 0;
	
$DirectedGraph = function(this$static){
  this$static.defaultPadding = new rmpw.diagrams.render.util.Insets(30, 30, 30, 30);
  this$static.edges = $EdgeList(new EdgeList());
  this$static.nodes = $NodeList(new NodeList());
  this$static.ranks = $RankList(new RankList());
  this$static.margin = new rmpw.diagrams.render.util.Insets(0, 0, 0, 0);
  this$static.size = new rmpw.diagrams.render.util.Dimension(0, 0);
  return this$static;
};

$getPadding = function(this$static, node){
  var pad;
  pad = node.padding;
  if (!pad)
    return this$static.defaultPadding;
  return pad;
};

$removeEdge = function(this$static, edge){
	var j;
	$remove_3(this$static.edges, edge);

	if (edge.source) {
		$remove_3(edge.source.outgoing, edge);
	}

	if (edge.target) {
		$remove_3(edge.target.incoming, edge);
	}
	if (edge.vNodes)
		for (j = 0; j < edge.vNodes.size; ++j)
			$removeNode(this$static, dynamicCast($get_0(edge.vNodes, j), 21));
};

$removeNode = function(this$static, node){
  $remove_3(this$static.nodes, node);
  if (this$static.ranks)
    $remove_3($getRank(this$static.ranks, node.rank), node);
};

Lorg_eclipse_draw2d_graph_DirectedGraph_2_classLit = createForClass('org.eclipse.draw2d.graph.', 'DirectedGraph');

getClass_98 = function(){
  return Lorg_eclipse_draw2d_graph_DirectedGraph_2_classLit;
};

DirectedGraph = function(){
};

_ = DirectedGraph.prototype = new Object_0();
_.getClass$ = getClass_98;
_.typeId$ = 0;
_.cellLocations = null;
_.forestRoot = null;
_.rankLocations = null;
_.tensorSize = 0;
_.tensorStrength = 0;