/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.KeyStrokeDescriptor");

/**
 * Descriptor for a key stroke
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.KeyStrokeDescriptor", null, {
	constructor: function(args) {
		this.ctrlKey = args.ctrlKey ? args.ctrlKey : null;
		this.keyChar = args.keyChar && args.keyChar !== "" ? args.keyChar : null;
		this.keyCode = args.keyCode ? args.keyCode : null;
		this.charOrCode = args.charOrCode ? args.charOrCode : this.keyChar ? this.keyChar : this.keyCode;
		this.altKey = args.altKey? args.altKey : null;
		this.shiftKey = args.shiftKey ? args.shiftKey : null;
	},
			
	equals: function(e) {
		if (this.ctrlKey === e.ctrlKey &&
			this.charOrCode === e.charOrCode &&
			this.altKey === e.altKey &&
			this.shiftKey === e.shiftKey) {
			return true;
		}
		
		return false;
	},
	
	toString: function(e) {
		var keyString = "";
		if (this.ctrlKey) {
			keyString += "<Ctrl>";
		}
		if (this.altKey) {
			keyString += "<Shift>";
		}
		if (this.shiftKey) {
			keyString += "<Alt>";
		}
		if (this.charOrCode) {
			keyString += this.charOrCode;
		}
		
		return keyString;
	}	
});