/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.Layer");

dojo.require("dijit._Widget");

dojo.declare("rmpw.panner.Layer", dijit._Widget, {
	
	constrainWidth: false,
	
	_x: 0,
	_y: 0,
	_height: 0,
	_width: 0,
	
	_scale: 1,
	_parent: null,
	
	buildRendering: function() {
		this.inherited(arguments);
		this.domNode.style.position = "absolute";
		this.domNode.style.width = "100%";
	},
	
	postCreate: function() {
		if (!this.containerNode) {
			this.containerNode = this.domNode;
		}
	},
	
	resize: function(size) {
		if (this.constrainWidth) {
			if (size && size.w) {
				this.containerNode.style.width = size.w + "px";
				this._width = size.w;
			}
		} else {
			this._width = this.domNode.offsetWidth;
		}
		if (size && size.h) {
			this.containerNode.style.height = size.h + "px";
			this._height = size.h;
		}
	},
	
	getParent: function() {
		return this._parent;
	},
	
	getRoot: function() {
		var root = this;
		var p = this.getParent();
		while (p) {
			root = p;
			p = p.getParent();
		}
		return root;
	},
	
	getSize: function() {
		return {
			w: this._width,
			h: this._height
		};
	},
	
	getLocation: function() {
		return {
			x: this._x,
			y: this._y
		};
	},
	
	setLocation: function(x, y) {
		this._x = x;
		this._y = y;
	},
	
	getScale: function() {
		return this._scale;
	},
	
	setScale: function(scale) {
		this._scale = scale;
	},
	
	getViewBox: function() {
		return {
			w: this._width,
			h: this._height
		};
	}
});

})();