/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.MappingTrackedItem");

dojo.require("rmpw.panner.Tracker");

dojo.declare("rmpw.panner.MappingTrackedItem", rmpw.panner.Tracker.TrackedItem, {
	
	mapping: null,
	
	activate: function() {
		if (this.mapping.policies.graphNode) {
			this._changeHandle = dojo.connect(this.mapping.policies.graphNode, "refresh", this, function() {
				this.boundsChanged();
			});
		}
	},
	
	deactivate: function() {
		if (this._changeHandle) {
			dojo.disconnect(this._changeHandle);
			delete this._changeHandle;
		}
	},
	
	/*
	 * seems to expect absolute coordinates bounding reverse offset
	 */
	getBoundingBox: function() {
		var bb = this.mapping.policies.graphElement.getBounds();
		var offset = this.mapping.viewer.viewport.getOffset();
		this.mapping.policies.graphElement.translateToAbsolute(bb);
		bb.x -= offset.x;
		bb.y -= offset.y;
		return bb;
	}
});

})();