/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2010, 2011. All
 * Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("rmpw.jazz.ModelingPage");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("rmpw.jazz.ui.Layout");
dojo.require("rmpw.jazz.ui.Controls");

(function() {
	var PlatformUI = net.jazz.ajax.ui.PlatformUI;
	var controls = rmpw.jazz.ui.Controls.items;

	dojo.declare("rmpw.jazz.ModelingPage", [ dijit._Widget, dijit._Templated ],	{
		templateString : "<div><div dojoAttachPoint='hiJazzAttachPoint'></div></div>",
		layout : null,
		test : 1,
		tools : null,
		prefix : null,

		startup : function() {
			this.inherited(arguments);

			var options = {
					size: {h:0, w:0},
					configuration: this.configuration,
					definition: this.definition,
					tools : this.tools,
					settings : this.settings,
					prefix : this.prefix,
					isReadOnly: this.editor.editorInput.isReadOnly()
			};
			this.layout = new rmpw.jazz.ui.Layout(options);

			if (this.load) {
				this.layout.loadDiagram = this.load;
			}

			if (this.save) {
				this.layout.saveDiagram = this.save;
			}

			this.hiJazzAttachPoint
			.appendChild(this.layout.domNode);

			// Should this be in resize method?
			this.layout.layout();
			this.extend();
		},

		compact : function(s) {
			this.layout.resize(s);
		},

		addTool : function(tool) {
			this.layout.addTool(tool);
		},

		extend : function() {

		},

		resize : function(size) {
			var navBar = dojo.byId("jazz_app_internal_Navbar_0");
			navBar = navBar ? dojo.position(navBar) : {h:0};

			if (size) {
				if (!size.w) {
					size.w = navBar.w;
				}

				size.h -= navBar.h;

				this.layout.resize(size);
				return;
			}

			// needed for ModelingPage not nested in Design
			var s = dojo
			.marginBox(this.hiJazzAttachPoint.parentNode);
			var scc = dojo.marginBox(dojo
					.byId("content-cell"));
			s.h = scc.h - navBar.h;
			s.w = navBar.w;
			this.layout.resize(s);
		}
	});
})();