/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.widgets.PropertyDialog");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.ui.Dialog");

dojo.require("dojo.string");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmpw.widgets", "PropertyDialogMessages");
	
var messages = dojo.i18n.getLocalization("rmpw.widgets", "PropertyDialogMessages");

dojo.declare("rmpw.widgets.PropertyDialog", [dijit._Widget, dijit._Templated], {
	
	messages: messages,
	connections: null,
	
	textbox: null,
	
	widgetsInTemplate: true,
	templateString: '<div class="rmps-viewlets-validation-constraitns-chooser">' +
			'<div style="padding-left:2px;padding-top:3px;padding-bottom:3px;"><label>${name} Name: </label><div dojoAttachPoint="_input"></div></div>' +
			'<div dojoAttachPoint="_description" class="description"></div>' +
				'<div class="buttons">' +
					'<button dojoAttachPoint="_okButton" disabled>${messages.ok}</button> ' +
					'<button dojoAttachPoint="_cancelButton">${messages.cancel}</button>' +
				'</div>' +
			'</div>',
			
	// mixin
	defaultSelectedConstraintIds: null, // initial selection
	onOk: null,
	onCancel: null,
	
	_dialog: null,
	_model: null,
	_ok: false,
	
	callback: null,
	
	arguments: null,
	name : null,
    constructor: function( callback, args ){
	   this.callback = callback;
	   this.arguments = args;
   },
    postMixInProperties: function( ) {
	   if(this.arguments.name){
		   this.name = this.arguments.name;
	   }
    },	
	postCreate: function() {
        this.connections = [];
	
        this.textbox = new dijit.form.TextBox( {
				name: this.name, 
				type: "text"
			}, this._input );

        dojo.connect(this._okButton, "onclick", this, "_onOk");
        dojo.connect(this._cancelButton, "onclick", this, "hide");
    },
		
	destroy: function() {
		if (this._dialog) {
			this.hide();
		}
		this.inherited(arguments);
		
		for( var count=0; count < this.connections.length; count++ ) {
		   this.connections.disconnect();
		}
		this.connections = null;
	},
	
	keystroke: function(e){
		if(e.keyCode === dojo.keys.ESCAPE) {
			this.hide();
		} else {
			if(this.textbox.textbox.value.length === 0) {
				this._okButton.disabled = true;
			} else {
				this._okButton.disabled = false;
				
				// confirm on enter
				if(e.keyCode === dojo.keys.ENTER) {
					this._onOk();
					return;
				}
			}
		}
	},
	
	show: function() {
		this._ok = false;
		this._dialog = new jazz.ui.Dialog({
			contentNode: this.domNode,
			primaryTitle: messages.title,
			width: "270px",
			onClose: dojo.hitch(this, this._onCancel) 
		});
		
		this.textbox.startup();
		this.textbox.focus();
		
		this.connections.push( dojo.connect( this.textbox.textbox, "onkeyup", dojo.hitch( this, "keystroke" ) ) );
		return this._ok;
	},
	
	hide: function() {
		if (this._dialog) {
			this._dialog.close();
			this._dialog.destroy();
			delete this._dialog;
		}
	},
	
	_onOk: function() {
		this._ok = true;
		
		this.callback( this.textbox.textbox.value, this.arguments );
		
		this.hide();
		if (this.onOk) {
			this.onOk();
		}
	},
	
	_onCancel: function() {
		if (!this._ok && this.onCancel) {
			this.onCancel();
		}
	},
	
	_onSelectAll: function(){
	},
	
	_onDeselectAll: function(){
	}
});


}());