/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.Rectangle");

dojo.declare("rmpw.panner.Rectangle", null, {
	
	x: 0,
	y: 0,
	width: 0,
	height: 0,
	
	constructor: function(rect) {
		if (rect) {
			this.x = rect.x || 0;
			this.y = rect.y || 0;
			this.width = rect.width || 0;
			this.height = rect.height || 0;
		}
	},
	
	getLocation: function() {
		return {x: this.x, y: this.y};
	},
	
	setLocation: function(x, y) {
		this.x = x;
		this.y = y;
		return this;
	},
	
	getSize: function() {
		return {width: this.width, height: this.height};
	},
	
	setSize: function(width, height) {
		this.width = width;
		this.height = height;
		return this;
	},
	
	scale: function(scale) {
		return this.scaleXY(scale, scale);
	},
	
	scaleXY: function(scaleX, scaleY) {
		var oldX = this.x;
		var oldY = this.y;
		this.x = Math.floor(this.x * scaleX);
		this.y = Math.floor(this.y * scaleY);
		this.width = Math.ceil((oldX + this.width) * scaleX) - this.x;
		this.height = Math.ceil((oldY + this.height) * scaleY) - this.y;
		return this;
	}
});

})();