/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

var dojoConfig= {
        has: {
            "host-rhino": true,
            "css-user-select": 0
        },
        parseOnLoad:false, 
        useGfxLayout:true,
		skipIeDomLoaded:true,
		forceGfxRenderer:'svg'
    };

var location = {
	protocol: "https",
	host: "localhost"
};

var window = {
		attachEvent: function() {}, 
		document: document,
		location: "http://localhost",
		addEventListener: function() {}}; 

var navigator = {
		userAgent: 'rhino', 
		appVersion: '1.7', 
		language: 'english'
};

var load = function( fileURL ) {
	var ok = javaScriptFileLoader.evaluateURL(globalRhinoContext, fileURL);
	if(!ok && !omitModuleCheck){
		throw new Error("File loader return false: Could not load '" + fileURL);
	}
	
	return ok;
};

var readFile = function( fileURL, charsetName ) {
	return this.readUrl(fileURL, charsetName);
};

var readUrl = function( fileURL, charsetName ) {
	var data = javaScriptFileLoader.loadURL(fileURL, charsetName);
	if(!data && !omitModuleCheck){
		throw new Error("File loader return false: Could not load '" + fileURL);
	}
	
	return data;
};

var rhino_timeouts = {};
var rhino_timeoutID = 0;
var setTimeout = function( callback, time ) {
	var timeoutID = rhino_timeoutID + '';
	rhino_timeouts[timeoutID] = callback;
	rhino_timeoutID++;
	return timeoutID;
};

var clearTimeout = function( timeoutID ) {
	delete rhino_timeouts[timeoutID];
};

var processTimeouts = function() {
	// process in order of timeout ids
	for (var i=0; i<=rhino_timeoutID; i++) {
		var callback = rhino_timeouts[i + ''];
		if (callback) {
			try {
				callback();
			}
			catch (e) {
				console.log("ERROR: " + e.message);
			}
		}
	}
	
	rhino_timeouts = {};
	rhino_timeoutID = 0;
};