/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide( "rmpw.widgets.SettingsButton" );

dojo.declare( "rmpw.widgets.SettingsButton", [dijit._Widget, dijit._Templated], {
	
   click: null,
   mouseover: null,
   mouseout: null,

   templateString: "<a dojoAttachPoint='settings' style=\"margin-top:1px;margin-bottom:1px;display:inline-block;-moz-border-radius: 2px;-webkit-border-radius: 2px;border:solid 1px #869CBF;\">" +
                     "<span dojoAttachPoint='anchor' class=\"settings\">View<span dojoAttachPoint='arrow' class=\"downIcon\">" +
                       "<fieldset dojoAttachPoint='menu' class=\"settingsMenu\">" +
                          "<form dojoAttachPoint='form' style=\"display:block\">" +
                             /* "<input dojoAttachPoint='input'></input>" + */
                          "</form>" +
                       "</fieldset>" +
                     "</span>" +
                   "</a>",

   open: false,
   
   postCreate: function(){ 
      this.inherited(arguments);
      this.click = dojo.connect( this.settings, "onclick", this, "toggle" );
      this.mouseover = dojo.connect( this.settings, "onmouseover", this, "highlight" );
      this.mouseout = dojo.connect( this.settings, "onmouseout", this, "out" );
      
      if( dojo.isFF ){
        this.anchor.style.paddingBottom = "6px";  
      }
   },
   
   highlight: function(){
	  this.anchor.style.backgroundColor = "#59B";  
   },
   
   out: function(){
	  this.anchor.style.backgroundColor = "#88BBD4"; 
   },
   
   toggle: function(){
	  
	  if( this.open === false ){
		  
	     this.anchor.style.backgroundColor = "#DDEEF6";
	     this.anchor.style.color = "#666666";  
	     this.arrow.className = "upIcon";
	     this.open = true;
	     this.menu.style.visibility = "visible";
	     
	     dojo.disconnect( this.mouseover );
	     dojo.disconnect( this.mouseout );
	     
	  }else{
		  
		 this.anchor.style.backgroundColor = "#88BBD4";
		 this.anchor.style.color = "white";  
		 this.arrow.className = "downIcon";
		 this.open = false; 
		 this.menu.style.visibility = "hidden";
		 
		 this.mouseover = dojo.connect( this.settings, "onmouseover", this, "highlight" );
	     this.mouseout = dojo.connect( this.settings, "onmouseout", this, "out" );
	     
	  }
   },
   
   addChild: function( widget ){
	  
	  widget.domNode.style.display = "block"; 
	   
	  this.form.appendChild( widget.domNode ); 
   },
   
   clearRegion: function(){	   
	  if( this.anchor.hasChildNodes() ){   
		 while( this.anchor.childNodes.length >= 1 ){
	        this.anchor.removeChild( this.anchor.firstChild );       
	     } 
	  }   
   }
});

}());
