/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide( "rmpw.widgets.SettingsToggle" );

dojo.require( "dijit.form.ToggleButton" );

dojo.declare( "rmpw.widgets.SettingsToggle", [dijit.form.ToggleButton], {
	
	_setCheckedAttr: function( value ){
	  
	   this.inherited( arguments );
	   
	   if( this.checked === true )
	   {
	      this.domNode.style.backgroundColor = "white";	   
	      this.domNode.style.border = "1px solid white";
	   
	   }else{
		
		  this.domNode.style.backgroundColor = "#DDEEF6"; 
		  this.domNode.style.border = "1px solid #DDEEF6"; 
	   }	   
    },
    
    _onMouse : function(/*Event*/ event){
		// summary:
		//	Sets _hovering, _active, and stateModifier properties depending on mouse state,
		//	then calls setStateClass() to set appropriate CSS classes for this.domNode.
		//
		//	To get a different CSS class for hover, send onmouseover and onmouseout events to this method.
		//	To get a different CSS class while mouse button is depressed, send onmousedown to this method.

		var mouseNode = event.currentTarget;
		if(mouseNode && mouseNode.getAttribute){
			this.stateModifier = mouseNode.getAttribute("stateModifier") || "";
		}

		if(!this.disabled){
			switch(event.type){
				case "mouseenter":
				case "mouseover":
					// this._hovering = true;
					this._active = this._mouseDown;	
					break;

				case "mouseout":
				case "mouseleave":
					this._hovering = false;
					this._active = false;
					break;

				case "mousedown" :
					this._active = true;
					this._mouseDown = true;
					// set a global event to handle mouseup, so it fires properly
					//	even if the cursor leaves the button
					var mouseUpConnector = this.connect(dojo.body(), "onmouseup", function(){
						// if user clicks on the button, even if the mouse is released outside of it,
						// this button should get focus (which mimics native browser buttons)
						if(this._mouseDown && this.isFocusable()){
							this.focus();
						}
						this._active = false;
						this._mouseDown = false;
						this._setStateClass();
						this.disconnect(mouseUpConnector);
					});
					break;
			}
			this._setStateClass();
		}
	}

});

}());
