/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.SimpleImageDescription");

dojo.require("dijit._Widget");

dojo.declare("rmps.ui.SimpleImageDescription", [dijit._Widget, dijit._Templated], {
	
	imgUrl: null,
	label: null,
	tooltip: null,
	
	constructor: function(args){
		this.imgUrl= args.imgUrl;
		if(!this.imgUrl){
			console.error("SimpleImageDescription exepcts imgUrl to be passed");
		}
		
		this.label= args.label? args.label: "";
		this.tooltip= args.tooltip? args.tooltip:"";
	},

	buildRendering: function() {
			
		this.domNode= dojo.create("span", {style: {backgroundImage: "url('" + this.imgUrl +"')"}, title: this.tooltip});
	
		var rendering= this.getRendering();
		var span= dojo.create("span");
		dojo.addClass(span,rendering.textStyle);
		
		span.appendChild(dojo.doc.createTextNode(this.label));
		this.domNode.appendChild(span);
		dojo.addClass(this.domNode, rendering.imageStyle);
	},
	
	getRendering: function(){
		return rmps.ui.SimpleImageDescription.Rendering.LEFT;
	}
});

rmps.ui.SimpleImageDescription.Rendering= {
	RIGHT: {imageStyle: "rmps-image-description-rightRendering", 
			textStyle: "rmps-image-description-rightTextEntry"
	},
	LEFT: {imageStyle: "rmps-image-description-leftRendering", 
			textStyle: "rmps-image-description-leftTextEntry"
	}
};

})();