/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide( "rmpw.widgets.TouchGuide" );

dojo.declare( "rmpw.widgets.TouchGuide", [dijit._Widget, dijit._Templated], {
	
   // border:solid 1px #869CBF;	

	templateString: "<div><div dojoAttachPoint='guide' style='background:white;opacity:0.8;height:100%;width:100%;position:absolute;top:0px; left:0px; z-index:999;'><div  style='display:-webkit-box; -webkit-box-orient:vertical; -webkit-box-pack:center; -webkit-box-align:center;'>" +
		"<canvas dojoAttachPoint='can' height='342' width='352' style='border-style:solid;border-width:4px;border-radius:5px;border-color:#f68c1e;background:white'>" +
		"</canvas>" +
	"</div></div></div>",
	
	touch: function(e){
		
		e.preventDefault();
		
		this.domNode.parentNode.removeChild( this.domNode );
		
		localStorage.setItem( "guide", "viewed" );
	},

	postCreate: function(){
		this.inherited(arguments);
		
		var box = dojo.marginBox( this.domNode );	
		console.log( box );
		
		 var ctx = this.can.getContext('2d');
		 var img = new Image();
		 img.src = dojo.moduleUrl( "rmpw.widgets","images/touches3.png" );
		 img.onload = function(){

			ctx.fillStyle = "black";
		    ctx.font = "bold 14px sans-serif";
            ctx.textAlign = "center";
            ctx.textBaseline = "middle";
            ctx.scale(0.75, 0.75); 
			ctx.drawImage(img,2,2);
			ctx.fillText( "Touch diagram elements", 110, 190 );
			ctx.fillText( "to select them", 110, 210 );
			ctx.fillText( "Elements and surface", 350, 190 );
			ctx.fillText( "can be moved", 350, 210 );

			ctx.fillText( "Pinch on surface to zoom", 110, 430 );
//			ctx.fillText( "Drag three fingers", 350, 390 );
//			ctx.fillText( "for navigation panel", 350, 410 );

		};
		 
		dojo.connect( this.guide, "touchstart", dojo.hitch( this, "touch" ) );		
	}

});

}());