/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.panner.Utils");

dojo.require("rmpw.panner.Rectangle");

rmpw.panner.Utils = {
	
	LineStyle: {
		SOLID: "solid",
		SHORT_DASH: "ShortDash",
		NONE: "none"
	},
	
	getGlobalCoords: function(figure) {
		var b = this.getTransformedBounds(figure);
		var dx = 0;
		var dy = 0;
		var parent = figure.getGroup().getParent();
		while (parent.getParent) {
			var t = parent.getTransform();
			if (t) {
				if (t.dx) {
					dx += t.dx;
				}
				if (t.dy) {
					dy += t.dy;
				}
			}
			parent = parent.getParent();
		}
		var c = dojo.position(parent.rawNode.parentNode);
		return {x: b.x + c.x + dx,
				y: b.y + c.y + dy,
				width: b.width,
				height: b.height
			};
	},
	
	getTransformedBounds: function(figure) {
		var bounds = new rmps.draw2d.Rectangle(figure.getBounds());
		var scale = 1;
		var parent = figure.getParent();
		while (parent) {
			if (parent.getScale) {
				scale *= parent.getScale();
			}
			parent = parent.getParent();
		}
		return bounds.scale(scale);
	}
}

})();