/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.ValidationText");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

/**
 * @author Mahmoud M.Orabi (morabi)
 */
dojo.declare("rmps.ui.ValidationText", [dijit._Widget, dijit._Templated], {

	value: null,
	errorMessage: null,
	lazyValidation: true,
	events: null,

	templateString: '<div><table>'
						+'	<tr">'
						+'		<td nowrap>'
						+'			<img dojoAttachPoint="_iconNode">'
						+'		</td>'
						+'		<td style="width: 100%;">'
						+'			<input style="width: 100%;" type="text" dojoAttachPoint="textInput">'
						+'		</td>'
						+'	</tr>'
					+'</table></div>',
	
	constructor: function(){
		this.events= [];
	},

	postCreate: function() {
		this.inherited(arguments);
		this._iconNode.src = dojo.moduleUrl("rmps.ui", "graphics/icons/error.gif");
		this._iconNode.title= this.errorMessage?this.errorMessage:"";

		if(this.lazyValidation){
			this._iconNode.style.visibility= "hidden";	/*Lazy Validation by default means that the validation starts once the control is initialized */
		}else{
			this._iconNode.style.visibility= this.validate(this.textInput.value)?"":"hidden";
		}

		this.textInput.value= this.value? this.value: "";

		var self= this;
		
		this.events.push(this.connect(this.textInput,"onkeydown", this._validate));
        this.events.push(this.connect(this.textInput,"onkeyup", this._validate));
        this.events.push(this.connect(this.textInput,"onpaste", this._validate));
        this.events.push(this.connect(this.textInput,"oncut", this._validate));
        this.events.push(this.connect(this.textInput,"onblur", this._validate));
	},
	
	destroy: function(){
		while (this.events.length > 0) {
			var entry = this.events.pop();
			if(entry){
				this.disconnect(entry);
			}
			entry = null;
		}
		this.inherited(arguments);
	},

	_validate: function(event){
		this._iconNode.style.visibility= this.validate(this.textInput.value)?"":"hidden";
	},

	/*Boolean */ validate: function(value){return false;}


});

})();