/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {	
dojo.provide("com.ibm.team.vvc.shared.web.access.AccessUtils");

dojo.require("dojox.xml.parser");
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");
var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");
var UIHelper= com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

	com.ibm.team.vvc.shared.web.access.AccessUtils = {
	        _getTextContent: function(node) {
	        	return node ? (node.textContent ? node.textContent : node.text) : null; //IE8
	        },
			
		    _getChildNodes: function(source) {
		        if (dojo.isArray(source)) {
		            return source;
		        }

		        if (dojo.isIE > 8) {
		            var childNodes = [];
		            var node = source.firstChild;
		            while (node) {
		                childNodes.push(node);
		                node = node.nextSibling;
		            }
		            return childNodes;
		        }

		        return source.childNodes;
		    },
		    
		    getTeamAreasFromRootServices: function(rootServices, securityContext) {
		    	
		    	var mainDeferred = new dojo.Deferred();
		    	
		    	var context = {
		    		mainDeferred: mainDeferred,
		    		securityContext: securityContext,
		    		self: this
		    	};
		    	var deferred1 = this.getProjectAreasFromRootServices(rootServices);
		    	deferred1.addCallback(context, function(result1){
		    	
		    		var hitched = dojo.hitch(this.self, this.self.getIndividualProjectAreas);
        			var deferred2 = hitched(result1);
        			
        			var context = {
        				mainDeferred: this.mainDeferred,
        				securityContext: this.securityContext,
        				self: this.self
        			};
    		    	deferred2.addCallback(context, function(result2){

    		    		var deferreds = [];
    		    		var projectAreas = [];
    		    		for (var i = 0; i < result2.length; i++) {
    		    			var projectArea = result2[i];
    		    			
    		    			if (!this.securityContext || (projectArea.uri.indexOf(this.securityContext, projectArea.uri.length - this.securityContext) >= 0)) {
        		    			var hitched = dojo.hitch(this.self, this.self.getTeamAreas);
        		    			if (projectArea.teamAreasUri) {
                        			var deferred3 = hitched(projectArea.teamAreasUri);
                        			var context = {
                        				projectArea: projectArea
                        			};
                        			deferred3.addCallback(context, function(result3){
                        				this.projectArea["teamAreas"] = result3;
                        			});
                		    		deferreds.push(deferred3);
                		    		projectAreas.push(projectArea);
        		    			} else {
        		    				//it should always have a teamAreasUri even when there are no team areas
        		    				console.error("missing teamAreasUri for projectArea " + projectArea.uri);
        		    			}
    		    			}
    		    		}
    		    		
            			var context = {
            				mainDeferred: this.mainDeferred,
            				projectAreas: projectAreas
                		};
    		    		var deferredList = new dojo.DeferredList(deferreds);
    		    		deferredList.then(dojo.hitch(context, function(res){
    		    			this.mainDeferred.resolve(this.projectAreas);
    		    		}));
    		    	});
        		});
		    	
		    	return mainDeferred;
        			
		    },
	        
	        getProjectAreasFromRootServices: function(rootServices) {
	    		var deferredRootservices = jazz.client.xhrGet({
	    			url: rootServices,
	    			headers: {
	    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
	    			},
	    			handleAs: "xml", //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//	    				console.error(error);
//	    			})
	    			load: dojo.hitch(this, function(xmlDocument) {
		                 
	                     var descriptionNode = UIHelper.getNode(this._getChildNodes(xmlDocument), "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
	                     
	                     var projectAreasNode = UIHelper.getNode(this._getChildNodes(descriptionNode), "projectAreas", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
	                     
	                     return projectAreasNode.getAttribute("rdf:resource");
	    			})
	    		});
	    		
	    		return deferredRootservices;
	        },
	        
	        getIndividualProjectAreas: function(projectAreasUrl) {
	    		var deferredProjectAreas = jazz.client.xhrGet({
	    			url: projectAreasUrl,
	    			headers: {
	    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
	    			},
	    			handleAs: "xml", //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//					console.error(error);
//				    })
	    			load: dojo.hitch(this, function(xmlDocument) {
	    				var projectAreas = [];
	    				
		                 var rootChildNodes = this._getChildNodes(xmlDocument);
		                 
		                 for (var rootChildNodeIndex = 0; rootChildNodeIndex < rootChildNodes.length; rootChildNodeIndex++) {
			                 
			                 if (rootChildNodes[rootChildNodeIndex].nodeName === "jp06:project-areas") {
			                 	var projectAreaNodes = this._getChildNodes(rootChildNodes[rootChildNodeIndex]);
			                 
				                 for (var i = 0; i < projectAreaNodes.length; i++) {
				                	 //we want name, url, and team area url
				                	 var projectNode = projectAreaNodes[i];
				                	 
				                	 if (projectNode.nodeName === "jp06:project-area") {
					                	 var name = projectNode.getAttribute("jp06:name");
					                	 
						                    var projectAreasNode = UIHelper.getNode(this._getChildNodes(projectNode), "url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    
						                    var teamAreasNode = UIHelper.getNode(this._getChildNodes(projectNode), "team-areas-url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    var projectArea = {
						                    	type: "projectArea",
						                    	name: name,
						                    	uri: this._getTextContent(projectAreasNode),
						                    	teamAreasUri: this._getTextContent(teamAreasNode),
						                    	teamAreas: []
						                    };
						                    
						                    projectAreas.push(projectArea);
				                	 }
				                	 
	
				                 }
			                 }
		                	 
		                 }
	                     
	                     return projectAreas;
	    			})
	    		});
	    		
	    		return deferredProjectAreas;
	        	
	        },
	        
	        setConfigurationOwner: function(configuration, configurationOwner) {
	        	
	    		var deferred = jazz.client.xhrPut({
	    			url: VvcUtils.getVvcUri() + "/configurations/restrict?configurationUri=" + encodeURIComponent(configuration) + "&teamAreaUri=" + encodeURIComponent(configurationOwner),
	    			headers: {
	    				"accept": "application/json"
	    			},
	    			handleAs: "xml" //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//	    				console.error(error);
//	    			})
//	    			load: dojo.hitch(this, function(result) {
//		                 //do nothing
//	    			})
	    		});
	    		
	    		return deferred;
	        },
	        
	        getConfigurationOwner: function(configuration) {
	        	
	    		var deferred = jazz.client.xhrGet({
	    			url: VvcUtils.getVvcUri() + "/configurations/getControlledBy?configurationUri=" + encodeURIComponent(configuration),
	    			headers: {
	    				"accept": "application/json"
	    			},
	    			handleAs: "json", //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//	    				console.error(error);
//	    			})
	    			load: dojo.hitch(this, function(result) {
	    				 return (result.owner === "null") ? null : result.owner;
	    			})
	    		});
	    		
	    		return deferred;
	        },
	        
	        getSpaceContext: function(space) {
	        	
	    		var deferred = jazz.client.xhrGet({
	    			url: VvcUtils.getVvcUri() + "/spaces/spaceContext?spaceUri=" + encodeURIComponent(space),
	    			headers: {
	    				"accept": "application/json"
	    			},
	    			handleAs: "json", //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//	    				console.error(error);
//	    			})
	    			load: dojo.hitch(this, function(result) {
	    				 return (result.securityContext === "null") ? null : result.securityContext;
	    			})
	    		});
	    		
	    		return deferred;
	        },	        
	        
	        
	        //this is really getTeamAreasRootedByProjects
	        getTeamAreas: function(teamAreasUrl) {
	    		var deferredTeamAreas = jazz.client.xhrGet({
	    			url: teamAreasUrl,
	    			headers: {
	    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
	    			},
	    			handleAs: "xml", //$NON-NLS-1$
//	    			error: dojo.hitch(this, function(error){
//					console.error(error);
//				    })
	    			load: dojo.hitch(this, function(xmlDocument) {
	    				var teamAreasMap = {}; //this is a map of teamArea uri to the teamArea object (intermediary)
	    				
		                 var rootChildNodes = this._getChildNodes(xmlDocument);
		                 
		                 for (var rootChildNodesIndex = 0; rootChildNodesIndex < rootChildNodes.length; rootChildNodesIndex++) {
		                	 
		                	 if (rootChildNodes[rootChildNodesIndex].nodeName === "jp06:team-areas") {
			                 	 var teamAreaNodes = this._getChildNodes(rootChildNodes[rootChildNodesIndex]);
			                 	
				                 for (var i = 0; i < teamAreaNodes.length; i++) {
				                	 
				                	 //we want name, url, and team area url
				                	 var teamAreaNode = teamAreaNodes[i];
				                	 
				                	 if (teamAreaNode.nodeName === "jp06:team-area") {
					                	 var name = teamAreaNode.getAttribute("jp06:name");
						                    
						                    var teamAreaURLNode = UIHelper.getNode(this._getChildNodes(teamAreaNode ), "url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    var membersNode = UIHelper.getNode(this._getChildNodes(teamAreaNode ), "members-url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    //this doesn't work because there is no definition for jp in the returned xml
						                    var adminsNode = UIHelper.getNode(this._getChildNodes(teamAreaNode ), "admins-url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    var parentNode = UIHelper.getNode(this._getChildNodes(teamAreaNode), "parent-url", "http://jazz.net/xmlns/prod/jazz/process/0.6/"); //$NON-NLS-1$
						                    
						                    var teamArea = {
						                    	type: "teamArea",
						                    	name: name,
						                    	uri: this._getTextContent(teamAreaURLNode),
						                    	membersUri: this._getTextContent(membersNode),
						                    	adminsUri: this._getTextContent(adminsNode), //this doesn't work because there is no definition for jp in the returned xml
						                    	parentUri: this._getTextContent(parentNode), //expected to be null for roots
						                    	teamAreas: []
						                    };
						                    
						                    teamAreasMap[teamArea.uri] = teamArea;
				                	 }
				                	 
				                 }
		                		 
		                	 }
		                 }
		                 
		    			var teamAreas = []; //roots of trees of teamArea objects (return)
	                    for (var teamAreaUri in teamAreasMap) {
	                    	var teamArea = teamAreasMap[teamAreaUri];

	                    	if (!teamArea.parentUri) {
	                    		teamAreas.push(teamArea);
	                    	} else {
	                    		var parentTeamArea = teamAreasMap[teamArea.parentUri];
	                    		if (parentTeamArea) {
	                    			parentTeamArea.teamAreas.push(teamArea);
	                    		} else {
	                    			//just skip it
	                    			console.error("missing parent URI " + parentUri + " for parent of team area " + teamArea.name);
	                    		}
	                    	}
	                    }
	                     
	                     return teamAreas;
	    			})
	    		});
	    		
	    		return deferredTeamAreas;
	        }

	};
}());