/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actionBindings.ActionBinding");

dojo.require("rmpw.common.policy.Policy");

/**
 * Binds some external attributes that represents an action to an action
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actionBindings.ActionBinding", rmpw.common.policy.Policy, {
	
	/*
	 * if this action binding is disabled then it will return null, other will return this.
	 * This is useful at the base class so we can use polymorphism when querying menu bindings
	 */
	_filterDisabled: function(targetController) {
		if (this._action && this._action.isEnabled) {
			if (this._action.isEnabled({targetController: targetController})) {
				return this;
			}
			return null;
		}
		
		return this;
	},

	setAction: function( action ) {
		this._action = action;
	},
	
	getAction: function() {
		return this._action;
	},

	setTunnelingAction: function( action ) {
		this._tunnelingAction = action;
	},
	
	getTunnelingAction: function() {
		return this._tunnelingAction;
	},
	
	setDomainId: function( domainId ) {
		this._domainId = domainId;
	},
	
	getDomainId: function() {
		return this._domainId;
	},
	
	isRunAction: function() {
		return false;
	}
});
