/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actionBindings.Button");

dojo.require("rmpw.diagrams.edit.actionBindings.ActionBinding");

/**
 * Binds a key stroke to an action
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actionBindings.Button", rmpw.diagrams.edit.actionBindings.ActionBinding, {
	
	_label: null,
	_description: null,
	_iconClass: "",
	_iconURL: null,
	_id: null,
	
	setId: function(id) {
		this._id = id;
	},

	/*
	 * Sets the icon URL for the pop-up menu / drop-down toolbar for this set of actions.
	 */
	setIconURL: function(iconURL) {
		this._iconURL = iconURL;
	},
	
	/*
	 * Sets the action label for the pop-up menu / drop-down toolbar for this set of actions.
	 */
	setLabel: function(label) {
		this._label = label;
		if (!this._description) {
			this._description = this._label;
		}
	},
	
	/*
	 * Sets the action description for the pop-up menu / drop-down toolbar for this set of actions.
	 */
	setDescription: function(description) {
		this._description = description;
		if (!this._label) {
			this._label = this._description;
		}
	},
	
	setIconClass: function(iconClass) {
		this._iconClass = iconClass;
	},
	
	getIconClass: function() {
		return this._iconClass;
	},
	
	getDescription: function() {
		return this._description;
	},
	
	getLabel: function() {
		return this._label;
	},
	
	getIconURL: function() {
		return this._iconURL;
	},
	
	getId: function() {
		return this._id;
	}
});
