/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actionBindings.KeyStroke");

dojo.require("rmpw.diagrams.edit.actionBindings.ActionBinding");
dojo.require("rmpw.diagrams.edit.KeyStrokeDescriptor");

/**
 * Binds a key stroke to an action
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actionBindings.KeyStroke", rmpw.diagrams.edit.actionBindings.ActionBinding, {
	
	_keyChar: null,
	_keyCode: null,
	_altKey: false,
	_shiftKey: false,
	_ctrlKey: false,
	
	setKeyChar: function(keyChar) {
		this._keyChar = keyChar;
	},
	
	setKeyCode: function(keyCode) {
		this._keyCode = keyCode;
	},
	
	setAltKey: function(altKey) {
		this._altKey = altKey;
	},
	
	setShiftKey: function(shiftKey) {
		this._shiftKey = shiftKey;
	},
	
	setCtrlKey: function(ctrlKey) {
		this._ctrlKey = ctrlKey;
	},
	
	getKeyStrokeDescriptor: function() {
		return new rmpw.diagrams.edit.KeyStrokeDescriptor({keyChar: this._keyChar, keyCode: this._keyCode, 
			altKey: this._altKey, shiftKey: this._shiftKey, ctrlKey: this._ctrlKey});
	},
	
	acceptKeyStroke: function(keyStroke) {
		if (this.getKeyStrokeDescriptor().equals(keyStroke)) {
			return true;
		}
		
		return false;
	}
	
});
