/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actionBindings.MouseDoubleClick");

dojo.require("rmpw.diagrams.edit.actionBindings.ActionBinding");

/**
 * Binds a double click gesture to an action
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actionBindings.MouseDoubleClick", rmpw.diagrams.edit.actionBindings.ActionBinding, {
	
	constructor: function() {
		
	},
	
	setShape: function(shape) {
		if(dojo.isString(shape)) {
			shape = this.host.renderMapping.template[shape];
		}
		
		if (this._connectDoubleClick) {
			dojo.disconnect(this._connectDoubleClick);
		}
		
		this._connectDoubleClick = shape.connect("ondblclick", this, dojo.hitch( function(e) {
			this.getAction().run({});
			dojo.stopEvent(e);
		}));
		
		// also add a function to shape
		var thisAction = this;
		shape.dblclick = function() {
			thisAction.getAction().run({});
		};
	},
	
	destroy: function() {
		if (this._connectDoubleClick) {
			dojo.disconnect(this._connectDoubleClick);
		}
	}
	
});
