/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.actions.AddRelationship");

dojo.require("rmpw.diagrams.edit.actions.AddElement");


/**
 *Add class 
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actions.AddRelationship", rmpw.diagrams.edit.actions.AddElement, {
	
	setSourceTrace: function(sourceTrace) {
		this._options.sourceTrace = sourceTrace;
	},
	
	setElementTypeTrace: function(targetTypeTrace) {
		this._options.targetTypeTrace = targetTypeTrace;
	},
	
	setTargetTrace: function(targetTrace) {
		this._options.targetTrace = targetTrace;
	},
	
	setTargetTypeIds: function() {
		this._options.targetTypeIds = arguments;
	},
	
	isEnabled: function(args) {
		var sourceMapping = this.host;
		if (this._options.targetTypeTrace && this._options.targetTypeIds) {
			var targetType = args.targetController.renderMapping.getSourceByPath(this._options.targetTypeTrace);
			if(targetType) {
				for (var i = 0, type; type = this._options.targetTypeIds[i]; i++) {
					if (type === targetType) {
						return this.inherited(arguments);
					}
				}
			}
			
			return false;
		}
		
		return this.inherited(arguments);
	},
	
	/*
	 * Gets the arguments passed into the command at execution time
	 */
	getExecutionArguments: function (e) {
		var ownerElement = this.host.renderMapping.getSourceByPath(this._options.ownerTrace);
		
		var sourceElement;
		var targetElement;
		if(this._options.sourceTrace) {
			sourceElement = e.sourceController.renderMapping.getSourceByPath(this._options.sourceTrace);
			targetElement = e.targetController.renderMapping.getSourceByPath(this._options.targetTrace);
		}
		else {
			sourceElement = e.sourceController.renderMapping.getDefaultSource();
			targetElement = e.targetController.renderMapping.getDefaultSource();
		}
		
		return {
			ownerElement: ownerElement,
			sourceElement: sourceElement,
			targetElement: targetElement
		};
	},
	
	/*
	 * Gets the command to be execution by the action
	 */
	getCommand: function(e) {
		var commandPackage = this.host.root.getCommandPackage();
		
		var createElCmd = commandPackage.select({
			// TODO add namespace to this API
			typeId: this._options.typeId,
			addTypeId: this._options.addTypeId,
			ownerChildrenProperty: this._options.ownerChildrenProperty,
			commandId: "rmpw.common.command.AddRelationship"
		});
		
		return createElCmd;
	}
	
});

