/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.web.comment.sketch.actions.AddText");

dojo.require("rmpw.diagrams.edit.actions.DirectEditText");
dojo.require("rmpw.common.vcs.ChangeSet")

/**
 * 
 * @author sshaw
 */
dojo.declare("rmps.web.comment.sketch.actions.AddText", rmpw.diagrams.edit.actions.DirectEditText, {
	
	constructor: function() {
		this.setTextShape("wrappingTextExpression");
		
		if( this.host.renderMapping.sources.svgRoot.elementId == "TextBox" && 
			(this.host.renderMapping.sources.svgShape.text == null || this.host.renderMapping.sources.svgShape.text == "")) {
			setTimeout(dojo.hitch(this, function() {
				this.run({});
			}), 0);
		}
	},
	
	_doCommit: function( newValue ) {
		var owner = this.host.renderMapping.sources.svgShape;
		var changeSet = new rmpw.common.vcs.ChangeSet();
		var change = changeSet.createChange(owner);
		
		change.set( "text", newValue );

		this.host.viewer._commandController.commandStack.repository.commit(changeSet);
    }

});

})();