/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.AddType");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * Action that adds an extra type to an instance.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.diagrams.edit.actions.AddType", rmpw.diagrams.edit.actions.Action, {
	
	setType: function(type) {
		this._options.type = type;
	},
	
	setInstancePath: function(path) {
		this._options.instancePath = path;
	},
	
	isEnabled: function(args) {
		return true;
	},
	
	getExecutionArguments: function (e) {
		var instance = this.host.renderMapping.getSourceByPath(this._options.instancePath);
		return { obj: instance, type: this._options.type };
	},
	
	getCommand: function(e) {
		var commandPackage = this.host.root.getCommandPackage();
		
		var command = commandPackage.select({
			commandId: "rmpw.common.command.AddType",
			typeId: [ "http://www.w3.org/2000/01/rdf-schema#Resource" ]
		});
		
		return command;
	}
});