/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.Cancel");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for cancelling UI gestures
 */
dojo.declare("rmpw.diagrams.edit.actions.Cancel", rmpw.diagrams.edit.actions.Action, {
	
	run: function(args) {
		var fs = args.viewer.policies.focusScope;
		var target = fs.getCaptureFocus();
		fs.releaseCapture();
		var ret = false;
		
		if (target) {
			for (var policy in target.policies) {
				if (target.policies && target.policies[policy].onCancel) {
					target.policies[policy].onCancel(); // all policies should process cancel (reset state)
					ret = true;
				}
			}
		}
		
		return ret;
	}
});