/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.actions.ChangeProperty");

dojo.require("rmpw.common.command.ChangeProperty");
dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * @author Marc Gobeil
 */
dojo.declare("rmpw.diagrams.edit.actions.ChangeProperty", rmpw.diagrams.edit.actions.Action, {
	
	/*
	 * Gets the change text command to be executed
	 */
	getCommand: function() {
		var propertyPath = this._options.propertyTrace;
		var propertyName = propertyPath.substring(propertyPath.lastIndexOf('.') + 1);
		
		return this._viewer.getCommandPackage().select({
			typeId: this._options.typeId,
			commandId: "rmpw.common.command.ChangeProperty",
			property: propertyName
		});
	},
	
	setPropertyTrace: function(propertyTrace) {
		this._options.propertyTrace = propertyTrace;
	},
	
	setTypeId: function(typeId) {
		this._options.typeId = typeId;
	},
	
	getExecutionArguments: function (e) {
		var ownerElement = this.host.renderMapping.getSourceOwnerByPath(this._options.propertyTrace);
		return { ownerElement: ownerElement, newValue: e.newValue };
	},
	
	run: function(e) {
		this.inherited(arguments);
		this.host.renderMapping.parent.invalidate();
	}
});