/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.Commit");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for committing UI gestures
 */
dojo.declare("rmpw.diagrams.edit.actions.Commit", rmpw.diagrams.edit.actions.Action, {
	
	run: function(args) {
		var fs = args.viewer.policies.focusScope;
		var target = fs.getCaptureFocus();
		fs.releaseCapture();
		var ret = false;
		
		if (target) {
			for (var policy in target.policies) {
				if (target.policies[policy].onCommit) {
					ret = target.policies[policy].onCommit(); // only allow one commit
					if (ret) {
						break;
					}
				}
			}
		}
		
		return ret;
	}
});