/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.DeleteBendpoint");

dojo.require("rmpw.diagrams.edit.actions.Action");
dojo.require("rmpw.diagrams.edit.commands.SetConnectionBendpointsCommand");

/**
 * Delete semantic action
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actions.DeleteBendpoint", rmpw.diagrams.edit.actions.Action, {
	
	/*
	 * Gets the arguments passed into the command at execution time
	 */
	getExecutionArguments: function (e) {
		var focusEl = e.viewer.policies.focusScope.getFocus();
	
		var graphEdge = focusEl.editController.renderMapping.policies.graphEdge;
		var index = focusEl.getIndex();
		
		var points = graphEdge.getPointList().getCopy();
		points.removePoint(index);
		
		return {editController: focusEl.editController, points: points.points,
			sourceAnchor: graphEdge.getSourceConnectionAnchor(), 
			targetAnchor: graphEdge.getTargetConnectionAnchor()};
	},
	
	isEnabled: function(e) {
		var focusEl = e.viewer.policies.focusScope.getFocus();
		
		if (focusEl && focusEl.editController && 
			focusEl.editController.renderMapping.policies.graphEdge &&
			focusEl.getIndex && focusEl.getIndex() !== -1) {
			return true;
		}
		
		return false;
	},
	
	/*
	 * Gets the command to be execution by the action
	 */
	getCommand: function(e) {
		return new rmpw.diagrams.edit.commands.SetConnectionBendpointsCommand();
	}
});

