/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.actions.NativeCode");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * This implementation of NativeCode action assumes that valid JSON is passed to the code body
 * The assumption is that there is one entry that is the function name
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.actions.NativeCode", rmpw.diagrams.edit.actions.Action, {
	/**
	 * Native code can be set from a string into this action.  In this implementation it is
	 * assumed to be JavaScript code.  There is one parameter that is the "args" object where the
	 * parameters will vary depending on the callback.
	 */
	setRun: function(f) {
		if(dojo.isString(f)) {
			f = new Function("args", f);
		}
		this._run = dojo.hitch(this, f);
	},
	
	run: function(e){
		if (this.isEnabled(e) && this._run) {
			return this._run(e);
		}
		
		return false;
	}
});