/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.NavigateToChildren");

dojo.require("rmpw.diagrams.edit.actions.Navigate");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for navigating to children of a controller
 */
dojo.declare("rmpw.diagrams.edit.actions.NavigateToChildren", rmpw.diagrams.edit.actions.Navigate, {
	
	findFocusableChild: function(parent) {
		if (parent.children) {
			for (var i=0, child; child = parent.children[i]; i++) {
				if (child.policies.focusable) {
					return child;
				}
				else {
					var subchild = this.findFocusableChild(child);
					if (subchild) {
						return subchild;
					}
				}
			}
		}
	},

	run: function(args) {
		// find the first focusable child
		var child = this.findFocusableChild(this.findFocus(args));
		if (child) {
			args.viewer.policies.focusScope.setFocus(child);
			return true;
		}
		
		return false;
	}
});