/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.NavigateToHandle");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for navigating to handles on a shape relation
 */
dojo.declare("rmpw.diagrams.edit.actions.NavigateToHandle", rmpw.diagrams.edit.actions.Action, {
	
	run: function(args) {
		var ss = args.viewer.policies.selectionScope;
		var fs = args.viewer.policies.focusScope;
		var target = fs.getFocus();
		if (!target) {
			target = ss.getPrimarySelection();
			if (!target) {
				return false;
			}
			else {
				ss.selectExclusive(target, {});
			}
		}
		else if (target.policies.selectable) {
			// select the handle if it's a top level edit controller
			var selection = ss.getSelection();
			if (selection.length !== 1 || selection[0] !== target) {
				ss.selectExclusive(target, {});
			}
		}
		
		// retrieve the next handle for focus
		if (target.policies.handleScope) {
			var handle = target.policies.handleScope.getNextHandle();
			if (handle.policies && handle.policies.focusable) {
				fs.setFocus(handle);
			}
		}
		
		return true;
	}
});