/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.NavigateToParent");

dojo.require("rmpw.diagrams.edit.actions.Navigate");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for navigating to the parent of a controller
 */
dojo.declare("rmpw.diagrams.edit.actions.NavigateToParent", rmpw.diagrams.edit.actions.Navigate, {
	
	findFocusableParent: function(parent) {
		if (parent.parent) {
			if (parent.parent.policies.focusable) {
				return parent.parent;
			}
			else {
				var nextparent = this.findFocusableParent(parent.parent);
				if (nextparent) {
					return nextparent;
				}
			}
		}
	},
	
	run: function(args) {
		var parent = this.findFocusableParent(this.findFocus(args));
		if (parent) {
			args.viewer.policies.focusScope.setFocus(parent);
			return true;
		}
		
		return false;
	}
});