/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.actions.ReparentElement");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 *	ReparentElement graph node action
 * 
 * @author John Swanke
 */
dojo.declare("rmpw.diagrams.edit.actions.ReparentElement", rmpw.diagrams.edit.actions.Action, {
	
	setTypeId: function(typeId) {
		this._options.typeId = typeId;
	},

	setConnectionTypeId: function(typeId) {
		this._options.connectionTypeId = typeId;
	},

	setOwnerTrace: function(ownerTrace) {
		this._options.ownerTrace = ownerTrace;
	},
	
	isEnabled: function(args) {
		return this.inherited(arguments);
	},
	
	setOwnerChildrenProperty: function(ownerChildrenProperty) {
		this._options.ownerChildrenProperty = ownerChildrenProperty;
	},
	
	/*
	 * Gets the arguments passed into the command at execution time
	 */
	getExecutionArguments: function (e) {
		return {newParentMapping: this.host.renderMapping, 
			nodes: e.nodes, 
			dx: e.dx, 
			dy: e.dy,
			xTraceName: this.host.renderMapping.policies.graphElement._getInternalTraceName("x"),
			yTraceName: this.host.renderMapping.policies.graphElement._getInternalTraceName("y")
		};
	},
	
	/*
	 * Gets the command to be execution by the action
	 */
	getCommand: function(e) {
		var commandPackage = this.host.root.getCommandPackage();
		
		var reparentCmd = commandPackage.select({
			typeId: [this._options.typeId],
			ownerChildrenProperty: this._options.ownerChildrenProperty,
			commandId: "rmpw.common.command.ReparentElement"
		});
		
		return reparentCmd;
	}
});

