/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.graphics.actions.ShowCompartment");

dojo.require("rmpw.diagrams.edit.actions.Action");

dojo.require("rmps.app.core.util");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.graphics.actions", "Messages");
var messages = dojo.i18n.getLocalization("rmps.graphics.actions", "Messages");

/**
 * 
 * @author Anton McConville (antonm)
 */
dojo.declare("rmps.graphics.actions.ShowCompartment", rmpw.diagrams.edit.actions.Action, {
	
	constructor: function() {
		this.text = messages.preview;
	},
	
	setZoneData: function( zonedata ){
		this.zonedata = zonedata;
		this.zonedata.opened = false;
	},
	
	openCompartment: function( view, graph ){
	    
	     var resourceUtil = rmps.app.core.util;

	     var resource = resourceUtil.getViewResourceUri( view );
	     
	     var suffix = encodeURIComponent( graph );
	     
	     var uri = resource + "&graph=" + suffix;
	     
	     location.href = uri;
	 },
	
	run: function(args) {
				
		var model = this.host.renderMapping.sources.model;
		
		if( this.zonedata.id != null ){	
			this.openCompartment( model.view, model.graph );
		}
	}
});

})();