/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.diagram.actions.ShowHyperlinks");

dojo.require("rmpw.diagrams.edit.actions.Action");
dojo.require("rmps.ui.properties.HyperlinksPopup");
dojo.require("rmps.ui.properties.PropertiesPopup");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.diagram.actions", "Messages");
var messages = dojo.i18n.getLocalization("rmps.diagram.actions", "Messages");

dojo.declare("rmps.diagram.actions.ShowHyperlinks", rmpw.diagrams.edit.actions.Action, {
	
	constructor: function() {
		this.text = messages.preview;
	},
	
	setZoneData: function( zonedata ){
		this.zonedata = zonedata;
		this.zonedata.opened = false;
	},
	
	run: function(args) {
		
		this.renderMapping = this.host.renderMapping;
		
		if( this.zonedata.hyperlinks ){
			var link = rmps.app.ui.internal.pages.design.DesignUtil.getEditResourceUri( this.zonedata.id );
			var popup = rmps.ui.properties.HyperlinksPopup.show( { multipleHyperlinks: this.zonedata.multipleHyperlinks } );  	
			this.renderMapping.root.policies.focusScope.disable();
			this.focusConnection = dojo.connect( popup, "hide", this, "enableFocus" );
			this.zonedata.opened = true;
			this.surfaceConnection = dojo.connect( this.renderMapping.__editMapping.viewer.diagram.__editMapping.viewer.surface._parent, "onmousedown", popup, "hide" );			
		}	
	},
	
	enableFocus: function(){
		this.renderMapping.root.policies.focusScope.enable();
		dojo.disconnect( this.focusConnection );
		dojo.disconnect( this.surfaceConnection );
		this.zonedata.opened = false;
	}
});

})();
