/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.graphics.actions.ShowProperties");

dojo.require("rmpw.diagrams.edit.actions.Action");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.graphics.actions", "Messages");
var messages = dojo.i18n.getLocalization("rmps.graphics.actions", "Messages");

/**
 * 
 * @author Anton McConville (antonm)
 */
dojo.declare("rmps.graphics.actions.ShowProperties", rmpw.diagrams.edit.actions.Action, {
	
	constructor: function() {
		this.text = messages.preview;
	},
	
	setZoneData: function( zonedata ){
		this.zonedata = zonedata;
		this.zonedata.opened = false;
	},
	
	run: function(args) {
		
		this.renderMapping = this.host.renderMapping;
		
		if( this.zonedata.hyperlink != null ){
			
			window.open(this.zonedata.hyperlink, "_blank");
			
		}else if( this.zonedata.id != null ){
			
			var link = rmps.app.core.util.getViewResourceUri( this.zonedata.id );
			
			/* Don't follow internal URI's ( e.g. addressed directly using pathmap:/ or platform:/ URI's ) */
			
			if( this.zonedata.id.search(/^https?\:\/\//i) === 0 && this.zonedata.opened == false ){
				var popup = rmps.ui.properties.PropertiesPopup.show( { resourceUri: this.zonedata.id, linkHref: link } );  	
				this.renderMapping.root.policies.focusScope.disable();
				
				this.focusConnection = dojo.connect( popup, "hide", this, "enableFocus" );
				
				this.zonedata.opened = true;
				
				this.surfaceConnection = dojo.connect( this.renderMapping.__editMapping.viewer.diagram.__editMapping.viewer.surface._parent, "onmousedown", popup, "hide" );			
			}
		}	
	},
	
	enableFocus: function(){
		this.renderMapping.root.policies.focusScope.enable();
		dojo.disconnect( this.focusConnection );
		dojo.disconnect( this.surfaceConnection );
		this.zonedata.opened = false;
	}
});

})();