/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.diagram.actions.ShowView");

dojo.require("dojo.i18n");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.requireLocalization("rmps.diagram.actions", "Messages");
var messages = dojo.i18n.getLocalization("rmps.diagram.actions", "Messages");

var SUPPORT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "support");

dojo.declare("rmps.diagram.actions.ShowView", rmpw.diagrams.edit.actions.Action, {
	
	constructor: function() {
		this.text = messages.preview;
	},
	
	setZoneData: function( zonedata ){
		this.zonedata = zonedata;
		this.zonedata.opened = false;
	},
	
	run: function(args) {
		
		this.renderMapping = this.host.renderMapping;
		var uri = this.zonedata.id;
		if( this.zonedata.hyperlink != null ){
			uri = this.zonedata.hyperlink;
		}
		if( uri != null ){
			if (uri.indexOf(SUPPORT_PATH) == 0) { 
				window.open(this.zonedata.hyperlink, "_blank");
			} else {
 				var link = rmps.app.ui.internal.pages.design.DesignUtil.getEditResourceUri( uri );
    			if (this.zonedata.hasElement) {
    				window.location.href = link;
		    	} else {
		       		// if view had no element open property dialog instead-- otherwise nothing happens
						var popup = rmps.ui.properties.PropertiesPopup.show( { resourceUri: uri, linkHref: link } );  	
					this.renderMapping.root.policies.focusScope.disable();
					this.focusConnection = dojo.connect( popup, "hide", this, "enableFocus" );
					this.zonedata.opened = true;
					this.surfaceConnection = dojo.connect( this.renderMapping.__editMapping.viewer.diagram.__editMapping.viewer.surface._parent, "onmousedown", popup, "hide" );
    			}
			}
		}	
	}
});

})();
