/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.ToggleRouter");

dojo.require("rmpw.diagrams.edit.actions.Action");
dojo.require("rmpw.diagrams.render.graph.BaseGraphConfigurator");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for toggling the line routing between oblique and rectilinear
 */
dojo.declare("rmpw.diagrams.edit.actions.ToggleRouter", rmpw.diagrams.edit.actions.Action, {
	id: "rmpw.diagrams.edit.actions.ToggleRouter",
	description: "Toggle Router",
	
	run: function(args) {
		var selection = args.viewer.getSelectionController().getSelection();
		if (selection && selection.length > 0) {
			var mapping = selection[0].renderMapping;
			
			if (mapping.policies.graphEdge) {
				args.routing = mapping.policies.graphEdge.getRouterType() === rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.RECTILINEAR_ROUTING ?  
						rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.OBLIQUE_ROUTING : rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.RECTILINEAR_ROUTING; 
				args.editControllers = selection;
				return args.viewer.getCommandController().execute("rmpw.diagrams.edit.commands.ChangeRouterCommand", args);
			}
		}
		
		return false;
	}
});