/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.ToggleSelect");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * 
 * @author Steve Shaw
 * 
 * Action for toggling selection 
 */
dojo.declare("rmpw.diagrams.edit.actions.ToggleSelect", rmpw.diagrams.edit.actions.Action, {
	
	run: function(args) {
		var editController = args.viewer.getSelectionController().getPrimarySelection();
		var focusEl = args.viewer.policies.focusScope.getFocus();
		if (!focusEl) {
			focusEl = editController; // use selection if no focus currently
		}
		
		if (focusEl && focusEl.policies.selectable) {
			args.viewer.getSelectionController().toggleSelect(focusEl);
			return true;
		}
		
		return false;
	}
});