/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.actions.ZoomTo");

dojo.require("rmpw.diagrams.edit.actions.Action");
dojo.require("dojo.fx.easing");
dojo.require("rmpw.diagrams.render.util.Workarounds");
dojo.require("dojox.gfx.matrix");

/**
 * Smoothly zooms a figure into full view.
 * 
 * @author Marc Gobeil
 * 
 */
dojo.declare("rmpw.diagrams.edit.actions.ZoomTo", rmpw.diagrams.edit.actions.Action, {
	id: "rmpw.diagrams.edit.actions.ZoomTo",
	iconEnableUrl: "web/rmpw.diagrams.edit/icons/zoom.png", // icon from http://publib.boulder.ibm.com/infocenter/ratportm/v7r1m1/index.jsp?topic=/com.ibm.help.doc/icons_and_descriptions_workflow_design.html
	description: "Zoom To",
	_padding: 100,
	_easing: dojo.fx.easing.cubicOut,
	_duration: 750,

	run: function(args) {
		var bounds = dojo.clone(rmpw.diagrams.render.util.Workarounds.getTransformedBoundingBox(this._shape));
		this.host.root.viewport.zoomToBounds(
				bounds.x, bounds.y, bounds.width, bounds.height, this._duration, this._easing, this._padding);		
	},
	
	setShape: function(shape) {
		this._shape = shape;
	},
	
	setPadding: function(padding) {
		this._padding = padding;
	},
	
	setDuration: function(duration) {
		this._duration = duration;
	},
	
	/**
	 * @see http://www.dojotoolkit.org/reference-guide/dojo/fx/easing.html
	 */
	setEasing: function(easing) {
		this._easing = dojo.fx.easing[easing];
	}
});