/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.applications.ReviewApplicationsLauncher");

dojo.require("jazz.core.loader");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

/*Required imports to make sure that request/response interceptors for cross-sever communication will be added */
dojo.require("jazz.app.events");
dojo.require("jazz.app.proxy");
dojo.require("jazz.app.auth");
dojo.require("jazz.client.xhr");

var Modules= {
	main:"dm.review.app.ui.internal.tabs.ReviewMainTab",
	participants: "dm.review.app.ui.internal.tabs.ReviewParticipantsTab",
	resources: "dm.review.app.ui.internal.tabs.ReviewResourcesTab",
	myWork: "dm.review.app.ui.internal.tabs.ReviewMyWorkTab"
};

/* 
 * It is used to invoke a specfic review tab widget based on the passed tabId
 * from the the current url. In addition, it expect the resource uri for the
 * review to be invoked.
 * 
 * Example:
 *	https://localhost:9444/dm/_ajax-modules/dm.review.tab.app#tabId=resources&resourceUri=https%3A%2F%2Ftporabim.dev.ratlcore.ibm.com%3A9444%2Fdm%2Freviews%2F60&projectName=testProject
 * 
 * if the resource uri is undefined, and we tried to use the url directly in the browser, the tab won't load
 * but in the review editor context, we do not need to pass the resource uri parameter, as we pass in the review
 * updater in the frame parameter
 * 
 * TODO: 21251: OSLC Select query should work on reviews as well as models
 *              We should not need to provide a project parameter
 * 
 */
dojo.declare("dm.review.app.applications.ReviewApplicationsLauncher", dijit._Widget, {
	
	
	postCreate: function(){
		var clazz= this.getClassObject();
		jazz.core.loader.load_async(clazz, dojo.hitch(this, function(_jsModule){
			var classConstructor = dojo.getObject(_jsModule);
			var func= dojo.getObject("window.frameElement.initializer");
			this.domNode.appendChild(new classConstructor({reviewController: func?func(this): null}).domNode);									
		},clazz));
	},
	
	getClassObject: function(){
		/*No need for extra NPE check here, as it is the responsbility of other places */
		return Modules[dojo.queryToObject(window.location.hash.replace("#", "")).tabId];
	}

});
})();
