/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.baseline.Baseline");
dojo.require("rmps.core.Enum");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.core.baseline", "BaselineMessages");

var messages = dojo.i18n.getLocalization("rmps.core.baseline", "BaselineMessages");

var BASELINE_NAME = "http://purl.org/dc/terms/title";
var BASELINE_DESCRIPTION = "http://purl.org/dc/terms/description";
var BASELINE_TIMESTAMP = "http://purl.org/dc/terms/issued";
var BASELINE_STATUS = "https://jazz.net/xmlns/rmps/baselines/1.0/status";

rmps.core.baseline.BaselineStates = new rmps.core.Enum({
	PENDING: new rmps.core.EnumLiteral({name: messages.Pending, value: "PENDING", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_pending.gif")}),
	IN_PROGRESS: new rmps.core.EnumLiteral({name: messages.In_Progress, value: "IN_PROGRESS", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_inProgress.gif")}),
	COMPLETED: new rmps.core.EnumLiteral({name: messages.Completed, value: "COMPLETED", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_completed.gif")}),
	ERROR: new rmps.core.EnumLiteral({name: messages.Error, value: "ERROR", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_error.gif")})
});

var States = rmps.core.baseline.BaselineStates;

dojo.declare("rmps.core.baseline.Baseline", null, {

	uri: null,
	name: null,
	description: null,
	status: null,
	timestamp: null,
	
	parseRdfJson: function(uri, rdf) {
		this.uri = uri;
		this.name = rdf[BASELINE_NAME][0].value;
		this.timestamp = dojo.date.stamp.fromISOString(rdf[BASELINE_TIMESTAMP][0].value);		
		this.status = States.get(rdf[BASELINE_STATUS][0].value);
		
		//description is optional
		if (rdf[BASELINE_DESCRIPTION] != null) {
			this.description = rdf[BASELINE_DESCRIPTION][0].value;
		}	
	}	
	
});
})();