/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions');

dojo.require("rmpw.diagrams.edit.EditControllerExtension");
dojo.require("rmpw.diagrams.edit.tools.LabelLinkable");
dojo.require("rmpw.diagrams.edit.tools.Duplicatable");
dojo.require("rmpw.common.command.DuplicateElement");

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////   DIAGRAM   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.FreeFormDiagramGroupBehaviorController");
	
	// add actions to this shape which will be used by behavior policies/popup palette buttons below
	editControllerExtension.setCreateActionsExtension(function(editController) {
		// register dup command 
		var cc = editController.root.getCommandController();
		var command = new rmpw.common.command.DuplicateElement();
		cc.unregisterCommand(command.id);
		cc.registerCommand(command);	
	});

	// rearrange context action bar
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addFreeFormDiagramGroupMenu");
	});
	
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addFreeFormDiagramGroupMenu","editFreeFormDiagramButton");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   RECTANGLE //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.RectangleShapeBehaviorController");
	
	// rearrange context action bar
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addRectangleShapeMenu");
	});

	// add editing tools for this shape to editor
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addRectangleShapeMenu","editRectangleButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   TEXT //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.TextShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   LINK //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.LinkShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		
		policy = editController.createPolicy(rmpw.diagrams.edit.tools.LabelLinkable);
		policy.setUrlLink("dmsketch_url");
		policy.setShape("label");
		policy.setTypeName("URLLink");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   STICK //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.StickShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
	});
	

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CYLINDER   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.CylinderShapeBehaviorController");
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addCylinderShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addCylinderShapeMenu","editCylinderButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CLOUD    //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.CloudShapeBehaviorController");
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addCloudShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addCloudShapeMenu","editCloudButton");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   OVAL    //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.OvalShapeBehaviorController");
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addOvalShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addOvalShapeMenu","editOvalButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   DIAMOND   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.DiamondShapeBehaviorController");
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions(editController,"addDiamondShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions(editController,"addDiamondShapeMenu","editDiamondButton");
	});

	
	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   BORDER   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.FreeFormDiagram.behavior.BorderShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies(editController,false);
	});
		
	rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.modifyCreationPolicies = function(editController) {
		dojo.map(editController.policies, function(policy) {
			if (policy.setRealtimeMode) {
				policy.setRealtimeMode(true);
			}

			if (policy.suppressLabelIncrement) {
				policy.suppressLabelIncrement(true);
			}
		});
	}
	
	rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setExtensionPolicies = function(editController, duplicatable) {
		var policy;
		if (duplicatable!==false) {
			policy = editController.createPolicy(rmpw.diagrams.edit.tools.Duplicatable);
			policy.setOwnerChildrenProperty("dmdiagram_mappingElement");
		}
		editController.policies.pushable.setIsAllowAlignment(true);
		editController.destroyPolicy("RichHover");
		
		if (editController.policies.moveable) {
			editController.policies.moveable.setLiveFeedback(true);
		}
	}
	
	rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setMenuActions = function(editController, policy) {
		var policies = editController.policies;
		if (policies.addDiamondButton && policies.addBorderButton && policies.addURLLinkButton) {
			policies[policy].removeDomainBindings("http://jazz.net/ns/dm/domain/definition/docSystemDomain#");
			
			policies[policy].setActionBindings(policies.addDiamondButton, policies.addBorderButton, policies.addURLLinkButton);
		}
	}

	rmpw.dsv.editor.sketcher.behavior.FreeformSketcherBehaviorExtensions.setContextBarActions = function(editController, menuPolicy, propPolicy) {	
		var policies = editController.policies;
		
		if (policies.addTextButton && policies.addStickButton && policies.addOvalButton && policies.addRectangleButton && 
			policies.addCylinderButton && policies.addCloudButton) {
			
			policies.contextActionBar.removeActionBinding(policies[menuPolicy]);
			policies.contextActionBar.removeActionBinding(policies[propPolicy]);
			policies.contextActionBar.removeDomainBindings("http://jazz.net/ns/dm/domain/definition/docSystemDomain#");
			
			policies.contextActionBar.setActionBindings(policies.addTextButton, policies.addStickButton, 
					policies.addOvalButton, policies.addRectangleButton, policies.addCylinderButton, 
					policies.addCloudButton, policies[menuPolicy], policies[propPolicy]);
			
			policies.contextActionBar.setFeedbackMode(true);
		}
	}
	
