/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmps.diagram.behavior.HotspotDiagramController");

dojo.require("rmps.diagram.behavior.HotSpotController");

dojo.require("rmpw.diagrams.edit.EditController");
dojo.require("rmpw.diagrams.edit.tools.ContextActionBar");


dojo.require("rmpw.diagrams.edit.tools.Selectable");
dojo.require("rmpw.diagrams.edit.tools.Focusable");

/**
 * A diagram behavior controller
 * 
 */
dojo.declare("rmps.diagram.behavior.HotspotDiagramController", rmpw.diagrams.edit.EditController, {	
	
	createTools: function(){
		var policy;		
		policy = this.createPolicy(rmpw.diagrams.edit.tools.Selectable);
	},
	
	createTraces: function() {
		this.renderMapping.createTrace("element", "svgRoot");
	},
	
	init: function(parent) {	
		this.inherited(arguments);	
	},
	 
	/*
	 * based on the mapping connect the appropriate behavior controller
	 */
	attachChild: function(mapping) {
		
		var behavior = null;
		
		switch( mapping.sources.model.eClass ){
		
			case "RectangleHotspot":
			case "LineHotspot":
				behavior = this.createChild(rmps.diagram.behavior.HotSpotController);	
				break;		
				
			case "Tile":
				break;
		}
		
		return behavior;
	}
});
