/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.behavior.LineMaker");

dojo.require("rmps.web.comment.sketch.commands.shapes.CreateLine");
dojo.require("rmps.web.comment.sketch.behavior.AbstractMaker");

dojo.declare("rmps.web.comment.sketch.behavior.LineMaker", rmps.web.comment.sketch.behavior.AbstractMaker, {

	mdconnection: null,
	mmconnection: null,
	muconnection: null,

	drawing: null,
	surface: null,
	viewport: null,
	feedback: null,
	
	controller: null,
	
	linecolor: null,
	linewidth: null,
	linestyle: null,
	
	pointA: null,
	pointB: null,
	
	constructor: function(controller){
		this.controller = controller;
	},
	
	mousedown: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchstart" ) {
			
			e = this.getTouch( e, "touchstart" );
		
			this.group = this.surface.createGroup();
					
			this.pointA = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			this.mouseA = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
		
			this.drawing = this.group.createLine( { x1:this.mouseA.x, 
				  									y1:this.mouseA.y, 
				  									x2:this.mouseA.x, 
				  									y2:this.mouseA.y } );
			
			this.style();
						
			this.mmconnection = dojo.connect( this.surface._parent, "onmousemove", dojo.hitch( this, "mousemove" ) );
			this.muconnection = dojo.connect( document, "onmouseup", dojo.hitch( this, "mouseup" ) );
			
			this.tmconnection = dojo.connect( this.surface._parent, "touchmove", dojo.hitch( this, "mousemove" ) );
			this.teconnection = dojo.connect( document, "touchend", dojo.hitch( this, "mouseup" ) );
			
			this.pointB = null;
		}
		dojo.stopEvent(eOrig);
		
	},
	
	mousemove: function(e){
		
		var eOrig = e;
		e = this.getTouch( e, "touchmove" );
				
		if( this.drawing ){
			
			this.pointB = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			this.mouseB = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );

			this.drawing.setShape({ x1:this.mouseA.x, 
									y1:this.mouseA.y, 
									x2:this.mouseB.x, 
									y2:this.mouseB.y } );
		}  
		
	    dojo.stopEvent(eOrig);
	},
	
	mouseup: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchend" ) {
			
			e = this.getTouch( e, "touchend" );
		
			if( this.pointB != null ){
			
				this.args.linecolor = this.linecolor;
				this.args.linewidth = this.linewidth;
				this.args.strokeopacity = this.strokeopacity;
				this.args.x1 = this.pointA.x;
				this.args.y1 = this.pointA.y;
				this.args.x2 = this.pointB.x;
				this.args.y2 = this.pointB.y;
				this.args.strokedash = this.strokedash;
				
				if( this.group ){
					this.surface.remove( this.group );
				}
				
				this.controller.commandStack.execute( new rmps.web.comment.sketch.commands.shapes.CreateLine(), this.args );		
			}
			
			this.setListeners();
		}
		dojo.stopEvent(eOrig);		

	}
});