/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.behavior.OvalMaker");

dojo.require("rmps.web.comment.sketch.commands.shapes.CreateOval");
dojo.require("rmps.web.comment.sketch.behavior.AbstractMaker");

dojo.declare("rmps.web.comment.sketch.behavior.OvalMaker", rmps.web.comment.sketch.behavior.AbstractMaker, {

	mdconnection: null,
	mmconnection: null,
	muconnection: null,

	drawing: null,
	surface: null,
	viewport: null,
	feedback: null,
	
	controller: null,
	
	linecolor: null,
	linewidth: null,
	linestyle: null,
	
	pointA: null,
	pointB: null,
	
	constructor: function(controller){
		this.controller = controller;
	},
	
	mousedown: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchstart" ) {
			
			e = this.getTouch( e, "touchstart" );
		
			this.group = this.surface.createGroup();
			
			this.zoom = this.viewport.getZoom();
					
			this.pointA = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			this.mouseA = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
		
			this.drawing = this.group.createEllipse( { cx:this.mouseA.x, cy:this.mouseA.y, rx:1, ry:1 } ); 
			
			this.style();
			
			this.pointB = null;
			
			this.mmconnection = dojo.connect( this.surface._parent, "onmousemove", dojo.hitch( this, "mousemove" ) );
			this.muconnection = dojo.connect( document, "onmouseup", dojo.hitch( this, "mouseup" ) );	
			
			this.tmconnection = dojo.connect( this.surface._parent, "touchmove", dojo.hitch( this, "mousemove" ) );
			this.teconnection = dojo.connect( document, "touchend", dojo.hitch( this, "mouseup" ) );
		}
		dojo.stopEvent(eOrig);
		
	},
	
	mousemove: function(e){
				
		var eOrig = e;
		if( this.drawing ){
			
			e = this.getTouch( e, "touchmove" );

			this.pointB = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			this.mouseB = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );

			this.ry = Math.abs( ( this.pointB.y - this.pointA.y )/2 );
			this.rx = Math.abs( ( this.pointB.x - this.pointA.x )/2 );

			if( this.pointB.y  > ( this.pointA.y )  ){
				this.cy = this.pointA.y + this.ry;
				this.mousecy = this.mouseA.y + ( this.ry * this.zoom );
			}else{
				this.cy = this.pointA.y - this.ry;
				this.mousecy = this.mouseA.y - ( this.ry * this.zoom );
			}

			if( this.pointB.x > this.pointA.x ){
				this.cx = this.pointA.x + this.rx;
				this.mousecx = this.mouseA.x + ( this.rx * this.zoom );
			}else{
				this.cx = this.pointA.x - this.rx;
				this.mousecx = this.mouseA.x - ( this.rx * this.zoom );
			}

			this.drawing.setShape( { cx:this.mousecx, cy: this.mousecy, rx: this.rx * this.zoom, ry:this.ry * this.zoom } ); 

			this.style();
		}  
	    dojo.stopEvent(eOrig);
		
	},
	
	mouseup: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchend" ) {
			
			e = this.getTouch( e, "touchend" );
		
			if( this.pointB == null ){
				this.cx = this.pointA.x + 50;
				this.cy = this.pointA.y + 50;
				this.rx = 50;
				this.ry = 50;
			}
			
			this.args.cx = this.cx;
		    this.args.cy = this.cy;
		    this.args.rx = this.rx;
		    this.args.ry = this.ry;
			this.args.linecolor = this.linecolor;
		    this.args.linewidth = this.linewidth;
		    this.args.fill = this.fillcolor;
		    this.args.fillopacity = this.fillopacity;
		    this.args.strokedash = this.strokedash;
		    this.args.strokeopacity = this.strokeopacity;
		
			if( this.group ){
				this.surface.remove( this.group );
			}
			
			this.controller.commandStack.execute( new rmps.web.comment.sketch.commands.shapes.CreateOval(), this.args );
			
			this.setListeners();
		}
		dojo.stopEvent(eOrig);
		
	}
});