/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.process.behavior.ProcessDiagram');

dojo.require("rmpw.diagrams.edit.EditControllerExtension");
dojo.require("rmpw.diagrams.edit.actions.SplitRelationship");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmpw.dsv.editor.process", "Messages");

var messages = dojo.i18n.getLocalization("rmpw.dsv.editor.process", "Messages");

var processShapeControllerExtension = new rmpw.diagrams.edit.EditControllerExtension("rmpw.dsv.codegen.FreeFormDiagram.behavior.ProcessShapeBehaviorController");
processShapeControllerExtension.setCreateActionsExtension(function(editController) {
	var action = editController.createPolicy(rmpw.diagrams.edit.actions.SplitRelationship, "splitFlow");
	action.setOwnerTrace("processShapeModel");
	action.setElementTrace("flowModel");
	action.setTypeId("http://jazz.net/ns/dm/process#Process");
	action.setAddTypeId("http://jazz.net/ns/dm/process#Action");
	action.setOwnerRelTrace("processShapeModel");
	action.setTargetTrace("flowModel.dmprocess_flowTarget");
	action.setRelTypeId("http://jazz.net/ns/dm/process#Process");
	action.setAddRelTypeId("http://jazz.net/ns/dm/process#Flow");
});

processShapeControllerExtension.setCreateActionBindingsExtension(function(editController) {
	var dm = net.jazz.ajax._contextRoot;
	var actionBinding = editController.createPolicy(rmpw.diagrams.edit.actionBindings.Button, "splitFlowButton");
	actionBinding.setAction(editController.policies.splitFlow);
	actionBinding.setIconURL(dm+"/web/rmpw.diagrams.edit/icons/splitrel.png");
	actionBinding.setLabel(messages.SplitFlow);
});

var flowShapeControllerExtension = new rmpw.diagrams.edit.EditControllerExtension("rmpw.dsv.codegen.FreeFormDiagram.behavior.FlowShapeBehaviorController");
flowShapeControllerExtension.setCreateToolsExtension(function(editController) {
	editController.policies.contextActionBar.addActionBinding(editController.parent.policies.splitFlowButton);
});






