/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.behavior.RectangleMaker");

dojo.require("rmps.web.comment.sketch.commands.shapes.CreateRectangle");
dojo.require("rmps.web.comment.sketch.behavior.AbstractMaker");

dojo.declare("rmps.web.comment.sketch.behavior.RectangleMaker", rmps.web.comment.sketch.behavior.AbstractMaker, {

	mdconnection: null,
	mmconnection: null,
	muconnection: null,

	drawing: null,
	surface: null,
	viewport: null,
	feedback: null,
	
	controller: null,
	
	linecolor: null,
	linewidth: null,
	linestyle: null,
	
	pointA: null,
	pointB: null,
	
	constructor: function(controller){
		this.controller = controller;
	},
	
	mousedown: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchstart" ) {
			
			e = this.getTouch( e, "touchstart" );
			
			this.group = this.surface.createGroup();
					
			this.zoom = this.viewport.getZoom();
					
			this.mouseA = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
			this.pointA = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			      
			this.origin = dojo.clone( this.pointA );
			
			this.drawing = this.group.createRect( { x:this.mouseA.x, y:this.mouseA.y, width:1, height:1 } ); 
			this.style();
			
			this.pointB = null;
			
			this.mmconnection = dojo.connect( this.surface._parent, "onmousemove", dojo.hitch( this, "mousemove" ) );
			this.muconnection = dojo.connect( document, "onmouseup", dojo.hitch( this, "mouseup" ) );
			
			this.tmconnection = dojo.connect( this.surface._parent, "touchmove", dojo.hitch( this, "mousemove" ) );
			this.teconnection = dojo.connect( document, "touchend", dojo.hitch( this, "mouseup" ) );
		}
		dojo.stopEvent(eOrig);
		
	},
	
	mousemove: function(e){
				
		var eOrig = e;
		if( this.drawing ){
			
			e = this.getTouch( e, "touchmove" );
			
			this.mouseB = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
			this.pointB = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			
			this.height = Math.abs( this.pointB.y - this.pointA.y );
			this.width = Math.abs( this.pointB.x - this.pointA.x );
		      
			if( this.pointB.y  > this.pointA.y ){
				this.toplefty = this.mouseA.y;	         
				this.origin.y = this.pointA.y;	         
			}else{
				this.toplefty = this.mouseA.y - ( this.height * this.zoom );		         
				this.origin.y = this.pointA.y - this.height;
			}

			if( this.pointB.x > this.pointA.x ){
				this.topleftx = this.mouseA.x;
				this.origin.x = this.pointA.x;
			}else{
				this.topleftx = this.mouseA.x - ( this.width * this.zoom );
				this.origin.x = this.pointA.x - this.width;
			}

			this.drawing.setShape( { x: this.topleftx, y: this.toplefty, width: this.width * this.zoom, height: this.height * this.zoom } ); 
			this.style();
		}  
		dojo.stopEvent(eOrig);
		
	},
	
	mouseup: function(e){
		
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchend" ) {
			
			e = this.getTouch( e, "touchend" );
		
			if( this.pointB == null ){
				this.width = 100;
				this.height = 100;
			}
			
			this.args.x = this.origin.x;
			this.args.y = this.origin.y;
			this.args.width = this.width;
			this.args.height = this.height;
			this.args.linecolor = this.linecolor;
		    this.args.linewidth = this.linewidth;
		    this.args.fill = this.fillcolor;
		    this.args.fillopacity = this.fillopacity;
		    this.args.strokeopacity = this.strokeopacity;
		    this.args.strokedash = this.strokedash;
		
			if( this.group ){
				this.surface.remove( this.group );
			}
			
			this.controller.commandStack.execute( new rmps.web.comment.sketch.commands.shapes.CreateRectangle(), this.args );
			
			this.setListeners();
		
		}
		dojo.stopEvent(eOrig);

	}
});