/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.behavior.Scribbler");

dojo.require("rmps.web.comment.sketch.commands.shapes.CreatePath");
dojo.require("rmps.web.comment.sketch.behavior.AbstractMaker");
dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.declare("rmps.web.comment.sketch.behavior.Scribbler", rmps.web.comment.sketch.behavior.AbstractMaker, {

	mdconnection: null,
	mmconnection: null,
	muconnection: null,

	drawing: null,
	surface: null,
	viewport: null,
	feedback: null,
	
	controller: null,
	
	linecolor: null,
	linewidth: null,
	linestyle: null,
	
	pointA: null,
	pointB: null, 
	
	constructor: function(controller){
		this.controller = controller;
	},
	
	mousedown: function(e){
					
		var eOrig = e;
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchstart" ){
			
			
			e = this.getTouch( e, "touchstart" );
					
			this.group = this.surface.createGroup();
							
			this.pointA = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			this.mousepoint = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
		
			this.drawing = this.group.createPath().moveTo( this.mousepoint.x, this.mousepoint.y ); 
			
			this.relativeDrawing = this.group.createPath().moveTo( this.pointA.x, this.pointA.y ); 
			
			this.style();
			
			this.pointB = null;
			
			this.mmconnection = dojo.connect( this.surface._parent, "onmousemove", dojo.hitch( this, "mousemove" ) );
			this.muconnection = dojo.connect( document, "onmouseup", dojo.hitch( this, "mouseup" ) );
			
			this.tmconnection = dojo.connect( this.surface._parent, "touchmove", dojo.hitch( this, "mousemove" ) );
			this.teconnection = dojo.connect( document, "touchend", dojo.hitch( this, "mouseup" ) );
		}
		dojo.stopEvent(eOrig);
		
	},
	
	store: function(e){
		if( this.pointB != null ){
			
			var util = new rmps.web.comment.sketch.serializer.SVGUtil();
			var newPath = util.softenPath( this.relativeDrawing.segments );
			
			this.args.path = newPath;
			this.args.linecolor = this.linecolor;
			this.args.linewidth = this.linewidth;
			this.args.strokeopacity = this.strokeopacity;
			this.args.strokedash = this.strokedash;
			this.args.fillopacity = this.fillopacity;
			this.args.fill = this.fillcolor;
			this.args.scribble = true;
			
			if( this.group ){
				this.surface.remove( this.group );
			}
			
			this.controller.commandStack.execute( new rmps.web.comment.sketch.commands.shapes.CreatePath(), this.args );	
		}
		
		this.setListeners();
	},
	
	mousemove: function(e){

		var eOrig = e;
		if( this.drawing ){		
			
			e = this.getTouch( e, "touchmove");
			
			var point = this.viewport.getSurfaceRelativeMousePosition( e.clientX, e.clientY );
			
			this.mousepoint = this.viewport.getSurfaceAbsoluteMousePosition( e.clientX, e.clientY );
			this.drawing.lineTo( this.mousepoint.x, this.mousepoint.y );		
			this.relativeDrawing.lineTo( point.x, point.y ); 
			
			this.pointB = point;
		}  
	    dojo.stopEvent(eOrig);
		
	},
	
	mouseup: function(e){
		
		if(e.button == dojo.mouseButtons.LEFT || e.type == "touchend" ) {
			this.store();
		}
		
		dojo.stopEvent(e);
	}
});