/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmps.web.comment.sketch.behavior.ShapeController");

dojo.require("rmpw.diagrams.edit.EditController");
dojo.require("rmpw.diagrams.edit.tools.Focusable");
dojo.require("rmpw.diagrams.edit.tools.Resizable");
dojo.require("rmpw.diagrams.edit.tools.Moveable");
dojo.require( "rmpw.diagrams.edit.handles.HandleUtils" );
dojo.require("rmps.web.comment.sketch.utilities.ChildBounds");
dojo.require("rmpw.diagrams.edit.actionBindings.Button");
dojo.require("rmpw.diagrams.edit.actions.NativeCode");

dojo.declare("rmps.web.comment.sketch.behavior.ShapeController", rmpw.diagrams.edit.EditController, {	
	
	position: rmpw.diagrams.edit.handles.HandleUtils,
		
	createActions: function() {
		var action;
		
		/* 
		 * TODO: Acting strictly on groups at the moment ... needs some thought
		 * if working on primitives. 
		 */
		action = this.createPolicy(rmpw.diagrams.edit.actions.NativeCode, "changePosition");
		action.setRun(function(args) {
			var renderMapping = this.host.renderMapping;					
			var bounds = renderMapping.policies.graphNode.getBounds();
			
			if (renderMapping.sources.svgShape.eClass && args.x != null && args.y != null){
				var mover = new rmps.web.comment.sketch.utilities.ChildBounds();
				bounds.x = args.x;
				bounds.y = args.y;
				mover.build( args.changeSet, renderMapping.sources.svgShape, bounds );
			}
			
			return true;
		});
		
		/* 
		 * TODO: Acting strictly on groups at the moment ... needs some thought
		 * if working on primitives. 
		 */
		action = this.createPolicy(rmpw.diagrams.edit.actions.NativeCode, "changeSize");
		action.setRun(function(args) {
			var renderMapping = this.host.renderMapping;
			var bounds = renderMapping.policies.graphNode.getBounds();
			
			if (renderMapping.sources.svgShape.eClass && args.x != null && args.y != null){
				var mover = new rmps.web.comment.sketch.utilities.ChildBounds();
				bounds.x = args.x;
				bounds.y = args.y;
				bounds.width = args.width;
				bounds.height = args.height;
				mover.build( args.changeSet, renderMapping.sources.svgShape, bounds );
			}
			
			return true;
		});
	},
		
	createTools: function() {
		var policy;

		if( this.root.__editMode ){
			policy = this.createPolicy( rmpw.diagrams.edit.tools.Focusable);

			policy = this.createPolicy( rmpw.diagrams.edit.tools.Resizable );
			policy.setOnChangeSize(this.policies.changeSize);
			
			policy = this.createPolicy( rmpw.diagrams.edit.tools.Moveable);
			policy.setOnChangePosition(this.policies.changePosition);
		}	
    }
});