/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmps.web.comment.sketch.behavior.ShapeWithTextController");

dojo.require("rmps.web.comment.sketch.behavior.ShapeController");
dojo.require("rmpw.diagrams.edit.actionBindings.AlphaNumericKeyStroke");
dojo.require("rmpw.diagrams.edit.actionBindings.MouseDoubleClick");
dojo.require("rmpw.diagrams.edit.actionBindings.Button");
dojo.require("rmps.web.comment.sketch.actions.AddText");
dojo.require("rmpw.diagrams.edit.tools.LabelEditable");
dojo.require("rmpw.diagrams.edit.tools.ContextActionBar");

dojo.requireLocalization("rmps.web.comment.sketch", "ToolStrings");
var strings = dojo.i18n.getLocalization("rmps.web.comment.sketch", "ToolStrings");

dojo.declare("rmps.web.comment.sketch.behavior.ShapeWithTextController", rmps.web.comment.sketch.behavior.ShapeController, {	
	
	position: rmpw.diagrams.edit.handles.HandleUtils,
		
	createActions: function() {
		this.inherited(arguments);
		
		this.createPolicy(rmps.web.comment.sketch.actions.AddText, "text");
	},
	
	createActionBindings: function() {
		var actionBinding;
		
		actionBinding = this.createPolicy(rmpw.diagrams.edit.actionBindings.Button, "textButton");
		actionBinding.setIconURL( dojo.moduleUrl("rmps.web.comment.sketch", "icons/pal/text_pal16.png") );
		actionBinding.setDescription( strings.text_label );
		actionBinding.setAction(this.policies.text);
		
		actionBinding = this.createPolicy(rmpw.diagrams.edit.actionBindings.MouseDoubleClick, "invokeEditWrappingTextExpression");
		actionBinding.setAction(this.policies.text);
		actionBinding.setShape("wrappingTextExpression");
		
		actionBinding = this.createPolicy(rmpw.diagrams.edit.actionBindings.AlphaNumericKeyStroke, "invokeKeyEditWrappingTextExpression");
		actionBinding.setAction(this.policies.text);
	},
	
	createTools: function() {
		this.inherited(arguments);
		
		var policy;

		if( this.root.__editMode ){
			policy = this.createPolicy(rmpw.diagrams.edit.tools.LabelEditable);
			policy.setOnEditLabel(this.policies.text);
			policy.setShape("wrappingTextExpression");
			
			policy = this.createPolicy(rmpw.diagrams.edit.tools.ContextActionBar);
			policy.setActionBindings( this.policies.textButton );
		}	
		
		
    }
});