/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions');

//dojo.require("rmpw.diagrams.edit.actions.NativeCode");
dojo.require("rmpw.diagrams.edit.EditControllerExtension");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherAddElement");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherAddRelationship");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherResizable");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherMoveable");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherBendpointAction");
dojo.require("rmpw.dsv.editor.sketcher.behavior.SketcherRouterChangeable");
dojo.require("rmpw.diagrams.edit.tools.LabelLinkable");
dojo.require("rmpw.diagrams.edit.tools.Duplicatable");
dojo.require("rmpw.dsv.editor.sketcher.behavior.DuplicateElement");

///////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////   DIAGRAM   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.DiagramShapeBehaviorController");
	
	// add actions to this shape which will be used by behavior policies/popup palette buttons below
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"document");
		
		// register dup command 
		var cc = editController.root.getCommandController();
		var command = new rmpw.dsv.editor.sketcher.behavior.DuplicateElement();
		cc.unregisterCommand(command.id);
		cc.registerCommand(command);		
	});

	// rearrange context action bar
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addDiagramShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addDiagramShapeMenu","editSketchButton");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   RECTANGLE //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.RectangleShapeBehaviorController");

	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"rect");
	});
	
	// rearrange context action bar
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addRectangleShapeMenu");
	});

	// add editing tools for this shape to editor
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addRectangleShapeMenu","editRectangleButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   TEXT //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.TextShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   LINK //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.LinkShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		
		policy = editController.createPolicy(rmpw.diagrams.edit.tools.LabelLinkable);
		policy.setUrlLink("sketch_url");
		policy.setShape("label");
		policy.setTypeName("URLLink");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   STICK //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.StickShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
	});
	

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CYLINDER   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.CylinderShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"cylndr");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addCylinderShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addCylinderShapeMenu","editCylinderButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CLOUD    //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.CloudShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"cld");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addCloudShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addCloudShapeMenu","editCloudButton");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CIRCLE   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.CircleShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"crcle");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addCircleShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addCircleShapeMenu","editCircleButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   OVAL    //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.OvalShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"ovl");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addOvalShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addOvalShapeMenu","editOvalButton");
	});


	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   DIAMOND   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.DiamondShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"dmnd");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addDiamondShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addDiamondShapeMenu","editDiamondButton");
	});

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   PICTURE   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.PictureShapeBehaviorController");
	editControllerExtension.setCreateActionsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions(editController,"pict");
	});
	editControllerExtension.setCreateActionBindingsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions(editController,"addPictureShapeMenu");
	});
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController);
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions(editController,"addPictureShapeMenu","editPictureButton");
	});

	

	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   BORDER   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.BorderShapeBehaviorController");
	editControllerExtension.setCreateToolsExtension(function(editController) {
		rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies(editController,false);
	});
	
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CONNECTION   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.ConnectionShapeBehaviorController");
	
	editControllerExtension.setCreateActionsExtension(function(editController) {
		editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherBendpointAction, "bendpointAction");
	});	
	
	editControllerExtension.setCreateToolsExtension(function(editController) {
		editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherRouterChangeable);
		editController.policies.polylineEditable.setOnChangeBendpoints(editController.policies.bendpointAction);
	});	
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   CONNECTION LABEL  //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
			"rmpw.dsv.codegen.SketcherDiagram.behavior.ConnectionLabelShapeBehaviorController");
	
	editControllerExtension.setCreateToolsExtension(function(editController) {
		editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherMoveable);
		editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherResizable);
	});	
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   HELPERS   //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
	
	rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.addElementShapeActions = function(editController, owner) {
		var action;
		
		// TextShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addText");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Text");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// LinkShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addURLLink");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#URLLink");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// StickShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addStick");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Stick");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// RectangleShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addRectangle");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Rectangle");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// CylinderShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addCylinder");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Cylinder");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// CloudShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addCloud");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Cloud");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// CircleShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addCircle");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Circle");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// OvalShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addOval");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Oval");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// DiamondShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addDiamond");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Diamond");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// PictureShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addPicture");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Picture");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		// BorderShape
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddElement, "addBorder");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Border");
		action.setRealtimeMode(true);
		action.suppressLabelIncrement(true);
		
		action = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherAddRelationship, "addConnectionShape");
		action.setOwnerTrace(owner);
		action.setTypeId("http://jazz.net/ns/dm/sketcher#SketchContainer");
		action.setAddTypeId("http://jazz.net/ns/dm/sketcher#Connection");

		// deletes
		editController.policies.deleteText.setRealtimeMode(true);
		editController.policies.deleteURLLink.setRealtimeMode(true);
		editController.policies.deleteStick.setRealtimeMode(true);
		editController.policies.deleteRectangle.setRealtimeMode(true);
		editController.policies.deleteCylinder.setRealtimeMode(true);
		editController.policies.deleteCloud.setRealtimeMode(true);
		editController.policies.deleteCircle.setRealtimeMode(true);
		editController.policies.deleteOval.setRealtimeMode(true);
		editController.policies.deleteDiamond.setRealtimeMode(true);
		editController.policies.deletePicture.setRealtimeMode(true);
		editController.policies.deleteBorder.setRealtimeMode(true);
		editController.policies.deleteConnectionShape.setRealtimeMode(true);
	}

	rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setExtensionPolicies = function(editController, duplicatable) {
		var policy;
		policy = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherMoveable);
		policy = editController.createPolicy(rmpw.dsv.editor.sketcher.behavior.SketcherResizable);
		if (duplicatable!==false) {
			policy = editController.createPolicy(rmpw.diagrams.edit.tools.Duplicatable);
			policy.setOwnerChildrenProperty("sketch_shape");
		}
		editController.policies.pushable.setIsAllowAlignment(true);
		editController.destroyPolicy("RichHover");
	}
	
	rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setMenuActions = function(editController, policy) {
		editController.policies[policy].removeAllBindings();
		
		editController.policies[policy].setActionBindings(editController.policies.addCircleButton, 
				editController.policies.addDiamondButton, editController.policies.addPictureButton, editController.policies.addBorderButton,
				editController.policies.addURLLinkButton);
	}

	rmpw.dsv.editor.sketcher.behavior.SketcherBehaviorExtensions.setContextBarActions = function(editController, menuPolicy, propPolicy) {	
		editController.policies.contextActionBar.removeAllBindings();
		
		editController.policies.contextActionBar.setActionBindings(editController.policies.addTextButton, editController.policies.addStickButton, 
				editController.policies.addOvalButton, editController.policies.addRectangleButton, editController.policies.addCylinderButton, 
				editController.policies.addCloudButton, editController.policies[menuPolicy], editController.policies[propPolicy]);
		editController.policies.contextActionBar.setFeedbackMode(true);
	}
	
	///////////////////////////////////////////////////////////////////////////////////////////////
	///////////////////////   EXAMPLE //////////////////////////////////////////////////////////
	//////////////////////////////////////////////////////////////////////////////////////////////
//	var editControllerExtension = new rmpw.diagrams.edit.EditControllerExtension(
//			"rmpw.dsv.codegen.SketcherDiagram.behavior.RectangleShapeBehaviorController");
//	
//	// add actions to this shape which will be used by behavior policies/popup palette buttons below
//	editControllerExtension.setCreateActionsExtension(function(editController) {
//		var action;
//				
//				action = editController.createPolicy(rmpw.diagrams.edit.actions.NativeCode, "changePosition");
//				action.setRun(function(args) {
//		            var x = this.host.renderMapping.traces.x;
//		            var y = this.host.renderMapping.traces.y;
//		            if (x && y) {
//		            	var change = args.changeSet.createChange(this.host.renderMapping.sources.rect);
//		            	change.set(x.propertyName, args.x);
//		            	change.set(y.propertyName, args.y);
//		            	return true;
//		            }
//				});
//		});
//
//		// add editing tools for this shape to editor
//		editControllerExtension.setCreateToolsExtension(function(editController) {
//			var tool;
////				tool.setOnChangePosition(editController.policies.changePosition);
//		});
