/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.sketcher.behavior.SketcherBendpointAction");

dojo.require("rmpw.diagrams.edit.actions.Action");

/**
 * Persist connection
 * 
 * @author John Swanke
 */
dojo.declare("rmpw.dsv.editor.sketcher.behavior.SketcherBendpointAction", rmpw.diagrams.edit.actions.Action, {
	
	run: function(args) {
		var renderMapping = this.host.renderMapping;
		var bendpointsTrace =  renderMapping.traces.bendpoints;
		var sourceAnchorTrace = renderMapping.traces.sourceAnchor;
		var targetAnchorTrace = renderMapping.traces.targetAnchor;
		var avoidObstructionsTrace = renderMapping.traces.avoidObstructions;
		var smoothnessTrace = renderMapping.traces.smoothness;
		if (bendpointsTrace && sourceAnchorTrace && targetAnchorTrace && avoidObstructionsTrace) {
			var change = args.changeSet.createChange(this.host.renderMapping.sources.conn);
			change.set(bendpointsTrace.propertyName, args.bendpoints);
			change.set(sourceAnchorTrace.propertyName, args.sourceAnchor);
			change.set(targetAnchorTrace.propertyName, args.targetAnchor);
			if (!args.autoLock) change.set(avoidObstructionsTrace.propertyName, false);
			if (args.layout && smoothnessTrace) {
				change.set(smoothnessTrace.propertyName, {rdf_about: "http://jazz.net/ns/dm/sketcher#Smoothness-none"});
			}
			return true;
		}
		return false;
	}

});