/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.sketcher.behavior.SketcherResizable");

dojo.require("rmpw.diagrams.edit.tools.Resizable");

/**
 * @author John Swanke
 */
dojo.declare("rmpw.dsv.editor.sketcher.behavior.SketcherResizable", rmpw.diagrams.edit.tools.Resizable, {
	
	constructor: function() {
		this.host.__setUpdateSize = dojo.hitch(this, function(changeSet, x, y, width, height) {
			// floating labels have their own locater
			var safeTrace;
			if (this.host.renderMapping.policies.graphFloatingLabel !== undefined) {
	            safeTrace = this.host.renderMapping.traces.labelText;				
			} else {
				this.host.__setUpdatePosition(changeSet, x, y);
	            safeTrace = this.host.renderMapping.traces.x;
			}
			var widthTrace = this.host.renderMapping.traces.width;
			var heightTrace = this.host.renderMapping.traces.height;
			if (safeTrace && widthTrace && heightTrace) {
				// use safeTrace because it will always exist (width,height might be undefined)
				var change = changeSet.createChange(safeTrace.getOwner());
				change.set(widthTrace.propertyName, width);
				change.set(heightTrace.propertyName, height);
				return true;
			}
			
        	// also need to update internal width,height so that GraphNode#getConstraintBounds() works
			var wTrace = this.host.renderMapping.traces[this.host.renderMapping.policies.graphElement._getInternalTraceName("width")];
			var hTrace = this.host.renderMapping.traces[this.host.renderMapping.policies.graphElement._getInternalTraceName("height")];
			if (wTrace && hTrace) {
				var change = changeSet.createChange(wTrace.getOwner());
				change.set(wTrace.propertyName, width);
				change.set(hTrace.propertyName, height);
				return true;
			} else {
				return false;
			}
			
			return false;
		});
	}

});