/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.sketcher.behavior.SketcherRouterChangeable");

dojo.require("rmpw.diagrams.edit.tools.RouterChangeable");

/**
 * @author John Swanke
 */
dojo.declare("rmpw.dsv.editor.sketcher.behavior.SketcherRouterChangeable", rmpw.diagrams.edit.tools.RouterChangeable, {
	
	constructor: function(host) {
    	this.host = host;
		this.host.__setChangeRouter = dojo.hitch(this, function(changeSet, router) {
            var trace = this.host.renderMapping.traces.routing;
            if (trace) {
            	var change = changeSet.createChange(this.host.renderMapping.sources.conn);
            	var prop;            	
            	switch (router) {
            	default:
        		case rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.OBLIQUE_ROUTING:
        			prop = {rdf_about:'http://jazz.net/ns/dm/sketcher#Router-oblique'};
        			break;
        		case rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.RECTILINEAR_ROUTING:
        			prop = {rdf_about: 'http://jazz.net/ns/dm/sketcher#Router-orthogonal'};
        			break;
        		case rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.TREE_ROUTING:
        			prop = {rdf_about: 'http://jazz.net/ns/dm/sketcher#Router-tree'};
        			break;
            	}
            	change.set(trace.propertyName, prop);
            	
            	// also need to update internal edge
				var routerTrace = host.renderMapping.traces[this.host.renderMapping.policies.graphEdge._getInternalTraceName("router")];			
				if (routerTrace) {
					var change = changeSet.createChange(routerTrace.getOwner());
					change.set(routerTrace.propertyName, router);
					return true;
				} else {
					return false;
				}
            }
			return false;
		});
	}

});