/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.behavior.TextMaker");
dojo.require("rmps.web.comment.sketch.behavior.RectangleMaker");

dojo.require("rmps.web.comment.sketch.commands.shapes.CreateTextBox");

dojo.declare("rmps.web.comment.sketch.behavior.TextMaker", rmps.web.comment.sketch.behavior.RectangleMaker, {
	
	style: function(){
		
		this.linecolor = "silver";
		this.strokeopacity = 0;
		this.strokedash = this.page.lineStyler.getLineStyle();
		
		var drawingColor = new dojo.Color( this.linecolor );
		drawingColor.a = 0.5;
		
		this.linewidth = this.page.lineStyler.getLineWidth();	
		
		this.fillcolor = this.page.fillpicker.color;
		this.fillopacity = 0.0;		// if user wants fill they would use a shape
		this.textColor = this.page.textfillpicker.color;
		
		var drawingFill = new dojo.Color( this.fillcolor );
		drawingFill.a = this.fillopacity;
		
		var dojoStyle = this.getStrokeStyle( this.strokedash );
		
		this.drawing.setStroke( {color: drawingColor, width: this.linewidth, style: dojoStyle } );
		
		this.drawing.setFill( drawingFill );
	},
	
	mouseup: function(e){
		
		if(e.button == dojo.mouseButtons.LEFT) {
		
			if( this.pointB == null ){
				this.width = 100;
				this.height = 100;
			}
			
			this.args.x = this.origin.x;
			this.args.y = this.origin.y;
			this.args.width = this.width;
			this.args.height = this.height;
			this.args.linecolor = this.linecolor;
		    this.args.linewidth = this.linewidth;
		    this.args.textColor = this.textColor;
		    this.args.fill = this.fillcolor;
		    this.args.fillopacity = this.fillopacity;
		    this.args.strokeopacity = this.strokeopacity;
		    this.args.strokedash = this.strokedash;
		
			if( this.group ){
				this.surface.remove( this.group );
			}
			
			this.controller.commandStack.execute( new rmps.web.comment.sketch.commands.shapes.CreateTextBox(), this.args );
			
			this.setListeners();
		
		}

		dojo.stopEvent(e);
	}

});