/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("rmps.core.changesets.Changeset");
	dojo.require("dojo.i18n");
	dojo.requireLocalization("rmps.core.changesets", "ChangesetMessages");

	var messages = dojo.i18n.getLocalization("rmps.core.changesets", "ChangesetMessages");

	rmps.core.changesets.ChangesetStates = new rmps.core.Enum({
		ACTIVE: new rmps.core.EnumLiteral({name: messages.Active, value: "ACTIVE"}),
		SUSPENDED: new rmps.core.EnumLiteral({name: messages.Suspended, value: "SUSPENDED"}),
		READONLY: new rmps.core.EnumLiteral({name: messages.Readonly, value: "READONLY"}),
		COMMITTED: new rmps.core.EnumLiteral({name: messages.Committed, value: "COMMITTED"})
	});

	var States = rmps.core.changesets.ChangesetStates;
	
	var VVC_PATH = "http://jazz.net/ns/vvc#";
	var DCTERMS_PATH = "http://purl.org/dc/terms/";
	
	var CHANGESET_CREATOR = DCTERMS_PATH + "creator";
	var CHANGESET_STATE = VVC_PATH + "state";
	var CHANGESET_NAME = DCTERMS_PATH + "title";
	var CHANGESET_CREATION = DCTERMS_PATH + "created";
	var CHANGESET_DESCRIPTION = DCTERMS_PATH + "description";
	var CHANGESET_COMPLETION = VVC_PATH + "completionTime";
		

	dojo.declare("rmps.core.changesets.Changeset", null, {
		uri: null,
		creator: null,
		state: null,
		creation: null,
		description: null,
		name: null,
		completion: null,
	
		parseRdfJson: function(uri, rdf) {
			this.uri = uri;
			this.creator = rdf[CHANGESET_CREATOR][0].value;					
			this.state = States.get(rdf[CHANGESET_STATE][0].value);
			//name is optional
			if (rdf[CHANGESET_NAME]) {
				this.name = rdf[CHANGESET_NAME][0].value;
			}else{
				this.name = this.uri;
			}
			this.creation = dojo.date.stamp.fromISOString(rdf[CHANGESET_CREATION][0].value);
			//completion is optional
			if (rdf[CHANGESET_COMPLETION]) {
				this.completion = dojo.date.stamp.fromISOString(rdf[CHANGESET_COMPLETION][0].value);
			}
			//description is optional
			if (rdf[CHANGESET_DESCRIPTION]) {
				this.description = rdf[CHANGESET_DESCRIPTION][0].value;
			}
		},
			
	});	
})();
