/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("rmps.core.changesets.ChangesetSummary");
	dojo.require("rmps.core.changesets.Changeset");
	dojo.require("dojo.i18n");

	dojo.requireLocalization("rmps.core.changesets", "ChangesetMessages");

	var messages = dojo.i18n.getLocalization("rmps.core.changesets", "ChangesetMessages");
	
	dojo.declare("rmps.core.changesets.ChangesetSummary", null, {
		uri: null,
		user: null,
		state: null,
		name: null,
		description: null,
		modificationTime: null,
	
		parseJson: function(json) {	
			this.uri = json.uri;
			this.user = json.creatorUri;
			//state is optional
			if (json.state){
				this.state = rmps.core.changesets.ChangesetStates.get(json.state);				
			}

			//title is optional
			if (json.title) {
				this.name = json.title;
			}else{
				this.name = this.uri;
			}
			
			if (json.description){
				this.descripiton = json.description;
			}
			
			this.modificationTime = json.modificationTime;
		}
	
	});
})();