/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.clipboard.ClipboardDialog");

dojo.require("jazz.ui.Dialog");
dojo.require("rmps.ui.clipboard.ClipboardWidget");

(function(){

dojo.declare("rmps.ui.clipboard.ClipboardDialog", jazz.ui.Dialog, {
	messages: dojo.i18n.getLocalization("rmps.ui.clipboard", "ClipboardWidgetMessages"),

	readOnly: true,
	width: "1000px",
	
	_table: null,
	
	postCreate: function() {
		if (!this.primaryTitle || this.primaryTitle.length === 0) {
			this.primaryTitle = this.messages.clipboardTitle;
		}
		this.setTitle(this.primaryTitle);
		if (!this.contentNode) {
			this.contentNode = new rmps.ui.clipboard.ClipboardWidget({
				onOkButton: dojo.hitch(this, this.onOkButton),
				onCancelButton: dojo.hitch(this, this.onCancelButton),
				readOnly: this.readOnly
			}).domNode;
		}
		
		this.inherited(arguments);
	},
	
	destroy: function() {
		if (this._table) {
			this._table.destroy();
			delete this._table;
		}
		
		this.inherited(arguments);
	},
	
	onOkButton: function(selection) {
		
	},
	
	onCancelButton: function() {
		// close will call destroy as well.
		this.close();			
	}
});

}());