/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.AddRelationship");

dojo.require("rmpw.common.command.AddElement");

/**
 * Command that creates a relationship element
 * 
 * @author Marc Gobeil / Steve Shaw
 */
dojo.declare("rmpw.common.command.AddRelationship", rmpw.common.command.AddElement, {
	id: "rmpw.common.command.AddRelationship",
	
	updateChangeSet: function(changeSet, args) {
		args.isRelationship = true;
		this.inherited(arguments);
		
		// handle the semantics
		var relElementChange = changeSet.createChange(this.semanticModel);
		if (args.sourceElement) {
			var sourceOwner = this.semanticModel[args.sourceProperty];
			if (dojo.isArray(sourceOwner)) {
				if(args.sourceProperty in args.sourceElement) {
					relElementChange.push(args.sourceProperty, args.sourceElement);
				} else {
					relElementChange.set(args.sourceProperty, [args.sourceElement]);
				}
			}
			else {
				relElementChange.set(args.sourceProperty, args.sourceElement);
			}
		}
		
		if (args.targetElement) {
			var targetOwner = this.semanticModel[args.targetProperty];
			if (dojo.isArray(targetOwner)) {
				if(args.targetProperty in args.targetElement) {
					relElementChange.push(args.targetProperty, args.targetElement);
				} else {
					relElementChange.set(args.targetProperty, [args.targetElement]);
				}
			}
			else {
				relElementChange.set(args.targetProperty, args.targetElement);
			}
		}
		
		return true;
	},
	
	setSourceProperty: function(sourceProperty) {
		this._options.sourceProperty = sourceProperty;
	},
	
	setTargetProperty: function(targetProperty) {
		this._options.targetProperty = targetProperty;
	}
	
});