/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.AddType");

dojo.require("rmpw.common.command.Command");

/**
 * Adds a type to an object.
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.common.command.AddType", rmpw.common.command.Command, {
	id: "rmpw.common.command.AddType",

	updateChangeSet: function(changeSet, args) {
		var obj = args.obj;
		var typeToAdd = args.type;
		var existingTypes = obj.rdf_type; 
		if(dojo.isArray(existingTypes)) {
			var index = this._getExistingType(existingTypes, typeToAdd);
			var change = changeSet.createChange(obj);
			if (index == -1) {
				change.push('rdf_type', { rdf_about: typeToAdd });
			} else {
				// if already added, remove
				change.removeArrayAt('rdf_type', index, existingTypes[index]);
			}
		}
		return true;
	},
	
	_getExistingType: function(existingTypes, typeToAdd) {
		for (var i = 0; i<existingTypes.length; i++) {
			if (existingTypes[i].rdf_about == typeToAdd) {
				return i;
			}
		}
		return -1;
	}
	
	
});