/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.ChangeProperty");

dojo.require("rmpw.common.command.Command");

/**
 * Command to rename an element
 * 
 * options:
 * 		ownerElement: the owning element that will own the newly created element
 * 		property: the name of the property on the ownerElement to be changed
 * 		newValue: the new value to set
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.common.command.ChangeProperty", rmpw.common.command.Command, {
	id: "rmpw.common.command.ChangeProperty",

	updateChangeSet: function(changeSet, args) {
		var modelElement = changeSet.createChange(args.ownerElement);
		modelElement.set(args.property, args.newValue);
		return true;
	},
	
	setProperty: function(property) {
		this._options.property = property;
	}
});