/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.common.command.DeleteReference");

dojo.require("rmpw.common.command.DeleteElement");

/**
 * Command that deletes a reference to an element
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.common.command.DeleteReference", rmpw.common.command.DeleteElement, {
	id: "rmpw.common.command.DeleteReference",
	
	updateChangeSet: function(changeSet, args) {
		// delete the model from the master model
		var semanticChange = changeSet.createChange(args.ownerElement);
		semanticChange.removeReferenceArrayAndMapping(args.ownerChildrenProperty, args.elementToDelete, args.deletedRenderMapping);
		
		return true;
	}
});
