/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.commands.ChangeLineStyleCommand");

dojo.require("rmpw.common.command.Command");

/**
 * Command for changing the line style.
 * 
 * @author Cherie Revells
 */
dojo.declare("rmpw.diagrams.edit.commands.ChangeLineStyleCommand", rmpw.common.command.Command, {
	id: "rmpw.diagrams.edit.commands.ChangeLineStyleCommand",
	description: "Change Line Style",
	
	updateChangeSet: function(changeSet, args) {
		if (!args.width && !args.style) {
			return false;
		}
		for(var i = 0, editController; editController = args.editControllers[i]; i++) {
			var renderMapping = editController.renderMapping;			
			var styleable = renderMapping.policies.styleable;
			
			if (!styleable) {
				continue;
			}
			
			var styleTrace = renderMapping.traces[styleable._getInternalTraceName(args.width ? "lineWidth" : "lineStyle")];
			if (styleTrace) {
				var change = changeSet.createChange(styleTrace.getOwner());
				change.set(styleTrace.propertyName, args.width ? args.width : args.style);
			}
		}
		
		return true;
	}

});