/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.commands.ChangeRouterCommand");

dojo.require("rmpw.common.command.Command");

/**
 * 
 * @author Steve Shaw
 * 
 * Command for changing the line routing style
 */
dojo.declare("rmpw.diagrams.edit.commands.ChangeRouterCommand", rmpw.common.command.Command, {
	id: "rmpw.diagrams.edit.commands.ChangeRouterCommand",
	description: "Change Router",
	
	updateChangeSet: function(changeSet, args) {
		for(var i = 0, editController; editController = args.editControllers[i]; i++) {
			var renderMapping = editController.renderMapping;
			
			var graphEdge = renderMapping.policies.graphEdge;
			if (!graphEdge) {
				continue;
			}
			
			if (editController.__setChangeRouter) {
				editController.__setChangeRouter(changeSet, args.routing);
			}
		}
		return true;
	}

});