/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.commands.shapes.CreateLine");

dojo.require("rmpw.common.command.Command");
dojo.require("rmps.web.comment.sketch.commands.shapes.TextArguments");

dojo.declare("rmps.web.comment.sketch.commands.shapes.CreateLine", rmpw.common.command.Command, {
	id: "rmps.web.comment.sketch.commands.shapes.CreateLine",
	icon: null,
	description: "CreateLine",
	
	updateChangeSet: function(changeSet, args) {
	
		var line = {
			eClass: "LineType",
		    x1: args.x1,
		    y1: args.y1,
		    x2: args.x2,
		    y2: args.y2,
		    stroke: args.linecolor,
		    strokeOpacity: args.strokeopacity,
		    strokeWidth: args.linewidth,
		    strokeDasharray: args.strokedash
		};
		
		var text = new rmps.web.comment.sketch.commands.shapes.TextArguments(args);		
		dojo.mixin( line, text.arguments() );
		
		var lineGroup = {
			eClass: "GType",
			elementId:"Line",
			line: [ line ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", lineGroup);

		return true;
	}
});