/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.commands.shapes.CreateOval");

dojo.require("rmpw.common.command.Command");
dojo.require("rmps.web.comment.sketch.commands.shapes.TextArguments");

dojo.declare("rmps.web.comment.sketch.commands.shapes.CreateOval", rmpw.common.command.Command, {
	id: "rmps.web.comment.sketch.commands.shapes.CreateOval",
	icon: null,
	description: "CreateOval",
	
	updateChangeSet: function(changeSet, args) {
	
		var oval = {
			eClass: "EllipseType",
		    cx: args.cx,
		    cy: args.cy,
		    rx: args.rx,
		    ry: args.ry,
		    stroke: args.linecolor,
		    strokeOpacity: args.strokeopacity,
		    strokeWidth: args.linewidth,
		    fill: args.fill,
		    fillOpacity: args.fillopacity,
		    strokeDasharray: args.strokedash
		    // style : "stroke-width:4;stroke:rgb(255,140,0);fill-opacity:0"
		};
		
		var text = new rmps.web.comment.sketch.commands.shapes.TextArguments(args);		
		dojo.mixin( oval, text.arguments() );
		
		var ovalGroup = {
			eClass: "GType",
			elementId:"Oval",
			ellipse: [ oval ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", ovalGroup);

		return true;
	}
});