/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.web.comment.sketch.commands.shapes.CreatePath");

dojo.require("rmpw.common.command.Command");
dojo.require("rmps.web.comment.sketch.commands.shapes.TextArguments");

dojo.declare("rmps.web.comment.sketch.commands.shapes.CreatePath", rmpw.common.command.Command, {
	id: "rmps.web.comment.sketch.commands.shapes.CreatePath",
	icon: null,
	description: "CreatePath",
	
	updateChangeSet: function(changeSet, args) {
		var path = {
			eClass: "PathType",
		    d: args.path,
		    stroke: args.linecolor,
		    strokeWidth: args.linewidth,
		    fill: args.fill,
		    fillOpacity: args.fillopacity,
		    strokeOpacity: args.strokeopacity,
		    strokeDasharray: args.strokedash
		};
		
		var text = new rmps.web.comment.sketch.commands.shapes.TextArguments(args);		
		dojo.mixin( path, text.arguments() );
		
		var pathgroup = {
			eClass: "GType",
			elementId:"Path",
			path: [ path ]
	    };
		
		var change = changeSet.createChange(args.svgParent);
		change.push("g", pathgroup);

		return true;
	}
});