/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.commenting.CommentEntryActionBar");

dojo.require("dijit._Widget");
dojo.require("dojo.i18n");

dojo.require("jazz.app.context");
dojo.require("jazz.ui.SimpleToolbar");

dojo.require("rmps.core.baseline.BaselineClient");

dojo.requireLocalization("rmps.ui.commenting", "CommentEntryActionBarMessages");

var messages = dojo.i18n.getLocalization("rmps.ui.commenting", "CommentEntryActionBarMessages");

var BaselineClient = rmps.core.baseline.BaselineClient;

dojo.declare("rmps.ui.commenting.CommentEntryActionBar", jazz.ui.SimpleToolbar, {
	
	"class": "rmps-ui-commenting-entry-actionBar",
	
	commentingWidget: null,
	entry: null,
	
	deleteAction: null,
	restoreAction: null,
	editAction: null,
	replyAction: null,
	
	postCreate: function() {
		this.inherited(arguments);
		this.containerNode = this.domNode;
		this.addButtons();

	},
	
	addButtons: function() {
		if (this.commentingWidget.operationReport.canEdit(this.entry.comment)) {
			this.editAction = this._addAction("editComment", messages.editTooltip, dojo.moduleUrl("rmps.ui", "graphics/icons/edit_comment_co.gif"));
		}
		if (this.commentingWidget.operationReport.canCreate()) {
			this.replyAction = this._addAction("replyToComment", messages.replyTooltip, dojo.moduleUrl("rmps.ui", "graphics/icons/reply_comment_co.gif"));
		}
		if (this.commentingWidget.operationReport.canDelete(this.entry.comment)) {
			this.deleteAction = this._addAction("deleteComment", messages.deleteTooltip, dojo.moduleUrl("rmps.ui", "graphics/icons/delete_comment_co.gif"));
			this.restoreAction = this._addAction("restoreComment", messages.restoreTooltip, dojo.moduleUrl("rmps.ui", "graphics/icons/restore_comment_co.gif"));
			this.hideItem(this.restoreAction);
		}
		
	},
	
	_addAction: function(eventHandler, tooltip, image) {
		return this.addButton(this, 
			function() {
				this[eventHandler](this.entry);
			}, 
			{   label: tooltip,
				imgSrc : image
			}
		);
		
	},
	
	// event handling
	
	deleteComment: function(entry) {},
	restoreComment: function(entry) {},
	editComment: function(entry) {},
	replyToComment: function(entry) {},
});

})();