/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.commenting.SettingsWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.ui.commenting", "SettingsWidgetMessages");

var DEFAULT_PAGE_SIZE = 25;

dojo.declare("rmps.ui.commenting.SettingsWidget", [dijit._Widget, dijit._Templated], {
	
	templateString: dojo.cache("rmps.ui", "commenting/templates/SettingsWidget.html"),
	widgetsInTemplate: true,
	
	messages: dojo.i18n.getLocalization("rmps.ui.commenting", "SettingsWidgetMessages"),
	
	// mixin properties
	commentingWidget: null,

	// properties
	pageSize: DEFAULT_PAGE_SIZE,
	
	postCreate: function() {
		this.connect(this._pageSizeInput, "onChange", this._onPageSizeChanged);
		this._pageSizeInput.set("value", this.pageSize != -1 ? this.pageSize : DEFAULT_PAGE_SIZE);
		this.commentingWidget.addSettings(this);
	},
	
	refresh: function() {
		this._pageSizeInput.refresh();
	},
	
	_onPageSizeChanged: function(newPageSize) {
		this.pageSize = parseInt(newPageSize);
		this._onChange();
	},

	isEnabled: function() {
		return this.pageSize > 0;
	},
	
	_onChange: function() {
		this.onChange(this.isEnabled());
	},
	
	onChange: function(enabled) {}
});

})();