/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.commenting.SnapshotFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");

dojo.require("rmps.ui.baseline.BaselineSelectionBox");
dojo.require("rmps.core.util.IRmpsConstants");

var IRmpsConstants= rmps.core.util.IRmpsConstants;

dojo.requireLocalization("rmps.ui.commenting", "SnapshotFilterWidgetMessages");

dojo.declare("rmps.ui.commenting.SnapshotFilterWidget", [dijit._Widget, dijit._Templated], {
	
	templateString: dojo.cache("rmps.ui", "commenting/templates/SnapshotFilterWidget.html"),
	widgetsInTemplate: true,
	
	messages: dojo.i18n.getLocalization("rmps.ui.commenting", "SnapshotFilterWidgetMessages"),
	
	//mix-in
	initialSelection: null,
	
	// private properties
	_baseline: null,
	
	postCreate: function() {
		this.inherited(arguments);		
		this.connect(this._snapshotInput, "onChange", this.onSnapshotChanged);
		
		this._baseline = this.initialSelection;
	},
	
	onSnapshotChanged: function(baseline) {
		if (baseline === this._snapshotInput.UNSPECIFIED) {
			this._baseline = null;
		} else {
			this._baseline = baseline.uri;
		}
		this.onChange();
	},
		
	reset: function() {
		this._reset = true;
		this._snapshotInput.reset();
	},
	
	isEnabled: function() {
		return this._baseline;
	},
	
	isFiltered: function(comment) {
		if (!this._baseline || 
				(this._baseline === IRmpsConstants.CURRENT_URI && !comment.revision) || 
				this._baseline === comment.revision) {
			return false;
		}
		return true;
	},
	
	onChange: function() {}
});