/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("rmps.ui.commenting.autocomplete.AutoComplete"); //$NON-NLS-1$

dojo.require("rmps.ui.commenting.autocomplete.AutoCompleteAction"); //$NON-NLS-1$
dojo.require("rmps.ui.commenting.autocomplete.AutoCompleteModel"); //$NON-NLS-1$
dojo.require("rmps.ui.commenting.autocomplete.AutoCompleteWidget"); //$NON-NLS-1$
dojo.require("rmps.ui.commenting.autocomplete.Observable"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.requireLocalization("rmps.ui.commenting", "AutoCompleteMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Messages= dojo.i18n.getLocalization("rmps.ui.commenting", "AutoCompleteMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var commenting = rmps.ui.commenting;
var autocomplete= commenting.autocomplete;
var AutoCompleteAction= autocomplete.AutoCompleteAction;
var AutoCompleteModel= autocomplete.AutoCompleteModel;
var AutoCompleteWidget= autocomplete.AutoCompleteWidget;
var Observable= autocomplete.Observable;
var keys= dojo.keys;
var string= dojo.string;

var AutoComplete= dojo.declare("rmps.ui.commenting.autocomplete.AutoComplete", Observable, { //$NON-NLS-1$

	//_widget: null,

	//_model: null,

	//_providers: null,

	_currentProvider: 0,

	//_filter: null,

	constructor: function(widget, model, providers) {
		this.inherited(arguments, []);
		this._model= model;
		this._widget= widget;
		this._providers= providers;
		this._currentProvider= 0;
		this._filter= ""; //$NON-NLS-1$
		this._widget.on('picked', dojo.hitch(this, function(callbackArg) { //$NON-NLS-1$
			this._activate(this._model.getSelectedAction());
		}));
	},

	getWidget: function() {
		return this._widget;
	},

	handleKey: function(key, ctrl, alt, shift) {
		if (key == 64) /* '@' */ {  // activate if they type the '@' symbol
			this._toggle();
			return false;
		}
		
		if (this._isActivator(key, ctrl, alt, shift)) {
			this._toggle();
			return true;
		}
		
		if (this.isActive()) {
			switch(key) {
				case keys.DOWN_ARROW:
					this._model.setSelectedIndex(this._model.getSelectedIndex() + 1);
					return true;
				case keys.UP_ARROW:
					this._model.setSelectedIndex(this._model.getSelectedIndex() - 1);
					return true;
				case keys.ENTER:
					this._activate(this._model.getSelectedAction());
					return true;
				case keys.HOME:
					this._model.setSelectedIndex(0);
					return true;
				case keys.END:
					this._model.setSelectedIndex(this._model.size() - 1);
					return true;
				case keys.ESCAPE:
					this.setActive(false);
					return true;
			}
		}
		return false;
	},

	_activate: function(action) {
		if (action.getCallBack() != null) {
			this.fire('action', null); //$NON-NLS-1$
			action.getCallBack()();
			this.setActive(false);
		}
	},

	_isActivator: function(key, ctrl, alt, shift) {
		if (this._isAlernativeKeybinding()) {
			return alt && key === 191 && !ctrl && !shift;
		} else {
			return ctrl && key === keys.SPACE && !alt && !shift;
		}
	},

	setPosition: function(positon) {
		this._widget.domNode.style.top= positon.y + "px"; //$NON-NLS-1$
		this._widget.domNode.style.left= positon.x + "px"; //$NON-NLS-1$
	},

	setActive: function(active) {
		if (active === this.isActive()) {
			return ;
		}
		if (active) {
			this.fire('open', null); //$NON-NLS-1$
			this._setCurrentProvider(0);
		} else {
			this.fire('close', null); //$NON-NLS-1$
			this._currentProvider= 0;
		}
		this._widget.setVisible(active);
	},

	isActive: function() {
		return this._widget.isVisible();
	},

	_toggle: function() {
		if (!this.isActive()) {
			this.setActive(true);
			return ;
		}
		var provider= (this._currentProvider + 1) % this._providers.length;
		this._setCurrentProvider(provider);
	},

	_getNextProvider: function(index) {
		return this._providers[index < this._providers.length ? index : 0];
	},

	complete: function(text, isHtml) {
		this.fire('complete', {text: text, isHtml: isHtml}); //$NON-NLS-1$
	},

	setFilter: function(text) {
		if (this._filter === text) {
			return ;
		}
		this._filter= text;
		if (this.isActive()) {
			this._updateModel();
		}
	},

	_setCurrentProvider: function(index) {
		this._currentProvider= index;
		this._updateModel();
	},

	_updateModel: function() {
		var deferred= this._providers[this._currentProvider].getActions(this, this._filter, AutoComplete.MAX_ACTIONS);
		if (!deferred.isResolved()) {
			this._model.setData([new AutoCompleteAction(Messages.busyLoading, null)]);
		}
		var keyText= this._isAlernativeKeybinding() ? Messages.AutoCompleter_key_label_asia : Messages.AutoCompleter_key_label_world;
		this._model.setHelpText(string.substitute(Messages.AutoCompleter_help_info, [keyText , this._getNextProvider(this._currentProvider + 1).getName()]));
		deferred.then(dojo.hitch(this, function(results) {
			this._model.setData(results);
			return results;
		}), dojo.hitch(this, function(error) {
			console.log("[AutoCompleteListWidget] Error fetching possible entries: " + error); //$NON-NLS-1$
			this.setActive(false);
			return error;
		}));
	},

	destroy: function() {
		this._widget.destroy(false);
		this._providers= null;
	},

	_isAlernativeKeybinding: function() {
		var locale= dojo.i18n.normalizeLocale();
		var isLinux = navigator.platform.indexOf("Linux") !== 0;
		var localeString= (locale.indexOf("zh") > -1) || (isLinux && locale.indexOf("ja") > -1) || (isLinux && locale.indexOf("ko") > -1); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		return localeString;
	}
});

AutoComplete.MAX_ACTIONS= 15;
AutoComplete.open= null;
AutoComplete.close= null;
AutoComplete.action= null;
AutoComplete.complete= null;
AutoComplete.create= function( /*, providers... */ ) {
	var providers= [];
	for (var $sourceIdx= 0; $sourceIdx < arguments.length; $sourceIdx++)
		providers.push(arguments[$sourceIdx]);

	var model= new AutoCompleteModel();
	var widget= new AutoCompleteWidget({model: model}, null);
	window.document.body.appendChild(widget.domNode);
	return new AutoComplete(widget, model, providers);
};

})();
