/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("rmps.ui.commenting.autocomplete.AutoCompleteModel"); //$NON-NLS-1$

dojo.require("rmps.ui.commenting.autocomplete.Observable"); //$NON-NLS-1$

(function() {
var Observable= rmps.ui.commenting.autocomplete.Observable;

var AutoCompleteModel= dojo.declare("rmps.ui.commenting.autocomplete.AutoCompleteModel", Observable, { //$NON-NLS-1$

	_currentSelection: 0,

	//_helpText: null,

	//_actions: null,

	constructor: function() {
		this.inherited(arguments, []);
		this._helpText= ""; //$NON-NLS-1$
		this._actions= [];
	},

	getSelectedAction: function() {
		return this._actions[this._currentSelection];
	},

	getSelectedIndex: function() {
		return this._currentSelection;
	},

	setSelectedIndex: function(newIndex) {
		if (newIndex < 0) {
			newIndex= this._actions.length - 1;
		} else if (newIndex >= this._actions.length) {
			newIndex= 0;
		}
		var oldIndex= this._currentSelection;
		this._currentSelection= newIndex;
		this.fire('selection', {newIndex: this._currentSelection, oldIndex: oldIndex}); //$NON-NLS-1$
	},

	setData: function(actions) {
		this._actions= actions.slice(0);
		this.fire('changed', {type: 'change', index: 0, count: this._actions.length}); //$NON-NLS-1$ //$NON-NLS-2$
		this.setSelectedIndex(0);
	},

	insert: function(actions, index) {
		var count= 0;
		var $subject= actions;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var action= $subject[$count];
			this._actions.splice(index + count++, 0, action);
		}
		this.fire('changed', {type: 'insertion', index: index, count: actions.length}); //$NON-NLS-1$ //$NON-NLS-2$
	},

	remove: function(action) {
		var index= dojo.indexOf(this._actions, action);
		if (index !== -1) {
			this.removeRange(index, 1);
		}
	},

	removeRange: function(index, count) {
		this._actions.splice(index, count);
		if (this._currentSelection >= index) {
			if (this._currentSelection < index + count) {
				this.setSelectedIndex(0);
			} else {
				this.setSelectedIndex(this._currentSelection - count);
			}
		}
		this.fire('changed', {type: 'removal', index: index, count: count}); //$NON-NLS-1$ //$NON-NLS-2$
	},

	setHelpText: function(helpText) {
		if (this._helpText !== helpText) {
			this._helpText= helpText;
			this.fire('helpTextChanged', null); //$NON-NLS-1$
		}
	},

	getHelpText: function() {
		return this._helpText;
	},

	size: function() {
		return this._actions.length;
	},

	getAction: function(index) {
		if (index < 0) {
			throw new Error("Index cannot be negative"); //$NON-NLS-1$
		}
		return this._actions[index];
	}
});

AutoCompleteModel.selection= null;
AutoCompleteModel.changed= null;
AutoCompleteModel.helpTextChanged= null;

})();
