/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("rmps.ui.commenting.autocomplete.AutoCompleteWidget"); //$NON-NLS-1$

dojo.require("rmps.ui.commenting.autocomplete.Observable"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var Observable= rmps.ui.commenting.autocomplete.Observable;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

var AutoCompleteWidget= dojo.declare("rmps.ui.commenting.autocomplete.AutoCompleteWidget", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("rmps.ui", "commenting/autocomplete/templates/AutoCompleteWidget.html"), //$NON-NLS-1$ //$NON-NLS-2$

	//_isVisible: null,

	//_model: null,

	//_container: null,

	//_helpInfo: null,

	//_listItems: null,

	//_observable: null,

	constructor: function(params, domNode) {
		this._listItems= [];
		this._observable= new Observable();
		this._model= params.model;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		this._model.on('selection', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this._setSelected(event.newIndex, event.oldIndex);
		}));
		this._model.on('changed', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this._renderEntries();
		}));
		this._model.on('helpTextChanged', dojo.hitch(this, function(callbackArg) { //$NON-NLS-1$
			dojo.place(dojo.doc.createTextNode(this._model.getHelpText()), this._helpInfo, 'only'); //$NON-NLS-1$
		}));
		this.connect(this._container, 'mousemove', dojo.hitch(this, function(event) { //$NON-NLS-1$
			var index= dojo.indexOf(this._listItems, event.target);
			if (index !== -1) {
				this._model.setSelectedIndex(index);
			}
		}));
		this.connect(this._container, 'mouseup', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fire('picked', null); //$NON-NLS-1$
			dojo.stopEvent(event);
		}));
		this.setVisible(false);
	},

	isVisible: function() {
		return this._isVisible;
	},

	setVisible: function(visible) {
		if (visible === this._isVisible) {
			return ;
		}
		this._isVisible= visible;
		if (!this._isVisible) {
			dojo.empty(this._container);
			this._listItems= [];
		} else {
			this._renderEntries();
		}
		dojo.toggleClass(this.domNode, "Hidden", !this._isVisible); //$NON-NLS-1$
	},

	_renderEntries: function() {
		var size= this._model.size();
		for (var i= 0; i < size; i++){
			var listItem= this._listItems[i] != null ? this._listItems[i] : dojo.create("div", {className: "ListItem"}); //$NON-NLS-1$ //$NON-NLS-2$
			this._highlight(listItem, this._model.getAction(i));
			if (this._listItems[i] == null) {
				this._listItems.push(listItem);
				this._container.appendChild(listItem);
			}
		}
		var elementsToBeRemoved= this._listItems.splice(size, this._listItems.length);
		var $subject= elementsToBeRemoved;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var element= $subject[$count];
			element.parentNode.removeChild(element);
		}
		this._setSelected(this._model.getSelectedIndex(), undefined);
	},

	_highlight: function(listItem, action) {
		var information= action.getMatchInformation();
		var label= action.getLabel();
		if (information != null) {
			dojo.empty(listItem);
			var i= 0;
			var highlights= information.highlights;
			for (var j= 0; j < highlights.length; j++){
				var highlight= highlights[j];
				dojo.place(dojo.doc.createTextNode(label.substring(i, highlight.index)), listItem);
				dojo.place(dojo.create("span", {className: "Highlight"}).appendChild(dojo.doc.createTextNode(label.substring(highlight.index, highlight.index + highlight.length))).parentNode, listItem); //$NON-NLS-1$ //$NON-NLS-2$
				i= highlight.index + highlight.length;
			}
			dojo.place(dojo.doc.createTextNode(label.substring(i, label.length)), listItem);
		} else {
			dojo.place(dojo.doc.createTextNode(label), listItem, 'only'); //$NON-NLS-1$
		}
	},

	_setSelected: function(index, oldIndex) {
		if (oldIndex !== undefined && this._listItems[oldIndex] != null) {
			dojo.removeClass(this._listItems[oldIndex], AutoCompleteWidget.SELECTED_CLASS);
		}
		var selectedItem= this._listItems[index];
		if (selectedItem != null) {
			dojo.addClass(selectedItem, AutoCompleteWidget.SELECTED_CLASS);
		}
	},

	on: function(event, callback) {
		return this._observable.on(event, callback);
	},

	removeListener: function(callback) {
		this._observable.removeListener(callback);
	},

	fire: function(event, data) {
		this._observable.fire(event, data);
	},

	destroy: function(preserveDom) {
		this._isVisible= false;
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

AutoCompleteWidget.SELECTED_CLASS= "Selected"; //$NON-NLS-1$
AutoCompleteWidget.confirmed= null;

})();
