/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("rmps.ui.commenting.autocompletematchers.ContributorProposalProvider"); //$NON-NLS-1$

dojo.require("rmps.ui.commenting.autocomplete.AutoCompleteAction"); //$NON-NLS-1$
dojo.require("rmps.ui.commenting.autocomplete.ProposalProvider"); //$NON-NLS-1$
dojo.require("rmps.ui.commenting.autocompletematchers.ContributorDialog"); //$NON-NLS-1$
dojo.require("dojo.Deferred"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("rmps.core.subscriptions.SubscriptionClient");
dojo.require("rmps.core.user.UserClient");

dojo.requireLocalization("rmps.ui.commenting.autocompletematchers", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Messages= dojo.i18n.getLocalization("rmps.ui.commenting.autocompletematchers", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

var commenting = rmps.ui.commenting;
var autocomplete= commenting.autocomplete;
var AutoCompleteAction= autocomplete.AutoCompleteAction;
var ProposalProvider= autocomplete.ProposalProvider;
var ContributorDialog= commenting.autocompletematchers.ContributorDialog;
var string= dojo.string;

dojo.declare("rmps.ui.commenting.autocompletematchers.ContributorProposalProvider", ProposalProvider, { //$NON-NLS-1$

	constructor: function(context) {
		this.inherited(arguments, []);
		this.context = context;
	},

	getActions: function(target, filter, limit) {
		if (filter.indexOf("@") === 0) { //$NON-NLS-1$
			filter= filter.substring(1);
		}
		var result= new (require("dojo/Deferred")); //$NON-NLS-1$
		
		var actionsDeferred = this._createActions(target, filter, limit);
		actionsDeferred.then(function(actions) {
			result.resolve(actions);
		});
		
		return result;
	},

	_createActions: function(target, filter, limit) {
		var actionsDeferred = new (require("dojo/Deferred")); //$NON-NLS-1$
		
		var contributorsDef = this._getKnownUsers();
		contributorsDef.then(dojo.hitch(this, function(contributors) {
			var result= [];
			
			for (var idx= 0, lg=contributors.length; idx < lg; idx++){
				var contributor= contributors[idx];
				if (contributor.name != null && contributor.id != null && this._matches(contributor, filter) && limit > result.length + 1) {
					result.push(this._createAction(target, contributor, filter));
				}
			}
			var moreAction= new AutoCompleteAction(Messages.ContributorAutoCompleter_more_users_label, dojo.hitch(this, function() {
				var dialog= new ContributorDialog({filter: filter.replace(new RegExp("^@"), ""), useOkCancel: true, allowMultiple: false}); //$NON-NLS-1$ //$NON-NLS-2$
				dialog["onOK"]= dojo.hitch(this, function(users) { //$NON-NLS-1$
					if (users.length > 0) {
						var user= users[0];
						target.complete("@" + user.userId + " ", false); //$NON-NLS-1$ //$NON-NLS-2$
					}
				});
			}));
			result.push(moreAction);
			actionsDeferred.resolve(result);
		}));
		
		return actionsDeferred;
	},

	_createAction: function(target, user, filter) {
		return new AutoCompleteAction(this._getLabel(user), dojo.hitch(this, function() {
			target.complete("@" + user.id + " ", false); //$NON-NLS-1$ //$NON-NLS-2$
		}), this._getMatchInformation(this._getLabel(user), filter));
	},

	_matches: function(user, filter) {
		filter= filter != null ? filter.toLocaleLowerCase() : ""; //$NON-NLS-1$
		return user.id.toLocaleLowerCase().indexOf(filter) !== -1 || user.name.toLocaleLowerCase().indexOf(filter) !== -1;
	},

	_getKnownUsers: function() {
		var usersDeferred = new (require("dojo/Deferred")); //$NON-NLS-1$
		var subscriptionsDeferred = rmps.core.subscriptions.SubscriptionClient.getSubscriptions(this.context);
		subscriptionsDeferred.then(dojo.hitch(this, function(subscriptions) {
			var userCount = subscriptions.length;
			var users = [];
			
			if (userCount > 0) {
				var userResolved = function(user) {
					users.push(user);
					if (users.length == userCount) {
						usersDeferred.resolve(users);
					}
				};
				for (var i=0, lg=subscriptions.length; i<lg; i++) {
					var userDeferred = rmps.core.user.UserClient.getUser(subscriptions[i].userUri);
					userDeferred.then(dojo.hitch(this, function(user) {
						userResolved(user);
					}));
				}
			}
			else {
				usersDeferred.resolve(users); // no users so we can resolve
			}
			
		}));
		
		return usersDeferred;
	},

	_getLabel: function(user) {
		return string.substitute(Messages.ContributorAutoCompleter_user_label, [user.id , user.name]);
	},

	getName: function() {
		return Messages.ContributorAutoCompleter_name;
	}
});

})();
