/*******************************************************************************
 * Licensed Materials - Property of IBM
 *
 * com.ibm.xtools.rmps.web.core
 *
 * Copyright IBM Corporation 2009, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.commenting.range.IDList");

var XMLNS = "http://jazz.net/xmlns/rmps/comments/1.0/range/idlist";

dojo.declare("rmps.core.commenting.range.IDList", null, {

	// serialized properties

	/**
	 * Array of IDs.
	 */
	ids: null, // []

	// END serialized properties

	// properties

	constructor: function(ids) {
		if (dojo.isArray(ids)) {
			this.ids = ids;
		} else if (dojo.isString(ids)) {
			this.ids = [ids];
		} else {
			this.ids = [];
		}
	},

	/**
	 * Return the XML representation of the range.
	 *
	 * @return the XML representation of the range
	 * @type String
	 */
	toXMLString: function() {
		if (this.ids.length == 0) {
			return "";
		}

		function encodeXML(text) {
			var div = document.createElement("div");
			div.appendChild(document.createTextNode(text));
			return div.innerHTML;
		}

		var xml = '<idl:range xmlns:idl="' + XMLNS + '">\n';

		for (var i = 0; i < this.ids.length; ++i) {
			var id = this.ids[i];
			xml += '<idl:id>' + encodeXML(id) + '</idl:id>\n';
		}

		xml += '</idl:range>';

		return xml;
	},

	parse: function(range, prefix) {
		this.ids = [];
		var idNodes = range[(prefix ? prefix + ':' : '') + 'id'];
		if (idNodes) {
			for (var i = 0; i < idNodes.length; i++) {
				this.ids.push(idNodes[i].value);
			}
		}
	},

	contains: function(id) {
		for (var i = 0; i < this.ids.length; ++i) {
			if (id == this.ids[i]) {
				return true;
			}
		}
		return false;
	}
});

})();