/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.common.SimpleToolbarButtonGlow");

// Create on a jazz.ui.SimpleToolbar button to get a green glow
// temporarily surrounding the button when trigged by specified event.
// TODO: Since SimpleToolbar is deprecated, remove this when no longer used
// ToolbarButtonGlow should be used instead

dojo.declare("rmps.ui.common.SimpleToolbarButtonGlow", null, {
	
	//mixin
	// The button that should be glowing
	button: null,
	// The event that should trigger the glow
	eventName: null,
	// An optional callback when the glowing is at its peak
	onGlow: null,
	
	_handle: null,
	
	constructor: function(args) {
		dojo.safeMixin(this, args);
		
		// Create IMG below button parent DIV
		var url = dojo.moduleUrl("rmps.ui", "graphics/button_green_glow.gif").toString();
		var glow = new dojo.create("img", {
			src: url,
			alt: "",
			"class": "glow-icon"
		}, this.button.domNode.parentNode);
		// Add a class on the button parent DIV to prevent unwanted adoptions 
		dojo.addClass(this.button.domNode.parentNode, "glow-button");
		// Animate on event
		var self = this;
		this._handle = dojo.subscribe(this.eventName, function() {
			var fadeIn = dojo.fadeIn({
				node: glow,
				duration: 1000,
				onEnd: self.onGlow
			});
			var fadeOut = dojo.fadeOut({
				node: glow,
				duration: 3000
			});
			dojo.fx.chain([fadeIn, fadeOut]).play();
		});
	},
		
	destroy: function() {
		dojo.unsubscribe(this._handle);
	}
});

}());