/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.common.ToolbarButtonGlow");

// Create on a jazz.ui.toolbar.Toolbar button to get a green glow
// temporarily surrounding the button when trigged by specified event.

dojo.declare("rmps.ui.common.ToolbarButtonGlow", null, {
	
	//mixin
	// The button that should be glowing
	button: null,
	// The event that should trigger the glow
	eventName: null,
	// An optional callback when the glowing is at its peak
	onGlow: null,

	_handle: null,
	
	constructor: function(args) {
		dojo.safeMixin(this, args);
		
		// Create IMG below within a DIV
		var div = new dojo.create("div", null, this.button.domNode);
		var glow = new dojo.create("img", {
			src: dojo.moduleUrl("rmps.ui", "graphics/button_green_glow.gif").toString(),
			alt: "",
			"class": "glow-icon"
		}, div);

		dojo.addClass(div, "glow-button");
		// Animate on event
		var self = this;
		this._handle = dojo.subscribe(this.eventName, function() {
			var fadeIn = dojo.fadeIn({
				node: glow,
				duration: 1000,
				onEnd: self.onGlow
			});
			var fadeOut = dojo.fadeOut({
				node: glow,
				duration: 3000
			});
			dojo.fx.chain([fadeIn, fadeOut]).play();
		});
	},
		
	destroy: function() {
		dojo.unsubscribe(this._handle);
	}
});

}());