/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.core.internal.AuthDialog");

dojo.require("jazz.ui.Dialog");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.core.internal", "AuthDialogMessages");

dojo.declare("rmps.app.core.internal.AuthDialog", jazz.ui.Dialog, {
	
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("rmps.app.core.internal", "AuthDialogMessages");
		this.contentNode = document.createElement("div");
		this.contentNode.style.border = "none";
		this.contentNode.style.padding = "30px";
		var contents= new rmps.app.core.internal.AuthDialog._Contents({messages: this.messages, popupUrl: args.popupUrl, onclick: dojo.hitch(this, this.onclick)});
		this.contentNode.appendChild(contents.domNode);
		contents.loginLink.appendChild(dojo.doc.createTextNode(" <"+net.jazz.ajax.BootstrapProperties.FRONTSIDE_URL+">"));
		this.primaryTitle = this.messages.loginPopupBlockedTitle;
	},
	
	onclick: function(e){
		dojo.stopEvent(e);
		this.setWindow(window.open(this.popupUrl, "oauthPopup", "location=1,status=1,scrollbars=1,width=650,height=500"));
	},
	
	setWindow: function(winObj){
		this._winObj = winObj;
	}
});

dojo.declare("rmps.app.core.internal.AuthDialog._Contents",[dijit._Widget, dijit._Templated],{

	templateString: '<div>'+
						'${messages.intro}'+
						'<a href="#" dojoAttachPoint="loginLink" title= "Login" dojoAttachEvent="onclick: onclick" </a>'+
						' ${messages.introTo}'+
					'</div>'

});


})();
