/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.core.internal.query.TextQuery");

dojo.require("rmps.core.query.TextQuery");

dojo.require("rmps.app.core.internal.util.QueryUtil");

dojo.require("dojo.string");

dojo.requireLocalization("rmps.app.core.internal.query", "TextQueryMessages");

var messages = dojo.i18n.getLocalization("rmps.app.core.internal.query", "TextQueryMessages");
var QueryUtil = rmps.app.core.internal.util.QueryUtil;

dojo.declare("rmps.app.core.internal.query.TextQuery", rmps.core.query.TextQuery, {
	
	// properties
	scope: null,
	scopeDescription: null,
	
	constructor: function(params) {
		if (params) {
			if (!this.scope) {
				if (params.diagramsOnly == true || params.diagramsOnly == "true") {
					this.scope = QueryUtil.SCOPE.DIAGRAMS;
				} else if (params.reviewsSearch == true || params.reviewsSearch == "true") {
					this.scope = QueryUtil.SCOPE.REVIEWS;
				} else {
					this.scope = QueryUtil.SCOPE.ALL;
				}
			}
			if (!this.description) {
				this.description = 
					dojo.string.substitute(messages.description, [this.scope.name]);
			}
			if (params.scopeDescription) {
				this.scopeDescription = params.scopeDescription;
			}
		}
	},
	
	_getQueryStringParams: function(params) {
		this.inherited(arguments);
		if (this.scope.value == QueryUtil.SCOPE.DIAGRAMS.value) {
			params.diagramsOnly = true;
		} else if (this.scope.value == QueryUtil.SCOPE.REVIEWS.value) {
			params.reviewsSearch = true;
		}
		if (this.scopeDescription) {
			params.scopeDescription = this.scopeDescription;
		}
	}, 
	
	equals: function(obj) {
		return this.inherited(arguments) && this.scope.value == obj.scope.value;
	}
});

})();