/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.editor.EditorView");

dojo.require("dijit._Widget");

dojo.require("rmps.ui.editor.EditorUtil");

/**
 * This widget is used to contain editor instances and manages resizing
 * the editor when the active editor changes.
 */
dojo.declare("rmps.ui.editor.EditorView", dijit._Widget, {
	
	// mixing properties
	editorUtil: null,
	
	// private properties
	_height: null,
	
	postCreate: function() {
		this.domNode.style.overflow = "hidden";
		if (dojo.isIE) {
			this.domNode.style.zoom = 1;
		}
		
		this.connect(this.editorUtil, "onActiveEditorChanged", function(editor) {
			if(this.editorUtil.resizePage){
				this.editorUtil.resizePage();
				return;	
			}
			setTimeout(dojo.hitch(this, function() {
				this.resize();
			}), 0);
		});
	},
	
	startup: function() {
		this.inherited(arguments);
		if (!this.editorUtil) {
			this.editorUtil = rmps.ui.editor.EditorUtil.getInstance(this.domNode);
			if (!this.editorUtil) {
				throw new Error("Could not find an editor util instance.");
			}
			if (!this.editorUtil.domNode) {
				// set the editor util domNode to be this.domNode
				this.editorUtil.domNode = this.domNode;
			}
		}
	},
	
	resize: function(size) {
		var editor = this.editorUtil.getEditor();
		
		if (editor && editor.resize) {
			editor.resize( size );
		}
	}
});

})();
