/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.explorer.ExplorerModel");

dojo.require("dijit.tree.ForestStoreModel");

dojo.require("rmps.core.explorer.ExplorerTreeService");
var ExplorerTreeService = rmps.core.explorer.ExplorerTreeService;



dojo.declare("rmps.ui.explorer.ExplorerModel", dijit.tree.ForestStoreModel, {

	// Overridden to support ellipsis nodes
	getIdentity: function(/* item */ item){
		return item.isEllipsis ? item.ellipsisUUID : this.inherited(arguments);
	},
	
	// Will set up the root children value in a ForestStoreModel
	// Since root is not a dojo.data.Item from a store, it's a safe operation
	setRootChildren: function(children) {
		this.root.children = children;
		this.onChildrenChange(this.root, children);
	},
	
	getRootChildren: function() {
		return this.root.children;
	},
	
	onSetItem: function(item, attribute, oldValue, newValue) {
		// Check if item is being set with something else than
		// a child list. That would indicate that the model is
		// updated with a partial object (since children = "true")
		// in those) which in turn indicates that something went
		// wrong while loading the object.
		if (dojo.indexOf(this.childrenAttrs, attribute) !== -1){
			if (oldValue === true && newValue === undefined) {
				newValue = [];
			}
			if (!(newValue instanceof Array)) {
				console.error("Explorer is being updated with a partial object. Probably due to a bad service response.");
				return;
			}
		}
		
		//this.inherited(arguments);
		if(dojo.indexOf(this.childrenAttrs, attribute) !== -1){
			// item's children list changed
			this.getChildren(item, dojo.hitch(this, function(children){
				// See comments in onNewItem() about calling getChildren()
				this.onChildrenChange(item, children);
			}));
		}else{
			// item's label/icon/etc. changed.
			this.onChange(item);
		}
	}
	
//	getChildren: function(/*dojo.data.Item*/ parentItem, /*function(items)*/ onComplete, /*function*/ onError){
//		// If the parent item has a viewpoint associated, set the explorer service to use the id in the request
//		//ExplorerTreeService.viewpoint = parentItem.viewpoint ? parentItem.viewpoint : null;		
//		var children = this.inherited(arguments);		
//		// Reset
//		//ExplorerTreeService.viewpoint = null;
//		return children;
//	}
});

})();
