/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.figures.Figure");

dojo.require("rmpw.diagrams.render.graph.AbstractNode");
dojo.require("rmpw.diagrams.layout.client.Node");
dojo.require("rmpw.diagrams.render.util.Insets");

dojo.declare("rmpw.diagrams.layout.client.figures.Figure", rmpw.diagrams.render.graph.AbstractNode, {
	
	constructor: function(mapping, graph, rect) {
		dojo.mixin(this, $Node(new Node(), mapping));
		this.padding = new rmpw.diagrams.render.util.Insets(20, 20, 20, 20);
		graph.addNode(this);
		
		if (rect) {
			this.x = rect.x;
			this.y = rect.y;
			this.width = rect.w;
			this.height = rect.h;
		}
	},
	
	destroy: function() {
		for (i = 0; i < this.outgoing.size; ++i) {
			var edge = $get_0(this.outgoing, i);
			edge.destroy();
		}
		
		for (i = 0; i < this.incoming.size; ++i) {
			var edge = $get_0(this.incoming, i);
			edge.destroy();
		}
		
		this.graph.removeNode(this);
	},
	
	revalidate: function() {
		// hook for diagram element invalidation
	},
	
	getBounds: function () {
		return new rmpw.diagrams.render.util.Rectangle(this.x, this.y, this.width, this.height);
	},

	setBounds: function (rect){
		var translate, x, y;
		
		var figBounds = this.getBounds();
		
		x = figBounds.x;
		y = figBounds.y;
		translate = rect.x != x || rect.y != y;
		if (translate) {
			this.x += rect.x - x;
			this.y += rect.y - y;
		}
		
		this.width = rect.width;
		this.height = rect.height;
	},

	setSize: function (size){
		this.width = size.width;
		this.height = size.height;
	}
});