/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.figures.MoveablePolygonAnchor");

dojo.require("rmpw.diagrams.render.util.Point");
dojo.require("rmpw.diagrams.render.util.Rectangle");
dojo.require("rmpw.diagrams.render.util.PointList");
dojo.require("rmpw.diagrams.render.graph.AbstractEdgeAnchor");

dojo.declare("rmpw.diagrams.layout.client.figures.MoveablePolygonAnchor", rmpw.diagrams.render.graph.AbstractEdgeAnchor, {
	
	constructor: function(figure) {
		this.relativeReference = null;
	},
	
	getRelativeReferencePoint: function() {
		return this.relativeReference;
	},
	
	setRelativeReferencePoint: function(relativeReference) {
		if (relativeReference != null) {
			this.relativeReference = new rmpw.diagrams.render.util.Point(relativeReference.x, relativeReference.y);
		}
		else {
			this.relativeReference = null;
		}
	},

	getCopy: function() {
		var anchor = new rmpw.diagrams.layout.client.figures.MoveablePolygonAnchor(this.owner);
		var relativeReference = this.getRelativeReferencePoint();
		if (relativeReference) {
			anchor.setRelativeReferencePoint(relativeReference);
		}
		return anchor;
	}
});