/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.form.SimpleInput");

dojo.require("dijit._Widget");

/*
 * Provide a simple input native javascript control represented in a form of widget, and hads the required listeners
 * such as onChange.
 *   
 */
dojo.declare("rmps.ui.form.SimpleInput", dijit._Widget, {
	
	type: null,
	label: null,
	value: null,
	onClick: null,
	readOnly: null,
	
	buildRendering: function() {
		this.inherited(arguments);
		if(!this.type){
			this.type= "input";
		}
		this.domNode = dojo.create("input", {type:this.type, name: this.name, value: this.value});
	},
	
	postCreate: function() {
		this.inherited(arguments);
		if(!this.readOnly){
			this.connect(this.domNode,"onkeyup", this._onChange);
        	this.connect(this.domNode,"onchange", this._onChange);			
		}
	},
	
	_setValueAttr: function(val){
		if(this.type=== "checkbox"){
			if(!val){
				this.domNode.value= false;
			}else if(dojo.isString(val)){
				this.domNode.checked= val=== "true";
			}else if (typeof val === "boolean"){
				this.domNode.checked= val;				
			}
			this.value= this.domNode.checked;
		}else{
			if(!val){
				this.domNode.value= "";
			}else if(dojo.isString(val)){
				this.domNode.value= val;
			}
			this.value= this.domNode.value;
		}
	},
	
	_getValueAttr: function(){
		return this.type=== "checkbox"? this.domNode.checked: this.domNode.value;
	},
	
	_setReadOnlyAttr: function(val){
		if(val){
			this.readOnly= true;
			this.domNode.readOnly=true;
			if(this.type=== "checkbox"){
				this.domNode.disabled=true;
			}
		}else{
			this.readOnly= false;
			this.domNode.readOnly=false;
			if(this.type=== "checkbox"){
				this.domNode.disabled=false;
			}
		}
	},
	
	_getReadOnlyAttr: function(){
		return this.readOnly;
	},
	
	_onChange: function(value){
		this.set("value", value);
		this.onChange(this.value);
	},
	
	onChange: function(value){
		/*To be implemented by sub-classes */
	},
	
	set: function(key, value) {
		if (this.type === "checkbox" && key === "type" && dojo.isIE < 9) {
			// workaround for IE8 - check box creation in buildRendering doesn't work otherwise
			this._set(name, value);
		} else {
			this.inherited(arguments);
		}
	}	
});

})();