/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.render.graph.AbstractElement");		

/**
 * Abstract base class for graph elements
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.render.graph.AbstractElement", null, {
	
	constructor: function(mapping, graph) {
		this.mapping = mapping;
		this.graph = graph;
		
		if (mapping) {
			this.translateToAbsolute = function(t) { mapping.policies.graphElement.translateToAbsolute(t); };
			this.translateToRelative = function(t) { mapping.policies.graphElement.translateToRelative(t); };
		}
		else {
			this.translateToAbsolute = function(t) { /* do nothing */ };
			this.translateToRelative = function(t) { /* do nothing */ };
		}
	},
	
	destroy: function() {
	},
	
	revalidate: function() {
		// hook for diagram element invalidation
	},
	
	getID: function() {
		return this.mapping.id;
	},
	
	invalidate: function() {
		// invalidate in the graph
	},
	
	getGraph: function() {
		return this.graph;
	}
});