/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.render.graph.AbstractNode");

dojo.require("rmpw.diagrams.render.util.Rectangle");
dojo.require("rmpw.diagrams.render.graph.AbstractElement");
dojo.require("rmpw.diagrams.render.util.Insets");

dojo.declare("rmpw.diagrams.render.graph.AbstractNode", rmpw.diagrams.render.graph.AbstractElement, {	
	constructor: function() {
		this._insets = new rmpw.diagrams.render.util.Insets(0, 0, 0, 0);
		this._layoutState = null;
	},
	
	isLayoutInvalid: function() {
		return !!this._layoutState;
	},
	
	getLayoutState: function() {
		return this._layoutState;
	},
	
	/*
	 * one of "incremental" or "invalid"
	 */
	setLayoutState: function(state) {
		this._layoutState = state;
	},
	
	getBounds: function () {
		// subclasses should implement
		return rmpw.diagrams.render.util.Rectangle(0,0,0,0);
	},

	setBounds: function (rect){
		// subclasses should implement
	},
	
	getAnchorInsets: function() {
		if (this.mapping.policies && this.mapping.policies.anchorable) {
			return this.mapping.policies.anchorable.getAnchorInsets();
		}
		
		return this._insets;
	}
});