/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.core.group.Group");

dojo.require("rmps.core.resource.Resource");

dojo.require("rmps.core.group.Project");

rmps.core.group.Group.XMLNS = 'http://jazz.net/xmlns/rmps/groups/1.0/';

dojo.declare("rmps.core.group.Group", rmps.core.resource.Resource, {
	id: null,
	name: null,
	projects : [],	
	groupEditable : false,
		
	parse: function(group, ioArgs) {
		var rdfPrefix = "rdf:";
		var groupPrefix = "j.0:";
		var key;
		
		for (key in group.namespaces) {
			var namespace = group.namespaces[key];	
			if (namespace == "http://www.w3.org/1999/02/22-rdf-syntax-ns#") {
				rdfPrefix = key + ":";
			} else if (namespace == "http://jazz.net/xmlns/rmps/groups/1.0/") {
				groupPrefix = key + ":";
			}	
		}
		var projectIds = [];
		this.id = group.getElementsByTagName(groupPrefix + "groupId")[0].childNodes[0].nodeValue;
		this.name = group.getElementsByTagName(groupPrefix + "groupName")[0].childNodes[0].nodeValue;
		var groupEditableElement = group.getElementsByTagName(groupPrefix + "groupEditable");
		if (groupEditableElement.length > 0) {
			this.groupEditable = groupEditableElement[0].childNodes[0].nodeValue == "true";
		}
		var projectEntries = group.getElementsByTagName(groupPrefix + "project");
		for (key in projectEntries){
			var node = projectEntries[key].getAttribute(rdfPrefix + "nodeID");
			projectIds.push(node);
		}
		
		var descriptions = group.getElementsByTagName(rdfPrefix + "Description");
		for (key in descriptions) {
			var description = descriptions[key];
			var localName = description.getAttribute(rdfPrefix + "nodeID");
			if (localName) {
				var project = new rmps.core.group.Project();
				project.id = description.getElementsByTagName(groupPrefix + "projectId")[0].childNodes[0].nodeValue;
				project.name = description.getElementsByTagName(groupPrefix + "projectName")[0].childNodes[0].nodeValue;
				project.uri = description.getElementsByTagName(groupPrefix + "projectUri")[0].childNodes[0].nodeValue;
				this.projects.push(project);
			} else {
				var uri = description.getAttribute(rdfPrefix + "about");
				if ( uri ) {
					this.uri = uri; 
				} 
			}
		}		
	}
	
});

