/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	
dojo.provide("rmps.core.group.GroupClient");
dojo.require("rmps.core.group.Group");
dojo.require("rmps.core.xhr");
dojo.require("jazz.client.xhr");
dojo.require("dojox.xml.DomParser");
dojo.require("rmps.core.RootServices");

var GROUP_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "groups");

rmps.core.group.GroupClient = {
	
	getGroup: function(groupId, appType) {
		var path = GROUP_PATH + '/' + groupId;
		var queryParams = '';
		if ( appType != null ) {
			queryParams += '?appType=' + appType;
		}
		var args = {
			url: path + queryParams,
			handleAs: 'text',
			headers: {
				"X-ibm-rmps-internal": "true",
				"Accept": "application/rdf+xml"  //todo: change the return type to rdf+json
			},
			haseBody: false,
			load  : function(response, ioArgs) {
				var doc = dojox.xml.DomParser.parse(response);
				var groups = [];
				var entries = doc.getElementsByTagName("rdf:RDF");
				for (var i = 0; i < entries.length; i++) {
					var group = new rmps.core.group.Group();
					group.parse(entries[i]);
					groups.push(group);
				}
				return groups;
			}
		};
		return rmps.core.xhrGet(args);
	},
	
	getGroupId: function(projectId, appType, includeDeactivated) {
		var path = GROUP_PATH;
		var queryParams = 'projectId=' + projectId;
		if ( appType != null ) {
			queryParams += '&appType=' + appType;
		}
		if ( includeDeactivated ) {
			queryParams += '&includeDeactivated=' + includeDeactivated;
		}
		var args = {
			url: path + '?' + queryParams,
			handleAs: 'text',
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			haseBody: false
		};
		return rmps.core.xhrGet(args);
	},
	
	setEditable: function(projectId, editable) {
		var path = GROUP_PATH;
		var queryParams = 'projectId=' + projectId + '&editable=' + editable;
		var args = {
			url: path + '?' + queryParams,
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			haseBody: false
		};
		return jazz.client.xhrPost(args);
	}
	
};

})();
