/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.handles.DuplicationHandle");

dojo.require("rmpw.diagrams.edit.handles.MoveableHandle");

/**
 * Class for displaying a duplication handle for a node
 * 
 * @author John Swanke
 */
dojo.declare("rmpw.diagrams.edit.handles.DuplicationHandle", rmpw.diagrams.edit.handles.MoveableHandle, {

	constructor: function(args) {
		this.source = false; // edit handle is always the target
	},
	
	createHandleShape: function(args) {
	    var bounds;
	    if (args.editController.renderMapping.policies.graphElement){
	    	bounds = args.editController.renderMapping.policies.graphElement.getBounds();
			args.editController.renderMapping.policies.graphElement.translateToAbsolute(bounds);
	    }
		if (bounds && bounds.width>0) {
			var dm = net.jazz.ajax._contextRoot;
			var icon = { width:9, height:9, src: dm + "/web/rmpw.diagrams.edit/icons/duplication.gif" };
			this.handleShape = args.owner.createImage(icon);
		    if(dojox.gfx.svg) {
				// workaround for bug fixed here: http://trac.dojotoolkit.org/changeset/18536
				this.handleShape.rawNode.setAttribute("fill", null);
		    }
			this.handleShape.rawNode.style.cursor = "pointer";
			this.handleShape.rawNode.style.zIndex = 1000;
			this.handleShape.rawNode.style.opacity = 0.5;
			var x = bounds.x + bounds.width;
			var y = bounds.y + bounds.height;
			x -= icon.width + 6;
			y -= icon.height + 6;
			this.handleShape.setTransform({dx: x, dy: y});
			this.pos = {x: x + (icon.width / 2), y: y + (icon.height / 2)};
		}
		
	},
	
	onFirstMove: function(/* dojox.gfx.Mover */ mover) {
		if (!this.pos) {
			return;
		}
		this.inherited(arguments);
		this.startPos = {x: this.pos.x, y: this.pos.y};
	},
	
	onMoveStop: function(/* dojox.gfx.Mover */ mover) {
		this.inherited(arguments);
		this.pos = this.startPos;
	}
	
});