/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.handles.Handle");

dojo.require("rmpw.diagrams.render.util.ColorConstants");
/**
 * Class for handle shapes
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.handles.Handle", null, {
	
	feedbackColor: null,
	pos: null,
	
	constructor: function(args) {
		this.createHandleShape(args);
	},
	
	createHandleShape: function(args) {
		COLOR = rmpw.diagrams.render.util.ColorConstants;
		if (args.invisible) {
			this.handleShape = args.owner.createGroup();
		}else if(args.triangle){
		    this.handleShape = args.owner.createPolyline(args.triangle)
		    .setTransform({dx: args.x, dy: args.y})
            .setStroke({color: COLOR.RESIZE_HANDLE, width: 1, style: "solid"})
            .setFill(COLOR.RESIZE_HANDLE);  //color of handles
		}else if(args.icon){
		    this.handleShape = args.owner.createImage(args.icon)
			.setTransform({dx: args.x, dy: args.y});
		}else {
			this.handleShape = args.owner.createCircle({r: 3.5})
			.setTransform({dx: args.x, dy: args.y})
			.setFill(COLOR.HANDLE);  //color of handles
		}
		this.feedbackColor = args.color;
		this.pos = {x: args.x, y: args.y};
	},
	
	destroy: function() {
		this.handleShape.removeShape();
	},
	
	getPosition: function() {
		return this.pos;
	}
	
});