/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.handles.LabelEditHandle");

dojo.require("rmpw.diagrams.render.util.Workarounds");
dojo.require("rmpw.diagrams.edit.handles.MoveableEndHandle");

/**
 * Class for displaying a rename button for a label
 * 
 * @author John Swanke
 */
dojo.declare("rmpw.diagrams.edit.handles.LabelEditHandle", rmpw.diagrams.edit.handles.Handle, {

	constructor: function(args) {
		this.source = false; // edit handle is always the target
	},
	
	createHandleShape: function(args) {
	    var labelBnds, nodeBnds;
	    if (args.target) {
            labelBnds = rmpw.diagrams.render.util.Workarounds.getTransformedBoundingBox(args.target);
	    }
	    if (args.editController.renderMapping.policies.graphElement && 
	    		!args.editController.renderMapping.policies.graphFloatingLabel){
            nodeBnds = args.editController.renderMapping.policies.graphElement.getBounds();
			args.editController.renderMapping.policies.graphElement.translateToAbsolute(nodeBnds);
	    }
	    var bounds = labelBnds ? labelBnds : nodeBnds;
		var icon = { width:16, height:16, src:net.jazz.ajax._contextRoot + "/web/rmpw.diagrams.edit/icons/labeledit.gif" };
		this.handleShape = args.owner.createImage(icon);
		this.handleShape.rawNode.style.cursor = "pointer";
		this.handleShape.rawNode.style.zIndex = 1000;
		var x = bounds.x;
		var y = bounds.y;
		if (bounds.width>0) {
			x -= icon.width + 2;
			if (nodeBnds && x < nodeBnds.x) {
				x = nodeBnds.x;
				this.handleShape.rawNode.style.opacity = 0.5;
			}
			y += bounds.height / 2;
		}
		this.handleShape.setTransform({dx: x, dy: y});
	}
});