/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

/**
 * Dialog that allows the user to check "Include comments" option when launching print preview page.
 * 
 * @author lgrahek
 */

(function() {
dojo.provide("rmpw.text.internal.PrintConfirmDialog");

dojo.require("jazz.ui.Dialog");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmpw.text.internal.widgets", "Messages");
var messages = dojo.i18n.getLocalization("rmpw.text.internal.widgets", "Messages");

dojo.declare("rmpw.text.internal.PrintConfirmDialog", [dijit._Widget, dijit._Templated], {
   templateString: "<div dojoAttachPoint='contentNode'>" +
   						"<p style='margin-left: 10px'><input type='checkbox' dojoAttachPoint='_includeCommentsCheckbox'><span style='margin-left: 10px'>" + messages.includeComments + "</span></input></p>" +
						"<p style='margin-right: 10px; text-align: right'><input type='button' dojoAttachPoint='_button' value='OK'/></p>" +
					"</div>",
	
	postCreate: function() {
		dojo.connect(this._button, "onclick", dojo.hitch(this, this.setIncludeComments));
		   	
		this.dialog = new jazz.ui.Dialog({
			contentNode: this.contentNode,
			primaryTitle: messages.viewPrintablePage,
			destroyContents: true,
			width: '200px',
			onClose: dojo.hitch(this, this.onClose)
		});
   },
   
   setIncludeComments: function() {
		this.includeComments = this._includeCommentsCheckbox.checked;
		this.onOk();
		this.dialog.close();
   },
   
	onOk: function() {
		// for listeners
	},
	
	onClose: function() {
		this.onCancel();
	},
      
   uninitialize: function() {
	   if (this.dialog) {
		   this.dialog.destroy();
	   }
   }   
});
})();
