/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.viewlets.internal.links.FullLinkDetails");

dojo.require("rmps.app.core.util");
dojo.require("rmps.ui.link.LinkDetails");
dojo.require("rmps.ui.resource.ResourceIconLabel");

dojo.declare("rmps.viewlets.internal.links.FullLinkDetails", rmps.ui.link.LinkDetails, {

	bodyLength: -1,

	// private properties
	_resourceIconLabel: null,

	postCreate: function() {
		this.inherited(arguments);

		this._resourceIconLabel = new rmps.ui.resource.ResourceIconLabel({
			isLink: true,
			showLongName: true,
			linkHref: this.getProjectPrefix()+ rmps.app.core.util.getViewResourceUri(this.object.resourceUri)
		});
		this.domNode.insertBefore(this._resourceIconLabel.domNode, this.domNode.firstChild);

		this.object.getResourceInfo(['shortName', 'iconUri', 'longName']).addCallback(this, function(resourceInfo) {
			var info;
			if(dojo.isArray(resourceInfo)){
				info= resourceInfo[0];
			}else{
				info= resourceInfo;
			}
			this._resourceIconLabel.setResourceInfo(info);
		});
	},

	startup: function() {
		this._resourceIconLabel.startup();
		this.inherited(arguments);
	},

	destroy: function() {
		this._resourceIconLabel.destroyRecursive();
		this.inherited(arguments);
	}
});

})();