/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2014.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.viewlets.internal.resource.TagCloudPresentation");

dojo.require("dijit._Widget");

dojo.require("rmps.app.core.util");

dojo.require("jazz.ui.TagCloud");

dojo.declare("rmps.viewlets.internal.resource.TagCloudPresentation", dijit._Widget, {

	"class": "rmps-viewlets-resource-popularity-tagCloud",

	// mixin properties
	results: null,
	contextURIDef: null,

	postCreate: function() {
		this.containerNode = this.domNode;

		var entries = [];
		var resources = {};
		for (var i = 0; i < this.results.length; ++i) {
			var result = this.results[i];
			var info = result.info;
			resources[info.shortName + result.value + info.uri] = result;
			entries.push({
				name: info.shortName + result.value + info.uri,
				value: result.value
			});
		}
		
		var def = this.contextURIDef;
		if (!def) {
			def = new dojo.Deferred();
			def.callback(null);
		}
		
		def.addBoth(dojo.hitch(this, function(contextURI) {		
			this._tagCloud = new rmps.viewlets.internal.resource_TagCloud({
				contextURI: contextURI,
				resources: resources,
				tags: entries,
				viewableTagLimit: this.results.length,
				showFrequencies: true,
				getProjectPrefix: dojo.hitch(this, this.getProjectPrefix),
				hrefProvider: function() {}
			});
			this.domNode.appendChild(this._tagCloud.domNode);
		}));
	}

});

dojo.declare("rmps.viewlets.internal.resource_TagCloud", jazz.ui.TagCloud, {

	resources: null,
	contextURI: null,
	
	postCreate: function() {
		this.inherited(arguments);
		this._isRTL = dojo.hasClass(document.documentElement, "dj_rtl");
	},

	_createTagLink: function(key) {
		var info = this.resources[key].info;

		var tagNameNode = dojo.doc.createTextNode(info.shortName);
		var linkElement = dojo.doc.createElement("a");

		var url = this.getProjectPrefix();
		var query = {};
		if (dojo.config.isDebug) {
			query["debug"] = true;
		}
		if (this.contextURI) {
			query["rmps.context"] = this.contextURI;			
		}
		var querystr = dojo.objectToQuery(query);
		if (querystr) {
			url += '?' + querystr;
		}
		url += rmps.app.core.util.getDesignViewResourceUri(info.uri);

		linkElement.href = url;
		linkElement.title = info.longName;
		linkElement.appendChild(tagNameNode);
		if (this._isRTL) {
			linkElement.dir = "rtl";
		} else {
			linkElement.dir = "ltr";
		}
		var container = dojo.doc.createElement("span");
		container.appendChild(linkElement);
		container.appendChild(dojo.doc.createTextNode(" "));
		return container;
	}
});

})();