/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.text.internal.util.ImageSrcUtil");
    
rmpw.text.internal.util.ImageSrcUtil = {
	embbedClassName: "dm-document-embbed",
	imageClassName: "dm-document-image",
	diagramImageSvc: net.jazz.ajax._contextRoot + "/diagrams/image?diagramUri=",
	imageSvc: net.jazz.ajax._contextRoot + "/fileUpload/view?resourceUri=",
	contextPrefix: "rmps.context=",
	changesetPrefix: "&changeset=",

    getImageFromResourceUri: function(resourceUri, className){
        var idx;
		if (!className) {
			// this is an image that is not inserted in the web client, just add context parameters
			return resourceUri + "?" + this.computeContextParams();
		}
        var prefix = this.getPrefix(className);
        if (prefix){
            idx = resourceUri.indexOf(prefix);
            if (idx === -1){
                var imageUri = prefix + encodeURIComponent(resourceUri) + "&" + this.computeContextParams();
            	return imageUri;
            }
        }
		return resourceUri;

    },
    
    extractResourceUriFromImage: function(imageUri, className){
        var idx, idx2;
		var prefix = this.getPrefix(className);
		if (prefix){
			var decodedImageUri = imageUri.replace(/&amp;/g, '&');
			idx = decodedImageUri.indexOf(prefix);
			idx2 = (decodedImageUri.indexOf(this.contextPrefix));
			if (idx > -1){
				if (idx2 > -1){
					return decodeURIComponent(decodedImageUri.substring(idx + prefix.length, idx2-1));					
				} else {
					return decodeURIComponent(decodedImageUri.substring(idx + prefix.length));
				}
			}
		}
		return imageUri;
    },
	
	getPrefix: function(className){
        var prefix = null;
        if (className === this.embbedClassName){
            prefix = this.diagramImageSvc;
        } else if (className === this.imageClassName){
            prefix = this.imageSvc;
        }
        return prefix;
    },
	
	computeContextParams: function(){
    	var contextParams = this.contextPrefix + jazz.app.context.get().baseline;
    	if (jazz.app.context.get().changeset){
    		contextParams += this.changesetPrefix + jazz.app.context.get().changeset;
    	}
    	return contextParams;
    }
};
