/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.viewlets.internal.validation.ValidationViewlet");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");

dojo.require("rmps.viewlets.internal.PagedTableViewlet");

dojo.requireLocalization("rmps.viewlets.internal.validation", "ValidationViewletMessages");

var messages = dojo.i18n.getLocalization("rmps.viewlets.internal.validation", "ValidationViewletMessages");
var DesignUtil = rmps.app.ui.internal.pages.design.DesignUtil;

dojo.declare("rmps.viewlets.internal.validation.ValidationViewlet", rmps.viewlets.internal.PagedTableViewlet, {

	fetchData: function(startIndex, count, entries, details, projectId) {
		this._showMessage(this._getUseValidationPageMessage());
	},
	
	_noProjectSpecified: function() {
		this._showMessage(this._getUseValidationPageMessage());
	},

	_getUseValidationPageMessage: function() {
		var divNode = dojo.doc.createElement("div"); 
		var explanationNode = dojo.doc.createTextNode(messages.unsupported);
		var linkNode = dojo.doc.createTextNode(messages.goTo);
		var breakElement = document.createElement('br');
		var hyperlink = document.createElement('a');
		hyperlink.href= DesignUtil.getValidationResourceUri();
		divNode.appendChild(explanationNode);
		divNode.appendChild(breakElement);
		divNode.appendChild(hyperlink);
		hyperlink.appendChild(linkNode);
		return divNode;
	}	
});

})();