/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.link.LinkDetails");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.html");
dojo.require("rmps.ui.ResourceDetails");
dojo.require("jazz.ui.ResourceLink");
dojo.require("rmps.core.util.ILinksConstants");

var ResourceLink = jazz.ui.ResourceLink;
var ILinksConstants = rmps.core.util.ILinksConstants;

dojo.declare("rmps.ui.link.LinkDetails", rmps.ui.ResourceDetails, {
	
	/*A flag to determine id we would like to get the compact rendering information for a link. It's true by default */
	compactRendering: true,
	
	setLabel: function(obj) {
		if(obj){
			var val= obj[this.object.value];
			if(val){
				var compactRendering= val.compactRendering;
				if(compactRendering){
					var anchor = document.createElement("a");
					var title= compactRendering.title;
					var label = jazz.util.html.unescape(title);
				    anchor.href = this.object.value;
				    anchor.target = "_blank";
					this._subject.domNode.appendChild(anchor);			
					anchor.appendChild(dojo.doc.createTextNode(label));					
				}
			}
		}
	},
	
	refreshLabel: function(){
		var anchor = document.createElement("a");
		var label = jazz.util.html.escape(this.object.value);
	    anchor.href = label;
	    anchor.target = "_blank";
	    
		if(this.compactRendering){
		    /*We do not require having a compact rednering for External Link Type */
		    if(this.object.predicate != ILinksConstants.EXTERNAL_LINK_TYPE){
			    anchor.appendChild(dojo.doc.createTextNode(label));	    	
				this._resourceLink= new ResourceLink({
				    uri: label,
				    label: label
				}, anchor);	  
			    this._subject.domNode.appendChild(anchor);
		    }
		}else if(this.object.predicate != ILinksConstants.EXTERNAL_LINK_TYPE){
			var dfd = jazz.client.xhrPost({
				url: dojo.baseUrl + "../../_compactRendering",
				handleAs: "json",
				content: {
					uri: [this.object.value]
				}
			});
			dfd.addCallback(dojo.hitch(this, this.setLabel));			
		}
	},
	
	refreshDescription: function(){
		if(this.object.predicate == ILinksConstants.EXTERNAL_LINK_TYPE) {
			var anchor = document.createElement("a");
			var label = jazz.util.html.escape(this.object.value);
		    anchor.href = label;
		    anchor.target = "_blank";
		    this._bodyText.appendChild(anchor);	
		    var val= this.object.description;
		    if(!val|| dojo.trim(val)== ""){
			    /*If there is no description for the external links, then, we show the link itself */
			    val= this.object.value;
			}
		    anchor.appendChild(dojo.doc.createTextNode(val));		
		}else{
			var body = this.object.description;
			if(!body){
				body= "";
			}
			var bodyObject = this.createBodyHtml(body);
			this._bodyText.innerHTML = bodyObject.innerHTML;
			if (bodyObject.more) {
				this._bodyTextMore.style.display = "";
				this._resourcePopup = this.createResourcePopup(this._bodyTextMore);
			} else {
				this._bodyTextMore.style.display = "none";
			}			
		}
	},
	
	refreshInfo: function() {
		dojo.html._emptyNode(this._info);
		this.destroyInfo();
	}

});

})();