/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.exporter.pages.ExportPageController");

dojo.require("rmpw.dsv.exporter.ExportStatusEditorInput");
dojo.require("rmpw.dsv.exporter.EcoreExportEditorInput");

dojo.declare("rmpw.dsv.exporter.pages.ExportPageController", null, {
	
	// private properties
	_page: null,
	
	_defaultUrl: null,
	
	constructor: function(page) {
		this._page = page;
	},
	
	_default: function(args) {
		setTimeout(dojo.hitch(this, function() {
			window.location.href = this._page.getDefaultUri();
		}), 0);
	},
	
	exportStatus: function() {
		if(!this._exportStatusEditorInput){
			this._exportStatusEditorInput = new rmpw.dsv.exporter.ExportStatusEditorInput({projectId: jazz.app.context.get().itemId});
		}
		this._page.getPageHelper().openEditor(this._exportStatusEditorInput);
	},
	
	ecoreExport: function(args) {
		if(!this._ecoreExportEditorInput) {
			this._ecoreExportEditorInput = rmpw.dsv.exporter.EcoreExportEditorInput({projectId: jazz.app.context.get().itemId});	
		}
		this._page.getPageHelper().openEditor(this._ecoreExportEditorInput);		
	}

});

})();
