/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide("rmpw.widgets.palettes.LinePalette");

dojo.declare( "rmpw.widgets.palettes.LinePalette", [dijit._Widget,dijit._Templated], {

   /* Reusing outer style of the Color Palette - to offer
    * some kind of consistency. Will revisit when more sketch
    * functionality is completed, and have talked with UX and VD.
    */

   templateString: "<div class=\"dijitInline dijitColorPalette\" dojoAttachPoint=\"shell\">\n\t<div class=\"dijitColorPaletteInner\" dojoAttachPoint=\"divNode\">\n\t</div>\t\n</div>\n",

   range: [1, 7],

   lines: null,

   borders: null,

   selected: null,

   onChange: null,

   highlight: "#C3D9FF",

   postCreate: function(){
      
      this.inherited(arguments);

      this.lines = [];
      
      this.borders = [];

      for( var r = this.range[0]; r <= this.range[1]; r++ )
      {
         this.borders[r] = dojo.doc.createElement( "div" );
             
         this.lines[r] = dojo.doc.createElement( "div" );

	     this.borders[r].id = r;
	     
	     this.lines[r].id = r;
	     
	     this.borders[r].style.width = "60px";
	     this.borders[r].style.height = "10px";
	     this.borders[r].style.margin = "3px";

	     var border = "" + r + "px solid #000000";

	     this.lines[r].style.borderBottom = border;
	     this.lines[r].style.backgroundColor = "transparent";
	     this.lines[r].style.height = "" + this.range[1] - r + "px";
	     this.lines[r].style.width = "50px";
	     this.lines[r].style.marginTop = "2px";
	     this.lines[r].style.marginBottom = "2px";
	     this.lines[r].style.marginRight = "7px";
	     this.lines[r].style.marginLeft = "5px";
	     this.lines[r].style.paddingTop = "2px";
	     
	     this.borders[r].appendChild( this.lines[r] );
             
	     this.divNode.appendChild( this.borders[r] );

	     dojo.connect( this.borders[r], "onmousedown", dojo.hitch( this, "onMouseDown" ) );
	     dojo.connect( this.borders[r], "onmouseover", dojo.hitch( this, "onMouseOver" ) );
	     dojo.connect( this.borders[r], "onmouseout", dojo.hitch( this, "onMouseOut" ) );
      }
   },

   onMouseDown: function(e){

      var a = dojo.byId( e.target );

      this.selected = a.id;
      
      /* Needs more attention - want to use the toggle facility of the dropdown */

      this.shell.style.visibility = "hidden";
     
      for( var b = this.range[0]; b <= this.range[1]; b++ )
      {
         this.borders[b].style.backgroundColor = "transparent";
      }

      this.borders[this.selected].style.backgroundColor = this.highlight;

      this.onChange( this.selected ); 
   },

   onMouseOver: function(e){

      var a = dojo.byId( e.target );
      
      this.borders[a.id].style.backgroundColor = this.highlight;
   },

   onMouseOut: function(e){
	   
      var a = dojo.byId( e.target );

      if( this.selected !== a.id )
      {
         this.borders[a.id].style.backgroundColor = "transparent";
      }
   }

});

}());
