/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
( function() {

dojo.provide("rmpw.widgets.palettes.ToolPalette");

dojo.declare( "rmpw.widgets.palettes.ToolPalette", [dijit._Widget,dijit._Templated], {

   /* Reusing outer style of the Color Palette - to offer
    * some kind of consistency. Will revisit when more sketch
    * functionality is completed, and have talked with UX and VD.
    */

   templateString: "<div class=\"dijitInline dijitColorPalette\" dojoAttachPoint=\"shell\">\n\t<div class=\"dijitColorPaletteInner\" dojoAttachPoint=\"divNode\">\n\t</div>\t\n</div>\n",

   range: [1, 6],

   lines: null,

   borders: null,

   selected: null,

   onChange: null,

   color: "#C3D9FF",
   
   tools: [ { path: "images/blue/rectangle_blue.png", name: "Rectangle", shape:"RMPW_RECTANGLE" },
            { path: "images/blue/oval_blue.png", name: "Oval", shape:"RMPW_OVAL" },
            { path: "images/blue/cloud_blue.png", name: "Cloud", shape:"RMPW_CLOUD" } ],
            
            //{ path: "images/sketch/actor_pal16.png", name: "Actor", shape:"RMPW_ACTOR" } 

   postCreate: function(){
      
      this.inherited(arguments);

      this.shapes = [];
      
      this.highlight = [];
      
      for( var r = 0; r < this.tools.length; r++ ){

         this.highlight[r] = dojo.doc.createElement( "div" );
             
         this.shapes[r] = dojo.doc.createElement( "div" );

	     this.highlight[r].id = r;
	     
	     this.shapes[r].id = r;
	     
	     this.highlight[r].style.width = "40px";
	     this.highlight[r].style.height = "20px";
	     this.highlight[r].style.margin = "3px";

         var border = "" + r + "px solid #000000";

	     var myurl = "url('" + dojo.moduleUrl("rmpw.widgets", this.tools[r].path ) + "')";
	     
	     this.shapes[r].style.align = "center";
	     
	     this.shapes[r].style.backgroundImage = myurl;
	     this.shapes[r].style.backgroundRepeat = "no-repeat"; 
	     this.shapes[r].style.backgroundPosition = "center center";
	     this.shapes[r].style.height = "20px";
	     this.shapes[r].style.width = "30px";
	     this.shapes[r].style.marginTop = "2px";
	     this.shapes[r].style.marginBottom = "2px";
	     this.shapes[r].style.marginRight = "7px";
	     this.shapes[r].style.marginLeft = "5px";
	     this.shapes[r].style.paddingTop = "3px";
	     
	     this.shapes[r].shape = this.tools[r].shape;
	     
	     this.highlight[r].appendChild( this.shapes[r] );
             
	     this.divNode.appendChild( this.highlight[r] );

	     dojo.connect( this.highlight[r], "onmousedown", dojo.hitch( this, "onMouseDown" ) );
	     dojo.connect( this.highlight[r], "onmouseover", dojo.hitch( this, "onMouseOver" ) );
	     dojo.connect( this.highlight[r], "onmouseout", dojo.hitch( this, "onMouseOut" ) );
      }
   },

   onMouseDown: function(e){

      var a = dojo.byId( e.target );

      this.selected = a.id;
      
      /* Needs more attention - want to use the toggle facility of the dropdown */

      this.shell.style.visibility = "hidden";
     
      for( var r = 0; r < this.tools.length; r++ ){
         this.highlight[r].style.backgroundColor = "transparent";
      }

      this.highlight[this.selected].style.backgroundColor = this.color;

      this.onChange( e.target.shape ); 
   },

   onMouseOver: function(e){

      var a = dojo.byId( e.target );
      
      this.highlight[a.id].style.backgroundColor = this.color;
   },

   onMouseOut: function(e){
	   
      var a = dojo.byId( e.target );

      if( this.selected !== a.id ){
         this.highlight[a.id].style.backgroundColor = "transparent";
      }
   }

});

}());
