/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| Copyright IBM Corp. 2009, 2012.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

( function() {

dojo.provide("rmpw.widgets.pickers.LineStylePicker");

dojo.require("rmpw.widgets.palettes.LineStylePalette");

dojo.require("rmpw.widgets.Events");

dojo.requireLocalization("rmpw.widgets", "ToolStrings");

var strings = dojo.i18n.getLocalization("rmpw.widgets", "ToolStrings");

var topics = rmpw.widgets.Events.topics;

dojo.declare( "rmpw.widgets.pickers.LineStylePicker", [dijit.form.DropDownButton], {

   showLabel: false, 
   title: strings.lineStyle_tooltip,
   iconClass: "styleIcon",
   dropDown: null,

   dash: "0",
   
   postCreate: function(){

      this.inherited(arguments);
   
      this.dropDown = new rmpw.widgets.palettes.LineStylePalette( { onChange: dojo.hitch( this, 'change' ) } );
   },
   
   change: function(val){
	   this.dash = val;
	   this.reset();
   },

   
   reset: function(){
      dojo.publish( topics.LINE_STYLE, [ { style: this.dash } ] );
   },
   
   destroy: function(){
      this.inherited( arguments );
      if (this.dropDown) {
          this.dropDown.destroy();
      }
   }
});

}());
