/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| Copyright IBM Corp. 2009, 2013.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

( function() {

dojo.provide("rmpw.widgets.pickers.TextPicker");

dojo.require("dijit.ColorPalette");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("rmpw.widgets.palettes.TextPalette");

dojo.require("rmpw.widgets.Events");

dojo.requireLocalization("rmpw.widgets", "ToolStrings");

var strings = dojo.i18n.getLocalization("rmpw.widgets", "ToolStrings");

dojo.declare( "rmpw.widgets.pickers.TextPicker", [dijit.form.DropDownButton], {

    showLabel: false,
    title: strings.chooseFont_tooltip,
    iconClass: "textConfigIcon",
    dropDown: null,

    connections: null,

    baseClass: "dijitToggleButton",

	hide : function() {
	}, 
    
    setStyles: function(){
    }, 
    
    getFontObject: function() {
        return this.dropDown.getFontObject();
    }, 
    
    initializeValues: function(fontObject) {
    	this.dropDown.initializeValues(fontObject);
    },
    
    postCreate: function() {
        this.inherited(arguments);
        this.connections = [];
        this.dropDown = new rmpw.widgets.palettes.TextPalette();
        this.connections.push(dojo.connect(this.dropDown, "setStyles", this, "setStyles"));
        this.connections.push(dojo.connect(this.dropDown, "hide", this, "hide"));
    },

	isFocusable: function(){
		return true;
	},
   
	destroy: function(){
		
		this.inherited( arguments );
		
		for( var c=0; c < this.connections.length; c++ ){
			dojo.disconnect( this.connections[c] );
		}
	}
});

}());
