/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *| Copyright IBM Corp. 2009, 2012.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

( function() {

dojo.provide("rmpw.widgets.pickers.ToolPicker");

dojo.require("dijit.ColorPalette");
dojo.require("dijit.Toolbar");
dojo.require("dijit.Menu");
dojo.require("rmpw.widgets.palettes.ToolPalette");

dojo.require("rmpw.widgets.Events");

dojo.requireLocalization("rmpw.widgets", "ToolStrings");

var strings = dojo.i18n.getLocalization("rmpw.widgets", "ToolStrings");

var topics = rmpw.widgets.Events.topics;

dojo.declare( "rmpw.widgets.pickers.ToolPicker", [dijit.form.DropDownButton], {

   showLabel: false, 
   title: strings.chooseShape_tooltip,
   iconClass: "shapesIcon",
   dropDown: null,
   
   baseClass: "dijitToggleButton",
   
   toolChoice: function( val ){
        console.log( "VALUE: " + val );
   },

   postCreate: function(){

      this.inherited(arguments);
   
      this.dropDown = new rmpw.widgets.palettes.ToolPalette( { onChange: dojo.hitch( this, "toolChoice" ) } );
   },
   
	checked: false,

	attributeMap: dojo.mixin(dojo.clone(dijit.form.Button.prototype.attributeMap), {
		checked:"focusNode"
	}),

	_clicked: function(/*Event*/ evt){
		this.set('checked', !this.checked);
		
		console.log( "CLICKED" );
	},

	_setCheckedAttr: function(/*Boolean*/ value, /* Boolean? */ priorityChange){
		this.checked = value;
		dojo.attr(this.focusNode || this.domNode, "checked", value);
		dijit.setWaiState(this.focusNode || this.domNode, "pressed", value);
		this._handleOnChange(value, priorityChange);
		
		
		if( value === false ){
			this._hovering = false;
			this._active = false;
			this._setStateClass();
		}
	},

	setChecked: function(/*Boolean*/ checked){
		// summary:
		//		Deprecated.   Use set('checked', true/false) instead.
		dojo.deprecated("setChecked("+checked+") is deprecated. Use set('checked',"+checked+") instead.", "", "2.0");
		this.set('checked', checked);
	},
   
	isFocusable: function(){
		return true;
	},
   
   destroy: function(){
      this.inherited( arguments );
   }
});

}());
