/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.pickers.internal.BaselinePicker");

dojo.require("rmps.core.baseline.BaselineClient");
dojo.require("rmps.app.pickers.internal.ContextPicker");

/**
 * An OSLC style delegated selection dialog for selecting DM baselines.
 */
dojo.declare("rmps.app.pickers.internal.BaselinePicker", [rmps.app.pickers.internal.ContextPicker], {
	
	/**
	 * Overridden from superclass.  Fetches baselines for the given project ID.
	 */
	fetchContexts: function(projectId) {
		var baselineDeferred = rmps.core.baseline.BaselineClient.getBaselines(null, this.projectId); 
		//TODO filter and sort this list?
		baselineDeferred.addCallback(this, function(baselines){
			/**The baseline objects returned by the client already have the appropriate format,
			 * so just return them as-is.
			 */
			return baselines;
		});
		return baselineDeferred;
	}
	
});
})();