/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.pickers.internal.QueryPicker");

dojo.require("rmps.core.querymodel.QueryModelClient");
dojo.require("rmps.app.pickers.internal.ContextPicker");
dojo.require("dojo.i18n");
		
dojo.requireLocalization("rmps.app.pickers.internal", "QueryPickerMessages");

/**
 * An OSLC style delegated selection dialog for selecting DM queries.
 */
dojo.declare("rmps.app.pickers.internal.QueryPicker", [rmps.app.pickers.internal.ContextPicker], {
		
	/**
	 * Overridden from superclass.  Fetches queries for the given project ID.
	 */
	fetchContexts: function(projectId) {
	    var def = null;
	    if (this.projectId) {
			def = rmps.core.querymodel.QueryModelClient.getQueryModels(this.projectId); 
			//TODO filter and sort this list?
			def.addCallback(this, function(queries){
				/**The baseline objects returned by the client already have the appropriate format,
				 * so just return them as-is.
				 */
				return queries;
			});
	    } else {
			// There is no project ID defined so the request to get the query models will
			// throw an error. Create a deferred response, wait half a second and output
			// a message indicating a project must be selected first.
			var messages = dojo.i18n.getLocalization("rmps.app.pickers.internal", "QueryPickerMessages");
			var textNode = dojo.doc.createTextNode(messages.noProject);
			var messageNode = this._messageNode;
			def = new dojo.Deferred();
			setTimeout(function(){ 
				messageNode.appendChild(textNode);
				def.resolve([]); 
			}, 500);
	    }
		return def;
	}
	
});
})();