/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.pickers.internal.StreamPicker");

dojo.require("rmps.core.streams.StreamClient");
dojo.require("rmps.app.pickers.internal.ContextPicker");

/**
 * An OSLC style delegated selection dialog for selecting DM streams.
 */
dojo.declare("rmps.app.pickers.internal.StreamPicker", [rmps.app.pickers.internal.ContextPicker], {
	
	/**
	 * Overridden from superclass.  Fetches baselines for the given project ID.
	 */
	fetchContexts: function(projectId) {
		var streamDeferred = rmps.core.streams.StreamClient.getStreams(this.projectId); 
		//TODO sort this list?
		streamDeferred.addCallback(this, function(stream){
			/**The stream objects returned by the client already have the appropriate format,
			 * so just return them as-is.
			 */
			return stream;
		});
		return streamDeferred;
	}
	
});
})();