/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.render.policies.AbstractScale");

dojo.require("rmpw.common.policy.Policy");

/**
 * TODO (MG): if a scale changes it should invalidate all the bindings to itself
 * 
 * @author Marc Gobeil
 */
dojo.declare("rmpw.diagrams.render.policies.AbstractScale", rmpw.common.policy.Policy, {
	/**
	 * Key for the scale, so bindings can distinguish the correct scale to bind to
	 * when they walk up their parent chain.  
	 */
	setKey: function(key) {
		this.host.policies["scale_" + key] = this;
	},
	
	/**
	 * Axis can either be 'x', 'y'
	 * TODO (MG): make constants for axes
	 */
	setAxis: function(axis) {
		this._axis = axis;
	},
	
	/**
	 * Returns a visual property assignment based on the value provided.
	 * 
	 * Result is an array with two elements:
	 * 0 - the name of the visual property
	 * 1 - the value the visual property is to be assigned.
	 */
	getPlacement: function(value) {
		return [this._axis, this._getPlacement(value)];
	}
});