/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.render.policies.ItemScale");

dojo.require("rmpw.diagrams.render.policies.AbstractScale");

/**
 * @author Marc Gobeil
 */
dojo.declare("rmpw.diagrams.render.policies.ItemScale", rmpw.diagrams.render.policies.AbstractScale, {
	_minItemSize: 50,
	
	constructor: function() {
		this._slots = {};
		this._lastPlacement = 0;
	},
	
	setItemSizeMin: function(size) {
		this._minItemSize = size;
	},
	
	_getPlacement: function(value) {
		var slot = this._slots[value];
		if(!slot) {
			var size = this._minItemSize;
			slot = {
				start: this._lastPlacement,
				size: size		// TODO (MG): allow size changes, and recalculate starts on enforce
			};
			this._lastPlacement += size;
			this._slots[value] = slot;
		}
		return slot.start;
	}

//	TODO (MG): I'm sure this will be useful some day	
//	
//	getSlotIdByValue: function(value) {
//		for(var slotId in this._slots) {
//			var slot = this._slots[slotId];
//			if(value >= slot.start && value <= (slot.start + slot.size)) {
//				return slotId;
//			}
//		}
//		return null;
//	}
});