/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.graphics.policies.OneClickHyperlinkPolicy");

dojo.require("rmps.core.RootServices");
dojo.require("rmps.app.core.util");

var modelsFrontService = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "models");			

/**
 * @author Anton McConville
 * @author John Swanke
 */
dojo.declare("rmps.graphics.policies.OneClickHyperlinkPolicy", rmpw.common.policy.Policy, {
	
	singleton: "oneclicklink",
	
	focusConnection: null,
	
	myShape: null, 
	
	constructor: function( ) {
		
		this.zonedata = this.host.renderMapping.sources.model.zonedata;
		this.zonedata.opened = false;
		
		if (this.zonedata.oneclickHyperlink) {
			var url = this.zonedata.oneclickHyperlink;
			this.internal = (url.indexOf(modelsFrontService) === 0);
			this.myShape = this.host.renderMapping.getShape();
			this.myShape.children[0].rawNode.style.cursor = "pointer";
			this.connection = this.myShape.connect( "onclick", this, this.open );
		}
	},
	
	destroy: function(){
		if( this.myShape != null ){
			this.myShape.disconnect( this.connection );
		}
	},
	
	open: function(e){
		if (this.internal) {
			location.href = "#action=rmps.app.design.edit&resource=" + this.zonedata.oneclickHyperlink;
		} else {
			window.open(this.zonedata.oneclickHyperlink, "_blank");
		}
		dojo.stopEvent(e);
	}
});

})();