/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.graphics.policies.PropertiesPolicy");

dojo.require("rmps.core.RootServices");
dojo.require("rmps.app.core.util");
/**
 * @author Anton McConville
 */
dojo.declare("rmps.graphics.policies.PropertiesPolicy", rmpw.common.policy.Policy, {
	
	singleton: "properties",
	
	focusConnection: null,
	
	myShape: null, 
	
	constructor: function( ){
		
		this.zonedata = this.host.renderMapping.sources.model.zonedata;
		this.zonedata.opened = false;
		
		this.myShape = this.host.renderMapping.getShape();
		
		this.connection = this.myShape.connect( "ondblclick", this, this.open );
	},
	
	destroy: function(){
		
		var shape = this.myShape;
		
		if( this.myShape != null ){
			this.myShape.disconnect( this.connection );
		}
	},
	
	open: function(e){
		
		if( this.zonedata.hyperlink != null ){
			
			window.open(this.zonedata.hyperlink, "_blank");
			
		}else if( this.zonedata.id != null ){
			
			var link = rmps.app.core.util.getViewResourceUri( this.zonedata.id );
			
			location.href = link;
		}	
		
		dojo.stopEvent(e);
	}
});