/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.render.policies.ToolTip");

dojo.require("rmpw.common.policy.Policy");


/**
 * Policy for installing a tooltip
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.render.policies.ToolTip", rmpw.common.policy.Policy, {
	singleton: "toolTip",
	
	constructor: function() {
	},

	/*
	 * Sets the shape that will have the tooltip 
	 */
	setShape: function(figure) {
		this._figure = figure;
	},
	
	/*
	 * Sets the tooltip description for this mapping
	 * @param text - the text that will appear
	 */
	setText: function(text) {
		this._text = text;
	},
	
	enforce: function() {
		if (this._figure && this._text) {
			if (dojox.gfx.vml) {
				this._figure.rawNode.title = this._text ? this._text : '';
			} else {
				this._figure.rawNode.setAttribute("title", this._text ? this._text : '');
			}
		}
	}
	
});