/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.process.ProjectRolePermissions");

dojo.declare("rmps.core.process.ProjectRolePermissions", null, {
	
	roles: null,
	
	constructor: function() {
		this.rolePermissions = {};
	},
	
	parse: function(doc) {
		var response= doc.getElementsByTagName("soapenv:Envelope")[0];
		if(!response){
			return;
		}
		
		var returnValues= response.getElementsByTagName("returnValue")[0];
		
		if(!returnValues){
			return;
		}
		
		var values= returnValues.getElementsByTagName("values"); 
		
		for(var index=0; index<values.length; index++){
			var value= values[index];
			var idNode= value.getElementsByTagName("id")[0];
			if(!idNode){continue;}
			
			var idNodeChild= idNode.childNodes[0];
			
			if(!idNodeChild){continue;}
			
			var id= idNodeChild.nodeValue;
			var enabledNode= value.getElementsByTagName("enabled")[0];
			
			if(!enabledNode){continue;}
			
			var enabledNodeChild= enabledNode.childNodes[0];
			if(enabledNodeChild){
				this.rolePermissions[id]= enabledNodeChild.nodeValue;							
			}		
		}
	}
});

})();