/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.properties.PropertiesClient");

dojo.require("jazz.app.context");

dojo.require("jazz.client.xhr");

dojo.require("rmps.core.RootServices");

var PROPERTIES_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "properties");

var BASELINE_PARAM = "rmps.context";

rmps.core.properties.PropertiesClient = {
	
	getPropertiesFor: function(resourceUri) {
		var p1;
		var p2;
		var fragmentIdx = resourceUri.indexOf('#');
		if (fragmentIdx > 0) {
			p1 = resourceUri.substring(0, fragmentIdx);
			p2 = resourceUri.substring(fragmentIdx + 1);
		} else {
			p1 = resourceUri;
		}
		
		// Baseline
		var content = {}; 
		var baseline = jazz.app.context.get().baseline;
		if (baseline) {
			content[BASELINE_PARAM] = baseline;
		}
		
		var args = {
			url: PROPERTIES_PATH + "?resourceUri=" + encodeURIComponent(p1)
				+ (p2 ? "&element=" + p2 : ''),
			handleAs: "json",
			content: content,
			headers: {
				accept: "application/json",
				"X-ibm-rmps-internal": "true"
			}
		};
		return jazz.client.xhrGet(args);
	}
};

})();