/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.properties.SectionContainer");

dojo.require("dijit._Widget");

dojo.declare("rmps.ui.properties.SectionContainer", dijit._Widget, {
	
	"class": "rmps-ui-properties-sectionContainer",
	
	// private properties
	_sections: null, //[]
	
	constructor: function() {
		this._sections = [];
	},
	
	postCreate: function() {
		this.containerNode = dojo.create("div", null, this.domNode);
	},
	
	resize: function(size) {
		if (size && size.h) {
			this.domNode.style.height = (size.h - 10) + "px";
		}
		var cb = dojo.contentBox(this.domNode.parentNode);
		for (var i = 0; i < this._sections.length; ++i) {
			if (this._sections[i].resize) {
				// subtract margins and padding from width and height
				this._sections[i].resize({ w: cb.w - 10, h: cb.h - 10 });
			}
		}
	},
	
	addSection: function(section) {
		this._sections.push(section);
		dojo.addClass(section.domNode, "section");
		if (section.setContainer) {
			section.setContainer(this.containerNode);
		} else {
			this.containerNode.appendChild(section.domNode);
		}
		section.startup();
	}
});