/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.properties.form.LabeledSection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare("rmps.ui.properties.form.LabeledSection", dijit._Widget, {
	
	// mixin properties
	label: null,
	defaultLabelWidth: 75,
	
	_table: null,
	
	setContainer: function(container) {
		if (container.lastChild) {
			var widget = dijit.byNode(container.lastChild);
			if (widget.declaredClass === "rmps.ui.properties.form.LabeledSection._Table") {
				widget.addSection(this);
				return;
			}
		}
		
		this._table = new rmps.ui.properties.form.LabeledSection._Table();
		container.appendChild(this._table.domNode);
		this._table.startup();
		this._table.addSection(this);
		
	}
});

dojo.declare("rmps.ui.properties.form.LabeledSection._Table", [dijit._Widget, dijit._Templated], {
	
	templateString: '<table style="border-spacing: 0;">' +
				'<tbody dojoAttachPoint="containerNode"></tbody>' +
			'</table>',
			
	addSection: function(section) {
		var row = new rmps.ui.properties.form.LabeledSection._Row({section: section});
		this.containerNode.appendChild(row.domNode);
		row.startup();
	}
});

dojo.declare("rmps.ui.properties.form.LabeledSection._Row", [dijit._Widget, dijit._Templated], {
	
	templateString: '<tr>' +
				'<td style="min-width: ${section.defaultLabelWidth}px; padding-right: 5px; padding-bottom: 5px;">' +
					'<span style="white-space: nowrap;" class="label" dojoAttachPoint="labelNode">${section.label}</span>' +
				'</td>' +
				'<td style="width: 100%; padding-bottom: 5px;" dojoAttachPoint="containerNode"></td>' +
				'<td style="width: 0px; padding-bottom: 5px;"><div style="min-height: 20px; width: 0px;"></div></td>' +
			'</tr>',
	
	section: null,
	
	postCreate: function() {
		// add the section
		this.containerNode.appendChild(this.section.domNode);
		
		if (dojo.isIE < 8) {
			var spacer = dojo.create("div");
			spacer.style.width = this.section.defaultLabelWidth + "px";
			spacer.style.height = "1px";
			spacer.style.visibility = "hidden";
			this.labelNode.parentNode.appendChild(spacer);
			this.labelNode.style.minHeight = "19px";
		}
	}
});