/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.properties.form.RadioInput");

dojo.require("rmps.ui.properties.form.LabeledSection");

dojo.declare("rmps.ui.properties.form.RadioInput", [rmps.ui.properties.form.LabeledSection], {
	
	// mixin properties
	name: null,
	readOnly: false,
	radios: null, // array of objects in the form: {value: "", label: "", checked: false}
	inputNodes: null,
	"class": "rmps-ui-properties-form-radioInput",
	
	constructor: function() {
		this.inputNodes = [];
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		for (var i = 0; i < this.radios.length; ++i) {
			var radio = this.radios[i];
			var id = this.id + radio.value;
			var inputNode = dojo.create("input", {type: "radio", name: this.name, id: id, value: radio.value}, this.domNode);
			this.inputNodes.push(inputNode);
			
			if (radio.checked) {
				inputNode.checked = true;
			}
			if (this.readOnly) {
				inputNode.disabled = true;
			}
			
			var container = dojo.create("label", {"for": id}, this.domNode);
			dojo.addClass(container, "radioLabel");
			container.appendChild(dojo.doc.createTextNode(radio.label));
			
			this.domNode.appendChild(container);
		}
	}
});