/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.properties.form.TextArea");

dojo.require("dijit._Templated");

dojo.require("rmps.ui.properties.form.LabeledSection");

dojo.declare("rmps.ui.properties.form.TextArea", [rmps.ui.properties.form.LabeledSection, dijit._Templated], {
	
	templateString: '<div class="rmps-ui-properties-form-textArea">' +
				'<textarea dojoAttachPoint="inputNode" rows="${rows}" name="${name}"></textarea>' +
			'</div>',
	
	// attach points
	inputNode: null,
	
	// mixin properties
	label: null,
	name: "",
	value: "",
	readOnly: false,
	rows: 5,

	postCreate: function() {
		if (this.readOnly) {
			this.inputNode.readOnly = "readOnly";
		}
		
		this.inputNode.appendChild(dojo.doc.createTextNode(this.value));
	}
	
});