/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.query.BasicQueryResult");

dojo.declare("rmps.core.query.BasicQueryResult", null, {
	
	query: null,
	
	id: null,
	//may be negative to indicate that there were results not returned because they were over the limit
	totalResults: 0,
	entries: null,
	uri: null,
	previousPage: null,
	nextPage: null,
	lastPage: null,
	firstPage: null,
	
	constructor: function(query) {
		if (query) {
			this.query = query;
		}
	},
	
	getTotalResults: function() {
		return this.totalResults;
	},
	
	parse: function(feed, ioArgs) {
		this.id = feed.id[0].value;
		this.entries = feed.entry || [];
		this.totalResults = parseInt(feed["opensearch:totalResults"][0].value);
		
		var links = feed.link;
		for (var i = 0; i < links.length; ++i) {
			var link = links[i];
			switch(link.rel) {
				case "self":
					this.uri = link.href;
					break;
				case "first":
					this.firstPage = link.first;
					break;
				case "previous":
					this.previousPage = link.href;
					break;
				case "next":
					this.nextPage = link.href;
					break;
				case "last":
					this.lastPage = link.href;
					break;
			}
		}
	}
});

})();