/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.query.QueryClient");

dojo.require("rmps.core.query.BasicQueryResult");

dojo.require("jazz.client.xhr");

dojo.require("rmps.core.RootServices");

var SEARCH_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "dm-search");

rmps.core.query.QueryClient = {
	
	execute: function(query, result) {
		var args = {
			url: SEARCH_PATH + '?' + query.toQueryString(),
			headers: {
				"Accept": "application/atom+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			load: function(response, ioArgs) {
				if (result && result.parse) {
					result.parse(response, ioArgs);
					return result;
				}

				if (response && response["dminternal:matchedById"][0].value === "true") {
					return response.entry[0].link[0].href;
				}

				var basicResult = new rmps.core.query.BasicQueryResult(query);
				basicResult.parse(response, ioArgs);
				return basicResult;
			}
		};

		return jazz.client.xhrGet(args);
	}
};

})();