/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.query.SearchQuery");

dojo.require("rmps.core.query.TextQuery");
dojo.require("rmps.core.util.IRmpsConstants");

var IRmpsConstants = rmps.core.util.IRmpsConstants;

dojo.declare("rmps.core.query.SearchQuery", rmps.core.query.TextQuery, {

	// mixin
	queryUri: null,
	scope: null,
	
	constructor: function(params) {
		if (params) {
			this.queryUri = params.queryUri;
			this.scope = params.scope;
			this.name = params.name;
		}
	},
	
	_getQueryStringSearchParams: function(params) {
		params.queryUri = this.queryUri;
		params.scope = this.scope;
		params.name = this.name;
	},
	
	equals: function(obj) {
		return false;
	},

	/**
	 * Returns null if there are no problems with the query; if there are, returns an array of strings listing any issues.  
	 * If a query is not valid, it can still be sent to the server, but the server may return an error. 
	 *
	 */	
	validate: function() {		
		return null;
	}
});

})();