/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.CompositeWidgetsContainer");

dojo.require("rmps.ui.queryeditor.WidgetsContainer");

dojo.declare("rmps.ui.queryeditor.CompositeWidgetsContainer", [rmps.ui.queryeditor.WidgetsContainer], {
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/templates/CompositeWidgetsContainer.html"),
	
	addSection: function (section, isContainer) {
		var order = section._order = this._sectionsCount++;
		var sections = isContainer ? this._containerSections : this._simpleSections;
		var beforeSection = dojo.filter(sections.children, function (sec) { return sec._order > order; })[0];
		
		if (beforeSection) {
			sections.insertBefore(section.domNode, beforeSection);
		} else {
			sections.appendChild(section.domNode);
		}
	},
	
	_allSections: function () {
		var sections = [];
		dojo.forEach(this._containerSections.children, function (s) { sections.push(s); });
		dojo.forEach(this._simpleSections.children, function (s) { sections.push(s); });
		return sections;
	}
});
