/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.GroupingPropertiesWidget");

dojo.require("dojo.i18n");
dojo.require("rmps.ui.queryeditor.QueryConstants");
dojo.require("rmps.ui.queryeditor.OntologyPropertiesWidget");

dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.GroupingPropertiesWidget", rmps.ui.queryeditor.OntologyPropertiesWidget, {

	_queryConditionListProperty: QueryConstants.QUERY_GROUPING_PROPERTY,

	getTitle: function() {
		return messages.labelGrouping;
	},
	
	getMenuItems: function() {
		return null;
	},
	
	serialize: function() {
		return  dojo.map(this.getSelectedValues(), function(item) {
			return item.id;
		});

	},
	
	initializeFromConditionData: function() {
		// not calling parent to prevent setting multiseleciton to true	
	},
	
	getWidgetDataOptions: function() {
		var dataOptions = this.inherited(arguments);
		dataOptions.typeURI = null;
		return dataOptions;
	}
});
}());