/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.IQueryWidget");

dojo.require("rmps.ui.queryeditor.WidgetDataStore");
dojo.require("rmps.ui.queryeditor.QueryConstants");

(function(){

var QueryConstants = rmps.ui.queryeditor.QueryConstants;
	
dojo.declare("rmps.ui.queryeditor.IQueryWidget", null, {
	
	//mix-in
	name: "",
	description: "",
	identifier: "",
	container: false,
	mainWidget: null,
	conditionData: null,
	
	getTitle: function() {
		return this.name;
	},
	
	getIdentifier: function() {
		return this.identifier;
	},
	
	getDescription: function() {
		return this.description;
	},
	
	getIconUrl: function() {
		return "";
	},
	
	// Return true if the widget is a container widget
	isContainer: function() {
		return this.container;
	},
	
	// Return a dojo.Deferred that returns a callback when ready for serialization, or errback on error.
	// If null is returned, serialization can be done immediately.
	preSerialize: function() {
		return null;
	},
	
	serialize: function() {
		// Overridden by widgets
		return {};
	},
	
	validate: function() {
		return { hasNonContainerPortlet: true, errors: [] };
	},
	
	getConditionData: function() {
		return this.conditionData;
	},
	
	setConditionData: function(data) {
		this.conditionData = data;
	},
	
	getDataStore: function() {
		if (this.mainWidget) {
			return this.mainWidget.widgetDataStore;
		}
	
		return new rmps.ui.queryeditor.WidgetDataStore();
	},
	
	// Return possible options that should be send to the widget data service
	getWidgetDataOptions: function() {
		return null;
	},
	
	// Call to refresh widget data
	refreshWidgetData: function() {
		// Override
	},
	
	// Call to enable/disable widget modifications
	setEnabled: function(value) {
		// Override		
	},
	
	// Return the menu items for the title menu.
	// Each menu item should have an 'id' and a 'label' variable.
	getMenuItems: function() {
		return [];
	},
	
	// Return the current selected menu item, based on 'id' value.
	getMenuSelection: function() {
		// Override
		return null;
	},
	
	// Will be called when a menu item is selected
	onMenuAction: function(e) {
		// Override
	},
	
	onAddContainer: function(containerWidget) {
		// Override
	}
	
});
}());