/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.OntologyTypesWidget");

dojo.require("dojo.i18n");
dojo.require("rmps.ui.queryeditor.ListWidget");
dojo.require("rmps.ui.queryeditor.QueryConstants");

dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;
	
dojo.declare("rmps.ui.queryeditor.OntologyTypesWidget", rmps.ui.queryeditor.ListWidget, {

	_queryConditionName: QueryConstants.TYPE_CONDITION_TYPE, 
	_queryConditionListProperty: QueryConstants.TYPE_CONDITION_EXACT_TYPE_LIST_PROPERTY,
	
	_warning: null,
	_itemsName: messages.types,
	
	_menuItems: [{
		id: QueryConstants.TYPE_CONDITION_EXACT_TYPE_LIST_PROPERTY,
		label: messages.labelIsExact
	}, {
		id: QueryConstants.TYPE_CONDITION_TYPE_LIST_PROPERTY,
		label: messages.labelIs 
	}],
	
	postCreate: function() {
		// Make sure the list property is correct
		var conditionData = this.getConditionData();
		if (conditionData) {
			if (QueryConstants.TYPE_CONDITION_TYPE_LIST_PROPERTY in conditionData) {
				this._queryConditionListProperty = QueryConstants.TYPE_CONDITION_TYPE_LIST_PROPERTY;
			}
		}
		this.setMultiple(true);
		this.inherited(arguments);
		this._updateWarning();
	},

	getMenuItems: function() {
		// Return the different conditions
		return this._menuItems; 
	},

	getMenuSelection: function() {
		if (this._queryConditionListProperty === QueryConstants.TYPE_CONDITION_EXACT_TYPE_LIST_PROPERTY) {
			return this._menuItems[0];
		} else {
			return this._menuItems[1];
		}
	},

	onMenuAction: function(item) {
		this._queryConditionListProperty = item.id;
		this._updateWarning();
	},

	getWidgetDataOptions: function () {
		return {
			selection: this._selection,
			localAndDependantOntologies: this.isViewpointEditor()  
		};
	},

	_updateWarning: function () {
		if (this._queryConditionListProperty === QueryConstants.TYPE_CONDITION_TYPE_LIST_PROPERTY) {
			this._showWarning(messages.typeWarning, true);
		} else {
			this._showWarning();
		}
	}
});
})();