/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.PredefinedPropertyResourcesWidget");

dojo.require("rmps.ui.queryeditor.OntologyPropertiesResourcesWidget");
dojo.require("rmps.ui.queryeditor.QueryConstants");

(function(){
	
var QueryConstants = rmps.ui.queryeditor.QueryConstants;
var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

dojo.declare("rmps.ui.queryeditor.PredefinedPropertyResourcesWidget", rmps.ui.queryeditor.OntologyPropertiesResourcesWidget, {
	
	_property: null,
	_propertyTargetType: null,
	_menuItems: null, // to get rid of standard resource predicates

	postCreate: function() {
		// Set the property
		var id = this.getIdentifier();
		if (id === QueryConstants.CREATED_BY_WIDGET_ID) {
			this._property = QueryConstants.JTS_SYSTEM_INDEX_CREATOR_PROPERTY;
			this._propertyTargetType = QueryConstants.USER_DATATYPE;
		} else if (id === QueryConstants.MODIFIED_BY_WIDGET_ID) {
			this._property = QueryConstants.JTS_SYSTEM_INDEX_CONTRIBUTOR_PROPERTY;
			this._propertyTargetType = QueryConstants.USER_DATATYPE;
		}
		this._onSelectionChange();
		this.inherited(arguments);
		this.hideList();
	},
	
	getSelectedValues: function() {
		return [{
			id: this._property,
			targetType: this._propertyTargetType
		}];
	},
	
	refreshWidgetData: function() {
		// No widget data for the widget itself, the filters will get data if necessary.
		this._defWidgetData = new dojo.Deferred();
		this._defWidgetData.callback();
	}
});
}());