/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.PredefinedPropertyValueWidget");

dojo.require("rmps.ui.queryeditor.OntologyPropertiesValueWidget");
dojo.require("rmps.ui.queryeditor.QueryConstants");

(function(){
	
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.PredefinedPropertyValueWidget", rmps.ui.queryeditor.OntologyPropertiesValueWidget, {
	
	_property: null,
	_propertyTargetType: null,
	
	postCreate: function() {
		// Set the property
		var id = this.getIdentifier();
		if (id === QueryConstants.MODIFIED_WIDGET_ID) {
			this._property = QueryConstants.JTS_SYSTEM_INDEX_MODIFIED_PROPERTY;
			this._propertyTargetType = QueryConstants.DATE_DATATYPE;
		} else if (id === QueryConstants.CREATED_WIDGET_ID) {
			this._property = QueryConstants.JTS_SYSTEM_INDEX_CREATED_PROPERTY;
			this._propertyTargetType = QueryConstants.DATE_DATATYPE;
		} else if (id === QueryConstants.NAME_WIDGET_ID) {
			this._property = QueryConstants.DM_INDEX_NAME_PROPERTY;
			this._propertyTargetType = QueryConstants.STRING_DATATYPE;
		}
		this.inherited(arguments);
		this.hideList();
	},
	
	getSelectedValues: function() {
		return [{
			id: this._property,
			targetType: this._propertyTargetType
		}];
	},
	
	refreshWidgetData: function() {
		// No widget data for the widget itself, the filters will get data if necessary.
		this._defWidgetData = new dojo.Deferred();
		this._defWidgetData.callback();
	}
});
}());