/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.QueryConstants");

(function(){

var DCTERMS_XML_NAMESPACE = "http://purl.org/dc/terms/";
var RDFS_XML_NAMESPACE = "http://www.w3.org/2000/01/rdf-schema#";
	
rmps.ui.queryeditor.QueryConstants = {
		LINK_WIDGET_ID: "dm.query.link",
		LOGICAL_WIDGET_ID: "dm.query.logical",
		PREDICATE_WIDGET_ID: "dm.query.ontology.predicate",
		PREDICATE_CHAIN_WIDGET_ID: "dm.query.ontology.predicate.chain",		
		PREDICATE_VALUE_WIDGET_ID: "dm.query.ontology.predicate.value",
		PREDICATE_RESOURCE_WIDGET_ID: "dm.query.ontology.predicate.resource",
		MODIFIED_BY_WIDGET_ID: "dm.query.modified.by",
		CREATED_BY_WIDGET_ID: "dm.query.created.by",
		MODIFIED_WIDGET_ID: "dm.query.modified",
		CREATED_WIDGET_ID: "dm.query.created",
		NAME_WIDGET_ID: "dm.query.name",

		CHAIN_CONDITION_TYPE: "ChainCondition",
		CHAIN_CONDITION_NEXT_PROPERTY: "next",
		
		CONDITION_PRESENTATION_PROPERTY: "presentation",
		CONDITION_IGNORE_CONTEXT_PROPERTY: "ignoreContext",

		LOGICAL_CONDITION_TYPE: "LogicalCondition",
		LOGICAL_CONDITION_SUBCONDITION_PROPERTY: "subcondition",
		LOGICAL_CONDITION_OPERATOR_PROPERTY: "operation",
		LOGICAL_CONDITION_OPERATOR_AND_VALUE: "and",
		LOGICAL_CONDITION_OPERATOR_OR_VALUE: "or",
		LOGICAL_CONDITION_OPERATOR_NOT_VALUE: "not",	
		
		PREDICATE_CONDITION_TYPE: "PredicateCondition",
		PREDICATE_CONDITION_PREDICATE_LIST_PROPERTY: "predicate",
		PREDICATE_CONDITION_EXACT_PREDICATE_LIST_PROPERTY: "exactPredicate",
		PREDICATE_CONDITION_PREDICATE_END_PROPERTY: "predicateEnd",
		PREDICATE_CONDITION_PREDICATE_END_SUBJECT: "subject",
		PREDICATE_CONDITION_PREDICATE_END_OBJECT: "object",
		
		TYPE_CONDITION_TYPE: "TypeCondition",
		TYPE_CONDITION_EXACT_TYPE_LIST_PROPERTY: "exactType",
		TYPE_CONDITION_TYPE_LIST_PROPERTY: "type",
		
		LINK_CONDITION_TYPE: "LinkCondition",
		LINK_CONDITION_LINK_TYPE_PROPERTY: "exactPredicate",
		LINK_CONDITION_DIRECTION_PROPERTY: "predicateEnd",
		LINK_CONDITION_DIRECTION_SOURCE: "subject",
		LINK_CONDITION_DIRECTION_TARGET: "object",
		
		PREDICATE_VALUE_CONDITION_TYPE: "ValueCondition",
		PREDICATE_VALUE_CONDITION_VALUE_PROPERTY: "value",
		PREDICATE_VALUE_CONDITION_SIGN_PROPERTY: "sign",
		PREDICATE_VALUE_CONDITION_SIGN_EQUAL: "equal",
		PREDICATE_VALUE_CONDITION_SIGN_LESS: "less",
		PREDICATE_VALUE_CONDITION_SIGN_MORE: "more",
		PREDICATE_VALUE_CONDITION_SIGN_LESS_OR_EQUAL: "lessOrEqual",
		PREDICATE_VALUE_CONDITION_SIGN_MORE_OR_EQUAL: "moreOrEqual",
		
		PREDICATE_RANGE_CONDITION_TYPE: "RangeCondition",
		PREDICATE_RANGE_CONDITION_MIN_VALUE_PROPERTY: "minValue",
		PREDICATE_RANGE_CONDITION_MAX_VALUE_PROPERTY: "maxValue",
		PREDICATE_RANGE_CONDITION_MIN_VALUE_INCLUSION_PROPERTY: "minValueInclusion",
		PREDICATE_RANGE_CONDITION_MAX_VALUE_INCLUSION_PROPERTY: "minValueInclusion",

		PREDICATE_RESOURCE_CONDITION_TYPE: "ResourceCondition",
		PREDICATE_RESOURCE_CONDITION_RESOURCE_PROPERTY: "resource",
		
		DM_INDEX_NAME_PROPERTY: RDFS_XML_NAMESPACE + "label",
		
		JTS_SYSTEM_INDEX_CREATOR_PROPERTY: DCTERMS_XML_NAMESPACE + "creator",
		JTS_SYSTEM_INDEX_CONTRIBUTOR_PROPERTY: DCTERMS_XML_NAMESPACE + "contributor",
		JTS_SYSTEM_INDEX_CREATED_PROPERTY: DCTERMS_XML_NAMESPACE + "created",
		JTS_SYSTEM_INDEX_MODIFIED_PROPERTY: DCTERMS_XML_NAMESPACE + "modified",
		
		BOOLEAN_DATATYPE: "http://www.w3.org/2001/XMLSchema#boolean",
		STRING_DATATYPE: "http://www.w3.org/2001/XMLSchema#string",
		INTEGER_DATATYPE: "http://www.w3.org/2001/XMLSchema#int",
		DATE_DATATYPE: "http://www.w3.org/2001/XMLSchema#dateTime",
		DURATION_DATATYPE: "http://www.w3.org/2001/XMLSchema#duration",
		ENUM_DATATYPE: "http://www.w3.org/2001/XMLSchema#enumeration",
		USER_DATATYPE: "http://purl.org/dc/terms/Agent",
		
		JSON_DATATYPE_FIELD: "__datatype",
		JSON_VALUE_FIELD: "__value",
		
		BOOLEAN_DATATYPES: ["http://www.w3.org/2001/XMLSchema#boolean"],
		STRING_DATATYPES: ["http://www.w3.org/2001/XMLSchema#string"],
		INTEGER_DATATYPES: ["http://www.w3.org/2001/XMLSchema#int",
		                    "http://www.w3.org/2001/XMLSchema#integer"],
							
		SORTING_SORTING_PROPERTY: "sortingProperty",
		SORTING_SORTING_ORDER: "sortingOrder",
		
		SORTING_ORDER_ASCENDING: "ascending",
		SORTING_ORDER_DESCENDING: "descending",
		
		QUERY_GROUPING_PROPERTY: "groupingProperty",
		QUERY_SORTING_PROPERTY: "sorting"
		
};
	
}());