/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.SortingPropertiesWidget");

dojo.require("dojo.i18n");
dojo.require("rmps.ui.queryeditor.QueryConstants");
dojo.require("rmps.ui.queryeditor.OntologyPropertiesWidget");

dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;
var ASCENDING_ID = "ascending";
var DESCENDING_ID = "descending";


dojo.declare("rmps.ui.queryeditor.SortingPropertiesWidget", rmps.ui.queryeditor.OntologyPropertiesWidget, {
	
	_queryConditionListProperty: QueryConstants.SORTING_SORTING_PROPERTY,
	_sortingOrder: QueryConstants.SORTING_ORDER_ASCENDING,
	
	_menuItems: [{
		id: ASCENDING_ID,
		label: messages.labelAscending
	}, {
		id: DESCENDING_ID,
		label: messages.labelDescending 
	}],
	
	initializeFromConditionData: function() {
		var conditionData = this.getConditionData();
		if (conditionData && conditionData[QueryConstants.SORTING_SORTING_ORDER]) {
			this._sortingOrder = conditionData[QueryConstants.SORTING_SORTING_ORDER];
		}
	},
	
	getTitle: function() {
		return messages.labelSorting;			
	},
	
	serialize: function() {
		var obj = {};
		obj[QueryConstants.SORTING_SORTING_PROPERTY] = dojo.map(this.getSelectedValues(), function(item) {
			return item.id;
		});
		obj[QueryConstants.SORTING_SORTING_ORDER] = this._sortingOrder;
		return obj;
	},

	getMenuSelection: function() {
		if (this._sortingOrder === QueryConstants.SORTING_ORDER_ASCENDING) {
			return this._menuItems[0];
		} else {
			return this._menuItems[1];
		}		
	},

	
	onMenuAction: function(item) {
		var id = item.id;
		if (id === ASCENDING_ID) {
			this._sortingOrder = QueryConstants.SORTING_ORDER_ASCENDING;
		} else {
			this._sortingOrder = QueryConstants.SORTING_ORDER_DESCENDING;
		}		
	}
	
});
}());