/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.WidgetDataStore");

dojo.require("rmps.core.querymodel.QueryModelClient");

(function(){
	
var QueryModelClient = rmps.core.querymodel.QueryModelClient;

// Associative array
var _index = {};

dojo.declare("rmps.ui.queryeditor.WidgetDataStore", null, {
	
	// mix-in
	inputData: {},
		
	constructor: function(args) {
		dojo.safeMixin(this, args);
	},
	
	getWidgetData: function(widgetId, options) {
		var inputData = dojo.clone(this.inputData);
		if (options) {
			dojo.mixin(inputData, options);
		}
		var jsonData = dojo.toJson(inputData);
		var id = jsonData + widgetId;
		if (options) {
			id += dojo.toJson(options);
		}
		var data = _index[id], def;
		if (data) {
			if (data instanceof dojo.Deferred) {
				return data;
			}
			
			def = new dojo.Deferred();
			def.callback(data);
			return def;
		}
		
		def = QueryModelClient.getWidgetData(widgetId, inputData);
		// Set the def as cache until data is retrieved
		// That way multiple calls use the same Deferred
		_index[id] = def;
		var self = this;
		def.addCallback(function(data) {
			_index[id] = data;
		});
		return def;
	}
});
})();