/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.filters.BooleanFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.FilteringSelect");
dojo.require("dojo.i18n");
dojo.require("rmps.ui.queryeditor.filters.IValueFilter");

dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){


var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.filters.BooleanFilterWidget", [dijit._Widget, dijit._Templated, rmps.ui.queryeditor.filters.IValueFilter], {

	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/filters/templates/BooleanFilterWidget.html"),

	_inputName: messages.labelBooleanFilter,
	_label: messages.labelBooleanFilter,
	_labelFalse: messages.labelFalse,
	_labelTrue: messages.labelTrue,
	_init: false,
	
	getValue: function() {
		return this._comboBox.getValue() === messages.labelTrue;
	},
	
	getDataType: function() {
		return QueryConstants.BOOLEAN_DATATYPE;
	},
	
	getSign: function() {
		return QueryConstants.PREDICATE_VALUE_CONDITION_SIGN_EQUAL;	
	},
	
	setValue: function(value) {
		this._comboBox.set('value', value === 'true' ? messages.labelTrue : messages.labelFalse); 
	},
	
	setSign: function(sign) {
	},
	
	validate: function(valResult) {
		var value = this._comboBox.get('value');
		if (value !== messages.labelTrue && value !== messages.labelFalse) {
			valResult.errors.push(messages.valWrongBooleanValue);
			if (this.parentWidget && this.parentWidget._showWarning) {
				this.parentWidget._showWarning(messages.valWrongBooleanValue);
			}
		}
	},
	
	_onValueChange: function(e) {
		if (this.parentWidget) {
			this.parentWidget._hideWarning();
		}
		if (!this._init) {
			this._init = true;
			return;
		}
		if (this.changeCallback) {
			this.changeCallback();
		}
	}
});

})();