/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.filters.EnumerationFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("rmps.ui.queryeditor.filters.IValueFilter");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.filters.EnumerationFilterWidget", [dijit._Widget, dijit._Templated, rmps.ui.queryeditor.filters.IValueFilter], {
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/filters/templates/EnumerationFilterWidget.html"),

	_label: messages.labelEnumerationFilter,
	targetType: null,
	nameValuePairs: null,
	
	postCreate: function() {
		this.inherited(arguments);
		if (this.targetType) {
			var i = this.targetType.indexOf("?");
			var nameValueParam;
			if (i != -1) {
				var params = this.targetType.substring(i+1).split("&");
				for (i = 0; i < params.length; i++) {
					var param = params[i];
					var index = param.indexOf("=");
					if (index != -1) {
						var name = param.substring(0, index);
						if (name === "nameValuePairs") {
							nameValueParam = unescape(param.substring(index+1));
						}
					}
				}
			}
			if (nameValueParam) {
				this.nameValuePairs = nameValueParam.split(",");
				if (this.nameValuePairs && this.nameValuePairs.length > 0) {
					for (var i = 0; i < this.nameValuePairs.length; i += 2) {
						var enumName = this.nameValuePairs[i];
						var enumValue = this.nameValuePairs[i+1];
						var option = dojo.create("option", {
							value: enumValue,
							selected: (i === 0)
						});
						option.appendChild(dojo.doc.createTextNode(enumName));
						this._inputNode.appendChild(option);
					}
				}
			}
		}
	},
	
	getResources: function() {
		var resources = [];
		resources.push(this._inputNode.value);
		return resources;
	},

	setResources: function(resources) {
		if (resources && resources.length == 1) {
			this._inputNode.value = resources[0];
		}
	},
	
	validate: function(valResult) {
		if (this._inputNode.value.length == 0) {
			valResult.errors.push(messages.valEmptyStringValue);
		}
	},
	
	_onValueChange: function(e) {
		if (this.changeCallback) {
			this.changeCallback();
		}
	}
});

})();
