/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.filters.IntegerFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("rmps.ui.queryeditor.filters.IValueFilter");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.filters.IntegerFilterWidget", [dijit._Widget, dijit._Templated, rmps.ui.queryeditor.filters.IValueFilter], {
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/filters/templates/IntegerFilterWidget.html"),

	_inputValue: "",
	_inputName: messages.labelIntegerFilter,
	_label: messages.labelIntegerFilter,
	
	getValue: function() {
		return parseInt(this._inputNode.value, 10);
	},
	
	getDataType: function() {
		return QueryConstants.INTEGER_DATATYPE;
	},
	
	setValue: function(value) {
		this._inputNode.value = value; 
	},
	validate: function(valResult) {
		if (isNaN(parseInt(this._inputNode.value, 10))) {
			valResult.errors.push(messages.valNotAnInteger);
		}
	},
	
	_onValueChange: function(e) {
		if (this.changeCallback) {
			this.changeCallback();
		}
	}
});

}());