/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.ui.queryeditor.filters.StringFilterWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("rmps.ui.queryeditor.filters.IValueFilter");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");

(function(){

var messages = dojo.i18n.getLocalization("rmps.ui.queryeditor", "QueryWidgetMessages");
var QueryConstants = rmps.ui.queryeditor.QueryConstants;

dojo.declare("rmps.ui.queryeditor.filters.StringFilterWidget", [dijit._Widget, dijit._Templated, rmps.ui.queryeditor.filters.IValueFilter], {
	templatePath: dojo.moduleUrl("rmps.ui", "queryeditor/filters/templates/StringFilterWidget.html"),

	_inputValue: "",
	_inputName: messages.labelStringFilter,
	_label: messages.labelStringFilter,
	
	getValue: function() {
		return this._inputNode.value;
	},

	getSign: function() {
		return QueryConstants.PREDICATE_VALUE_CONDITION_SIGN_EQUAL;
	},
	
	getDataType: function() {
		return QueryConstants.STRING_DATATYPE;
	},

	setValue: function(value) {
		this._inputNode.value = value; 
	},
	
	setSign: function(sign) {
		// ignored
	},
	
	validate: function(valResult) {
		if (this._inputNode.value.length == 0) {
			valResult.errors.push(messages.valEmptyStringValue);
			if (this.parentWidget && this.parentWidget._showWarning) {
				this.parentWidget._showWarning(messages.valEmptyStringValue);
			}
		}
	},
	
	_onValueChange: function(e) {
		if (this.parentWidget) {
			this.parentWidget._hideWarning();
		}
		if (this.changeCallback) {
			this.changeCallback();
		}
	}
});

})();