/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2009, 2010. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.editor.owl.rdf.Json2Rdf");
dojo.declare("rmpw.dsv.editor.owl.rdf.Json2Rdf", null, {
		parse : function(content) {
			var json = dojo.fromJson(content);
			var xml = "";
			var result = {};
			json = this.createType(json);
			for(p in json)
				result['rdf_type']=p;
			for( var m in json)
				xml += this.toXml(json[m], m, "");
			result['xml']=xml;
			return result;
		},
		toXml : function(v, name, ind) {
			v = this.createType(v);
			name = this.replace(name);
			var xml = "";
			if (v instanceof Array) {
				for ( var i = 0, n = v.length; i < n; i++)
					xml += ind + this.toXml(v[i], name, ind + "\t") + "\n";
			} else if (typeof (v) == "object") {
				var hasChild = false;
				xml += ind + "<" + name;
				for ( var m in v) {
					if (m.charAt(0) == "@")
						xml += " " + m.substr(1) + "=\"" + v[m].toString()
								+ "\"";
					else
						hasChild = true;
				}
				xml += hasChild ? ">\r\n" : "/>\r\n";
				if (hasChild) {
					for ( var m in v) {
						if (m == "#text")
							xml += v[m];
						else if (m == "#cdata")
							xml += "<![CDATA[" + v[m] + "]]>";
						else if (m.charAt(0) != "@")
							xml += this.toXml(v[m], m, ind + "\t");
					}
					xml += (xml.charAt(xml.length - 1) == "\n" ? ind : "")
							+ "</" + name + ">\r\n";
				}
			} else {
				xml += ind + "<" + this.getStartTag(name) + ">" + v.toString() + "</" + name
						+ ">\r\n";
			}
			return xml;
		},
		replace : function(name) {
			name = name.replace("_",":");
			if(name=="$ref")
				name="rdf:about"
			else if(name=="kdm:restrictionsSubclassOf")
				name = "rdfs:subClassOf";
			return name;
		},
		createType: function(json){
			if(typeof (json) == "object" && json['rdf_type']){
				var newObj={};
				var className =  json['rdf_type']
				newObj[className]=json;
				delete json['rdf_type'];
				return newObj;
			}
			return json;
		},
		replaceType : function(json) {
			var hasType = false;
			var className;
			if(typeof (json) == "object" && json['rdf_type']){
				hasType = true;
				className =  json['rdf_type'].replace("_",":");
				if(json['rdf_about']){
					var about =json['rdf_about']; 
					xml += "<" +className+' rdf:about="=\"'+about+"\">\r\n";
					delete json['rdf_about'];
				}else
					xml += "<" +className+">";
				delete json['rdf_type'];
			}
			
		},
		getStartTag: function(name, v) {
			//var val = v.toString();
			if("owl:cardinality"==name ||
					"owl:maxCardinality"==name ||
					"owl:minCardinality"==name)
					name += " rdf:datatype=\"&xsd;integer\"";
			return name;
		}
//		,
//		function isNumeric(str) {
//			return /^\d+$/.match(str);
//		}		
		
	});

})();
