/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.domain.render.DMCoreClassDiagram');

rmpw.dsv.editor.domain.render.DMCoreClassDiagram.ExtractShortURI = function(obj) {
	var resource = obj.rdf_about;
	var hashIndex = resource.indexOf("#");
	var namespace = resource.substring(0, hashIndex + 1);
	var localName = resource.substring(hashIndex + 1); 
	
	var namespaces = this.root.commandPackage.namespaces;
	var shortNamespace = null;
	for(var key in namespaces) {
		if(namespaces[key] == namespace) {
			shortNamespace = key;
		}
	}
	if(!shortNamespace) {
		console.error("Short name not found for ", namespace);
	}
	return shortNamespace + "_" + localName;
};

rmpw.dsv.editor.domain.render.DMCoreClassDiagram.BuildMultiplicityLabel = function(minCardinality, maxCardinality, cardinality) {
	var label = '';
	if(cardinality) {
		label = cardinality;
	} else if (minCardinality && (minCardinality == maxCardinality)) {
		label = minCardinality;
	} else {
		label = (minCardinality ? minCardinality : '0') + '..' + (maxCardinality ? maxCardinality : '*');
	}	
	return label;
};

rmpw.dsv.editor.domain.render.DMCoreClassDiagram.ParseDatatypeRange = function(clazz) {
	return clazz ? clazz.rdfs_label : "undefined";
};