/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.domain.render.EcoreComplete');

rmpw.dsv.editor.domain.render.EcoreComplete.IsReferenceInternalToPackage = function(eReference) {
	var isInternal = true;
	if(eReference.eContainingClass && eReference.eReferenceType) {
		isInternal = eReference.eContainingClass.ePackage == eReference.eReferenceType.ePackage;
	}
	return isInternal;
};

rmpw.dsv.editor.domain.render.EcoreComplete.EAnnotationHasKey = function(annotation, key) {
	var details = annotation.details;
	for(var i = 0, entry; entry = details[i]; i++) {
		if(entry.key == key) {
			return true;
		}
	}
	return false;
};

rmpw.dsv.editor.domain.render.EcoreComplete.GetEAnnotationValue = function(annotation, key) {
	var details = annotation.details;
	for(var i = 0, entry; entry = details[i]; i++) {
		if(entry.key == key) {
			return entry.value
		}
	}
	return "";
};

rmpw.dsv.editor.domain.render.EcoreComplete.BuildMultiplicityLabel = function(minCardinality, maxCardinality) {
	var label = '';
	if (minCardinality == maxCardinality) {
		label += minCardinality;
	} else {
		label += minCardinality + '..' + ((maxCardinality == -1) ? "*" : maxCardinality);
	}	
	return label;
};