/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmps.graphics.render.LineHotspotMapping");

dojo.require("rmpw.common.transform.Mapping");

dojo.require("rmps.graphics.render.StackLayout");
dojo.require("rmpw.diagrams.render.decorations.RectangleShadow");
dojo.require("rmpw.diagrams.render.policies.GraphNode");

/**
 * A node figure that represents an entity
 * 
 * @author Anton McConville
 */
dojo.declare("rmps.graphics.render.LineHotspotMapping", rmpw.common.transform.Mapping, {
	layout: null,
	
	// TODO: remove, rely on layout to generate width
	w: 100,
	
	// TODO: remove, should be defined by the view's style
	border: {color: "#FAD163", width: 2},
	
	setModel: function(model) {
		this.sources.model = model;
	},
	
	createTraces: function() {
		this.inherited(arguments);
		
		this.createTrace("relationships", "model.relationships", true);
	},
	
	attachListeners: function() {
		this.inherited(arguments);
		this.connectTraces(this.sources.model, ["relationships"]);
	},
	
	applyModelChanges: function() {
		this.inherited(arguments);
	},
	
	getFrontFeedbackLayer: function(){
		return this.fbLayer;
	},
	
	setParentFigure: function(parentFigure) {
		
		// Create figure template
		var figure = parentFigure.createGroup();
		this.layout = new rmps.graphics.render.StackLayout({x: 1, y: 1});
		this.layout.clear();

		// run layout
		this.layout.layout();
		
		// create outer rect
		var padding = 1;
		
		var shape = figure.createPolyline( this.sources.model.points );
		
		var color = new dojo.Color("white");
		color.a = 0.0001;
		
		shape.setFill( color );
		
		this.fbLayer = parentFigure.createGroup();

		// Save attach points
		var template = this.template;
		template.figure = figure;
		template.anchorFigure = shape;
	},
	
	createPolicies: function() {
		var policy;
		
		policy = this.createPolicy(rmpw.diagrams.render.policies.GraphNode);
		policy.updateOutlineShape = dojo.hitch(this, function() { /* do nothing */ });
		policy.useDojoPosition(true);
		policy.setFigure(this.template.figure);
		policy.setAnchorFigure(this.template.anchorFigure);
	}
});