/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide('rmpw.dsv.editor.sketcher.rendering.FreeformSketcherRenderingExtensions');

if (!dojo.isOffscreen) {
	dojo.require("rmps.core.util.ContextUtils");
}

/////////////////////////////////////// HELPER ///////////////////////////////////////////////////////////////

/*
 * Need to stub off dependencies into the edit / jazz infrastructure otherwise, server side render will fail.
 * In general - the render layer should respect this.  By design it should be able to exist without any of the
 * edit plug-ins being deployed.
 */
rmpw.dsv.editor.sketcher.rendering.FreeformSketcherRenderingExtensions.getFileUri = function(uri) {
	if (dojo.isOffscreen) {
		return uri += "?" + _JAZZ_APP_CONTEXT_BASELINE_PARAM;
	}
	else {
		return uri + "?" + rmps.core.util.ContextUtils.computeContextParams();
	}
};

rmpw.dsv.editor.sketcher.rendering.FreeformSketcherRenderingExtensions.getCustomImageSrc = function(image) {
	if (image && (image.rdf_about || image.$ref)) {
		var imageUrl = rmpw.dsv.editor.sketcher.rendering.FreeformSketcherRenderingExtensions.getFileUri(image.rdf_about || image.$ref);
		var dm = net.jazz.ajax._contextRoot;
		return '[{src:"' + imageUrl + '", proportionalShapeMinSize:120, customImage:true },' +
		//container shape
        '{container:true, src:['+
           '{h:3,tb:"'+dm+'/web/rmpw.dsv.editor.sketcher/icons/dgm/layhoutline.gif"},'+ //top/bottom
           '{w:3,lr:"'+dm+'/web/rmpw.dsv.editor.sketcher/icons/dgm/layvoutline.gif"},'+  //left/right
           '{icon:"'+ imageUrl +'"}]}]';     //icon
	}
	return null;
};
