/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.core.resource.ResourceInfo");

dojo.require("dojo.date.stamp");

dojo.declare("rmps.core.resource.ResourceInfo", null, {
	
	// properties
	uri: null,
	
	parseDescription: function(description) {
		this.uri = description["rdf:about"];
		
		for (var key in description) {
			var child = description[key];
			
			if (!dojo.isArray(child)) {
				continue;
			}
			
			var splitName = key.split(":");
			if (splitName.length == 2 && splitName[0] == "xmlns") {
				continue;
			}
			var name = splitName[splitName.length - 1];
			
			var value = child[0]["rdf:resource"];
			if (!value) {
				value = child[0].value;
				
				var dataType = child[0]["rdf:datatype"];
				if (dataType && dataType == "http://www.w3.org/2001/XMLSchema#dateTime") {
					value = dojo.date.stamp.fromISOString(value);
				}
			}
			this[name] = value;
		}
	}
});