/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.review.AbstractReviewControllerDescriptor");

dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("rmps.core.util.xhrUtil");

dojo.declare("rmps.core.review.AbstractReviewControllerDescriptor", null, {
	
	reviewController: null,
	
	projectName: null,
	
 	/*
	 * Get the current context that a review belong to. 
	 */
	getOwingContext: function(){
		var projectName= this.getProjectName();
		if(projectName){
			var currentContext= rmps.core.util.xhrUtil.getContexts(projectName);
			if(currentContext){
				return currentContext;
			}
			/*If specified project name in the url is invalid, then just log a console error and try to get the default context instead */
	 		console.error("Specified project name does not exist");
		}
		/*
		 * If context is defined, then we are using the main application
		 * As if someone decided not to pass in the context, then we assume
		 * the default context. However, it won't work for iFrame and non-repositroy applications
		 */
		return jazz.app.context.get();
	},
	
	getProjectName: function(){
		var hash = window.location.hash;
		hash= hash.replace("#action=", "");
		return dojo.queryToObject(hash)[rmps.core.util.IRmpsConstants.PROJECT_NAME];
	},
	
	getBaseline: function(reviewController){
		/*No need to check for null, as the review controller will be defined when making the first call for getBaseline*/
		return this.reviewController.review.getReviewAttribute("reviewBaseline");
	},
	
	/*
	 * If we need to proivde an id instead of the review resource uri. Required for cases when no resource uri
	 * eists still (when creating new reviews for instance) 
	 */
	getDescriptorId: function(){
		return null;
	},
	
	/* 
	 * When extended, make sure to make a call for the parent 
	 */
	onReviewControllerLoad: function(reviewController){
		this.reviewController= reviewController;
	},
	
	onError: function(errors){}
	
});

})();