/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.BendpointConnectionRouter");

dojo.require("rmpw.diagrams.layout.client.routers.AbstractRouter");
dojo.require("rmpw.diagrams.render.util.Point");

dojo.declare("rmpw.diagrams.layout.client.routers.BendpointConnectionRouter", rmpw.diagrams.layout.client.routers.AbstractRouter, {
	construction: function() {
		this.A_POINT = new rmpw.diagrams.render.util.Point();
	},

	route: function (conn){
		var bendpoints, bp, i, points, ref1, ref2;
		points = conn.getPointList();
		points.removeAllPoints();
		bendpoints = this.getConstraint(conn);
		if (!bendpoints) {
			bendpoints = [];
		}
			
		if (bendpoints.length == 0) {
			ref1 = conn.endAnchor.getReferencePoint();
			ref2 = conn.startAnchor.getReferencePoint();
		}
		else {
			ref1 = bendpoints[0].getCopy();
			conn.translateToAbsolute(ref1);
			ref2 = bendpoints[bendpoints.length - 1].getCopy();
			conn.translateToAbsolute(ref2);
		}
		this.A_POINT.setLocation(conn.startAnchor.getLocation(ref1));
		conn.translateToRelative(this.A_POINT);
		points.addPoint_1(this.A_POINT);
		for (i = 0, bp; bp = bendpoints[i]; i++) {
			points.addPoint_0(bp.x, bp.y);
		}
		this.A_POINT.setLocation(conn.endAnchor.getLocation(ref2));
		conn.translateToRelative(this.A_POINT);
		points.addPoint_1(this.A_POINT);
		conn.setPointList(points);
	}
});