/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.ConstraintBendpoint");

/**
 * Handles Relative Bendpoints
 *  
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.layout.client.routers.ConstraintBendpoint", null, {
	
	constructor: function(connection, srcX, srcY, trgX, trgY, weight) {
		this.connection = connection;
		this.sourceX = srcX;
		this.sourceY = srcY;
		this.targetX = trgX;
		this.targetY = trgY;
		this.weight = weight;
	},
	
	/**
 	* Calculates the absolute location of a bendpoint
 	*/
	getLocation: function() {
		var a1 = this.connection.startAnchor.getReferencePoint();
		var a2 = this.connection.endAnchor.getReferencePoint();
			
		this.connection.translateToRelative(a1);
		this.connection.translateToRelative(a2);
		
		var src = {x: this.sourceX, y: this.sourceY};
		var trg = {x: this.targetX, y: this.targetY};
		return {x: (a1.x + src.x) * (1.0 - this.weight) + this.weight * (a2.x + trg.x), 
				y: (a1.y + src.y) * (1.0 - this.weight) + this.weight * (a2.y + trg.y)};
	}
	
});
