/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.FanRouter");

dojo.require("rmpw.diagrams.layout.client.routers.AutomaticRouter");
dojo.require("rmpw.diagrams.render.util.Dimension");
dojo.require("rmpw.diagrams.render.util.Ray");
dojo.require("rmpw.diagrams.render.util.Point");

dojo.declare("rmpw.diagrams.layout.client.routers.FanRouter", rmpw.diagrams.layout.client.routers.AutomaticRouter, {
	constructor: function (nextRouter){
		this.separation = 30;
	},
	
	handleCollision: function (points, index){
		var bendPoint, end, length_0, midPoint, position, ray, start, xSeparation, ySeparation;
		if (points.size == 2 && points.getPoint( 0).equals$(points.getPoint( points.size - 1))) {
			return;
		}
		start = points.getPoint( 0);
		end = points.getPoint( points.size - 1);
		if (start.equals$(end))
			return;
		midPoint = new rmpw.diagrams.render.util.Point(~~((end.x + start.x) / 2), ~~((end.y + start.y) / 2));
		position = end.getPosition(start);
		if (position == 4 || position == 16)
			ray = new rmpw.diagrams.render.util.Ray(start, end);
		else 
			ray = new rmpw.diagrams.render.util.Ray(end, start);
		length_0 = Math.sqrt(ray.x * ray.x + ray.y * ray.y);
		xSeparation = this.separation * ray.x / length_0;
		ySeparation = this.separation * ray.y / length_0;
		if (index % 2 == 0) {
			bendPoint = new rmpw.diagrams.render.util.Point(midPoint.x + ((index / 2.0) * -ySeparation), midPoint.y + ((index / 2.0) * xSeparation));
		}
		else {
			bendPoint = new rmpw.diagrams.render.util.Point(midPoint.x + ((index / 2.0) * ySeparation), midPoint.y + ((index / 2.0) * -xSeparation));
		}
		if (!bendPoint.equals$(midPoint))
			points.insertPoint(bendPoint, 1);
	}
});