/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.ObliqueRouter");

dojo.require("rmpw.diagrams.layout.client.routers.FanRouter");
dojo.require("rmpw.diagrams.layout.client.routers.BendpointConnectionRouter");
dojo.require("rmpw.diagrams.render.util.Rectangle");
dojo.require("rmpw.diagrams.render.util.LineSeg");
dojo.require("rmpw.diagrams.render.graph.BaseGraphConfigurator");
dojo.require("rmpw.diagrams.layout.client.util.ArrayList");

dojo.declare("rmpw.diagrams.layout.client.routers.ObliqueRouter$ArrayListKey", null, {

	constructor: function(conn) {
		dojo.mixin(this, new Object_0());
		this.connectAnchor1 = conn.getSourceAnchor();
		this.connectAnchor2 = conn.getTargetAnchor();
		this.typeId$ = 105;
		this.equals$ = this.equals_obliqueRouterKey;
		this.hashCode$ = this.hashCode_obliqueRouterKey;
	},
	
	equals_obliqueRouterKey: function (object){
		var isEqual, listKey, lk1, lk2;
		isEqual = false;
		if (object != null && canCast(object.typeId$, 61)) {
			listKey = dynamicCast(object, 61);
			lk1 = listKey.connectAnchor1;
			lk2 = listKey.connectAnchor2;
			isEqual = lk1.equals$(this.connectAnchor1) && lk2.equals$(this.connectAnchor2) || lk1.equals$(this.connectAnchor2) && lk2.equals$(this.connectAnchor1);
		}
		return isEqual;
	},

	hashCode_obliqueRouterKey: function (){
		return this.connectAnchor1.hashCode$() ^ this.connectAnchor2.hashCode$();
	}
});

dojo.declare("rmpw.diagrams.layout.client.routers.ObliqueRouter$ArrayListMap", null, {

	constructor: function() {
		this.map = $HashMap(new HashMap());
		this.typeId$ = 0;
	},
	
	get: function (key){
		var v, value;
		value = $get(this.map, key);
		if (value == null)
			return null;
		if (value != null && canCast(value.typeId$, 12))
			return dynamicCast(value, 12);
		v = $ArrayList_0(new ArrayList(), 1);
		setCheck(v.array, v.size++, value);
		return v;
	},

	put: function (key, value){
		var arrayList, arrayListObject;
		arrayListObject = $get(this.map, key);
		if (arrayListObject == null) {
			$put(this.map, key, value);
			return;
		}
		if (arrayListObject != null && canCast(arrayListObject.typeId$, 12)) {
			arrayList = dynamicCast(arrayListObject, 12);
			if ($indexOf(arrayList, value, 0) == -1)
				setCheck(arrayList.array, arrayList.size++, value);
			return;
		}
		if ((arrayListObject == null?null:arrayListObject) !== (value == null?null:value)) {
			arrayList = $ArrayList_0(new ArrayList(), 2);
			setCheck(arrayList.array, arrayList.size++, arrayListObject);
			setCheck(arrayList.array, arrayList.size++, value);
			$put(this.map, key, arrayList);
		}
	},

	remove: function (key, value){
		var arrayList, arrayListObject;
		arrayListObject = $get(this.map, key);
		if (arrayListObject != null) {
			if (arrayListObject != null && canCast(arrayListObject.typeId$, 12)) {
				arrayList = dynamicCast(arrayListObject, 12);
				$remove_3(arrayList, value);
				if (arrayList.size == 0)
					$remove_0(this.map, key);
				return;
			}
			$remove_0(this.map, key);
		}
	}
});

dojo.declare("rmpw.diagrams.layout.client.routers.ObliqueRouter", rmpw.diagrams.layout.client.routers.BendpointConnectionRouter, {

	constructor: function() {
		this.constraints = {};
		this.selfRelConnections = new rmpw.diagrams.layout.client.routers.ObliqueRouter$ArrayListMap();
		this.intersectingShapesConnections = [];
	},
	
	getType: function() {
		return rmpw.diagrams.render.graph.BaseGraphConfigurator.prototype.OBLIQUE_ROUTING;
	},
	
	calculateBendPoints: function (conn){
		var pts = new rmpw.diagrams.render.util.PointList();
		if (!conn.isFeedback() && conn.isAvoidingObstructions()) {
			try {
				pts = this.getContainer().getAvoidObstructionsRouter().calculateBendPoints(conn);
			}
			catch (e) {
				console.debug("Avoid obstructions failed: ", e);
			}
		}
		else {
			pts = this.getPointsFromConstraint(conn);
			this.getContainer().getAvoidObstructionsRouter().remove(conn);
		}
		
		return pts;
	},
	
	checkSelfRelConnection: function (conn, newLine){
		if (conn.getSourceAnchor().getOwner() == conn.getTargetAnchor().getOwner() && newLine.size < 4) {
			this.getSelfRelVertices(conn, newLine);
			return true;
		}
		else {
			this.removeSelfRelConnection(conn);
			return false;
		}
	},
	
	checkShapesIntersect: function (conn, newLine){
		var sourceBounds, targetBounds;
		if (!conn.getSourceAnchor().getOwner() || instanceOf(conn.getSourceAnchor().getOwner(), 30) || !conn.getTargetAnchor().getOwner() || instanceOf(conn.getTargetAnchor().getOwner(), 30))
			return false;
		if (newLine.size < 3) {
			sourceBounds = conn.getSourceAnchor().getOwner().getBounds();
			targetBounds = conn.getTargetAnchor().getOwner().getBounds();
			conn.getSourceAnchor().getOwner().translateToAbsolute(sourceBounds);
			conn.getTargetAnchor().getOwner().translateToAbsolute(targetBounds);
			if (targetBounds.x < sourceBounds.x + sourceBounds.width && targetBounds.y < sourceBounds.y + sourceBounds.height && targetBounds.x + targetBounds.width > sourceBounds.x && targetBounds.y + targetBounds.height > sourceBounds.y && !(sourceBounds.x <= targetBounds.x && sourceBounds.y <= targetBounds.y && sourceBounds.x + sourceBounds.width >= targetBounds.x + targetBounds.width && sourceBounds.y + sourceBounds.height >= targetBounds.y + targetBounds.height) && !(targetBounds.x <= sourceBounds.x && targetBounds.y <= sourceBounds.y && targetBounds.x + targetBounds.width >= sourceBounds.x + sourceBounds.width && targetBounds.y + targetBounds.height >= sourceBounds.y + sourceBounds.height) || sourceBounds.equals$(targetBounds)) {
				this.getVerticesForIntersectingShapes(conn, newLine);
				return true;
			}
		}
		else {
			this.removeIntersectingShapesConnection(conn);
		}
		return false;
	},
	
	getConnectionPoints: function (connRect, position, sourcePosition, line){
		line.removeAllPoints();
		switch (position) {
		case 9:
			if (sourcePosition == 16) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
			}
			else {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
			}
	
			break;
		case 17:
			if (sourcePosition == 8) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
			}
			else {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
			}
	
			break;
		case 20:
			if (sourcePosition == 8) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
			}
			else {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
			}
	
			break;
		case 12:
			if (sourcePosition == 16) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
			}
			else {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y + connRect.height));
			}
	
			break;
		case 0:
			if (sourcePosition == 1) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
			}
			else if (sourcePosition == 4) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y + connRect.height));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
			}
			else if (sourcePosition == 8) {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
			}
			else {
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x + connRect.width, connRect.y));
				line.addPoint_1( new rmpw.diagrams.render.util.Point( connRect.x, connRect.y));
			}
	
		}
	},
	
	getCornerSelfRelVertices: function (conn, bBox, newLine, nOffset, nXDir, nYDir, ptOrient){
		var p1, p2, p3, p4, p5, selfrelsizeinit, x, xNew, y, yNew;
		x = ptOrient.x;
		y = bBox.getCenter().y + ~~(nYDir * bBox.height / 4);
		p1 = new rmpw.diagrams.render.util.Point( x, y);
		newLine.addPoint_0( p1.x, p1.y);
		selfrelsizeinit = new rmpw.diagrams.render.util.Dimension(62, 0);
		if (!this.isFeedback(conn)) {
			selfrelsizeinit.width = round_int(Math.floor(selfrelsizeinit.width));
			selfrelsizeinit.height = round_int(Math.floor(selfrelsizeinit.height));
		}
		xNew = x + nXDir * (selfrelsizeinit.width + nOffset);
		p2 = new rmpw.diagrams.render.util.Point( xNew, y);
		newLine.addPoint_0( p2.x, p2.y);
		yNew = ptOrient.y + nYDir * (selfrelsizeinit.width + nOffset);
		p3 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p3.x, p3.y);
		xNew = ptOrient.x - ~~(nXDir * bBox.width / 4);
		p4 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p4.x, p4.y);
		yNew = ptOrient.y;
		p5 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p5.x, p5.y);
	},
	
	getHorizontalSelfRelVertices: function (conn, bBox, newLine, nOffset, nDir, ptOrient){
		var nHeight, p1, p2, p3, p4, selfrelsizeinit, x, xNew, y, yNew;
		nHeight = ~~(bBox.height / 4);
		y = ptOrient.y - ~~(nHeight / 2);
		x = ptOrient.x;
		p1 = new rmpw.diagrams.render.util.Point( x, y);
		newLine.addPoint_0( p1.x, p1.y);
		selfrelsizeinit = new rmpw.diagrams.render.util.Dimension(62, 0);
		if (!this.isFeedback(conn))
		{
			selfrelsizeinit.width = round_int(Math.floor(selfrelsizeinit.width));
			selfrelsizeinit.height = round_int(Math.floor(selfrelsizeinit.height)); 
		}		
        xNew = x + nDir * (selfrelsizeinit.width + nOffset);
		p2 = new rmpw.diagrams.render.util.Point( xNew, y);
		newLine.addPoint_0( p2.x, p2.y);
		yNew = ptOrient.y + ~~(nHeight / 2);
		p3 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p3.x, p3.y);
		xNew = ptOrient.x;
		p4 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p4.x, p4.y);
	},
	
	getPrimaryPreciseConnectionArea: function (r, size, positionOfConnArea){
		r.shrink(-size, -size);
		if (r.width < r.height) {
			r.height -= size;
			if ((positionOfConnArea & 4) != 0) {
				r.y += size;
			}
		}
		else {
			r.width -= size;
			if ((positionOfConnArea & 16) != 0) {
				r.x += size;
			}
		}
	},
	
	getSelfRelVertices: function (conn, newLine){
		var bBox, connectionKey, connectionList, nIndex, nSelfIncr, owner, ptAbsE2, ptAbsS2, ptE1, ptE2, ptEdge, ptS1, ptS2, selfrelsizeincr;
		if (!conn.getSourceAnchor().getOwner())
			return;
		connectionKey = new rmpw.diagrams.layout.client.routers.ObliqueRouter$ArrayListKey(conn);
		nSelfIncr = 0;
		nIndex = 0;
		connectionList = this.selfRelConnections.get(connectionKey);
		if (connectionList) {
			if ($indexOf(connectionList, conn, 0) == -1) {
				this.selfRelConnections.put(connectionKey, conn);
				connectionList = this.selfRelConnections.get(connectionKey);
			}
			nIndex = $indexOf(connectionList, conn, 0);
		}
		else {
			this.selfRelConnections.put(connectionKey, conn);
		}
		selfrelsizeincr = new rmpw.diagrams.render.util.Dimension(10, 0);
		if (!this.isFeedback(conn))
		{
           selfrelsizeincr.width = round_int(Math.floor(selfrelsizeincr.width));
           selfrelsizeincr.height = round_int(Math.floor(selfrelsizeincr.height));
		}
		owner = conn.getSourceAnchor().getOwner();
		bBox = owner.getBounds();
		owner.translateToAbsolute(bBox);
		conn.translateToRelative(bBox);
		nSelfIncr = selfrelsizeincr.width * ~~(nIndex / 8);
		newLine.removeAllPoints();
		switch (nIndex % 8) {
		case 0:
			this.getCornerSelfRelVertices(conn, bBox, newLine, nSelfIncr, 1, 1, new rmpw.diagrams.render.util.Point( bBox.x + bBox.width, bBox.y + bBox.height));
			break;
		case 1:
			this.getVerticalSelfRelVertices(conn, bBox, newLine, nSelfIncr, 1, new rmpw.diagrams.render.util.Point( bBox.x + ~~(bBox.width / 2), bBox.y + bBox.height));
			break;
		case 2:
			this.getCornerSelfRelVertices(conn, bBox, newLine, nSelfIncr, -1, 1, new rmpw.diagrams.render.util.Point( bBox.x, bBox.y + bBox.height));
			break;
		case 3:
			this.getHorizontalSelfRelVertices(conn, bBox, newLine, nSelfIncr, -1, new rmpw.diagrams.render.util.Point( bBox.x, bBox.y + ~~(bBox.height / 2)));
			break;
		case 4:
			this.getCornerSelfRelVertices(conn, bBox, newLine, nSelfIncr, -1, -1, new rmpw.diagrams.render.util.Point( bBox.x, bBox.y));
			break;
		case 5:
			this.getVerticalSelfRelVertices(conn, bBox, newLine, nSelfIncr, -1, new rmpw.diagrams.render.util.Point( bBox.x + ~~(bBox.width / 2), bBox.y));
			break;
		case 6:
			this.getCornerSelfRelVertices(conn, bBox, newLine, nSelfIncr, 1, -1, new rmpw.diagrams.render.util.Point( bBox.x + bBox.width, bBox.y));
			break;
		case 7:
			this.getHorizontalSelfRelVertices(conn, bBox, newLine, nSelfIncr, 1, new rmpw.diagrams.render.util.Point( bBox.x + bBox.width, bBox.y + ~~(bBox.height / 2)));
		}
		ptS2 = newLine.getPoint( 0);
		ptS1 = conn.getSourceAnchor().getReferencePoint();
		conn.translateToRelative(ptS1);
		ptAbsS2 = ptS2.getCopy();
		conn.translateToAbsolute(ptAbsS2);
		ptEdge = conn.getSourceAnchor().getLocation(ptAbsS2);
		conn.translateToRelative(ptEdge);
		ptS1 = this.getStraightEdgePoint(ptEdge, ptS1, ptS2);
		ptE2 = newLine.getPoint( newLine.size - 1);
		ptE1 = conn.getTargetAnchor().getReferencePoint();
		conn.translateToRelative(ptE1);
		ptAbsE2 = ptE2.getCopy();
		conn.translateToAbsolute(ptAbsE2);
		ptEdge = conn.getTargetAnchor().getLocation(ptAbsE2);
		conn.translateToRelative(ptEdge);
		ptE1 = this.getStraightEdgePoint(ptEdge, ptE1, ptE2);
		newLine.setPoint(ptS1, 0);
		newLine.setPoint(ptE1, newLine.size - 1);
	},
	
	getSourcePositionFromConnectionRectangle: function (connRectangle, sourceRect, position){
		var initial = null, source = null, diff = null;
		switch (position) {
		case 9:
			initial = new rmpw.diagrams.render.util.Point(connRectangle.x + connRectangle.width, connRectangle.y + connRectangle.height);
			source = new rmpw.diagrams.render.util.Point(sourceRect.x, sourceRect.y);
			diff = initial.getDifference(source);
			if (diff.width == 0) {
				return 16;
			}
			else {
				return 4;
			}
	
		case 17:
			initial = new rmpw.diagrams.render.util.Point(connRectangle.x, connRectangle.y + connRectangle.height);
			source = new rmpw.diagrams.render.util.Point(sourceRect.x + sourceRect.width, sourceRect.y);
			diff = initial.getDifference(source);
			if (diff.width == 0) {
				return 8;
			}
			else {
				return 4;
			}
	
		case 20:
			initial = new rmpw.diagrams.render.util.Point(connRectangle.x, connRectangle.y);
			source = new rmpw.diagrams.render.util.Point(sourceRect.x + sourceRect.width, sourceRect.y + sourceRect.height);
			diff = initial.getDifference(source);
			if (diff.width == 0) {
				return 8;
			}
			else {
				return 1;
			}
	
		case 12:
			initial = new rmpw.diagrams.render.util.Point(connRectangle.x + connRectangle.width, connRectangle.y);
			source = new rmpw.diagrams.render.util.Point(sourceRect.x, sourceRect.y + sourceRect.height);
			diff = initial.getDifference(source);
			if (diff.width == 0) {
				return 16;
			}
			else {
				return 1;
			}
	
		case 0:
			initial = connRectangle.getCenter();
			source = new rmpw.diagrams.render.util.Point(sourceRect.x + sourceRect.width / 2, sourceRect.y + sourceRect.height / 2);
			diff = initial.getDifference(source);
			if (diff.width == 0) {
				return diff.height < 0?4:1;
			}
			else {
				return diff.width < 0?16:8;
			}
	
		}
		return 0;
	},
	
	getVerticalSelfRelVertices: function (conn, bBox, newLine, nOffset, nDir, ptOrient){
		var nWidth, p1, p2, p3, p4, selfrelsizeinit, x, xNew, y, yNew;
		nWidth = ~~(bBox.width / 4);
		x = ptOrient.x - ~~(nWidth / 2);
		y = ptOrient.y;
		p1 = new rmpw.diagrams.render.util.Point( x, y);
		newLine.addPoint_0( p1.x, p1.y);
		selfrelsizeinit = new rmpw.diagrams.render.util.Dimension(62, 0);
		if (!this.isFeedback(conn))
		{	
			selfrelsizeinit.width = round_int(Math.floor(selfrelsizeinit.width));
			selfrelsizeinit.height = round_int(Math.floor(selfrelsizeinit.height));
		}
		yNew = y + nDir * (selfrelsizeinit.width + nOffset);
		p2 = new rmpw.diagrams.render.util.Point( x, yNew);
		newLine.addPoint_0( p2.x, p2.y);
		xNew = ptOrient.x + ~~(nWidth / 2);
		p3 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p3.x, p3.y);
		yNew = ptOrient.y;
		p4 = new rmpw.diagrams.render.util.Point( xNew, yNew);
		newLine.addPoint_0( p4.x, p4.y);
	},
	
	getVerticesForIntersectingShapes: function (conn, newLine){
		var areaBottomLeft, areaBottomRight, areaTopLeft, areaTopRight, connArea, connectionList, diffVector, intersection, isFeedbackConn, key, minArea, nIndex, nSelfIncr, position, ptAbsE2, ptAbsS2, ptE1, ptE2, ptEdge, ptS1, ptS2, selfrelsizeincr, sourceFig, sourcePosition, sourceRect, targetFig, targetRect, translateExpansion, union, unionBottomLeft, unionBottomRight, unionTopLeft, unionTopRight;
		key = '' + getHashCode(conn.getSourceAnchor().getOwner()) ^ getHashCode(conn.getTargetAnchor().getOwner());
		nSelfIncr = 0;
		nIndex = 0;
		connectionList = this.intersectingShapesConnections[key];
		if (connectionList) {
			if ($indexOf(connectionList, conn, 0) == -1) {
				this.intersectingShapesConnections[key] = conn;
				connectionList = this.intersectingShapesConnections[key];
			}
			nIndex = $indexOf(connectionList, conn, 0);
		}
		else {
			this.intersectingShapesConnections[key] = conn;
		}
		selfrelsizeincr = new rmpw.diagrams.render.util.Point( 10, 0);
		isFeedbackConn = this.isFeedback(conn);
		if (!isFeedbackConn)
		{
			selfrelsizeincr.performScale(1);
			selfrelsizeincr = selfrelsizeincr;
		}
		sourceFig = conn.getSourceAnchor().getOwner();
		sourceRect = sourceFig.getBounds();
		sourceFig.translateToAbsolute(sourceRect);
		conn.translateToRelative(sourceRect);
		targetFig = conn.getTargetAnchor().getOwner();
		targetRect = targetFig.getBounds();
		targetFig.translateToAbsolute(targetRect);
		conn.translateToRelative(targetRect);
		union = sourceRect.getCopy().union_0(targetRect);
		nSelfIncr = selfrelsizeincr.x * nIndex;
		intersection = sourceRect.getCopy().intersect(targetRect);
		connArea = new rmpw.diagrams.render.util.Rectangle(0, 0, 0, 0);
		position = 0;
		minArea = 0;
		unionTopLeft = new rmpw.diagrams.render.util.Point( union.x, union.y);
		unionTopRight = new rmpw.diagrams.render.util.Point( union.x + union.width, union.y);
		unionBottomRight = new rmpw.diagrams.render.util.Point( union.x + union.width, union.y + union.height);
		unionBottomLeft = new rmpw.diagrams.render.util.Point( union.x, union.y + union.height);
		if (!unionTopLeft.equals$(new rmpw.diagrams.render.util.Point( sourceRect.x, sourceRect.y)) && !unionTopLeft.equals$(new rmpw.diagrams.render.util.Point( targetRect.x, targetRect.y))) {
			diffVector = unionTopLeft.getDifference(new rmpw.diagrams.render.util.Point( intersection.x, intersection.y));
			diffVector.width = Math.abs(diffVector.width);
			diffVector.height = Math.abs(diffVector.height);
			areaTopLeft = diffVector.width * diffVector.height;
			if (minArea == 0 || minArea > areaTopLeft) {
				position = 9;
				connArea.setSize(diffVector);
				connArea.setLocation_0(unionTopLeft.x, unionTopLeft.y);
				minArea = areaTopLeft;
			}
		}
		if (!unionTopRight.equals$(new rmpw.diagrams.render.util.Point( sourceRect.x + sourceRect.width, sourceRect.y)) && !unionTopRight.equals$(new rmpw.diagrams.render.util.Point( targetRect.x + targetRect.width, targetRect.y))) {
			diffVector = unionTopRight.getDifference(new rmpw.diagrams.render.util.Point( intersection.x + intersection.width, intersection.y));
			diffVector.width = Math.abs(diffVector.width);
			diffVector.height = Math.abs(diffVector.height);
			areaTopRight = diffVector.width * diffVector.height;
			if (minArea == 0 || minArea > areaTopRight) {
				position = 17;
				connArea.setSize(diffVector);
				connArea.setLocation_0(unionTopRight.x - connArea.width, unionTopRight.y);
				minArea = areaTopRight;
			}
		}
		if (!unionBottomRight.equals$(new rmpw.diagrams.render.util.Point( sourceRect.x + sourceRect.width, sourceRect.y + sourceRect.height)) && !unionBottomRight.equals$(new rmpw.diagrams.render.util.Point( targetRect.x + targetRect.width, targetRect.y + targetRect.height))) {
			diffVector = unionBottomRight.getDifference(new rmpw.diagrams.render.util.Point( intersection.x + intersection.width, intersection.y + intersection.height));
			diffVector.width = Math.abs(diffVector.width);
			diffVector.height = Math.abs(diffVector.height);
			areaBottomRight = diffVector.width * diffVector.height;
			if (minArea == 0 || minArea > areaBottomRight) {
				position = 20;
				connArea.setSize(diffVector);
				connArea.setLocation_0(unionBottomRight.x - connArea.width, unionBottomRight.y - connArea.height);
				minArea = areaBottomRight;
			}
		}
		if (!unionBottomLeft.equals$(new rmpw.diagrams.render.util.Point( sourceRect.x, sourceRect.y + sourceRect.height)) && !unionBottomLeft.equals$(new rmpw.diagrams.render.util.Point( targetRect.x, targetRect.y + targetRect.height))) {
			diffVector = unionBottomLeft.getDifference(new rmpw.diagrams.render.util.Point( intersection.x, intersection.y + intersection.height));
			diffVector.width = Math.abs(diffVector.width);
			diffVector.height = Math.abs(diffVector.height);
			areaBottomLeft = diffVector.width * diffVector.height;
			if (minArea == 0 || minArea > areaBottomLeft) {
				position = 12;
				connArea.setSize(diffVector);
				connArea.setLocation_0(unionBottomLeft.x, unionBottomLeft.y - connArea.height);
				minArea = areaBottomLeft;
			}
		}
		if (position == 0) {
			connArea = intersection;
		}
		sourcePosition = this.getSourcePositionFromConnectionRectangle(connArea, sourceRect, position);
		if (position != 0) {
			translateExpansion = new rmpw.diagrams.render.util.Point( Math.max(connArea.width, connArea.height), 0);
			if (isFeedbackConn) {
				translateExpansion.x = Math.pow(translateExpansion.x, 0.8);
			}
			else {
				translateExpansion.performScale(1);			
				translateExpansion.x = Math.pow(translateExpansion.x, 0.8);
				translateExpansion.performScale(1);
			}
			translateExpansion.x = round_int(Math.floor(translateExpansion.x + 1.0E-9));
			translateExpansion.y = round_int(Math.floor(translateExpansion.x + 1.0E-9));
			this.getPrimaryPreciseConnectionArea(connArea, translateExpansion.x, position);
		}
		else {
			connArea.shrink(-(selfrelsizeincr.x << 1), -(selfrelsizeincr.x << 1));
		}
		connArea.shrink(-nSelfIncr, -nSelfIncr);
		this.getConnectionPoints(connArea, position, sourcePosition, newLine);
		ptS2 = newLine.getPoint( 0).getCopy();
		ptS1 = conn.getSourceAnchor().getReferencePoint().getCopy();
		conn.translateToRelative(ptS1);
		ptAbsS2 = ptS2.getCopy();
		conn.translateToAbsolute(ptAbsS2);
		ptEdge = conn.getSourceAnchor().getLocation(ptAbsS2).getCopy();
		conn.translateToRelative(ptEdge);
		ptS1 = this.getStraightEdgePoint(ptEdge, ptS1, ptS2).getCopy();
		ptE2 = newLine.getPoint( newLine.size - 1).getCopy();
		ptE1 = conn.getTargetAnchor().getReferencePoint().getCopy();
		conn.translateToRelative(ptE1);
		ptAbsE2 = new rmpw.diagrams.render.util.Point(ptE2.x, ptE2.y);
		conn.translateToAbsolute(ptAbsE2);
		ptEdge = conn.getTargetAnchor().getLocation(ptAbsE2).getCopy();
		conn.translateToRelative(ptEdge);
		ptE1 = this.getStraightEdgePoint(ptEdge, ptE1, ptE2).getCopy();
		newLine.insertPoint(new rmpw.diagrams.render.util.Point(toDouble(fromDouble(Math.round(ptS1.x))), toDouble(fromDouble(Math.round(ptS1.y)))), 0);
		newLine.insertPoint(new rmpw.diagrams.render.util.Point(toDouble(fromDouble(Math.round(ptE1.x))), toDouble(fromDouble(Math.round(ptE1.y)))), newLine.size);
	},
	
	isClosestDistance: function (conn){
		if (conn != null && canCast(conn.typeId$, 58)) {
			return dynamicCast(conn, 58) , false;
		}
		return false;
	},
	
	remove: function (connection){
		this.inherited(arguments);
		this.removeSelfRelConnection(connection);
		this.removeIntersectingShapesConnection(connection);
		this.getContainer().getAvoidObstructionsRouter().remove(connection);
	},
	
	removeIntersectingShapesConnection: function (conn){
		var connectionList, index, key;
		if (!conn.getSourceAnchor() || !conn.getTargetAnchor() || !conn.getSourceAnchor().getOwner() || !conn.getTargetAnchor().getOwner())
			return;
		key = '' + getHashCode(conn.getSourceAnchor().getOwner()) ^ getHashCode(conn.getTargetAnchor().getOwner());
		connectionList = this.intersectingShapesConnections[key];
		if (connectionList) {
			index = $indexOf(connectionList, conn, 0);
			if (index == -1)
				return;
			delete this.intersectingShapesConnections[key];
		}
	},
	
	removePointsInViews: function (conn, newLine){
		var sourceOwner = conn.getSourceAnchor().getOwner();
		var targetOwner = conn.getTargetAnchor().getOwner();
		if (!sourceOwner)
			return false;
		if (!targetOwner)
			return false;
		
		var nodes = [];
		nodes.push(sourceOwner);
		nodes.push(targetOwner);
		
		return this.removePointsInNodes(nodes, newLine);
	},
	
	removeSelfRelConnection: function (conn){
		var connectionKey, connectionList, index;
		if (!conn.getSourceAnchor() || !conn.getTargetAnchor() || !conn.getSourceAnchor().getOwner() || !conn.getTargetAnchor().getOwner())
			return;
		connectionKey = new rmpw.diagrams.layout.client.routers.ObliqueRouter$ArrayListKey(conn);
		connectionList = this.selfRelConnections.get(connectionKey);
		if (connectionList) {
			index = $indexOf(connectionList, conn, 0);
			if (index == -1)
				return;
			this.selfRelConnections.remove(connectionKey, conn);
		}
	},
	
	route: function (conn){
		this.routeBendpoints_0(conn);
	},
	
	routeBendpoints_0: function (conn){
		var points;
		if (!conn.startAnchor || !conn.endAnchor)
			return;
		points = this.calculateBendPoints(conn);
		if (points) {
			this.routeLine(conn, 0, points);
			conn.setPointList(points);
		}
	},
	
	normalize: function(conn, newLine) {
		if (!this.checkSelfRelConnection(conn, newLine) && !this.checkShapesIntersect(conn, newLine)) {
			this.removePointsInViews(conn, newLine);
		}

		this.normalizePoints(newLine, this.getDefaultStraightlineTolerance());
	},
	
	routeLine: function (conn, nestedRoutingDepth, newLine){
		this.normalize(conn, newLine);
		this.resetEndPointsToEdge(conn, newLine);
	},
	
	getStraightEdgePoint: function (ptEdge, ptRef1, ptRef2){
		var lineSeg, ptProj;
		lineSeg = new rmpw.diagrams.render.util.LineSeg(ptRef1, ptRef2);
		ptProj = lineSeg.perpIntersect(ptEdge.x, ptEdge.y);
		if (Math.abs(ptProj.x - ptRef2.x) < Math.abs(ptProj.y - ptRef2.y))
			ptProj.x = ptRef2.x;
		else 
			ptProj.y = ptRef2.y;
		return ptProj;
	},
	
	invalidate: function (connection){
		this.inherited(arguments);
		this.getContainer().getAvoidObstructionsRouter().invalidate(connection);
	},
	
	setConstraint: function(conn, points) {
		this.inherited(arguments);
		this.getContainer().getAvoidObstructionsRouter().setConstraint(conn, points);
	},
	
	isReorienting: function (conn){
		if (!conn.getSourceAnchor().getOwner() || !conn.getTargetAnchor().getOwner()) {
		    return true;
		}
		
		return false;
	}
});