/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.Obstacle");

dojo.require("rmpw.diagrams.layout.client.routers.Vertex");
dojo.require("rmpw.diagrams.render.util.Rectangle");

dojo.declare("rmpw.diagrams.layout.client.routers.Obstacle", rmpw.diagrams.render.util.Rectangle, {
	constructor: function (x, y, width, height, router){
		this.exclude = false;
		this.topLeft = new rmpw.diagrams.layout.client.routers.Vertex(this.x, this.y, this);
		this.topLeft.positionOnObstacle = 9;
		this.topRight = new rmpw.diagrams.layout.client.routers.Vertex(this.x + this.width - 1, this.y, this);
		this.topRight.positionOnObstacle = 17;
		this.bottomLeft = new rmpw.diagrams.layout.client.routers.Vertex(this.x, this.y + this.height - 1, this);
		this.bottomLeft.positionOnObstacle = 12;
		this.bottomRight = new rmpw.diagrams.layout.client.routers.Vertex(this.x + this.width - 1, this.y + this.height - 1, this);
		this.bottomRight.positionOnObstacle = 20;
		var pt = new rmpw.diagrams.render.util.Point( this.x + ~~(this.width / 2), this.y + ~~(this.height / 2));
		this.center = new rmpw.diagrams.layout.client.routers.Vertex(pt.x, pt.y, this);
		this.router = router;
		this.typeId$ = 85;
	},
	
	containsProper: function (p){
		return p.x > this.x && p.x < this.x + this.width - 1 && p.y > this.y && p.y < this.y + this.height - 1;
	},
	
	growVertex: function (vertex){
		if (vertex.totalCount > 0)
			vertex.grow();
	},
	
	growVertices: function (){
		this.growVertex(this.topLeft);
		this.growVertex(this.topRight);
		this.growVertex(this.bottomLeft);
		this.growVertex(this.bottomRight);
	},
	
	shrinkVertex: function (vertex){
		if (vertex.totalCount > 0) {
			vertex.x = vertex.origX;
			vertex.y = vertex.origY;
		}
	},
	
	shrinkVertices: function (){
		this.shrinkVertex(this.topLeft);
		this.shrinkVertex(this.topRight);
		this.shrinkVertex(this.bottomLeft);
		this.shrinkVertex(this.bottomRight);
	}
});
