/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2010, 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.routers.Path");

dojo.require("rmpw.diagrams.layout.client.routers.Segment");
dojo.require("rmpw.diagrams.layout.client.routers.Vertex");
dojo.require("rmpw.diagrams.render.util.Point");
dojo.require("rmpw.diagrams.layout.client.util.ArrayList");
dojo.require("rmpw.diagrams.layout.client.util.HashMap");
dojo.require("rmpw.diagrams.layout.client.util.HashSet");

dojo.declare("rmpw.diagrams.layout.client.routers.Path$SegmentStack", null, {
	constructor: function (){
		this.prototype = new ArrayList();
		$ArrayList(this);
		this.typeId$ = 87;
	},
	
	pop: function (){
		  return $remove_2(this, this.size - 1);
	}
});

dojo.declare("rmpw.diagrams.layout.client.routers.Path", null, {
	constructor: function (start, end, data){
	  this.segments = $ArrayList(new ArrayList());
	  this.grownSegments = $ArrayList(new ArrayList());
	  this.points = new rmpw.diagrams.render.util.PointList();
	  this.visibleVertices = $HashSet(new HashSet());
	  this.stack = new rmpw.diagrams.layout.client.routers.Path$SegmentStack();
	  this.visibleObstacles = $HashSet(new HashSet());
	  this.excludedObstacles = $ArrayList(new ArrayList());
	  this.start = start;
	  this.end = end;
	  this.data = data;
	  
	  this.typeId$ = 86;
	  this.bendpoints = null;
	  this.isDirty = true;
	  this.isInverted = false;
	  this.isMarked = false;
	  this.prevCostRatio = 0;
	  this.subPath = null;
	  this.threshold = 0;
	},
	
	addAllSegmentsBetween: function (source, target){
	  this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.bottomLeft), source, target, false, false);
	  this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.bottomRight), source, target, true, true);
	  this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.topLeft), source, target, true, true);
	  this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.topRight), source, target, false, false);
	  if (source.y + source.height == target.y + target.height) {
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.bottomRight), source, target, false, true);
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.bottomLeft), source, target, true, false);
	  }
	  if (source.y == target.y) {
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.topRight), source, target, true, false);
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.topLeft), source, target, false, true);
	  }
	  if (source.x == target.x) {
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.topLeft), source, target, false, true);
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomLeft), source, target, true, false);
	  }
	  if (source.x + source.width == target.x + target.width) {
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.topRight), source, target, true, false);
	    this.addConnectingSegment(new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomRight), source, target, false, true);
	  }
	},

	addConnectingSegment: function (segment, o1, o2, checkTopRight1, checkTopRight2){
	  if (this.threshold != 0 && (Math.sqrt(segment.end.getPreciseDistance2(this.end)) + Math.sqrt(segment.end.getPreciseDistance2(this.start)) > this.threshold || Math.sqrt(segment.start.getPreciseDistance2(this.end)) + Math.sqrt(segment.start.getPreciseDistance2(this.start)) > this.threshold))
	    return;
	  if (o2.containsProper(segment.start) || o1.containsProper(segment.end))
	    return;
	  if (checkTopRight1 && segment.intersects(o1.x, o1.y + o1.height - 1, o1.x + o1.width - 1, o1.y))
	    return;
	  if (checkTopRight2 && segment.intersects(o2.x, o2.y + o2.height - 1, o2.x + o2.width - 1, o2.y))
	    return;
	  if (!checkTopRight1 && segment.intersects(o1.x, o1.y, o1.x + o1.width - 1, o1.y + o1.height - 1))
	    return;
	  if (!checkTopRight2 && segment.intersects(o2.x, o2.y, o2.x + o2.width - 1, o2.y + o2.height - 1))
	    return;
	  $add_0(this.stack, o1);
	  $add_0(this.stack, o2);
	  $add_0(this.stack, segment);
	},

	addObstacle: function (newObs){
	  var currObs, oItr, outerIter, entry, seg;
	  $add_1(this.visibleObstacles, newObs);
	  outerIter = $AbstractHashMap$EntrySetIterator(new AbstractHashMap$EntrySetIterator(), $keySet($HashSet_0(new HashSet(), this.visibleObstacles).map).val$entrySet.this$0);
	  oItr = ( $AbstractMap$1$1(new AbstractMap$1$1(), outerIter));
	  while ($hasNext(oItr.val$outerIter.iter)) {
		entry = $next(oItr.val$outerIter);  
	    currObs = entry.getKey();
	    if (newObs != currObs)
	    	this.addSegmentsFor(newObs, currObs);
	  }
	  seg = new rmpw.diagrams.layout.client.routers.Segment(newObs.topLeft, newObs.topRight);
	  $add_0(this.stack, newObs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg);
	  seg = new rmpw.diagrams.layout.client.routers.Segment(newObs.topRight, newObs.bottomRight);
	  $add_0(this.stack, newObs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg);
	  seg = new rmpw.diagrams.layout.client.routers.Segment(newObs.bottomRight, newObs.bottomLeft);
	  $add_0(this.stack, newObs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg);
	  seg = new rmpw.diagrams.layout.client.routers.Segment(newObs.bottomLeft, newObs.topLeft);
	  $add_0(this.stack, newObs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg);
	  this.addSegmentsFor_0(this.start, newObs);
	  this.addSegmentsFor_0(this.end, newObs);
	},

	addSegment: function (segment, exclude1, exclude2, allObstacles){
	  var i, obs;
	  if (this.threshold != 0 && (Math.sqrt(segment.end.getPreciseDistance2(this.end)) + Math.sqrt(segment.end.getPreciseDistance2(this.start)) > this.threshold || Math.sqrt(segment.start.getPreciseDistance2(this.end)) + Math.sqrt(segment.start.getPreciseDistance2(this.start)) > this.threshold))
	    return;
	  for (i = 0; i < allObstacles.size; ++i) {
		checkIndex(i, allObstacles.size);   
	    obs = allObstacles.array[i];
	    if (obs == exclude1 || obs == exclude2 || obs.exclude)
	      continue;
	    if (segment.intersects(obs.x, obs.y, obs.x + obs.width - 1, obs.y + obs.height - 1) || segment.intersects(obs.x, obs.y + obs.height - 1, obs.x + obs.width - 1, obs.y) || obs.containsProper(segment.start) || obs.containsProper(segment.end)) {
	      if (!$containsKey(this.visibleObstacles.map, obs))
	        this.addObstacle(obs);
	      return;
	    }
	  }
	  this.linkVertices(segment);
	},

	addSegmentsFor: function (source, target){
	  if (target.x < source.x + source.width && target.y < source.y + source.height && target.x + target.width > source.x && target.y + target.height > source.y)
	    this.addAllSegmentsBetween(source, target);
	  else if (target.y + target.height - 1 < source.y)
		  this.addSegmentsTargetAboveSource(source, target);
	  else if (source.y + source.height - 1 < target.y)
		  this.addSegmentsTargetAboveSource(target, source);
	  else if (target.x + target.width - 1 < source.x)
	    this.addSegmentsTargetBesideSource(source, target);
	  else 
	    this.addSegmentsTargetBesideSource(target, source);
	},

	addSegmentsFor_0: function (vertex, obs){
	  var seg, seg2;
	  seg = null;
	  seg2 = null;
	  switch (obs.getPosition_0(vertex)) {
	    case 12:
	    case 17:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topLeft);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomRight);
	      break;
	    case 20:
	    case 9:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topRight);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomLeft);
	      break;
	    case 1:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topLeft);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topRight);
	      break;
	    case 16:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomRight);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topRight);
	      break;
	    case 4:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomRight);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomLeft);
	      break;
	    case 8:
	      seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topLeft);
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomLeft);
	      break;
	    default:if (vertex.x == obs.x) {
	        seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topLeft);
	        seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomLeft);
	      }
	       else if (vertex.y == obs.y) {
	        seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topLeft);
	        seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topRight);
	      }
	       else if (vertex.y == obs.y + obs.height - 1) {
	        seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomLeft);
	        seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomRight);
	      }
	       else if (vertex.x == obs.x + obs.width - 1) {
	        seg = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.topRight);
	        seg2 = new rmpw.diagrams.layout.client.routers.Segment(vertex, obs.bottomRight);
	      }
	       else {
	        throw 'Unexpected vertex conditions';
	      }

	  }
	  $add_0(this.stack, obs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg);
	  $add_0(this.stack, obs);
	  $add_0(this.stack, null);
	  $add_0(this.stack, seg2);
	},

	addSegmentsTargetAboveSource: function (source, target){
	  var seg, seg2;
	  seg = null;
	  seg2 = null;
	  if (target.x > source.x) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.topLeft);
	    if (target.x < source.x + source.width - 1)
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomLeft);
	    else 
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.topLeft);
	  }
	   else if (source.x == target.x) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomLeft);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomLeft);
	  }
	   else {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.bottomLeft);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomLeft);
	  }
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg);
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg2);
	  seg = null;
	  seg2 = null;
	  if (target.x + target.width < source.x + source.width) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.topRight);
	    if (target.x + target.width - 1 > source.x)
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	    else 
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.topRight);
	  }
	   else if (source.x + source.width == target.x + target.width) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	  }
	   else {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.bottomRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	  }
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg);
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg2);
	},

	addSegmentsTargetBesideSource: function (source, target){
	  var seg, seg2;
	  seg = null;
	  seg2 = null;
	  if (target.y > source.y) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.topLeft);
	    if (target.y < source.y + source.height - 1)
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.topRight);
	    else 
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.topLeft);
	  }
	   else if (source.y == target.y) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.topRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.topRight);
	  }
	   else {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.topRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.topRight);
	  }
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg);
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg2);
	  seg = null;
	  seg2 = null;
	  if (target.y + target.height < source.y + source.height) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.bottomLeft);
	    if (target.y + target.height - 1 > source.y)
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	    else 
	      seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topRight, target.bottomLeft);
	  }
	   else if (source.y + source.height == target.y + target.height) {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.bottomLeft, target.bottomRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	  }
	   else {
	    seg = new rmpw.diagrams.layout.client.routers.Segment(source.bottomRight, target.bottomRight);
	    seg2 = new rmpw.diagrams.layout.client.routers.Segment(source.topLeft, target.bottomRight);
	  }
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg);
	  $add_0(this.stack, source);
	  $add_0(this.stack, target);
	  $add_0(this.stack, seg2);
	},

	createVisibilityGraph: function (allObstacles){
	  $add_0(this.stack, null);
	  $add_0(this.stack, null);
	  $add_0(this.stack, new rmpw.diagrams.layout.client.routers.Segment(this.start, this.end));
	  while (this.stack.size != 0)
	    this.addSegment(this.stack.pop(), this.stack.pop(), this.stack.pop(), allObstacles);
	},

	determineShortestPath: function (){
	  var nextVertex, s, vertex;
	  if (!this.labelGraph())
	    return false;
	  vertex = this.end;
	  this.prevCostRatio = this.end.cost / Math.sqrt(this.start.getPreciseDistance2(this.end));
	  while (!vertex.equals$(this.start)) {
	    nextVertex = vertex.label;
	    if (!nextVertex)
	      return false;
	    s = new rmpw.diagrams.layout.client.routers.Segment(nextVertex, vertex);
	    $add_0(this.segments, s);
	    vertex = nextVertex;
	  }
	  reverse_0(this.segments);
	  return true;
	},

	fullReset: function (){
	  var distance;
	  $clearImpl(this.visibleVertices.map);
	  $clear(this.segments);
	  if (this.prevCostRatio == 0) {
	    distance = Math.sqrt(this.start.getPreciseDistance2(this.end));
	    this.threshold = distance * 1.13;
	  }
	   else 
	    this.threshold = this.prevCostRatio * 1.04 * Math.sqrt(this.start.getPreciseDistance2(this.end));
	  $clearImpl(this.visibleObstacles.map);
	  this.resetPartial();
	},

	generateShortestPath: function (allObstacles){
		this.createVisibilityGraph(allObstacles);
	  if (this.visibleVertices.map.size == 0)
	    return false;
	  return this.determineShortestPath();
	},

	getSubPath: function (currentSegment){
	  var i, newGrownSegments, newPath;
	  newPath = new rmpw.diagrams.layout.client.routers.Path(currentSegment.start, this.end, null);
	  newPath.grownSegments = $ArrayList(new ArrayList());
	  for (i = $indexOf(this.grownSegments, currentSegment, 0); i < this.grownSegments.size; ++i) {
	    $add_0(newPath.grownSegments, $get_0(this.grownSegments, i));
	  }
	  newGrownSegments = $ArrayList(new ArrayList());
	  for (i = 0; i < $indexOf(this.grownSegments, currentSegment, 0) + 1; ++i) {
	    $add_0(newGrownSegments, $get_0(this.grownSegments, i));
	  }
	  this.grownSegments = newGrownSegments;
	  this.end = currentSegment.end;
	  this.subPath = newPath;
	  return newPath;
	},

	invertPriorVertices: function (currentSegment){
	  var i, stop, vertex;
	  stop = $indexOf(this.grownSegments, currentSegment, 0);
	  for (i = 0; i < stop; ++i) {
	    vertex = $get_0(this.grownSegments, i).end;
	    if (vertex.type == 1)
	      vertex.type = 2;
	    else 
	      vertex.type = 1;
	  }
	},

	labelGraph: function (){
	  var i, neighborVertex, neighbors, newCost, numPermanentNodes, smallestCost, tempVertex, v, vertex, outerIter, entry;
	  numPermanentNodes = 1;
	  vertex = this.start;
	  neighborVertex = null;
	  vertex.isPermanent = true;
	  while (numPermanentNodes != this.visibleVertices.map.size) {
	    neighbors = vertex.neighbors;
	    if (!neighbors)
	      return false;
	    for (i = 0; i < neighbors.size; ++i) {
	      checkIndex(i, neighbors.size);	
	      neighborVertex = neighbors.array[i];
	      if (!neighborVertex.isPermanent) {
	        newCost = vertex.cost + Math.sqrt(vertex.getPreciseDistance2(neighborVertex));
	        if (!neighborVertex.label) {
	          neighborVertex.label = vertex;
	          neighborVertex.cost = newCost;
	        }
	         else if (neighborVertex.cost > newCost) {
	          neighborVertex.label = vertex;
	          neighborVertex.cost = newCost;
	        }
	      }
	    }
	    smallestCost = 0;
	    tempVertex = null;
	    outerIter = $AbstractHashMap$EntrySetIterator(new AbstractHashMap$EntrySetIterator(), $keySet(this.visibleVertices.map).val$entrySet.this$0);
	    v = ( $AbstractMap$1$1(new AbstractMap$1$1(), outerIter));
	    while ($hasNext(v.val$outerIter.iter)) {
	      entry = $next(v.val$outerIter);	
	      tempVertex = entry.getKey();
	      if (!tempVertex.isPermanent && !!tempVertex.label && (tempVertex.cost < smallestCost || smallestCost == 0)) {
	        smallestCost = tempVertex.cost;
	        vertex = tempVertex;
	      }
	    }
	    vertex.isPermanent = true;
	    ++numPermanentNodes;
	  }
	  return true;
	},

	linkVertices: function (segment){
	  if (!segment.start.neighbors)
	    segment.start.neighbors = $ArrayList(new ArrayList());
	  if (!segment.end.neighbors)
	    segment.end.neighbors = $ArrayList(new ArrayList());
	  if ($indexOf(segment.start.neighbors, segment.end, 0) == -1) {
	    $add_0(segment.start.neighbors, segment.end);
	    $add_0(segment.end.neighbors, segment.start);
	  }
	  $add_1(this.visibleVertices, segment.start);
	  $add_1(this.visibleVertices, segment.end);
	},

	reconnectSubPaths: function (){
	  var changedSegment, oldSegment;
	  if (this.subPath) {
		this.subPath.reconnectSubPaths();
	    changedSegment = $remove_2(this.subPath.grownSegments, 0);
	    oldSegment = $get_0(this.grownSegments, this.grownSegments.size - 1);
	    oldSegment.end = changedSegment.end;
	    $addAll_0(this.grownSegments, this.subPath.grownSegments);
	    this.subPath.points.removePoint(0);
	    this.points.removePoint(this.points.size - 1);
	    this.points.addAll(this.subPath.points);
	    this.visibleObstacles.addAll(this.subPath.visibleObstacles);
	    this.end = this.subPath.end;
	    this.subPath = null;
	  }
	},

	refreshExcludedObstacles: function (allObstacles){
	  var i, o;
	  $clear(this.excludedObstacles);
	  for (i = 0; i < allObstacles.size; ++i) {
		checkIndex(i, allObstacles.size) ;
	    o = allObstacles.array[i];
	    o.exclude = false;
	    if (o.contains_3(this.start)) {
	      if (o.containsProper(this.start))
	        o.exclude = true;
	      else {
	      }
	    }
	    if (o.contains_3(this.end)) {
	      if (o.containsProper(this.end))
	        o.exclude = true;
	      else {
	      }
	    }
	    if (o.exclude && $indexOf(this.excludedObstacles, o, 0) == -1)
	      $add_0(this.excludedObstacles, o);
	  }
	},

	resetPartial: function (){
	  this.isMarked = false;
	  this.isInverted = false;
	  this.subPath = null;
	  this.isDirty = false;
	  $clear(this.grownSegments);
	  this.points.removeAllPoints();
	},

	setEndPoint: function (end){
	  if (end.equals$(this.end))
	    return;
	  this.end = new rmpw.diagrams.layout.client.routers.Vertex(end.x, end.y, null);
	  this.isDirty = true;
	},

	setStartPoint: function (start){
	  if (start.equals$(this.start))
	    return;
	  this.start = new rmpw.diagrams.layout.client.routers.Vertex(start.x, start.y, null);
	  this.isDirty = true;
	},

	testAndSet: function (obs){
	  var s, seg1, seg2;
	  if (this.isDirty)
	    return false;
	  if ($indexOf(this.excludedObstacles, obs, 0) != -1)
	    return false;
	  seg1 = new rmpw.diagrams.layout.client.routers.Segment(obs.topLeft, obs.bottomRight);
	  seg2 = new rmpw.diagrams.layout.client.routers.Segment(obs.topRight, obs.bottomLeft);
	  
	  var CURRENT = new rmpw.diagrams.render.util.Point();
	  var NEXT = new rmpw.diagrams.render.util.Point();
	  
	  for (s = 0; s < this.points.size - 1; ++s) {
		  this.points.getPoint_0(CURRENT, s);
		  this.points.getPoint_0(NEXT, s + 1);
	    if (seg1.intersects_0(CURRENT, NEXT) || seg2.intersects_0(CURRENT, NEXT) || obs.contains_3(CURRENT) || obs.contains_3(NEXT)) {
	      this.isDirty = true;
	      return true;
	    }
	  }
	  return false;
	}
});