/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.setup.SetupInitializer");

dojo.declare("rmps.core.setup._SetupInitializer", null, {
	
	initialize: function(/*Function */ callback){
		var extensions= jazz.core.RegistryFactory.getRegistry().getExtensionPoint("com.ibm.xtools.rmps.web.core.setupInitializer").getExtensions();
		
		/*If no intializers are defined, then execute the callback directly */
		if(!extensions|| extensions.length==0){
			callback();
			return;
		}
		var tracker= [];
		
		for(var index=0; index<extensions.length; index++){
			var extension= extensions[index];
			var elements= extension.getConfigurationElements();
			
			for(var subIndex=elements.length-1; subIndex>=0; subIndex--){
				var element= elements[subIndex];
				if ("initializer" == element.getName()) {
					var jsModule= element.getAttribute("jsModule");
					var classConstructor = dojo.getObject(jsModule);
					if (!classConstructor) {
						jazz.core.loader.load_async(jsModule, dojo.hitch(this, function(_jsModule){
							classConstructor = dojo.getObject(_jsModule);
							tracker.push(classConstructor);
							if(tracker.length== extensions.length){
								callback();									
							}
						},jsModule));
						
					}else{
						tracker.push(classConstructor);
						if(tracker.length== subIndex){
							callback();								
						}	
					}
				}
			}	
		}
	}	
});

rmps.core.setup.SetupInitializer = {
	getInstance: function() {
		return new rmps.core.setup._SetupInitializer();
	}
};


})();