/******************************** ***********************************************
* Licensed Materials - Property of IBM
* Copyright IBM Corp. 2009, 2013.  All Rights Reserved.
* 
* US Government Users Restricted Rights - Use, duplication or disclosure
* restricted by GSA ADP Schedule Contract with IBM Corp.
***************************************** **************************************/
dojo.provide("rmpw.widgets.slider.HorizontalSlider");

dojo.require("dijit.form.HorizontalSlider");

/*
 * This horizontal slider has a custom look and modified keyboard shortcuts so that it does not
 * break accessibility when placed in a toolbar.
 */
dojo.declare("rmpw.widgets.slider.HorizontalSlider", dijit.form.HorizontalSlider, {
	
	templateString: dojo.cache( "dijit.form", 
            "templates/HorizontalSlider.html", 
            "<span style=\"display:inline-block\"><table class=\"dijit dijitReset dijitSlider dijitSliderH\" cellspacing=\"0\" cellpadding=\"0\" border=\"0\" rules=\"none\" dojoAttachEvent=\"onkeypress:_onKeyPress,onkeyup:_onKeyUp\"\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t\t><td dojoAttachPoint=\"topDecoration\" class=\"dijitReset dijitSliderDecoration dijitSliderDecorationT dijitSliderDecorationH\"></td\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t></tr\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset dijitSliderButtonContainer dijitSliderButtonContainerH\"\n\t\t\t><div class=\"dijitSliderDecrementIconH\" style=\"display:none\" dojoAttachPoint=\"decrementButton\"><span class=\"dijitSliderButtonInner\">-</span></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><div class=\"dijitSliderBar dijitSliderBumper dijitSliderBumperH dijitSliderLeftBumper\" dojoAttachEvent=\"onmousedown:_onClkDecBumper\"></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><input dojoAttachPoint=\"valueNode\" type=\"hidden\" ${!nameAttrSetting}\n\t\t\t/><div class=\"dijitReset dijitSliderBarContainerH\" role=\"presentation\" dojoAttachPoint=\"sliderBarContainer\"\n\t\t\t\t><div role=\"presentation\" dojoAttachPoint=\"progressBar\" class=\"dijitSliderBar dijitSliderBarH dijitSliderProgressBar dijitSliderProgressBarH\" dojoAttachEvent=\"onmousedown:_onBarClick\"\n\t\t\t\t\t><div class=\"dijitSliderMoveable dijitSliderMoveableH\"\n\t\t\t\t\t\t><div dojoAttachPoint=\"sliderHandle,focusNode\" class=\"dijitSliderImageHandle dijitSliderImageHandleV\" style=\"top:-7px;\" dojoAttachEvent=\"onmousedown:_onHandleClick\" role=\"slider\" valuemin=\"${minimum}\" valuemax=\"${maximum}\"></div\n\t\t\t\t\t></div\n\t\t\t\t></div\n\t\t\t\t><div role=\"presentation\" dojoAttachPoint=\"remainingBar\" class=\"dijitSliderBar dijitSliderBarH dijitSliderRemainingBar dijitSliderRemainingBarH\" dojoAttachEvent=\"onmousedown:_onBarClick\"></div\n\t\t\t></div\n\t\t></td\n\t\t><td class=\"dijitReset\"\n\t\t\t><div class=\"dijitSliderBar dijitSliderBumper dijitSliderBumperH dijitSliderRightBumper\" dojoAttachEvent=\"onmousedown:_onClkIncBumper\"></div\n\t\t></td\n\t\t><td class=\"dijitReset dijitSliderButtonContainer dijitSliderButtonContainerH\"\n\t\t\t><div class=\"dijitSliderIncrementIconH\" style=\"display:none\" dojoAttachPoint=\"incrementButton\"><span class=\"dijitSliderButtonInner\">+</span></div\n\t\t></td\n\t></tr\n\t><tr class=\"dijitReset\"\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t\t><td dojoAttachPoint=\"containerNode,bottomDecoration\" class=\"dijitReset dijitSliderDecoration dijitSliderDecorationB dijitSliderDecorationH\"></td\n\t\t><td class=\"dijitReset\" colspan=\"2\"></td\n\t></tr\n></table></span>\n"),
            

	_onKeyPress : function _onKeyPress(/*Event*/e) {
		// Override dijit implementation so that left/right arrow keys can be used to navigate
		// between actions on a toolbar instead of moving the slider.  Add +/- keys to move the
		// slider as well.
		 if(this.disabled || this.readOnly || e.altKey || e.ctrlKey || e.metaKey){ return; }
		 switch(e.charOrCode){
			case dojo.keys.RIGHT_ARROW:
				return;
			case dojo.keys.LEFT_ARROW:
				return;
			case (this._descending === false ? dojo.keys.NUMPAD_MINUS : dojo.keys.NUMPAD_PLUS):
			case (this._descending === false ? '-' : '+'):
				this.increment(e);
				break;
			case (this._descending === false ? dojo.keys.NUMPAD_PLUS : dojo.keys.NUMPAD_MINUS):
			case (this._descending === false ? '+' : '-'):
				this.decrement(e);
				break;
			default:
				this.inherited(arguments);
				return;
		 }
		 dojo.stopEvent(e); 
	} 
});