/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.status.ProviderStatus");

dojo.require("rmps.core.status.Status");

var PROVIDER_NAME = "http://jazz.net/xmlns/rmps/status/1.0/providerName";
var PROVIDER_STATE = "http://jazz.net/xmlns/rmps/status/1.0/importState";
var PROVIDER = "http://jazz.net/xmlns/rmps/status/1.0/provider";
var IMPORT_WEB_URI = "http://jazz.net/xmlns/rmps/status/1.0/importWebUri";
var IMPORT_STATUS_URI = "http://jazz.net/xmlns/rmps/status/1.0/importStatusUri";

var States = rmps.core.status.StatusStates;

dojo.declare("rmps.core.status.ProviderStatus", null, {
	
	projectId: null,
	
	providerName: null,
	importState: null,
	importWebUri: null,
	importStatusUri: null,
	
	parseRdfJson: function(projectId, rdf) {
		this.projectId = projectId;
		
		this.importState = States.get(rdf[PROVIDER_STATE][0].value);
		this.providerName = rdf[PROVIDER_NAME][0].value;
		
		// Status results from the Rhapsody provider do not limit results
		// to the given project area. They also do not have the Web URI 
		// or the status URI defined in the result.
		if (rdf[IMPORT_WEB_URI]) {
			this.importWebUri = rdf[IMPORT_WEB_URI][0].value;
		}
		if (rdf[IMPORT_STATUS_URI]) {
			this.importStatusUri = rdf[IMPORT_STATUS_URI][0].value;
		}
	}
});
})();