/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

(function() {

dojo.provide("rmps.core.status.StatusClient");
 
dojo.require("jazz.app.context");
dojo.require("rmps.core.client");
dojo.require("rmps.core.status.ProviderStatus");
dojo.require("rmps.core.RootServices");

var STATUS_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "status");
var BASELINE_PARAM = "rmps.context=";
 
rmps.core.status.StatusClient = {
 
	getProviderStatus: function(projectId) {
		var args = {
			url: STATUS_PATH + "/import/" + projectId + "?" + BASELINE_PARAM + jazz.app.context.get().baseline,
			headers: {
				"Accept": "application/rdf+json",
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			load: function(response, ioArgs) {
				var statuses = [];
				for (var uri in response) {
					if (uri.indexOf("_") === 0) {
						var status = new rmps.core.status.ProviderStatus();
						status.parseRdfJson(projectId, response[uri]);
						
						// Ensure the status is well defined (state, name and web URI)
						if (status.providerName && status.importState && status.importWebUri) { 
							statuses.push(status);
						}
					}
				}
				return statuses;
			}
		};
		return jazz.client.xhrGet(args);
	}
};
})();