/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.core.streams.Stream");
dojo.require("rmps.core.Enum");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.core.streams", "StreamMessages");

	var messages = dojo.i18n.getLocalization("rmps.core.streams", "StreamMessages");
	
	rmps.core.streams.StreamStates = new rmps.core.Enum({
		PENDING: new rmps.core.EnumLiteral({name: messages.Pending, value: "PENDING", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_pending.gif")}),
		IN_PROGRESS: new rmps.core.EnumLiteral({name: messages.In_Progress, value: "IN_PROGRESS", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_inProgress.gif")}),
		COMPLETED: new rmps.core.EnumLiteral({name: messages.Completed, value: "COMPLETED", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_completed.gif")}),
		ERROR: new rmps.core.EnumLiteral({name: messages.Error, value: "ERROR", icon: dojo.moduleUrl("rmps.core", "graphics/icons/state_error.gif")})
	});

	var States = rmps.core.streams.StreamStates;
	
	var STREAM_NAME = "http://purl.org/dc/terms/title";
	var STREAM_DESCRIPTION = "http://purl.org/dc/terms/description";
	var STREAM_STATUS = "https://jazz.net/xmlns/rmps/baselines/1.0/status";
	var STREAM_CHILD_SNAPSHOTS = "https://jazz.net/xmlns/rmps/streams/1.0/ownedSnapshotUri";
	var STREAM_PARENT_SNAPSHOT = "https://jazz.net/xmlns/rmps/streams/1.0/parentSnapshotUri";

	dojo.declare("rmps.core.streams.Stream", null, {
		uri: null,
		name: null,
		date: null,
		snapshots: null,
		parentSnapshot: null,
	
parseRdfJson: function(uri, rdf) {			
			this.uri = uri;
			this.name = rdf[STREAM_NAME][0].value;
					
			this.status = States.get(rdf[STREAM_STATUS][0].value);
			this.snapshots = [];
			if (rdf[STREAM_PARENT_SNAPSHOT]) {
				this.parentSnapshot = rdf[STREAM_PARENT_SNAPSHOT][0].value;
			}
			//child snapshots are optional
			if (rdf[STREAM_CHILD_SNAPSHOTS]) {
				for (var i = 0; i<rdf[STREAM_CHILD_SNAPSHOTS].length; i++) {
					this.snapshots.push(rdf[STREAM_CHILD_SNAPSHOTS][i].value);
				}
			}
			
			//description is optional
			if (rdf[STREAM_DESCRIPTION]) {
				this.description = rdf[STREAM_DESCRIPTION][0].value;
			}
		} // end parseRdfJson
	
	});
})();