/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.Reorientable");
dojo.require("rmpw.common.policy.Policy");

/**
 *	Reorient relationship
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.tools.Reorientable", rmpw.common.policy.Policy, {
	singleton: "reorientable",
	
	setOnReorient: function(reorientAction) {
		this.doReorient = dojo.hitch(this, function(newSourceEditController, newTargetEditController) {
			return reorientAction.run({targetController: this.host, newSourceEditController: newSourceEditController, 
				newTargetEditController: newTargetEditController});
		});
		
		this.enableReorient = dojo.hitch(this, function(newSourceEditController, newTargetEditController) {
			return reorientAction.isEnabled({targetController: this.host, newSourceEditController: newSourceEditController, 
				newTargetEditController: newTargetEditController});
		});
	}
});

