/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.Reparentable");
dojo.require("rmpw.common.policy.Policy");

/**
 *	Reparent graph node tool policy
 * 
 * @author John Swanke
 */
dojo.declare("rmpw.diagrams.edit.tools.Reparentable", rmpw.common.policy.Policy, {
	singleton: "reparentable",
	
	setOnReparent: function(reparentAction) {
		this.doReparent = dojo.hitch(this, function(nodes, dx, dy) {
			return reparentAction.run({nodes: nodes, dx: dx, dy: dy});
		});
		
		this.isEnabled = dojo.hitch(this, function(nodes) {
			return reparentAction.isEnabled({nodes: nodes});
		});
	}
});

