/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.Resizable");

dojo.require("rmpw.diagrams.edit.tools.Feedback");

dojo.require("rmpw.diagrams.render.util.LabelHelper");

dojo.require("rmpw.diagrams.edit.tools.figures.RectangularResizableSelection");

/**
 * @author Anton McConville
 */

dojo.declare("rmpw.diagrams.edit.tools.Resizable", rmpw.diagrams.edit.tools.Feedback, {

	constructor: function(host){
	
		// this policy depends on the selectable policy so create it if it
		// doesn't exist
		var selectable = this.host.policies.selectable;
		if (!selectable) {
			this.host.createPolicy(rmpw.diagrams.edit.tools.Selectable);
		}
		
	    this.host = host;
	    this.host.policies.selectable.feedbackFigureType = rmpw.diagrams.edit.tools.figures.RectangularResizableSelection;	
		
		if (!host.__setUpdateSize) {
			host.__setUpdateSize = dojo.hitch(this, function(changeSet, x, y, width, height) {
				if (host.renderMapping.policies.graphFloatingLabel) {
					var figureBounds = host.renderMapping.policies.graphElement.getBounds();
					figureBounds.x = x;
					figureBounds.y = y;
					var helper = new rmpw.diagrams.render.util.LabelHelper();
					var labelLocation = helper.offsetFromRelativeCoordinate(figureBounds, 
							host.renderMapping.policies.graphFloatingLabel.locator.getParentPointList(), 
							host.renderMapping.policies.graphFloatingLabel.locator.getReferencePoint());	
					x = labelLocation.x;
					y = labelLocation.y;
				}
				
				host.__setUpdatePosition(changeSet, x, y);
				
				var widthTrace = host.renderMapping.traces[this.host.renderMapping.policies.resizeable._getInternalTraceName("width")];
				var heightTrace = host.renderMapping.traces[this.host.renderMapping.policies.resizeable._getInternalTraceName("height")];
				
				if (widthTrace && heightTrace) {
					var change = changeSet.createChange(widthTrace.getOwner());
					change.set(widthTrace.propertyName, width);
					change.set(heightTrace.propertyName, height);
					return true;
				}
				
				return false;
			});
		}
	},
		
	setOnChangeSize: function(changeSizeAction) {
		this.host.__setUpdateSize = dojo.hitch(this, function(changeSet, x, y, width, height) {
			changeSizeAction.run({changeSet: changeSet, x: x, y: y, width: width, height: height});
		});
	}
	
});