/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.RouterChangeable");

/**
 * Allows router to be toggled changed on the editpart.
 * 
 * @author Steve Shaw
 */

dojo.declare("rmpw.diagrams.edit.tools.RouterChangeable", rmpw.common.policy.Policy, {
	singleton: "routerChangeable",

	constructor: function(host){
	
	    this.host = host;
		
		if (!host.__setChangeRouter) {
			host.__setChangeRouter = dojo.hitch(this, function(changeSet, router) {
				var routerTrace = host.renderMapping.traces[this.host.renderMapping.policies.graphEdge._getInternalTraceName("router")];
				
				if (routerTrace) {
					var change = changeSet.createChange(routerTrace.getOwner());
					change.set(routerTrace.propertyName, router);
					return true;
				}
				
				return false;
			});
		}
	},
		
	setOnChangeRouter: function(changeRouterAction) {
		this.host.__setChangeRouter = dojo.hitch(this, function(changeSet, router) {
			changeRouterAction.run({changeSet: changeSet, router: router});
		});
	}
	
});