/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.TouchZoom");

dojo.require("rmpw.common.policy.Policy");
dojo.require("dojox.gfx.matrix");
dojo.require("dojox.gfx.fx");
dojo.require("dojo.fx.easing");

/**
 * Pans the diagram when a mouse drag event isn't caught by anything else first.
 * 
 * @author Anton McConville
 */
dojo.declare("rmpw.diagrams.edit.tools.TouchZoom", rmpw.common.policy.Policy, {
	singleton: "TouchZoom",
	
	scale: 1,
	
	constructor: function() {
		this.viewport = this.host.root.viewport;
		this.container = this.viewport.container;
		
		this._connectListeners();
	},
		
	_connectListeners: function() {
		this.gestureChangeListener = dojo.connect(this.container, "gesturechange", dojo.hitch( this, "gesture" ) );
		this.gestureStartListener = dojo.connect(this.container, "gesturestart", dojo.hitch( this, "gestureStart" ) );
	},
	
	gesture: function(e){
					
		var newScale = this.scale * e.scale;
		
		if( newScale < 4 && newScale > 0.25 ){
			this.viewport.setZoom( newScale );
		}
		
		dojo.stopEvent(e);			
	},
	
	gestureStart: function(e){		
		e.preventDefault(); 
		
		this.scale = this.viewport.getZoom();
		
		dojo.stopEvent(e);
	}
});