/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
    
dojo.provide("rmpw.diagrams.edit.tools.figures.AffordanceMoveable");

dojo.require("rmpw.diagrams.edit.handles.HandleUtils" );
dojo.require("rmpw.diagrams.edit.tools.MoveableBase");

var my ={ //used for private functions and variables
    reorient: function(box, region){
        var max_min = function(func, array, key){ //returns max/min value of a certain key in a array
               var result = array[0][key], i;
               for(i = 1; i < array.length; i++){
                   result = Math[func](result, array[i][key]);
               }
               return result;
            },  
        min_x = max_min("min", box, "x"),
        min_y = max_min("min", box, "y"),
        max_x = max_min("max", box, "x"),
        max_y = max_min("max", box, "y"),
        result = [],
        i,
        entered = [false, false, false, false];
               
        result.dx = box.dx;
        result.dy = box.dy;
                
        for(i = 0; i < box.length; i++){
            if(box[i].x === min_x && box[i].y === min_y && !entered[region.TOP_LEFT]){
                result[region.TOP_LEFT] = box[i];
                entered[region.TOP_LEFT] = true;
            }else if(box[i].x === max_x && box[i].y === min_y && !entered[region.TOP_RIGHT]) {
                result[region.TOP_RIGHT] = box[i];
                entered[region.TOP_RIGHT] = true;
            }else if(box[i].x === max_x && box[i].y === max_y && !entered[region.BOTTOM_RIGHT]){
                result[region.BOTTOM_RIGHT] = box[i];
                entered[region.BOTTOM_RIGHT] = true;
            }else{
                result[region.BOTTOM_LEFT] = box[i];
            }
        }
        
        return result;
    }    

};

dojo.declare("rmpw.diagrams.edit.tools.figures.AffordanceMoveable", rmpw.diagrams.edit.tools.MoveableBase, {

	REGION: rmpw.diagrams.edit.handles.HandleUtils,
	
	TOTAL_DX: 0,
	
	TOTAL_DY: 0,
	
	onFirstMove: function(/* dojox.gfx.Mover */ mover) {
		this.inherited(arguments);
		
		this.host.root.policies.focusScope.disable();
		this._hideSelectedFeedback(this.host.renderMapping.__editController);
	},
	
	_hideSelectedFeedback: function(controller) {
		if (controller.policies.focusable) {
			controller.policies.focusable.hideFeedbackNoFade();			
		}
		var selectable = controller.policies.selectable;
		for (var name in controller.policies) {
			var policy = controller.policies[name];
			if (policy.hideFeedback && policy!==selectable) {
				policy.hideFeedback();
			}
		}
		
		if (controller.children) {
			for (var i = 0, len_i = controller.children.length; i < len_i; i++) {
				this._hideSelectedFeedback(controller.children[i]);				
			}
		}
	},
	
	// mouse event processors
	onMove: function(/* dojox.gfx.Mover */ mover, /* Object */ shift)  {
		this.inherited(arguments);
		
		var dx = shift.dx;
		var dy = shift.dy;
		
		var top = this.host.affordance.outlines[ this.REGION.TOP ];
		var left = this.host.affordance.outlines[ this.REGION.LEFT ];		
		var right = this.host.affordance.outlines[ this.REGION.RIGHT ];
		var bottom = this.host.affordance.outlines[ this.REGION.BOTTOM ];
		
		var BORDER_WIDTH = this.host.affordance.BORDER_WIDTH;
		
		this.box = this.host.affordance.box;

		var id = parseInt(this._moveableShape.id, 10);
						
		if( id === this.REGION.TOP_LEFT ){

			this.box[ this.REGION.TOP_LEFT ].x = this.box[ this.REGION.TOP_LEFT ].x + dx; 
			this.box[ this.REGION.TOP_LEFT ].y = this.box[ this.REGION.TOP_LEFT ].y + dy;
			this.box[ this.REGION.TOP_RIGHT ].y = this.box[ this.REGION.TOP_RIGHT ].y + dy;
			this.box[ this.REGION.BOTTOM_LEFT ].x = this.box[ this.REGION.BOTTOM_LEFT ].x + dx;
			
			this.TOTAL_DX = this.TOTAL_DX + dx;
			this.box.dx = this.TOTAL_DX;
			
			this.TOTAL_DY = this.TOTAL_DY + dy;
			this.box.dy = this.TOTAL_DY;

		}else if( id === this.REGION.TOP_RIGHT ){

			this.box[ this.REGION.TOP_LEFT ].y = this.box[ this.REGION.TOP_LEFT ].y + dy; 
			this.box[ this.REGION.TOP_RIGHT ].x = this.box[ this.REGION.TOP_RIGHT ].x + dx;
			this.box[ this.REGION.TOP_RIGHT ].y = this.box[ this.REGION.TOP_RIGHT ].y + dy;
			this.box[ this.REGION.BOTTOM_RIGHT ].x = this.box[ this.REGION.BOTTOM_RIGHT ].x + dx;
			
			this.box.dx = 0;
			
			this.TOTAL_DY = this.TOTAL_DY + dy;
			this.box.dy = this.TOTAL_DY;

		}else if( id === this.REGION.BOTTOM_RIGHT ){

			this.box[ this.REGION.TOP_RIGHT ].x = this.box[ this.REGION.TOP_RIGHT ].x + dx;
			this.box[ this.REGION.BOTTOM_LEFT ].y = this.box[ this.REGION.BOTTOM_LEFT ].y + dy;
			this.box[ this.REGION.BOTTOM_RIGHT ].x = this.box[ this.REGION.BOTTOM_RIGHT ].x + dx;
			this.box[ this.REGION.BOTTOM_RIGHT ].y = this.box[ this.REGION.BOTTOM_RIGHT ].y + dy;
			
			this.box.dx = 0;
			this.box.dy = 0;

		}else if( id === this.REGION.BOTTOM_LEFT ){

			this.box[ this.REGION.TOP_LEFT ].x = this.box[ this.REGION.TOP_LEFT ].x + dx;
			this.box[ this.REGION.BOTTOM_RIGHT ].y = this.box[ this.REGION.BOTTOM_RIGHT ].y + dy;
			this.box[ this.REGION.BOTTOM_LEFT ].x = this.box[ this.REGION.BOTTOM_LEFT ].x + dx;
			this.box[ this.REGION.BOTTOM_LEFT ].y = this.box[ this.REGION.BOTTOM_LEFT ].y + dy;
			
			this.TOTAL_DX = this.TOTAL_DX + dx;		
			this.box.dx = this.TOTAL_DX;	
			
			this.box.dy = 0;
		}

		this.box.width = this.box[ this.REGION.TOP_RIGHT ].x - this.box[ this.REGION.TOP_LEFT ].x;
		this.box.height = this.box[ this.REGION.BOTTOM_LEFT ].y - this.box[ this.REGION.TOP_LEFT ].y;
		
		// we make changes to accomodate having a border 
		// when rendering the inner shapes: selectionBox and host shape
        if(this.box.width > 0){       
            this.box.width -= 2*BORDER_WIDTH;
        }else{
            this.box.dx -= 2*BORDER_WIDTH;
            this.box.width += 2*BORDER_WIDTH;
        }
        if(this.box.height > 0){
            this.box.height -= 2*BORDER_WIDTH;
        }else{
            this.box.dy -= 2*BORDER_WIDTH;
            this.box.height += 2*BORDER_WIDTH;
        }
        
        // if a render policy will resize host shape
        if (dojox.gfx.svg && this._renderMapping.policies.resizeable) {
            this._renderMapping.policies.resizeable.resize(this.box);
        }
        
		this.setOutline( top, this.box[ this.REGION.TOP_LEFT ], this.box[ this.REGION.TOP_RIGHT ] );
        this.setOutline( right, this.box[ this.REGION.TOP_RIGHT ], this.box[ this.REGION.BOTTOM_RIGHT ] );
        this.setOutline( bottom, this.box[ this.REGION.BOTTOM_RIGHT ], this.box[ this.REGION.BOTTOM_LEFT ] );
        this.setOutline( left, this.box[ this.REGION.BOTTOM_LEFT ], this.box[ this.REGION.TOP_LEFT ] );  
        
        //the top_left may no longer be the actual top left after moving, so we reorient the box
        //this is only necessary for drawing the rectangular selection box, and the triangular handles
        this.box = my.reorient(this.box, this.REGION);
        
        this.box.x = this.box[ this.REGION.TOP_LEFT].x + BORDER_WIDTH;        
        this.box.y = this.box[ this.REGION.TOP_LEFT].y + BORDER_WIDTH;  
        this.box.height = Math.max( Math.abs(this.box[ this.REGION.BOTTOM_LEFT ].y - this.box[ this.REGION.TOP_LEFT ].y) - BORDER_WIDTH*2, 0);        
        this.box.width = Math.max( Math.abs(this.box[ this.REGION.TOP_RIGHT ].x - this.box[ this.REGION.TOP_LEFT ].x) - BORDER_WIDTH*2, 0);
        
        
        for( var h=0; h < this.REGION.HANDLE_COUNT; h++ ){
            /* Want to replace all handles, but for the one that is currently
               being moved (h) */       
            if( id !== h ){
                this.host.affordance.replaceHandle( h, this.box[h] );
            }else{
                /* Reposition the handle being dragged */       
                mover.shape.setTransform({dx: this.box[h].x, dy: this.box[h].y});
            }
        }

        this.host.affordance.replaceSelectionBox(this.host.affordance.feedbackLayer, this.box);
        
	},
	
	
	setOutline: function( line, start, end ){		
	  line.setShape( { x1: start.x, y1: start.y, x2: end.x, y2: end.y } );
	},
	
	onMoveStop: function(/* dojox.gfx.Mover */ mover) {
		this.host.root.policies.focusScope.enable();

		/* In resizing path based shapes, the bounding box can result in instructions to 
         * make the drawing be of zero width or height - so I want to prevent that because
         * subsequent resizing will result in an empty bounding box. If the width or
         * height of the resized bounding box is zero, then don't try to transform the 
         * internal shape. This works well visually.
         */
		
		if( this.box ){
			
			var suggestedHeight = this.box[ this.REGION.TOP_LEFT ].y - this.box[ this.REGION.BOTTOM_LEFT ].y;
			var suggestedWidth = this.box[ this.REGION.TOP_LEFT ].x - this.box[ this.REGION.BOTTOM_RIGHT ].x;

			if( suggestedWidth !== 0 && suggestedHeight !== 0 ){
				this.host.affordance.reshapeDrawing( this.box );
			}
		}

		this.inherited(arguments);
	}
});

}());
