/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.tools.figures.Highlight");

dojo.require("dojox.gfx.fx");

/**
 * Abstract class for highlighting
 * 
 * @author Steve Shaw
 */
dojo.declare("rmpw.diagrams.edit.tools.figures.Highlight", null, {
	padding: 3,
	colorStart: [255, 151, 33, 0.3],
	colorEnd: [255, 151, 33, 0],

	constructor: function(target) {
	},
	
	createShape: function(target) {
		// subclasses should override
	},
	
	destroy: function() {
		if(dojox.gfx.vml) {
			// use a cheap version when rendering to IE VML
			this.shape.removeShape();
		} else {
			var fadeOut = dojox.gfx.fx.animateFill({
				shape: this.shape,
	            color : {start: this.colorStart, end: this.colorEnd},
	            duration : 300
	        });
			dojo.connect(fadeOut, "onEnd", function() {
				this.shape.removeShape();
			});
			fadeOut.play();
		}		
	}
});