/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.dsv.editor.ui.Application");

dojo.require("jazz.util.ResizeNotifier");
dojo.require("rmpw.jazz.theming");
dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.declare("rmpw.dsv.editor.ui.Application", { 

     layout: null,
     
     constructor: function(args) {
	    this.config.showLoginLogout = false;	
        this.start();
     },
     
     start: function() {
    	 
    	rmpw.jazz.theming.initialize();
    	 
 		this.config.productName = this.productName;
 		this.config.applicationRoot = this.applicationRoot;
 		this.config.productIconSmall = this.productIconSmall;
 		this.config.productIconLarge = this.productIconLarge;
 		try {
 			this.ui.init(this.config);	
 		} catch(e){
 			this.onFailure(e);
 			return;
 		}
 		dojo.addClass(dojo.body(), "jazz-app-body");
 		this.workbench.rootNode().appendChild(this.ui.domNode);
 		net.jazz.ajax.ui.PlatformUI.getWorkbench()._start();
 		this.started = true;
	 },
	 
	 onFailure: function(errorObj, message, showFinePrint) {

	    this.ui.init({		
			productName: this.productName, 
			productIconLarge: this.productIconLarge,
			productTitleImg: this.config.productTitleImg,
			showLoginLogout: this.config.showLoginLogout,
			login: this.config.login,
			logout: this.config.logout,
			user: this.config.user,
			buttons: this.config.buttons
		});
			
		dojo.addClass(dojo.body(), "jazz-app-body");	
		this.workbench.rootNode().appendChild(this.ui.domNode);
		this.workbench.setTitle("");
			
		if (errorObj && errorObj.status && errorObj.status == 401) {
			message = document.createElement("div"); //$NON-NLS-1$
			message.appendChild(document.createTextNode(messages.ProjectAreaListApplication_8));
			if (dojo.cookie("JazzFormAuth") != null && this.config.showLoginLogout) { //$NON-NLS-1$
				message.appendChild(document.createTextNode(messages.ProjectAreaListApplication_9));
				var button = document.createElement("button"); //$NON-NLS-1$
				button.appendChild(document.createTextNode(messages.ProjectAreaListApplication_10));
				var buttonDiv = document.createElement("div"); //$NON-NLS-1$
				buttonDiv.style.marginTop = "1em"; //$NON-NLS-1$
				buttonDiv.appendChild(button);
				message.appendChild(buttonDiv);
				dojo.connect(button,"onclick",this,function (e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					var dfd = jazz.app.auth.logout();
					dfd.addCallback(function(){
						window.location.reload();
					});
				});
			} else {
				message.appendChild(document.createTextNode(messages.ProjectAreaListApplication_12));
				var button = document.createElement("button"); //$NON-NLS-1$
				button.appendChild(document.createTextNode(messages.ProjectAreaListApplication_13));
				var buttonDiv = document.createElement("div"); //$NON-NLS-1$
				buttonDiv.style.marginTop = "1em"; //$NON-NLS-1$
				buttonDiv.appendChild(button);
				message.appendChild(buttonDiv);
				dojo.connect(button,"onclick",this,function (e) { //$NON-NLS-1$
					dojo.stopEvent(e);
					window.location.reload();
				});
			}
		}
			
		if (!errorObj || showFinePrint === false) {
			dojo.publish(net.jazz.ajax.internal.events.viewErrorPage, [message, "", true]);
		} else {
			dojo.publish(net.jazz.ajax.internal.events.viewErrorPage, [message, errorObj.message, true]);
		}
			dojo.body().removeChild(dojo.byId("net-jazz-ajax-InitialLoadMessage"));
	 },
	 
	 resize: function( x ){	
		var size = dojo.marginBox( this.ui._content );		 
	    this.layout.resize();
	 }   
});

if (dojo.isIE >= 8) {
	// Workaround for IE8 standards mode
	try{
		document.namespaces.add("v","urn:schemas-microsoft-com:vml");
		var vmlElems = ["*", "group", "roundrect", "oval", "shape", "rect", "imagedata"],
			i = 0, l = 1, s = document.createStyleSheet();
		if(dojo.isIE >= 8){
			i = 1;
			l = vmlElems.length;
		}
		for(; i < l; ++i){
			s.addRule("v\\:" + vmlElems[i], "behavior:url(#default#VML); display:inline-block");
		}
	}catch(e){}
}