/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2012, 2013. All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

dojo.provide("rmps.diagram.ui.DiagramStore");

dojo.require("rmps.diagram.behavior.HotspotDiagramController");
dojo.require("rmps.diagram.data.JtsRdfStore");
dojo.require("rmps.graphics.ui.DiagramLoader");
dojo.require("rmps.graphics.render.HotspotDiagramViewMapping");

dojo.require("rmpw.diagrams.edit.tools.DragPan");
dojo.require("rmpw.diagrams.edit.tools.TouchZoom");
dojo.require("rmpw.diagrams.edit.tools.WheelZoom");

(function() {
	
	dojo.declare("rmps.diagram.ui.DiagramStore", [ rmps.diagram.data.JtsRdfStore ],	{

		fetch: function(resourceInfo, definition) {
			if(!resourceInfo) {
				return;
			}		
			var diagramWidget = this.viewer;
			diagramWidget.clear();
			diagramWidget.loaded=false;
			dojo.mixin(diagramWidget, {
				drawDiagram: function(model) {
					var diagram = new rmps.graphics.render.HotspotDiagramViewMapping();
					diagram.setModel(model);
					diagram.setParentFigure(this.viewer.viewport.contents);
					
					this.controller = new rmps.diagram.behavior.HotspotDiagramController( diagram );		
						
					this.controller._connectConstruction = dojo.connect(diagram, "applyModelChanges", this, function() {			
						this.controller.setParent(this.viewer);
						this.controller.setRenderMapping( diagram );
						dojo.disconnect( this.controller._connectConstruction );
						delete this.controller._connectConstruction;
					});
					this.viewer.setDiagram(diagram);
					if (diagram.children && diagram.children[0] && diagram.children[0].rect) {
						this.viewer.setFixedDiagramSize(diagram.children[0].rect.getBoundingBox());
					}
					diagramWidget.hideLoadingMessage();
				},
			});
			this.loader = new rmps.graphics.ui.DiagramLoader();	    
			this.loader.handleDiagramAssets( resourceInfo.uri, null, this.viewer );
			
		},
		
		save: function() {
			// do nothing
		},
		
		deleteResource: function() {
			// do nothing
		}
	
				
	});
})();
