/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

( function(){

  dojo.provide("rmpw.jazz.ui.LineStyler");
  
  dojo.require("rmpw.widgets.Events");
  dojo.require("rmpw.widgets.pickers.ColorPicker");
  dojo.require("rmpw.widgets.pickers.LineWidthPicker");
  dojo.require("rmpw.widgets.pickers.LineStylePicker");
  
  var topics = rmpw.widgets.Events.topics;

  dojo.declare("rmpw.jazz.ui.LineStyler", null, {
	  
	  toolbar: null,
	  	  
	  selection: null,
	  
	  subscriptions: null,
	  
	  addStyleTools: function( bar ){
	  
	     this.toolbar = bar;
	     	     	     
         this.linecolor = new rmpw.widgets.pickers.ColorPicker({});
         
         this.toolbar.addChild( this.linecolor );
         
         this.linecolor.startup();
         
         this.linewidth = new rmpw.widgets.pickers.LineWidthPicker({});
	          
         this.toolbar.addChild( this.linewidth );   
         
         this.linestyle = new rmpw.widgets.pickers.LineStylePicker({});
         
         this.toolbar.addChild( this.linestyle );
         
         this.subscriptions = new Array();
         
         this.subscriptions.push( dojo.subscribe( topics.LINE_COLOR, dojo.hitch( this, "setLineColor" ) ) );
         this.subscriptions.push( dojo.subscribe( topics.LINE_WIDTH, dojo.hitch( this, "setLineWidth" ) ) );
         this.subscriptions.push( dojo.subscribe( topics.LINE_STYLE, dojo.hitch( this, "setLineStyle" ) ) );
      },
      
      removeStyleTools: function(){
    	  
    	 if( this.toolbar != null ){ 
    		 
  		    for( var item in this.subscriptions ){	    	
  		       if( this.subscriptions[item] != null ){		    	
  		    	   dojo.unsubscribe( this.subscriptions[item] );
  		       }
		    }
	 
  		    this.toolbar.removeChild( this.linecolor );
  		    this.toolbar.removeChild( this.linewidth );
  		    this.toolbar.removeChild( this.linestyle );
   		 
 		    this.subscriptions = null;
 		    
 		    this.toolbar = null;
    	 }
      },
      
      referenceLines: function( lines ){
    	 this.selection = lines; 
      },
      
      setLineColor: function( message ){

      },
      
      setLineWidth: function( message ){     	 
     	
      },
      
      setLineStyle: function( message ){
    	        	 
      },
      
      getLineColor: function(){
    	  return this.linecolor.color;
      },
      
      getLineOpacity: function(){
    	  return this.linecolor.decimalValue;
      },
      
      getLineWidth: function(){
    	  return this.linewidth.width;
      },
      
      getLineStyle: function(){
    	  return this.linestyle.dash;
      }
	  
  });

})();
