/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.jazz.ui.RootLayer");

dojo.require("rmpw.panner.RootLayer");

/* Extending the Root Layer, so that we can listen for pan events
 * and stop/start listening for focus. Please see: Work Item 46282.
 */

dojo.declare("rmpw.jazz.ui.RootLayer", rmpw.panner.RootLayer, {
	
	focusController: null,
	
	setFocusController: function( fController ){
		this.focusController = fController;
	},
	
	_onMoveStart: function() {
		this.inherited(arguments);
		if( this.focusController ){
			this.focusController.disable();
		}
	},

	_onMoveStop: function() {
		this.inherited(arguments);
		if( this.focusController ){
			this.focusController.enable();
		}
	}
});

})();