/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmpw.dsv.editor.owl.ui.Vocabulary");

dojo.require("rmps.core.client");
dojo.require("dijit.layout.ContentPane");
dojo.require("dijit.layout.TabContainer");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmpw.dsv.editor.owl", "Messages");

var messages = dojo.i18n.getLocalization("rmpw.dsv.editor.owl", "Messages");

dojo.declare("rmpw.dsv.editor.owl.ui.Vocabulary",  dijit.layout.TabContainer, {
	_raw: null,
	_oslc: null,
	
	postCreate: function() {
		this.loaded = false;
		this.loadingnode = null;
		
	    this.inherited(arguments);
	    this._raw = new dijit.layout.ContentPane({title: messages.RAW});
	    this.addChild(this._raw);
	    this._oslc = new dijit.layout.ContentPane({title: "OSLC"});
	    this.addChild(this._oslc);
	    dojo.connect(this, 'selectChild', this.showResourceShapeDoc);
	    dojo.connect("onresize", dojo.hitch(this, this.resize));
	},
	
	// Override the resize() method and ensure the domNode is
	// defined before doing a resize() or else the error
	// "TypeError: node is null" appears. (WI 37909)
	resize: function() {
		if (this.domNode) {
			this.inherited(arguments);
		}
	},
	
	showResourceShapeDoc: function() {
		var uri = net.jazz.ajax._contextRoot + "/rdfdirectory/doc?logicalURI=" + encodeURIComponent(this.uri);
		var content_type = "text/html";
		var oslc = false;
		
		if(this.selectedChildWidget == this._oslc) {
			 uri += "&oslc=true";
		} 
		
		this.showLoadingMessage();
		rmps.core.client.xhrGet({
			url : uri,
			headers: {
			"Accept": content_type,
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "text",
			load: dojo.hitch(this, function(data) {
				this.hideLoadingMessage();
				this.selectedChildWidget.attr("content", data);
				window.onresize({}); // Resize the content so it fits
			}),
			error: function(error, ioArgs) {
				this.hideLoadingMessage();
				rmps.core.error.createXhrError(ioArgs, messages.ErrorLoadingVocab).dispatch();
				console.error(error);
			}
		});	
	},
	
	showLoadingMessage: function(s) {
		if (this.loaded == false) {
			if (this.loadingnode == null) {
				this.loadingnode = document.createElement("div");

				this.loadingnode.style.padding = "10px";
				this.loadingnode.style.position = "absolute";
				this.loadingnode.style.color = "#BBBBBB";
				this.loadingnode.style.fontSize = "2em";
				this.loadingnode.innerHTML = messages.Loading;

				this.domNode.appendChild(this.loadingnode);
			}

			this.loadingnode.style.top = "100px";
			this.loadingnode.style.left = "100px";
		}
	},

	hideLoadingMessage: function() {
		if (this.loadingnode != null) {
			this.domNode.removeChild(this.loadingnode);
			delete this.loadingnode;
		}

		this.loaded = true;
	}
});

})();
