/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function() {

	dojo.provide("com.ibm.team.vvc.shared.web.ui.VvcConstants");
	
	/**
	 * <p>
	 * Common, shared place to put VVC Constants
	 * </p> 
	 */
	com.ibm.team.vvc.shared.web.ui.VvcConstants = {

		// Cache
		CONFIGURATION_CACHE_KEY: "com.ibm.team.vvc.configurationSessionCache",
		CONFIGURATION_SPACE_CACHE_KEY: "com.ibm.team.vvc.configurationSpaceSessionCache",
		VVC_URL_STORAGE_KEY: "com.ibm.team.vvc.vvcUrl",	
		
		CREATE_OPERATION: "operation=create",
		OPEN_OPERATION: "operation=open",
		
		/* --- New '#action=' verbs --- */
		// Configurations
		CREATE_CONFIGURATION : "createNewConfiguration",
		VIEW_CONFIGURATION : "viewConfiguration",
		EDIT_CONFIGURATION : "editConfiguration",
		EXPLORE_CONFIGURATIONS : "exploreConfigurations",
		
		// Workspaces
		CREATE_WORKSPACE : "createNewWorkspace",
		VIEW_WORKSPACE : "viewWorkspace",
		EDIT_WORKSPACE : "editWorkspace",
		EDIT_GLOBAL_CONFIGURATION : "editGlobalConfiguration",
		EDIT_GLOBAL_CONFIGURATION_CONTRIBUTIONS : "editGlobalConfigurationContributions",
		EXPLORE_WORKSPACES : "exploreWorkspaces",	// TODO: (amooz) investigate this term!
		
		// Workspaces, Snapshots, and Change Set editor tabs
		WORKSPACES_OVERVIEW_TAB: "overview",
		DIMENSIONS_TAB: "dimensions",
		DEPENDENCIES_TAB: "dependencies",
		CONTIRBUTIONS_TAB: "contributions",
		SNAPSHOTS_TAB: "snapshots",
		WORKSPACES_TAB: "workspaces",
		CHANGESETS_TAB: "changesets",
		RESOURCES_TAB: "resources",
		WORKITEMS_TAB: "workitems",
		
		// Workspace Explorer 2.0
		EXPLORER_FLOW_VIEW: "flow",
		EXPLORER_DEPENDENCY_VIEW: "dependency",
		
		// Snapshots
		CREATE_SNAPSHOT : "createNewSnapshot",
		VIEW_SNAPSHOT : "viewSnapshot",
		EDIT_SNAPSHOT : "editSnapshot",
		EXPLORE_SNAPSHOTS : "exploreSnapshots",
		
		// Changesets
		CREATE_CHANGESET : "createNewChangeset",
		VIEW_CHANGESET : "viewChangeset",
		EDIT_CHANGESET : "editChangeset",
		EXPLORE_CHANGESETS : "exploreChangesets",
		
		// Dimensions
		CREATE_DIMENSION : "createNewDimension",
		VIEW_DIMENSION : "viewDimension",
		EDIT_DIMENSION : "editDimension",
		EDIT_DIMENSION_TYPE : "editDimensionType",
		EXPLORE_DIMENSIONS : "exploreDimensions",
		
		// Misc
		DEFAULT : "vvc",
		SHOW_EXPLORER : "exploreConfigurations",	// TODO: REMOVE THIS!
		REFRESH_EXPLORER : "refreshConfigurationsExplorer",	// TODO: (amooz) investigate this term!
		SHOW_HISTORY : "exploreHistory",
		EDIT_BASE_CONFIGURATION : "rebase",
		EDIT_DEPENDENCIES : "editDependencies",
		/* ---------------------------- */
		
		// VVC App & Icons
		WORKSPACE_TYPE: "workspace",
		SNAPSHOT_TYPE: "snapshot",
		WORKSPACE_ICON_URI: dojo.moduleUrl("com.ibm.team.vvc.shared.web", "graphics/workspace.gif"),
		SNAPSHOT_ICON_URI: dojo.moduleUrl("com.ibm.team.vvc.shared.web", "graphics/snapshot.gif"),
		/* ---------------------------- */
		
		// Error Codes
		ERROR_CODE_EXISTS: "EXISTS",
		/* ---------------------------- */
		
		// Explorer
		PRESERVE_EXPANSION_STATE_STORAGE_KEY: "com.ibm.team.vvc.explorer.expansionState",
		PRESERVE_SELECTION_STATE_STORAGE_KEY: "com.ibm.team.vvc.explorer.selectionState",
		/* ---------------------------- */
		
		SNAPSHOT: "snapshot",
		WORKSPACE: "workspace",
					
		// Pre-defined dimensions
		PURPOSE_DIMENSION_URI: "http://jazz.net/ns/vvc/ootb#purpose",
		CHANGESET_DIMENSION_URI: "http://jazz.net/ns/vvc/ootb#changeSet",
		TIMEORDER_DIMENSION_URI: "http://jazz.net/ns/vvc#timeOrder",
			
		// --- Events ---
		// + Changeset Events
		EVENTS_CHANGESET_CREATED: "vvc.changeset_created",
		EVENTS_CHANGESET_COMPLETED: "com.ibm.team.vvc.events.changesets.completed",
		EVENTS_CHANGESET_RENAMED: "com.ibm.team.vvc.events.changesets.renamed",
		EVENTS_CHANGESET_DISCARDED: "com.ibm.team.vvc.events.changesets.discarded",
		EVENTS_CHANGESET_SHARED: "com.ibm.team.vvc.events.changesets.shared",
		// --------------
		
	}
	
}());
