/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("rmps.app.ui.internal.ClipboardEditorInput");
 
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");

dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal", "ClipboardEditorInputMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal", "ClipboardEditorInputMessages");
 
var DesignUtil = rmps.app.ui.internal.pages.design.DesignUtil;

dojo.declare("rmps.app.ui.internal.ClipboardEditorInput", rmps.ui.editor.EditorInput, {
	
	_hasSidebarExplorer: true,
	
	projectId: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	getName: function() {
		return messages.editor_input_title;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		return DesignUtil.getClipboardUri();
	},

	isRecentlyViewedSupported: function() {
		return false;
	}
});

}());
