/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.ExplorerViewpointEditorInput");

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.core.explorer.ViewpointClient");
dojo.require("rmps.core.explorer.Viewpoint");

dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal", "ExplorerViewpointEditorInputMessages");
var messages= dojo.i18n.getLocalization("rmps.app.ui.internal", "ExplorerViewpointEditorInputMessages");

var ViewpointClient = rmps.core.explorer.ViewpointClient;
var DesignUtil = rmps.app.ui.internal.pages.design.DesignUtil;

dojo.declare("rmps.app.ui.internal.ExplorerViewpointEditorInput", rmps.ui.editor.EditorInput, {
	
	_resourceUri: null,
	_explorerViewpoint: null,
	
	constructor: function(params) {
		if (params.uri) {
			this._resourceUri = params.uri;
		}
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this._resourceUri);
	},
	
	getName: function() {
		if (this._explorerViewpoint) {
			return this._explorerViewpoint.getName();
		}
		return "";
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.app", "graphics/icons/show_viewpoint_co.gif");
	},	
	
	getBasePresentationUri: function() {
		return DesignUtil.getViewpointUri(this._resourceUri);
	},

	getResourceUri: function() {
		return this._resourceUri;
	},
	
	getExplorerViewpoint: function() {
		return this._explorerViewpoint;
	},
	
	isLoaded: function() {
		return this._explorerViewpoint != null;
	},
	
	unload: function() {
		delete this._explorerViewpoint;
	},
	
	load: function() {
		var def;
		if (this._resourceUri) {
			var self = this;
			def = ViewpointClient.getViewpoint(this._resourceUri);
			def.addCallback(function(viewpoint) {
				self._explorerViewpoint = viewpoint;
			});			
		} else {
			// No-op
			def = new dojo.Deferred();
			this._explorerViewpoint = new rmps.core.explorer.Viewpoint(); 
			def.callback(this._explorerViewpoint);
		}
		return def;
	}
});

}());
