/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("rmps.app.ui.internal.OslcContextEditorInput");

dojo.require("rmps.ui.editor.EditorInput");

dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal", "OslcContextEditorInputMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal", "OslcContextEditorInputMessages");

var BASIC_ACTION_PREFIX = "#action=rmps.app.settings.";

/**
 * Editor input class for setting the default OSLC context of a project area.
 */
dojo.declare("rmps.app.ui.internal.OslcContextEditorInput", [rmps.ui.editor.EditorInput], {

	projectConfigurationsInfo: null,

	constructor: function(projectConfigurationsInfo) {
		this.projectConfigurationsInfo = projectConfigurationsInfo;
	},

	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectConfigurationsInfo.projectId);
	},

	getName: function() {
		return messages.editorInputTitle;
	},

	getBasePresentationUri: function()  {
		return BASIC_ACTION_PREFIX + "oslcContext";
	}

});
 
})();