/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("rmps.app.ui.internal.RequestBaselineEditorInput");
 
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.app.core.util");
dojo.require("rmps.app.ui.internal.common.ImageService");
dojo.require("rmps.core.util.IRmpsConstants");

dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal", "RequestBaselineEditorInputMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal", "RequestBaselineEditorInputMessages");
var ImageService= rmps.app.ui.internal.common.ImageService;
 
dojo.declare("rmps.app.ui.internal.RequestBaselineEditorInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	workspaceUri: null,
	workspaceName: null,
	id: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
		this.workspaceUri = params.workspaceUri;
		this.workspaceName = params.workspaceName;
		var s = this.declaredClass + ',' + this.projectId;
		if (this.workspaceUri) {
			s = s + ',' + this.workspaceUri;
		}
		this.id = dojox.encoding.digests.MD5(s);
	},
	
	getId: function() {
		return this.id;
	},
	
	getName: function() {
		// initial default name is in request baseline editor
		return null;
	},

	getWorkspaceUri: function () {
		return this.workspaceUri;
	},
	
	getWorkspaceName: function () {
		return this.workspaceName;
	},
	
	getTooltip: function() {
		return messages.editor_input_tooltip;
	},
	
	getBasePresentationUri: function() {
		return rmps.core.util.IRmpsConstants.ADMIN_REQUEST_BASELINE;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	},
	
	getIconUri: function() {
		return ImageService.BASELINE_EDITOR_ICON;
	}
	
});

})();