/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.SearchQueryEditorInput");

dojo.provide("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.core.querymodel.QueryModelClient");
dojo.require("rmps.core.querymodel.QueryModel");

dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal", "SearchQueryEditorInputMessages");
var messages= dojo.i18n.getLocalization("rmps.app.ui.internal", "SearchQueryEditorInputMessages");

var QueryModelClient = rmps.core.querymodel.QueryModelClient;
var DesignUtil = rmps.app.ui.internal.pages.design.DesignUtil;

dojo.declare("rmps.app.ui.internal.SearchQueryEditorInput", rmps.ui.editor.EditorInput, {
	
	_resourceUri: null,
	_searchQuery: null,
	
	constructor: function(params) {
		if (params.uri) {
			this._resourceUri = params.uri;
		}
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this._resourceUri);
	},
	
	getName: function() {
		if (this._searchQuery) {
			return this._searchQuery.getName();
		}
		return "";
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.app", "graphics/icons/query.gif");
	},	
	
	getBasePresentationUri: function() {
		return DesignUtil.getQueryUri(this._resourceUri);
	},
	
	getResourceUri: function() {
		return this._resourceUri;
	},
	
	getSearchQuery: function() {
		return this._searchQuery;
	},
	
	isLoaded: function() {
		return this._searchQuery != null;
	},
	
	unload: function() {
		delete this._searchQuery;
	},
	
	load: function() {
		var def;
		if (this._resourceUri) {
			var self = this;
			def = QueryModelClient.getQueryModel(this._resourceUri);
			def.addCallback(function(query) {
				self._searchQuery = query;
			});			
		} else {
			// No-op
			def = new dojo.Deferred();
			this._searchQuery = new rmps.core.querymodel.QueryModel(); 
			def.callback(this._searchQuery);
		}
		return def;
	}
});

}());
