/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("rmps.app.ui.internal.StreamEditorInput");
 
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.app.core.util");
dojo.require("rmps.app.ui.internal.common.ImageService");
dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal", "StreamEditorInputMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal", "StreamEditorInputMessages");
var IRmpsConstants= rmps.core.util.IRmpsConstants;
 
dojo.declare("rmps.app.ui.internal.StreamEditorInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	snapshotUri: null,
	id: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
		this.snapshotUri = params.snapshotUri;
		var s = this.declaredClass + ',' + this.projectId;
		if (this.snapshotUri) {
			s = s + ',' + this.snapshotUri;
		}
		this.id = dojox.encoding.digests.MD5(s);
	},
	
	getId: function() {
		return this.id;
	},
	
	getName: function() {
		// initial default name is in Stream editor
		return null;
	},
	
	getSnapshotUri: function () {
		return this.snapshotUri;
	},
	
	getTooltip: function() {
		return messages.editor_input_tooltip;
	},
	
	getBasePresentationUri: function() {
		return IRmpsConstants.ADMIN_STREAM_VIEWER;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	},
	
	getIconUri: function() {
		return rmps.app.ui.internal.common.ImageService.WORKSPACE_ICON;
	}

});

})();
