/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.application.AdminApplication");

dojo.require("com.ibm.team.app.web.internal.AdminApplication");
dojo.require("rmps.app.ui.internal.application.AdminMenu");
/**Need to require this class to load the web initializers*/
dojo.require("rmps.app.core.internal.WebUiInitializers");
dojo.require("rmps.app.ui.internal.util.DmProjectAreaConverter");

dojo.require("jazz.app.ua.internal.client");

/*
 * Update the prototype of JTS ProjectAreaEditor widget such that it has our extensions of it.
 * Other applications such as CCM, RM, QM all get their own copy of the widget
 * Safe to do this here, because AdminApplication is loaded before ProjectAreaEditor widget created 
 */
rmps.app.ui.internal.util.DmProjectAreaConverter.convert();

dojo.declare("rmps.app.ui.internal.application.AdminApplication", com.ibm.team.app.web.internal.AdminApplication, { //$NON-NLS-1$

	_fnGetTopicPrefix: null,
	
	postCreate: function() {
		// Hack to change the info center for CLM topics
		this._fnGetTopicPrefix = jazz.app.ua.internal.client.getTopicPrefix; 
		jazz.app.ua.internal.client.getTopicPrefix = function (id) {
			if (id.indexOf("com.ibm.team") !== -1) {
				// Return the public CLM info center
				var def = new dojo.Deferred();
				def.callback("http://pic.dhe.ibm.com/infocenter/clmhelp/v4r0/index.jsp?topic=");
				return def;
			}
			return this._fnGetTopicPrefix(id);
		}; 
		
		this.inherited(arguments);
	},
	
	_adminMenuProvider: function() {
		return new rmps.app.ui.internal.application.AdminMenu({showProjectProperties: false});
	}
	
});

}());