/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.analysis                                       |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
(function() {
dojo.provide("dm.app.analysis.ui.internal.application.AnalysisActions");

/** Define the page and action prefix for all actions associated with
 *  the DM analysis menu and page. Applications, such as reports,
 *  that extend the analysis page MUST use the page ID and action prefix
 *  defined here.
 *  
 *  @author Kevin Cornell
 */

// Define the actions supported by the base analysis application.
// Other applications such as DM reports can extend this analysis application.

dm.app.analysis.ui.internal.application.AnalysisActions = {
	
	PAGE_ID:       "dm.app.analysis",
	ACTION_PREFIX: "dm.app.analysis.",
	
	// Define the application sections that will extend this
	// base analysis application
	SECTION_REPORTS:		"reports",
	SECTION_TRACEABILITY:	"trace",
	SECTION_IMPACTANALYSIS:	"impact",
	SECTION_VALIDATION:		"validation",
	
	// Define the default analysis actions
	ACTION_DEFAULT:				"_default",
	ACTION_WELCOME:				"welcome",

	_UriPrefix:     "#action=dm.app.analysis.",
		
	
	/* Get the action URI for a given action name.
	 *
	 * @param  actionName
	 * @return the RUI of the action
	 */
	getActionUri: function(actionName) {
		return this._UriPrefix + actionName;
	}
	
  };
})();