/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2014.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
if (dojo.isIE >= 8) {
	// Workaround for IE8 standards mode
	try{
		document.namespaces.add("v","urn:schemas-microsoft-com:vml");
		var vmlElems = ["*", "group", "roundrect", "oval", "shape", "rect", "imagedata"],
			i = 0, l = 1, s = document.createStyleSheet();
		if(dojo.isIE >= 8){
			i = 1;
			l = vmlElems.length;
		}
		for(; i < l; ++i){
			s.addRule("v\\:" + vmlElems[i], "behavior:url(#default#VML); display:inline-block");
		}
	}catch(e){}
}

/* The following meta tag will remove the url header when the
 * web application is running on an iPad - this is desirable
 * but it's problematic ( I think for oauth security )

	var meta = document.createElement('meta');
	meta.name = "apple-mobile-web-app-capable";
	meta.content = "yes"
	headID.appendChild(meta);
*/

/* The following link tag determines the icon used for the
 * home screen link on an ipad
 */

var headID = document.getElementsByTagName("head")[0];

var link = document.createElement('link');
link.rel = "apple-touch-icon";
link.href = dojo.moduleUrl( "rmps.app.ui","internal/application/images/dmbluebutton.png" );
headID.appendChild(link);

(function() {
dojo.provide("rmps.app.ui.internal.application.ModelingApplication");

dojo.require("rmps.app.core.internal.WebUiInitializers");

dojo.require("rmps.app.core.internal.Workarounds");

dojo.require("rmps.core.RootServices");
dojo.require("rmps.core.BackendScr");
dojo.require("rmps.core.util.IRmpsConstants");
dojo.require("com.ibm.team.app.web.RepositoryApplication");
dojo.require("jazz.app.auth");
dojo.require("jazz.app.proxy");
dojo.require("jazz.ui.Dialog");

dojo.require("dojo.i18n");

dojo.require("dojo.io.iframe");

dojo.require("dojo.DeferredList");

dojo.require("jazz.client.xhr");

dojo.require("jazz.core.loader");

dojo.require("rmps.ui.ErrorReportController");
dojo.require("rmps.core.error");
dojo.require("rmps.ui._Styles");

dojo.require("rmps.core.user.UserClient");
dojo.require("rmps.app.ui.internal.util.UrlUtil");

dojo.require("dojox.xml.DomParser");

dojo.require("rmps.app.ui.internal.application.AdminMenu");

dojo.require("com.ibm.team.vvc.shared.web.ui.context.ConfigurationContextBannerButton");
dojo.require("rmps.core.util.ContextUtils");
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
dojo.require("rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog");
dojo.require("rmps.app.ui.internal.util.DomainRegistryUtil");

dojo.require("net.jazz.ajax.viewletServiceRoot");
dojo.require("rmps.app.ui.internal.util.DmProjectAreaConverter");

dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

dojo.requireLocalization("rmps.app.ui.internal.application", "ApplicationMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.application", "ApplicationMessages");
var jfsMessages = dojo.i18n.getLocalization("com.ibm.team.app.web.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var PlatformUI = net.jazz.ajax.ui.PlatformUI;

var JTS_IDENTIFIER = "http://jazz.net/application/jts";

var LOGOUT_REST_SERVICE = "/service/com.ibm.team.repository.service.internal.ILogoutRestService";

dojo.require("jazz.core.loader");

// 40963 - need to preload gfx so that Impact Analysis loads properly
dojo.require("dojox.gfx");
dojo.require("dojox.gfx.Moveable")
dojo.require("dojox.collections.ArrayList");
dojo.require("dojox.dtl.Context");
dojo.require("dojox.dtl.tag.logic");

dojo.requireIf = function relmRequireIf(condition, module) {
	if (condition) {
		jazz.core.loader.load_async(module, function() {
			console.debug('Conditionally include module:' + module); //$NON-NLS-1$
		});
	};
};

/*
 * Update the prototype of JTS ProjectAreaEditor widget such that it has our extensions of it.
 * Other applications such as CCM, RM, QM all get their own copy of the widget
 * Safe to do this here, because AdminApplication is loaded before ProjectAreaEditor widget created 
 */
rmps.app.ui.internal.util.DmProjectAreaConverter.convert();

dojo.declare("rmps.app.ui.internal.application.ModelingApplication", com.ibm.team.app.web.RepositoryApplication, {

	name: messages.productName,
	iconSmall: dojo.moduleUrl("rmps.app", "graphics/DM_16.png"),
	iconLarge: dojo.moduleUrl("rmps.app", "graphics/DM_24.png"),

	_setup: false,

	autoRequestInitData: false,
	applicationContext: null,
	newHref: null,

	constructor: function(args) {
		// ensure the web URI is correct
		var webUri = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "web");
		var uri = String(window.location);
		if (uri.search(new RegExp("^" + webUri, "i")) !== 0) {
			// redirect to web URI
			var pathPrefix = new dojo._Url(webUri).path;
			var idx = uri.search(new RegExp(pathPrefix, "i"));
			window.location = webUri + uri.substr(idx + pathPrefix.length);
		} else {
			if (this._isSetup()) {
				this.fetchInitData();
			}
		}
		
		this.gettingStartedLink = "http://www.ibm.com/support/knowledgecenter/SSB2MU_8.1.0/com.ibm.xtools.rcam_prodover.doc/topics/t_gs_dm.html";
	},

	_fetchUserRolesSuccess: function() {
		this.fetchInitData();
	},
	
	_logout: function (e) {
		
		jazz.client.xhrGet({
			sync: true,
			url: net.jazz.ajax.contextRoot() + '/queryvvc/vvcurl', //$NON-NLS-1$
			handle: dojo.hitch(this, function () {
				var vvcUrl = arguments[1].xhr.getResponseHeader("Location");
				if (dojo.isIE == 8) {
					//In IE 8 the logic in the else block below does not work correctly and
					//we never log out from DM (see 33507: Can't Log out of /dm/web with IE8)
					//so we use a different approach in this case to ensure we log out from
					//both apps.

					//This logic is extracted from the supertype implementation of _logout.
					//Here we need to inject the VVC logout URI to make sure that VVC also
					//logs out to address defect 30095: Logout and log back in as another user
					//in dm/web, it changes back to the old user when going to vvc configuration page
					
					var daLogoutUrl = net.jazz.ajax.contextRoot() + LOGOUT_REST_SERVICE
						+ "?"
						+ "redirectURL=" +  vvcUrl + LOGOUT_REST_SERVICE;
					if (this._logoutObj.href) {
						daLogoutUrl = daLogoutUrl + "?"
								+ "redirectURL=" + this._logoutObj.href;
					} else {
						daLogoutUrl = daLogoutUrl + "?"
								+ "redirectURL="
								+ document.location;
					}
					document.location = daLogoutUrl;

				} else {
					var logoutUrl = vvcUrl + LOGOUT_REST_SERVICE;
	
					var iframe = document.createElement("iframe");
					iframe.style.display = "none";
					iframe.src = logoutUrl;
					iframe.onload = dojo.hitch(this, this._logoutContinue);
					document.body.appendChild(iframe);
				}
			})
		});
		
		return false;
	},
	
	
	// this function is a copy of ..._logout. Since we don't want to return control to _logout,
	// we have to reproduce it here.
	_logoutContinue: function () {
		var logoutObj = this._logoutObj;
//		if (net.jazz.ajax.isDelegatingAuthentication()) {
// We assume that DM has it
			var daLogoutUrl = net.jazz.ajax.contextRoot() + LOGOUT_REST_SERVICE;
			if (logoutObj.href) {
				daLogoutUrl = daLogoutUrl + "?"
						+ "redirectURL=" + logoutObj.href;
			} else {
				daLogoutUrl = daLogoutUrl + "?"
						+ "redirectURL="
						+ document.location;
			}
			document.location = daLogoutUrl;
//		} else {
//			var logoutDef = jazz.app.auth.logout();
//			logoutObj.href
//					&& logoutDef.addCallback(function() {
//						document.location = logoutObj.href;
//					});
//			logoutDef.addErrback(function(err) {
//				if (logoutObj.href) {
//					document.location = logoutObj.href;
//				} else {
//					var error = messages.logoutError;
//					if (err && err.status == 404) {
//						error += "\n\n"
//								+ messages.basicAuthWarn;
//					}
//					alert(error);
//				}
//			});
//		}
	},
	
	_logoutObj: null,
	
	start: function() {
		this.config.user.uri = this.config.user.userId ? rmps.core.user.UserClient.getUserUri(this.config.user.userId) : "";

		// Setting up logout.
		//
		// Currently JTS doesn't notify applications when one of them logs user out (see WI 140166)
		//
		// Dirty hack to make VVC logout too:
		// We should load VVC's ILogoutRestService directly, without using proxy,
		// so client will have correctly updated cookies. We couldn't use xhrGet because of
		// cross-domain policy.
		// So we just create an iframe that'll load VVC's ILogoutRestService. To let it actually load
		// the url we shouldn't let jazz logout to continue immediately, since it changes window's url
		// before our iframe is loaded. So we hook on iframe.onload and do logout by ourselves.
		//
		// this._logout() creates a frame to load VVC's ILogoutRestService
		// this._logoutContinue() performs the standard Jazz logout sequence after that
		this.config.logout = this._logoutObj = {callback: dojo.hitch(this, this._logout)};
	
		// check if we should go to landing page
		var context = jazz.app.context.get();
		if (context && !context.name) {
			// Go to home link
			window.location.href = this.getHomeLink();
			return;
		}
		

		/*
		 * No context supplied need open project
		 * area list. Done in initContext() in the
		 * super. Override here, because navigation
		 * to that page happens in the start()
		 * function called at the end of the
		 * initContext()
		 */
		
		// Suppress the 'Settings' page since it's accessible from admin menu.
		var sp = dojo.getObject("com.ibm.team.repository.web.suppressedPages");
		if (sp) {
			var spIsString = dojo.isString(sp);
			if (spIsString) {
				sp = dojo.fromJson(sp);
			}
			var appId = PlatformUI._getApplicationId();
			var spa = sp[appId];
			if (!spa) {
				sp[appId] = spa = [];
			}
			if (dojo.indexOf(spa, "rmps.app.settings") === -1) {
				spa.push("rmps.app.settings");
			}
			dojo.setObject("com.ibm.team.repository.web.suppressedPages", spIsString ? dojo.toJson(sp) : sp);
		}
		
		this._initializeContextSelector();
		
		// if we are on a deleted/committed changeset context, 
		// display a dialog and redirect to parent when the dialog is closed
		if (this.newHref){
			var dialogContent = document.createElement("div");
			dialogContent.innerHTML = '<div>' + messages.redirectToParent + '</div><br>'+
			'<table align=right>' +
				'<tr>' +
					'<td><button dojoAttachPoint="_closeButton">' + messages.closeButton + '</button></td>' +
				'</tr>' +
			'</table>';
			
			dojo.connect(dialogContent._closeButton, "onclick",  dojo.hitch(this, this._navigateToParent));

			new jazz.ui.Dialog({
				primaryTitle: messages.redirectTitle,
				isClosable: true,
				contentNode: dialogContent,
				onClose: dojo.hitch(this, this._navigateToParent)
			});
		} else {
			this.inherited(arguments);

			// handle return from configuration creation
			var uri = window.location.href;
			var pattern = "&creatingConfiguration=";
			var i = uri.indexOf(pattern);
			if (i != -1) {
				var configName = unescape(decodeURIComponent(uri.substring(i + pattern.length)));
				var msg = dojo.string.substitute(messages.creatingConfiguration, [ configName ]);
				var action = dojo.string.substitute(messages.creatingConfigurationAction, [ configName ]);
				rmps.core.error.createInfo(msg, action).dispatch();
			}
		}
	},

	_navigateToParent: function()
	{
		window.location.href = this.newHref;
	},

	_initializeContextSelector: function()
	{
		var deferred = this._getSpace();
		if (deferred) {
			deferred.addCallback(dojo.hitch(this, function (ioArgs) {
				com.ibm.team.vvc.shared.web.ui.context.ContextUtils.setSpace(ioArgs.xhr.getResponseHeader("Location"));
				var d2 = this._getConfiguration();
				d2.addCallback(dojo.hitch(this, function (configuration) {
					if (configuration === "" && this.applicationContext.changeset){
						// if the changeset configuration does not exist anymore remove the changeset parameter from the uri
						this.newHref = this._removeChangesetFromUri();
					} else {
						//to avoid needlessly resolving the second deferred when configuration === "", we do not make a deferred list
						var expandedContextUri = rmps.core.util.ContextUtils.getExpandedContext();
						if (expandedContextUri) {
							var d3 = ContextUtils.getConfigurationAsync(expandedContextUri);
							d3.addCallback(dojo.hitch(this, function (expandedConfiguration) {
								com.ibm.team.vvc.shared.web.ui.context.ContextUtils.setCurrentContext(configuration, expandedConfiguration);
								//Inform anyone that's interested that we're done initializing the context.
								dojo.publish("vvc.context_initialized", [configuration]);
							}));
							//TODO add errback when expanded configuration is gone, and inform user that they are redirected to the configuration without the expandedConfiguration 
						} else {
							com.ibm.team.vvc.shared.web.ui.context.ContextUtils.setCurrentContext(configuration);
							//Inform anyone that's interested that we're done initializing the context.
							dojo.publish("vvc.context_initialized", [configuration]);
						}
						return null;
					}
				}));
			}));
		}
		return deferred;
	},
	
	_removeChangesetFromUri: function(){
		
		// matches only ?changeset=.....&
		var pattern1 = /[?]changeset=.*[&]/;
		
		/* matches all cases
		 *    ?changeset=.....&
		 *    ?changeset=.....#
		 *    ?changeset=..... (last parameter in the uri)
		 *    &changeset=.....&
		 *    &changeset=.....#
		 *    &changeset=..... (last parameter in the uri)
		 */ 
		var pattern2 = /([?|&])(changeset=.*([#|&])|changeset=.*$)/;
		if(window.location.href.match(pattern1)){
			// if changeset is the first parameter in a multi-parameter chain, replace it by ?
			return window.location.href.replace(pattern1,'?'); 
		} else {
			// otherwise replace by the end separator, or "" if it was the last parameter
			var matches = pattern2.exec(window.location.href);
			var replacement = (matches[3])?matches[3]:"";
			return window.location.href.replace(pattern2,replacement); 
		}		
	},

	onContextChange: function(configuration, expandedConfiguration) {
		var rmpsUri = rmps.core.util.ContextUtils.getContextUriFromVvcContextUri(configuration.uri)
		//DM may implement something similar to this if desired; however I do not see the point of the separate DM url var expandedRmpsUri = (expandedConfiguration && expandedConfiguration.uri) ? rmps.core.util.ContextUtils.getContextUriFromVvcContextUri(expandedConfiguration.uri) : undefined;
		var expandedRmpsUri = expandedConfiguration ? expandedConfiguration.uri : undefined; 
		if (rmpsUri) {
			if (expandedRmpsUri) {
				rmps.core.util.ContextUtils.setContext(rmpsUri, null, expandedRmpsUri);
			} else {
				rmps.core.util.ContextUtils.setContext(rmpsUri, null);
			}
		}
	},

	getRedirect: function() {
		var projectId = jazz.app.context.get().itemId;
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");

		return link + "/redirectfromcreation?projectId=" + projectId;
	},

	_getConfiguration: function() {
		var contextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		var changesetUri = rmps.core.util.ContextUtils.getCurrentChangesetURI();
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");
		
		if (changesetUri) {
			link += "/configfromchangeset?context=" + escape(changesetUri);
		}else if (rmps.core.util.ContextUtils.isSnapshot(contextUri)) {
			link += "/configfromsnapshot?context=" + escape(contextUri);
		} else {
			link += "/configfromworkspace?context=" + escape(contextUri);
		}
		var projectUri = jazz.app.context.get().uri;

		var args = {
			handleAs: 'json',
			url: link,
			sync: true,
			headers: {
				"projectUri" : projectUri
			},
			load: function(response, ioArgs) {
				return response;
			},
			error: function(response, ioArgs) {
				var error = rmps.core.error.createXhrError(ioArgs);
				if (ioArgs.xhr.status === 403){
					var dialog = new rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog();
					dialog.show(messages.noConfigurationPermission);					
				} else if (error.subStatus == "INVALID_CONFIGURATION_CONTEXT") {
					var defWorkspaceUri = ioArgs.xhr.getResponseHeader("Location");
					var dialog = new rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog();
					dialog.show(error.message, defWorkspaceUri);
				} else {
					error.dispatch();
				}
			}
		};
		return jazz.client.xhrGet(args);
	},

	_getSpace: function() {
		var contextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		if (!contextUri) {
			return null;
		}
		var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");
		if (rmps.core.util.ContextUtils.isSnapshot(contextUri)) {
			link += "/spacefromsnapshot?context=" + escape(contextUri);
		} else {
			link += "/spacefromworkspace?context=" + escape(contextUri);
		}

		var args = {
			url: link,
			sync: true,
			load: function(response, ioArgs) {
				return ioArgs;
			},
			error: function(response, ioArgs) {
				rmps.core.error.createXhrError(ioArgs);
				if (ioArgs.xhr.status === 403){
					var dialog = new rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog();
					dialog.show(messages.noConfigurationPermission);					
				} else {
					error.dispatch();
				}
			}
		};
		return jazz.client.xhrGet(args);
	},

	getHomeLink: function() {
		return rmps.core.RootServices.getUri(rmps.core.Namespaces.JDB, "dashboards"); //$NON-NLS-1$
	},
	
	initContext: function() {
		var errorReport = new rmps.ui.ErrorReportController();
		errorReport.startup();
		this.inherited(arguments);
		if (this.ui.containerNode.firstChild) {
			this.ui.containerNode.insertBefore(errorReport.domNode, this.ui.containerNode.firstChild);
		} else {
			this.ui.containerNode.appendChild(errorReport.domNode);
		}
		var context = this.getCurrentContext();
		if (context && context.itemId) {
			// Only add the VVC banner button if we're in a project context.
			var bannerButtons = this.ui.get("bannerRight");
	
			if (bannerButtons)
			{
				var args = {};
				args.workspaceBasedOffSnapshotOnly = false;
				args.redirectUriSelector = this.getRedirect;
				args.app = this;
				this.contextBannerButton = new rmps.app.ui.internal.application._ConfigurationContextBannerButton(args);
				this.contextBannerButton.onContextChange = this.onContextChange;
				var pipeNode = document.createElement("span");
				dojo.addClass(pipeNode, 'pipe');
				pipeNode.innerHTML = "|";
				dojo.place(pipeNode, bannerButtons.domNode, "first");
				dojo.place(this.contextBannerButton.domNode, bannerButtons.domNode, "first");
			}
		}
	},
	
	getCurrentContext: function() {
		if (this.applicationContext) {
			/*Required to track the baseline changes while working */
			this.applicationContext.baseline = this._getBaselineFromUrl();
			this.applicationContext.changeset = this._getChangesetFromUrl();

			return this.applicationContext;
		}
		this.applicationContext = this.inherited(arguments);
		/*Required to track the baseline changes while working */
		this.applicationContext.baseline = this._getBaselineFromUrl();
		this.applicationContext.changeset = this._getChangesetFromUrl();
		if (this.applicationContext.name) {
			var self = this;
			var args = {
				url: rmps.core.RootServices.getUri(rmps.core.Namespaces.JP_0_6, "projectAreas"),
				 /*
				 * Handle as XML (not parasable text) due to that dojo bug:
				 *
				 * http://bugs.dojotoolkit.org/ticket/14290
				 *
				 * But make sure to deal with the behaviour differences in XML manipulation
				 *
				 */
				handleAs: "xml",
				load: function(doc, ioArgs) {

					/*
					 * Required for WebKit browsers (Safari, Chrome, etc). We do not use the prefix when getting the elements by tag name (when using the
					 * method getElementsByTagName). Thus, in order to maintain the same behavior on all browsers versions, we use our method, till 14290
					 * is resolved
					 *
					 */
					var getNode = function(parentNode, tagName) {
						var list = [];
						var childNodes = parentNode.childNodes;

						/*no need to check for childNodes being defined */
						var length = childNodes.length;

						for(var index = 0; index < length; index++) {
							var current = childNodes[index];
							if (current.tagName === tagName) {
								list.push(current);
							}
						}
						return list;
					};

					var projectsMainNode = getNode(doc, "jp06:project-areas")[0];

					var projects = getNode(projectsMainNode, "jp06:project-area");

					var pas = [];
					for (var i = 0, p; p = projects[i]; ++i) {
						var c = {};
						pas.push(c);
						c.name = p.getAttribute("jp06:name");

						c.archived = getNode(p, "jp06:archived")[0].childNodes[0].nodeValue === true;
						c.uri = getNode(p, "jp06:url")[0].childNodes[0].nodeValue;
						var segments = c.uri.split('/');
						c.itemId = segments[segments.length - 1];
						if (c.name === self.applicationContext.name) {
							self.context = c.uri;
						}
					}
					self.config.projectAreas = pas;

				}
			};
			jazz.client.xhrGet(args);
		}

		return this.applicationContext;
	},

	_isSetup: function() {
		if (net.jazz.ajax.viewletServiceRoot()) {
			return true;
		}
		this.ui._homeMenu.style.display = this.ui._searchArea.style.display = "none";
		this.config.showLoginLogout = false;
		this.onFailure(null, messages.setupError);
		return false;
	},

	_getBaselineFromUrl: function() {
		var curUrl = new dojo._Url(location.href);
		var query = curUrl.query;
		if (query) {
			var queryParameters = dojo.queryToObject(query.substring(query.indexOf("?") + 1, query.length));
			var contextUri = queryParameters[rmps.core.util.IRmpsConstants.BASELINE];
			if (contextUri instanceof Array) {
				contextUri = contextUri[0];
			}

			//for backwards compatibility with 3.0, convert internal baseline URL to front side URL
			if (contextUri) {
				var jtsBaselineUrl = rmps.core.RootServices.getUri(rmps.core.Namespaces.JFS_1_0, "baselines");
				if (contextUri.indexOf(jtsBaselineUrl !== -1)) {
					contextUri = contextUri.replace(jtsBaselineUrl, rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "dm-baselines"));
				}
			}
			return contextUri;
		} else {
			return null;
		}
	},
	_getChangesetFromUrl: function() {
		var curUrl = new dojo._Url(location.href);
		var query = curUrl.query;
		if (query) {
			var queryParameters = dojo.queryToObject(query.substring(query.indexOf("?") + 1, query.length));
			var contextUri = queryParameters[rmps.core.util.IRmpsConstants.CHANGESET];
			return contextUri;
		} else {
			return null;
		}
	},

	_adminMenuProvider: function() {
		return new rmps.app.ui.internal.application.AdminMenu({showProjectProperties: this.context != null});
	},
	
	_helpMenuProvider: function() {
		var menu = new jazz.app._ComponentMenu();
		var helpuri = "http://www.ibm.com/support/knowledgecenter/SSB2MU_8.1.0/com.ibm.dm.legal.doc/helpindex_dm.html";
		if (helpuri) {
			this.helpuri = helpuri;
			menu.addItemByArgs({label: jfsMessages.helpContents, icon: dojo.moduleUrl("jazz.app","graphics/JazzUI/icons/systemhelp.gif"), onClick: dojo.hitch(this,this._openHelpContents)});
		}
		if (this.gettingStartedLink)
			menu.addItemByArgs({label: jfsMessages.gettingStarted, href: this.gettingStartedLink});
		menu.addItemByArgs({label: jfsMessages['jazz.net'], href: "https://jazz.net/forum/tags/design-management/"});
		menu.addItemByArgs({label: jfsMessages['jazz.net/forum'], href: "https://jazz.net/forum"});
		menu.addItemByArgs({label: this._aboutStr, onClick: dojo.hitch(this,this._openAboutBox)});
		return menu;
	}
});


dojo.declare("rmps.app.ui.internal.application._ConfigurationContextBannerButton", [com.ibm.team.vvc.shared.web.ui.context.ConfigurationContextBannerButton], {

	_isDmManaged: null,
	_isUserDsp: null,
	
	postCreate: function() {
		var contextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		if (contextUri == null) {
			if (this._button && this._button.parentNode) {
				var container = this._button.parentNode;
				var link = dojo.create("span");
				link.innerHTML = messages.configureSpace;
				link.style.cursor = "pointer";
				dojo.addClass(link, "com-ibm-team-vvc-shared-web-banner-button-label");
				container.appendChild(link);
				dojo.connect(container, "onclick", this, "_onConfigureSpace");
			    dojo.connect(container, "onkeypress", this, "_onKeyPress");
				return;
			}
		}
		
		// initialize dm manage flag and the DSP project flag
		var context = com.ibm.team.vvc.shared.web.ui.context.ContextUtils.getCurrentContext();
		if (context != null && context.isMutable()) {
			
			var defManaged = new dojo.Deferred();
			var defDsp     = new dojo.Deferred();
			
			var managedCallback = dojo.hitch(this, function(isDmManaged, error) {
				if (!error) {
					this._isDmManaged = isDmManaged;
				}
				defManaged.callback();
			});
			
			var dspCallback = dojo.hitch(this, function(isDsp, isSystemDsp) {
				this._isUserDsp = isDsp && !isSystemDsp;
				defDsp.callback();
			});
			
			/* Once we know whether we're actively managed, or a DSP, update the
			 * Context Banner Buttons appropriately.
			 */
			var defList = new dojo.DeferredList([defManaged, defDsp]);
			defList.addCallback(dojo.hitch(this, function() {
				this._toggleMenuItems();
			}));
			
			rmps.app.ui.internal.util.DomainRegistryUtil.isProjectActivelyManaged(managedCallback);
			rmps.app.ui.internal.util.DomainRegistryUtil.isCurrentProjectDSP(dspCallback);
		}
		
		this.inherited(arguments);
	},
	
	_onClick: function(event) {
		if (this._menuPopup) {
			this.inherited(arguments);
		}
	},
	
	onChange: function(item) {
		if (this._isValidConfiguration(item.configuration)) {
			this.inherited(arguments);
		}
	},
	
	_toggleMenuItems: function() {
		this.inherited(arguments);
		var canCreateChangeSet = this._isDmManaged || this._isUserDsp;
		var context = com.ibm.team.vvc.shared.web.ui.context.ContextUtils.getCurrentContext();
		if (context && context.isMutable() && !canCreateChangeSet) {
			if (this._createChangesetsMenuItem && this._createChangesetsMenuItem.setDisabled) {
				this._createChangesetsMenuItem.setDisabled(true);
			}
			if (this._completeChangesetMenuItem && this._completeChangesetMenuItem.setDisabled) {
				this._completeChangesetMenuItem.setDisabled(true);
			}
			if (this._commitChangesetMenuItem && this._commitChangesetMenuItem.setDisabled) {
				this._commitChangesetMenuItem.setDisabled(true);
			}
		}
	},
	
	_isValidConfiguration: function(vvcConfiguration) {
		var valid = true;
		var contextUri = rmps.core.util.ContextUtils.getCurrentContextURI();
		if (contextUri != null) {
			var projectUri = jazz.app.context.get().uri;
			var params = {};
			params.projectUri = projectUri;
			params.configurationUri = vvcConfiguration.uri;
			var link = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc")
					+  "/validateSelectedContext?" + dojo.objectToQuery(params);

			// validate the new configuration is existing in current project
			var args = {
				handleAs: 'json',
				url: link,
				sync: true,
				headers: {
					"projectUri" : projectUri
				},
				load: function(response, ioArgs) {
					return response;
				},
				error: function(response, ioArgs) {
					valid = false;
					var error = rmps.core.error.createXhrError(ioArgs);
					if (error.subStatus == "INVALID_CONFIGURATION_CONTEXT") {
						var defWorkspaceUri = ioArgs.xhr.getResponseHeader("Location");
						var dialog = new rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog();
						dialog.show(error.message, defWorkspaceUri);
					} else {
						error.dispatch();
					}
				}
			};
			jazz.client.xhrGet(args);
		}
		return valid;			
	},
	
	_onKeyPress: function(e) {
		if(e.keyCode === dojo.keys.ENTER) { 
			this._onConfigureSpace();
		}
	},
	
	_onConfigureSpace: function() {
		window.location.href = rmps.core.util.ContextUtils.getConfigureContextURL();
	},
	
	_newSnapshot:function()
	{
		this._newConfigurationForm({type: "snapshot", validParentTypes: "workspace"});
	},
	
	_newWorkspace: function()
	{
		this._newConfigurationForm({type: "workspace", validParentTypes: "snapshot"});
	}
	
});

})();