/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.reports.ui.internal.application.ReportActions");

/** Define the actions for the Reports section of analysis.
 * 
 * @author Kevin Cornell
 */

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;

dm.app.reports.ui.internal.application.ReportActions = {
	
	REPORTS_APP:   "dm.app.reports",
	
	// Use the same page ID and action prefix and the base analysis page.
	PAGE_ID:       AnalysisActions.PAGE_ID,
	ACTION_PREFIX: AnalysisActions.ACTION_PREFIX,

	// Define the reporting specific actions
	// These actions must all be defined in the ReportPageController.
	ACTION_CREATE_REPORT:		"reports_createReport",
	ACTION_DEPLOY_TEMPLATES:	"reports_deployTemplates",
	ACTION_EDIT_REPORT:			"reports_editReport",
	ACTION_EDIT_TEMPLATE:		"reports_editTemplate",
	ACTION_VIEW_REPORTS:		"reports_viewReports",
	ACTION_VIEW_TEMPLATES:		"reports_viewTemplates",
		
	/* Get the action URI for a given action name.
	 *
	 * @param  actionName
	 * @return the RUI of the action
	 */
	getActionUri: function(actionName) {
		return AnalysisActions.getActionUri(actionName);
	}
	
  };

})();