/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2013.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.reports.ui.internal.application.ReportPageInitializer");

/** Initialize the base Analysis page by registering the actions for
 *  the Reports application.
 *  
 *  @author Kevin Cornell
 */

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");
dojo.require("dm.app.analysis.ui.internal.application.AnalysisPage");

dojo.require("dm.app.reports.ui.internal.application.ReportActions");
dojo.require("dm.app.reports.ui.internal.application.ReportPageController");

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;
var ReportActions = dm.app.reports.ui.internal.application.ReportActions;

/** Add the report actions to the analysis page */
dojox.lang.aspect.advise(dm.app.analysis.ui.internal.application.AnalysisPage, "registerExtendedActions", {
	
	// private variables
	_reportPageContoller: null,
	
	after: function() {
		var page = dojox.lang.aspect.getContext().instance;

		// If this call is for report actions to be registered
		if (page.getCurrentSection() === AnalysisActions.SECTION_REPORTS) {
			this._reportPageContoller = new dm.app.reports.ui.internal.application.ReportPageController(page);
			
			page.registerActionEditor( 
					ReportActions.ACTION_CREATE_REPORT, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.CreateReport",
					"dm.app.reports.ui.internal.pages.CreateReportInput");

			page.registerActionEditor( 
					ReportActions.ACTION_DEPLOY_TEMPLATES, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.DeployTemplates",
					"dm.app.reports.ui.internal.pages.DeployTemplatesInput");

			page.registerActionEditor( 
					ReportActions.ACTION_EDIT_REPORT, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.ReportEditor",
					"dm.app.reports.ui.internal.pages.ReportEditorInput");

			page.registerActionEditor( 
					ReportActions.ACTION_EDIT_TEMPLATE, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.TemplateEditor",
					"dm.app.reports.ui.internal.pages.TemplateEditorInput");

			page.registerActionEditor( 
					ReportActions.ACTION_VIEW_REPORTS, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.ReportBrowser",
					"dm.app.reports.ui.internal.pages.ReportBrowserInput");

			page.registerActionEditor( 
					ReportActions.ACTION_VIEW_TEMPLATES, 
					this._reportPageContoller,
					"dm.app.reports.ui.internal.pages.TemplateBrowser",
					"dm.app.reports.ui.internal.pages.TemplateBrowserInput");
		}
	}
});


})();