/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.comment.SketchContribution");

dojo.require("rmps.ui.commenting.CommentContributionRegistry");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal.comment", "SketchContributionMessages");

var SKETCH_TYPE = "image/svg+xml";

dojo.declare("rmps.app.ui.internal.comment.SketchContribution", null, {

	createContribution: function(comment) {
		for (var i = 0; i < comment.bodies.length; ++i) {
			if (comment.bodies[i].type == SKETCH_TYPE) {
				return new rmps.app.ui.internal.comment._SketchContributionWidget();
			}
		}
		return null;
	}
});

dojo.declare("rmps.app.ui.internal.comment._SketchContributionWidget", [dijit._Widget, dijit._Templated], {
	
	messages: dojo.i18n.getLocalization("rmps.app.ui.internal.comment", "SketchContributionMessages"),
	
	iconUrl: dojo.moduleUrl("rmps.app", "graphics/icons/sketch_added.gif"),
	
	templateString: '<div class="rmps-app-comment-sketchContribution">' +
			'<img src="${iconUrl}" style="float: left; margin-right: 6px;">' +
			'<span style="position: relative; top: 1px;">${messages.sketchPresent}</span>' +
			'</div>'
});

// register the sketch contribution provider
rmps.ui.commenting.CommentContributionRegistry.registerProvider("rmps.app.ui.internal.comment.SketchContribution");

})();
