/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("rmps.app.ui.internal.common.ContextInitializer");
	dojo.require("rmps.core.util.IRmpsConstants");
	dojo.require("jazz.app.context");
	
	/**
	 * This is an initialization utility that ensures that the application context retrieves
	 * the rmps context from the page's uri during initialization of the web application.
	 * 
	 * This initializer combined with the server-side code in the ModelingStatusHandler makes
	 * sure that a context is always used when talking to the rmps server-side services.
	 * 
	 * Both changes were introduced to address the following defect:
	 * 		23625: Default context should not be set when the context picker is initialized
	 */
	rmps.app.ui.internal.common.ContextInitializer = {
		initContext: function(uri) {
			var query = uri.substring(uri.indexOf("?") + 1, uri.length);
			var queryObject = dojo.queryToObject(query);
			if (queryObject[rmps.core.util.IRmpsConstants.BASELINE]) {
				var appContext = jazz.app.context.get();
				appContext.baseline = queryObject[rmps.core.util.IRmpsConstants.BASELINE];
			}
		}
	};
	
	rmps.app.ui.internal.common.ContextInitializer.initContext(window.location.search);
})();
