/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("dm.review.app.ui.internal.dialogs.ChangeElementStatusForm");

dojo.require("dojo.i18n");	
dojo.require("dijit.form.Form");
dojo.require("rmps.ui.DialogForm");
dojo.require("dijit.form.Button");
dojo.require("rmps.core.review.util.ReviewTypes");

var ReviewTypes = rmps.core.review.util.ReviewTypes;

dojo.requireLocalization("dm.review.app.ui.internal.dialogs", "ChangeElementStatusFormMessages");

dojo.declare("dm.review.app.ui.internal.dialogs.ChangeElementStatusForm", rmps.ui.DialogForm,{
	
	templateString: dojo.cache("dm.review.app", "ui/internal/dialogs/templates/ChangeElementStatusForm.html"),
	
	artifactStatusType: null,
	messages: null, 
	
	postMixInProperties: function() {
		this.messages = dojo.i18n.getLocalization("dm.review.app.ui.internal.dialogs", 
					"ChangeElementStatusFormMessages");
	},
	
	postCreate: function(){				
		this.inherited("postCreate", arguments);
		this._createOptions();
	},
	
	
	_createOptions: function(){
		var currentParticipant= this.review.getUserResults(this.review.myUserURI);
		
		switch (currentParticipant.reviewRole) {
			case ReviewTypes.PARTICIPANT_ROLE_TYPES.Approver:
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.Approved,
						this.messages.statusApproved));
						
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.Disapproved,
						this.messages.statusDisapproved));
				break;
			case ReviewTypes.PARTICIPANT_ROLE_TYPES.RequiredReviewer:
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.Reviewed,
						this.messages.statusReviewed));
						
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.ReviewedComments,
						this.messages.statusReviewedComments));
						
				break;
			case ReviewTypes.PARTICIPANT_ROLE_TYPES.OptionalReviewer:
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.Reviewed,
						this.messages.statusReviewed));
				this._statusDropDownList.appendChild(this._createNewOption(ReviewTypes.ARTIFACT_STATUS_TYPES.Abstained,
						this.messages.statusDisapproved));
				break;
		}
	},
	
	_createNewOption: function(value, label){
		var option = document.createElement("option");
        option.value = value;
        option.appendChild(document.createTextNode(label));
        return option;
	},
	
	show: function() {	
		this.inherited(arguments);				
		this._statusDropDownList.focus();
	},
	
	getOkParamaters: function(){
		return this._statusDropDownList.options[this._statusDropDownList.selectedIndex].value;
	},
	
	getDialogArguments: function(){
		return {
			contentNode: this._changeArtifactStatusForm,
			primaryTitle: this.messages.changeArtifactStatusTitle,
			destroyContents: true,
			width: "400px"
		};
	}
});

})();
