/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("rmps.app.ui.internal.dialogs.InfoContent");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojo.i18n");
    dojo.require("jazz.ui.Dialog");
    
    dojo.requireLocalization("rmps.app.ui.internal.dialogs", "InfoContentMessages");
    
    dojo.declare("rmps.app.ui.internal.dialogs.InfoContent", [dijit._Widget, dijit._Templated], {
        templateString: dojo.cache("rmps.app", "ui/internal/dialogs/templates/InfoContent.html"),
        
        constructor: function(params){
            this.messages= dojo.i18n.getLocalization("rmps.app.ui.internal.dialogs", "InfoContentMessages");
            this.buttonOk = this.messages.buttonOK;
            this.setInfo();
        },

        setInfo: function(){
        	/*Abstract Method */
        },
        
        destroy: function(){
            dojo.forEach(this._childWidgets, function(widget){
                widget.destroy();
            });
            this.inherited(arguments);
        },
        
        _handleOk: function(){
            this.onCancel();
        }
    });
    
})();
