/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function() {
dojo.provide("rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog");

dojo.require("jazz.ui.Dialog");
dojo.require("rmps.core.util.IRmpsConstants");

dojo.requireLocalization("rmps.app.ui.internal.dialogs", "InvalidConfigurationContextDialogMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.dialogs", "InvalidConfigurationContextDialogMessages");

dojo.declare("rmps.app.ui.internal.dialogs.InvalidConfigurationContextDialog", [dijit._Widget, dijit._Templated], {
	
	messages: messages,
	widgetsInTemplate: true,
	templateString: "<div dojoAttachPoint='contentNode' style='margin: 10px 10px 30px 10px;'>"
		+ "<div dojoAttachPoint='_messageContainer'></div><br/>"
		+ "<div style='float: right'>"
		+ "<input type='button' dojoAttachPoint='okButton' style='width:80px; margin-right: 10px;' align='right' value='${messages.buttonOk}'/>"
		+ "</div>"
		+ "</div>",
	_defaultWorkspaceUri: null,
	_defaultUri: rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "web"),
	
	show: function (message, defWorkspaceUri) {
		this._defaultWorkspaceUri = defWorkspaceUri;
		
		var textNode = this._messageContainer;
		textNode.appendChild(dojo.doc.createTextNode(message));
		textNode.appendChild(dojo.create("br"));
		textNode.appendChild(dojo.create("br"));
		if (defWorkspaceUri && query[rmps.core.util.IRmpsConstants.BASELINE] !== defWorkspaceUri) {
			textNode.appendChild(dojo.doc.createTextNode(messages.redirectToDefaultConfig));
		} else {
			textNode.appendChild(dojo.doc.createTextNode(messages.redirectToHome));
		}
		
		// show dialog
		this.dialog = new jazz.ui.Dialog({
			contentNode: this.contentNode,
			primaryTitle: messages.title,
			closable: false,
			closeOnEsc: false,
			onClose: dojo.hitch(this, this.close),
			width: "500px"
		});
		
		this.connect(this.okButton, "onclick",  this.okPressed);
	},
	
	okPressed: function() {
		this.closeDialog();
	},
	
	closeDialog: function() {
		if (this.dialog) {
			this.dialog.close();
		}
	},
      
	close: function() {
		if (this._defaultWorkspaceUri) {
			var currentURL = location.search;
			var params = currentURL.substring(currentURL.indexOf("?") + 1, currentURL.length);
			var query = dojo.queryToObject(params);
			if (query[rmps.core.util.IRmpsConstants.BASELINE] === this._defaultWorkspaceUri) {
				// if the default workspace is the invalid configuration go to the home page
				window.location.href = this._defaultUri;
			} else {
				query[rmps.core.util.IRmpsConstants.BASELINE] = this._defaultWorkspaceUri;
				window.location.search = dojo.objectToQuery(query);
			}
		} else {
			// Go to the home page
			window.location.href = this._defaultUri;
		}
	},
	
	uninitialize: function() {
		if (this.dialog) {
			this.dialog.destroy();
		}
	}   
});
})();
