/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("rmps.app.ui.internal.dialogs.NoProjectLinksFoundContent");

    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojo.i18n");
    dojo.require("rmps.app.ui.internal.dialogs.InfoContent");
    dojo.require("rmps.app.ui.ProjectLinkingEditorUtil");

    dojo.requireLocalization("rmps.app.ui.internal.dialogs", "NoProjectLinksFoundContentMessages");

    dojo.declare("rmps.app.ui.internal.dialogs.NoProjectLinksFoundContent", rmps.app.ui.internal.dialogs.InfoContent, {

		setInfo: function(){
			var self= this;
			this.messages= dojo.i18n.getLocalization("rmps.app.ui.internal.dialogs", "NoProjectLinksFoundContentMessages");
			jazz.client.xhrGet({
				url: rmps.core.BackendScr.get().getUriForPath([
					{namespace: rmps.core.Namespaces.JUENTRY, name: "JTSApplicationAdminLinksService"},
					{namespace: rmps.core.Namespaces.JD_1_0,name: "service"}
				]),
				headers: {
					"Accept": "application/rdf+json",
					"X-ibm-rmps-internal": "true"
				},
				sync: true,
				handleAs: "json",
				load: dojo.hitch(this, function(response) {
					var projectArea= response.projectArea.url;
					this.contentNode = dojo.string.substitute(self.messages.AddProjectLinkDialogHTML_NoProjectLinksFound, [projectArea]);
				})
			});
        },

        getIsOnDebug: function(){
        	if(this.isDebug()){
        		return "?debug=true";
        	}
        	return "";
        },

        isDebug: function() {
	    	var qstr = window.location.search.substr(1);
	    	if (qstr.length) {
	    		var qparts = qstr.split("&");
	    		for (var x = 0; x < qparts.length; x++) {
	    			var tp = qparts[x].split("=");
	    			if (tp[0] == "debug") {
	    				return tp[1] === "true";
	    		}
	    	}
	    	}
    	}
    });

})();
