/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.editors.ClipboardEditor");

dojo.require("rmps.app.ui.internal.editors.BaseEditor");
dojo.require("rmps.ui.clipboard.ClipboardTable");
dojo.require("rmps.ui.clipboard.ClipboardWidget");

var UA_KEY = "com.ibm.xtools.rmps.web.app.page_Clipboard001";

dojo.declare("rmps.app.ui.internal.editors.ClipboardEditor", rmps.app.ui.internal.editors.BaseEditor, {

	"class": "rmps-clipboard-editor",
	
	isReadOnly: true,
	isRefreshable: false,
	uaKey: UA_KEY,
	
	_clipboardWidget: null,
	
	postCreate: function() {
		this._clipboardWidget = new rmps.ui.clipboard.ClipboardWidget({
			isFullPage: true
		});

		this.inherited(arguments);
		
		this.containerNode.appendChild(this._clipboardWidget.domNode);
	},
	
	destroy: function() {
		if (this._clipboardWidget) {
			this._clipboardWidget.destroy();
			delete this._clipboardWidget;
		}

		this.inherited(arguments);
	},
	
	activate: function() {
		this._clipboardWidget.refresh();
		
		this.inherited(arguments);
	},
	
	addButtons: function(toolbar) {
		// TODO: When editors has switched to jazz.ui.Toolbar, use table addButtons function directly
		this._clipboardWidget.addEditorToolbarButtons(toolbar);
		
		this.inherited(arguments);
	},
	
	refresh: function() {
	}
});

}());