/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.editors.RegisterDesignEditorsInitializer");

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("rmps.ui.editor.EditorRegistry");

var DesignUtil = rmps.app.ui.internal.pages.design.DesignUtil;

rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.DesignTabbedEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.pages.design.DesignEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.MetamodelImportEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.pages.design.MetamodelImportEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.ValidationEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.pages.design.ValidationEditorInput";
});	

rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.OwlImportEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.pages.design.OwlImportEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.ExploreEditor", function (editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.pages.design.ExplorerEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.ExplorerViewpointEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.ExplorerViewpointEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.ExplorerViewpointsListEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.ExplorerViewpointsListEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.SearchQueryEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.SearchQueryEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.SearchQueriesListEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.SearchQueriesListEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.ClipboardEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.ClipboardEditorInput";
});
rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.editors.SearchResultsEditor", function(editorInput) {
	return editorInput.declaredClass == "rmps.app.ui.internal.SearchResultsEditorInput";
});

rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.ExplorerViewpointEditorInput", DesignUtil.viewpointAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.ExplorerViewpointsListEditorInput", DesignUtil.viewpointsAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.SearchQueryEditorInput", DesignUtil.queryAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.SearchQueriesListEditorInput", DesignUtil.queriesAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.ExplorerEditorInput", DesignUtil.exploreAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.MetamodelImportEditorInput", DesignUtil.importAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.OwlImportEditorInput", DesignUtil.importOwlAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.ValidationEditorInput", DesignUtil.validationAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.DesignEditorInput", DesignUtil.editAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.pages.design.DesignEditorInput", DesignUtil.createAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.ClipboardEditorInput", DesignUtil.clipboardAction);
rmps.ui.editor.EditorRegistry.registerEditorInput("rmps.app.ui.internal.SearchResultsEditorInput", DesignUtil.searchAction);

})();
