/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.ui.internal.editors.ReviewViewerEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.core.review.util.ReviewImageService");

dojo.requireLocalization("dm.review.app.ui.internal.editors", "ReviewViewerEditorInputMessages");
var messages = dojo.i18n.getLocalization("dm.review.app.ui.internal.editors", "ReviewViewerEditorInputMessages");

dojo.declare("dm.review.app.ui.internal.editors.ReviewViewerEditorInput", rmps.ui.editor.EditorInput, {

	getId: function() {
		return "reviewViewerEditor" ;	//$NON-NLS-1$
	},

	getName: function() {
		return messages.editor_name;
	},

	getTooltip: function() {
		return null;
	},

	isRecentlyViewedSupported: function() {
		return false;
	},

	getPresentationUri: function(state) {
		return rmps.app.ui.ReviewEditorUtil.getReviewViewerEditorUri();
	},
	
	getIconUri: function() {
		return rmps.core.review.util.ReviewImageService.REVIEWS;
	}

});

})();
