/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {

dojo.provide("rmps.app.ui.internal.editors.views.explorerviewpoint.RootQueryTab");

dojo.require("dijit._Templated");
dojo.require("dijit._Widget");
dojo.require("rmps.app.ui.internal.editors.views.explorerviewpoint.ViewpointSegment");

dojo.declare("rmps.app.ui.internal.editors.views.explorerviewpoint.RootQueryTab", [dijit._Widget, dijit._Templated],{
	// mix-in
	rootQueryUri: null,
	queryWidgetInputData: "{}", // json
	groups: null, //[]
	editor: null,
	
	_viewpointSegment: null,
	
	widgetsInTemplate: true,
	templatePath: dojo.moduleUrl("rmps.app", "ui/internal/editors/views/explorerviewpoint/templates/RootQueryTab.html"),
	
	constructor: function() {
		if (!this.groups) {
			this.groups = [];
		}
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		this._viewpointSegment = new rmps.app.ui.internal.editors.views.explorerviewpoint.ViewpointSegment({
			queryUri: this.rootQueryUri,
			queryWidgetInputData: this.queryWidgetInputData,
			groups: this.groups,
			editor: this.editor
		});
		this._segment.appendChild(this._viewpointSegment.domNode);
	},
	
	destroy: function() {
		if (this._viewpointSegment) {
			this._viewpointSegment.destroy();
			delete this._viewpointSegment;
		}
		
		this.inherited(arguments);
	},
	
	doSave: function(taskMonitor, synchronous) {
		return this._viewpointSegment.doSave(taskMonitor, synchronous);
	},
	
	validate: function(){
		return this._viewpointSegment.validate(true /* rootTab */);
	}
});

})();