/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.app.admin.ui.internal.pages.AdminComponentMenu");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("dojo.i18n");
dojo.require("rmps.core.util.IRmpsConstants");

dojo.require("dm.app.admin.core.AdminUtil");
dojo.require("rmps.app.ui.internal.common.ImageService");
dojo.require("rmps.ui.editor.CapabilityComponentMenu");
dojo.require("rmps.ui.editor.PageHelper");
dojo.require("com.ibm.team.vvc.shared.web.ui.context.ContextUtils");
var ContextUtils = com.ibm.team.vvc.shared.web.ui.context.ContextUtils;

dojo.require("rmps.core.util.ContextUtils");

dojo.requireLocalization("rmps.app.ui.internal.pages", "DesignPageMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages", "DesignPageMessages");

dojo.requireLocalization("dm.app.admin.ui.internal.pages", "AdminPageMessages");
var admin_messages = dojo.i18n.getLocalization("dm.app.admin.ui.internal.pages", "AdminPageMessages");

dojo.requireLocalization("rmps.ui.common", "CommonMessages");
var commonMessages = dojo.i18n.getLocalization("rmps.ui.common", "CommonMessages");

var ImageService= rmps.app.ui.internal.common.ImageService;
var AdminUtil= dm.app.admin.core.AdminUtil;
var IRmpsConstants= rmps.core.util.IRmpsConstants;

dojo.declare("dm.app.admin.ui.internal.pages.AdminComponentMenu", rmps.ui.editor.CapabilityComponentMenu, {
	
	addCapabilityComponentMenuItems: function(){
		// TODO: duc: Need to add the Welcome page only once we make it an Import-only welcome page.
//		this.addItemByArgs({
//			label: admin_messages.welcomeToAdmin,
//			href: AdminUtil.getWelcomeUri()
//		});
		
		this.addExtendedCapabilityComponentMenuItems();
		
		this.inherited(arguments);
	},
	
	showMessage: function(title, text) {
		if (this.dialog) {
			this.dialog.destroy();
			this.dialog = null;
		}
	
		var div = dojo.create("div");
		div.innerHTML = text;
		
		this.dialog = new jazz.ui.Dialog({
			contentNode: div,
			primaryTitle: title,
			width: "400px",
			closeOnBlur: true
		});
	},
	
	/*Designed to be extended by sub classes to add extra menu items */
	addExtendedCapabilityComponentMenuItems: function(){/*Empty Block */},
	
	getPageId: function(){
		return AdminUtil.ADMIN_PAGE;
	}
	
	
});

})();