/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.app.admin.ui.internal.pages.AdminPage");

dojo.require("dm.app.admin.core.AdminUtil");
dojo.require("dm.app.admin.ui.internal.pages.AdminPageController");
dojo.require("rmps.ui.editor.AbstractPage");
dojo.require("rmps.app.ui.internal.pages.SideNavigation");
dojo.require("rmps.app.ui.internal.pages.SideNavigationContextContents");
dojo.require("rmps.ui.editor.PageHelper");
dojo.require("dojo.i18n");
dojo.require("dm.app.admin.ui.internal.editors.RegisterAdminEditorsInitializer");
dojo.require("dm.app.admin.ui.internal.editors.RegisterBaselineEditorsInitializer");
dojo.require("dm.app.admin.ui.internal.editors.RegisterStreamEditorInitializer");

var PAGE_REMOVAL_ID = "com.ibm.xtools.rmps.jfs.web.removeAdminPage";

var ACTIONS_LIST= ["_default","welcome","baselineStatus", "requestBaseline","requestStream","streamViewer"];

/*The admin page design for our application. This page contains the basic administration actions cuh as baseline. It also provides a way for other places and
 * extensions to extend it and provide extneded page contents, actions, etc. However, at the moment, it does not guarantee that the order of registered actions
 * would come in order. At the moment, we do not need to worry about it, as we do not have scenarios for that.  */
dojo.declare("dm.app.admin.ui.internal.pages.AdminPage", rmps.ui.editor.AbstractPage, {

	"class": "dm-app-admin",
	
	// private properties
	_controller: null,
	
	createPageContents: function() {
		this.createExtendedAdminPageContents();
		this.inherited(arguments);
	},
	
	/*Expected to be extneded by other sub classes to add extra contents */
	createExtendedAdminPageContents: function(){/*Empty block */},
	
	/*Expected to be extneded by other sub classes to register extra actions */
	registerExtendedActions: function(actions){/*Empty block */},
	
	/*Expected to be extneded by other sub classes to subscribe extra actions */
	subscribeExtendedActions: function(){/*Empty block */},
	
	subscribeActions: function(){
		this._controller = new dm.app.admin.ui.internal.pages.AdminPageController(this);
		this.subscribeAllActions(this._controller);	
		this.subscribeExtendedActions();
	},
		
	registerActions: function(actions){
		this.registerActionsList(ACTIONS_LIST);
		this.registerExtendedActions(actions);
	},
	
	getPageRemovalId: function(){
		return PAGE_REMOVAL_ID;
	},
		
	getPageId: function(){
		return dm.app.admin.core.AdminUtil.ADMIN_PAGE;
	},
	
	getDefaultUri: function(){
		return dm.app.admin.core.AdminUtil.getWelcomeUri();
	}
	
});


})();
