/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.analysis                                       |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.analysis.ui.internal.pages.AnalysisWelcomeInput");

/** The input for creating the analysis welcome page editor. 
 *   
 *  @author Kevin Cornell
 */

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");
dojo.require("dm.app.analysis.ui.internal.util.AnalysisIcons");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("dm.app.analysis.ui.internal", "AnalysisMessages");
var messages = dojo.i18n.getLocalization("dm.app.analysis.ui.internal", "AnalysisMessages");

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;

dojo.declare("dm.app.analysis.ui.internal.pages.AnalysisWelcomeInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	title: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
		this.title = messages.welcomeToAnalysis;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	getIconUri: function() {
		return null;
	},
	
	getName: function() {
		return this.title;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		return AnalysisActions.getActionUri(AnalysisActions.ACTION_WELCOME);
	}
});

})();
