/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2012.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.reports.ui.internal.pages.CreateReportInput");

/** Create Report editor initialization.
 * 
 * @author Kevin Cornell
 */

dojo.require("dm.app.reports.ui.internal.application.ReportActions");
dojo.require("dm.app.reports.ui.internal.util.Icons");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");
dojo.requireLocalization("dm.app.reports.ui.internal", "ReportMessages");
var messages = dojo.i18n.getLocalization("dm.app.reports.ui.internal", "ReportMessages");

var ReportActions = dm.app.reports.ui.internal.application.ReportActions;

dojo.declare("dm.app.reports.ui.internal.pages.CreateReportInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	getIconUri: function() {
		return dm.app.reports.ui.internal.util.Icons.CREATE_REPORT;
	},
	
	getName: function() {
		return messages.createReportName;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		return ReportActions.getActionUri(ReportActions.ACTION_CREATE_REPORT);
	}
});

})();
