/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
	
	dojo.provide("rmps.app.ui.internal.pages.DMProjectDashboardComponentMenu");
	
	dojo.require("com.ibm.team.dashboard.web.ui.ProjectDashboardComponentMenu");
	dojo.require("jazz.util.html");
	dojo.require("jazz.app.context");
	dojo.require("jazz.ui.MegaMenu");
	dojo.require("jazz.ui.internal.MenuItemGroup");
	dojo.require("com.ibm.team.dashboard.web.ui.DashboardConstants");
	dojo.require("com.ibm.team.dashboard.web.util.DashboardUtil");
	dojo.require("com.ibm.team.dashboard.web.util.internal.Util");
	dojo.require("rmps.core.util.ContextUtils");
	
	dojo.requireLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMenuMessages");
		
	var HTML = jazz.util.html;
	var MenuItemGroup = jazz.ui.internal.MenuItemGroup;
	var DashboardConstants = com.ibm.team.dashboard.web.ui.DashboardConstants;
	var DashboardUtil = com.ibm.team.dashboard.web.util.DashboardUtil;
	var Util = com.ibm.team.dashboard.web.util.internal.Util;
	var messages = dojo.i18n.getLocalization("com.ibm.team.dashboard.web.ui.internal", "DashboardMenuMessages");
	var WrapHints = jazz.ui.MegaMenu.WrapHints;	
	
	var addBaselineParamToURL = function(url) {
		var context = rmps.core.util.ContextUtils.computeContextParams();
		if (context) {
			var parts = url.split("#");
			var add = (parts[0] && parts[0].indexOf("?") === -1) ? "?" : "&"; 
			parts[0] += add + context;
			url = parts.join("#");			
		}
		return url;
	};
	
	dojo.declare("rmps.app.ui.internal.pages.DMProjectDashboardComponentMenu", com.ibm.team.dashboard.web.ui.ProjectDashboardComponentMenu, {
		
		postCreate: function() {
			if (dojo.isIE < 10) {
				// Defect 35274.
				// Making dashboard links context-aware, otherwise IE 8, 9 will loose the fragment part (#action=...)
				
				dojo.addClass(this.domNode, "com-ibm-team-dashboard-ComponentMenu");
				var projectName = jazz.app.context.get().name;
				var escName = HTML.escape(projectName);
				var dashboardUrl = DashboardUtil.getDashboardHref(DashboardConstants.SCOPE_PROJECT_AREA, projectName);
				
				this._projectDashboards = new MenuItemGroup({
					menu: this,
					groupTitle: messages.projectDashboards,
					items: [{
						label: escName,
						iconClass: "project-dashboard",
						href: addBaselineParamToURL(dashboardUrl)
					}, {
						label: dojo.string.substitute(messages.allProjectDash, [escName]),
						iconClass: "all-projects",
						href: addBaselineParamToURL(Util.getAllProjectDashboardsHref(projectName)),
						wrapHint: WrapHints.NO_WRAP
					}]
				});
				this.initRecent();
				dojo.publish("/jazz/dashboard/initMenu", [this]);
				this.subscribe("/jazz/dashboard/view", this._addRecentItem); // pass item obj
				this.subscribe("/jazz/dashboard/dirty", this.onDirtyStateChange); // pass bundle and dirty state 				
			} else {
				this.inherited(arguments);
			}
		}
		
		
	}); // end of declare
	
	
}()); // end of function