/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.reports.ui.internal.pages.DeployTemplatesInput");

/** Initialize the editor for creating a report template.
 * 
 * @author Kevin Cornell
 */

dojo.require("dm.app.reports.ui.internal.application.ReportActions");
dojo.require("dm.app.reports.ui.internal.util.Icons");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");
dojo.require("jazz.util.html");

dojo.require("dojo.i18n");
dojo.requireLocalization("dm.app.reports.ui.internal", "ReportMessages");
var messages = dojo.i18n.getLocalization("dm.app.reports.ui.internal", "ReportMessages");

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;
var ReportActions = dm.app.reports.ui.internal.application.ReportActions;

dojo.declare("dm.app.reports.ui.internal.pages.DeployTemplatesInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	templateName: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		var id = this.declaredClass + ',' + this.projectId;
		return dojox.encoding.digests.MD5(id);
	},
	
	getIconUri: function() {
		return dm.app.reports.ui.internal.util.Icons.TEMPLATE_FIND;
	},
	
	setName: function(newName) {
		this.getParams().name = newName;
	},
	
	getName: function() {
		var params = this.getParams();
		var name = (params.name && params.name.length > 0 ? params.name : messages.deployPredefinedTemplates);
		return name;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function() {
		var editorUri = ReportActions.getActionUri(ReportActions.ACTION_DEPLOY_TEMPLATES);
		return editorUri;
	}
});

})();
