/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("rmps.app.ui.internal.pages.ProjectAreaEditorDmContribution"); //$NON-NLS-1$
	dojo.require("dojox.xml.parser"); //$NON-NLS-1$
	dojo.require("dojo.DeferredList"); //$NON-NLS-1$
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	dojo.require("rmps.core.TaskMonitor"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.editors.DefaultOslcContextEditor"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.OslcContextEditorInput"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.editors.views.DataManagementSection"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.editors.ConfigureSpaceEditor"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.ConfigureSpaceEditorInput"); //$NON-NLS-1$
	dojo.require("rmps.app.ui.internal.editors.DomainsManagementFragment"); //$NON-NLS-1$
	dojo.require("rmps.core.streams.StreamClient"); //$NON-NLS-1$
	dojo.require("rmps.core.projects.ProjectClient");
	dojo.require("rmps.app.ui.internal.util.DmProjectAreaEditorUtils"); //$NON-NLS-1$
	
	dojo.require("dojo.i18n");
	dojo.requireLocalization("rmps.app.ui.internal.pages", "ProjectAreaEditorDmContributionMessages"); //$NON-NLS-1$ //$NON-NLS-2$

	var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages", "ProjectAreaEditorDmContributionMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	var StreamClient = rmps.core.streams.StreamClient;
	var ProjectClient = rmps.core.projects.ProjectClient;
	var DmProjectAreaEditorUtils = rmps.app.ui.internal.util.DmProjectAreaEditorUtils;
	
	var PROJECT_DASHBOARD_URL_PREFIX = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "web") + "/projects/"; //$NON-NLS-1$
	var VVC_QUERY_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "queryvvc");
	var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;
	
	
	dojo.declare("rmps.app.ui.internal.pages.ProjectAreaEditorDmContribution", [dijit._Widget, dijit._Templated], { //$NON-NLS-1$
		
		templateString: '<div><div class="section">' +
							'<div class="outerHeading">' +
								'<div class="heading j-h2">' +
									'<div class="inlineHeading" role="heading" aria-level="1">${messages.projectType}' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="content" dojoAttachPoint="dataManagementConatiner">' +
							'</div>' +
						'</div>' +
						'<div class="section hidden" dojoAttachPoint="_domainsSection">' +
							'<div class="outerHeading">' +
								'<div class="heading j-h2">' +
									'<div style="float:right">' +
										'<a href="#" class="linkButton" role="button" dojoAttachEvent="onclick: _assignDomains">${messages.assign}</a>' +
									'</div>' +
									'<div class="inlineHeading" role="heading" aria-level="1">${messages.domains}' + 
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="content" dojoAttachPoint="domainsConatiner">' +
							'</div>' +
						'</div>' +
						'<div class="section">' +
							'<div class="outerHeading">' +
								'<div class="heading j-h2">' +
									'<div class="inlineHeading" role="heading" aria-level="1">${messages.space}' +
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="content" dojoAttachPoint="spaceConatiner">' +
							'</div>' +
						'</div>' +
						'<div class="section">' +
							'<div class="outerHeading">' +
								'<div class="heading j-h2">' +
									'<div style="float:right">' +
										'<a href="#" class="linkButton" role="button" dojoAttachEvent="onclick: _clearDefaultOslcContext">${messages.unset}</a>' +
									'</div>' +
									'<div style="float:right">' +
										'<a href="#" class="linkButton" role="button" dojoAttachEvent="onclick: _modifyDefaultOslcContext">${messages.set}</a>' +
									'</div>' +
									'<div class="inlineHeading" role="heading" aria-level="1">${messages.defaultOslcContext}' + 
									'</div>' +
								'</div>' +
							'</div>' +
							'<div class="content" dojoAttachPoint="oslcContextConatiner">' +
							'</div>' +
						'</div></div>',
		
		messages: messages,
		
		"class": "rmps-app-ui-internal-pages-ProjectAreaEditorDmContribution",
		
		editor: null,
		
		// tab only properties
		tabContainer: null,
		tabTitle: null,
		
		_dmModeHandle: null,
		_successMsg: null,
		
	    constructor: function(args) {
	    	this.editor = args.editor;
	    	this.tabContainer = args.tabContainer;
	    	this.tabTitle = args.tabTitle;
	    },
	    
		postCreate: function() {
			
			this.inherited(arguments);
			
			if (this.editor.isNew) {
				this._removeOslcSection();
			} else {
				this._initOslcSection();
			}
			
			this._initDataManagementSection();
			
			this._initSpaceSection();
			
			this._initDomainsSection();
			
			this.editor.setDirty(this.editor.changesPending());
		},
		
		_initDomainsSection: function() {
			this._toggleDomainsSection(this.dataManagementEditor.isDMManagedMode());
			this._dmModeHandle = dojo.connect(this.dataManagementEditor, "_updateDirty", dojo.hitch(this, function(originalValue, newValue, key) {
				this._toggleDomainsSection(newValue);
			}));
		},
		
		_toggleDomainsSection: function(show) {
			dojo.toggleClass(this._domainsSection, "hidden", !show); //$NON-NLS-1$			
			if (show && !this.domainsEditor) {
				this.domainsEditor = new rmps.app.ui.internal.editors.DomainsManagementFragment({
					projectConfigurationsInfo: this.editor.projectConfigurationsInfo,
					aboutToBeSaved: function(){},
					saved: function(){},
					dirtyStateChanged: dojo.hitch(this, function(isDirty) {
						this.editor.setDirty(this.editor.changesPending());
					})
				});
				this.domainsConatiner.appendChild(this.domainsEditor.domNode);
			} else if (!show && this.domainsEditor){
				if (this.domainsEditor) {
					this.domainsEditor.destroyRecursive();
					delete this.domainsEditor;
				}
				dojox.xml.parser.removeChildren(this.domainsConatiner);
			}
		},
		
		_initOslcSection: function() {
			var oslcContextEditorInput = new rmps.app.ui.internal.OslcContextEditorInput(this.editor.projectConfigurationsInfo);
			this.oslcContextEditor = new rmps.app.ui.internal.editors.DefaultOslcContextEditor({
				suppressEditorUi: true,
				editorInput: oslcContextEditorInput,
				showLoading: function() {},
				hideMessage: function() {},
				changesPending: function() {
					return this.isDirty();
				},
				aboutToBeSaved: function(){},
				saved: function(){},
				dirtyStateChanged: dojo.hitch(this, function(isDirty) {
					this.editor.setDirty(this.editor.changesPending());
				})
			});
			this.oslcContextEditor.headerContainerNode.parentNode.removeChild(this.oslcContextEditor.headerContainerNode);
			this.oslcContextConatiner.appendChild(this.oslcContextEditor.domNode);
		},
		
		_removeOslcSection: function() {
			var oslcContextSectionDiv = this.oslcContextConatiner.parentNode;
			oslcContextSectionDiv.parentNode.removeChild(oslcContextSectionDiv);
		},
		
		_initSpaceSection: function() {
			var self = this;
			this.spaceEditor = new rmps.app.ui.internal.editors.ConfigureSpaceEditor({
				suppressEditorUi: true,
				editorInput: new rmps.app.ui.internal.ConfigureSpaceEditorInput(this.editor.isNew ? undefined : this.editor.projectAreaItemId),
				showLoading: function() {},
				hideMessage: function() {},
				changesPending: function() {
					return this.isDirty() || self.editor.isNew;
				},
				aboutToBeSaved: function(){},
				saved: function(){},
				dirtyStateChanged: dojo.hitch(this, function(isDirty) {
					this.editor.setDirty(this.editor.changesPending());
				})
			});
			this.spaceEditor.headerContainerNode.parentNode.removeChild(this.spaceEditor.headerContainerNode);
			this.spaceEditor.startup();
			this.spaceConatiner.appendChild(this.spaceEditor.domNode);
			
			var div = dojo.create('div', {style : "margin-left: 0.3em; margin-top: 0.3cm;"}, this.spaceConatiner);
			var label = dojo.create('label', null, div); 
			this._indexingAllowed = dojo.create('input', {
				type: "checkbox",
				style: "margin-right: 0.3em;"
			}, label);
			;
			label.appendChild(dojo.doc.createTextNode(messages.allowIndexing));
			this._indexingAllowed.checked = false; 
			
			var div = dojo.create('div', {style : "margin-left: 0.3em; margin-top: 0.3cm;"}, this.spaceConatiner);
			var label = dojo.create('label', null, div); 
			this._RMV2ResourceType = dojo.create('input', {
				type: "checkbox",
				style: "margin-right: 0.3em;",
				onclick: dojo.hitch(this, function() {
					this.editor.setDirty(this.editor.changesPending());
				})
			}, label);
			
			label.appendChild(dojo.doc.createTextNode(messages.addRMV2Resource));
			this._RMV2ResourceType.checked = false;	
			this._RMV2OriginalValue = null;
			
			if (!this.editor.isNew) {
				this._RMV2ResourceType.disabled = true;
				var def = ProjectClient.getProjectProperty(this.editor.projectAreaItemId, "oslcRMV2Support");
				def.addCallback(this, function(propertyValue){
					this._RMV2OriginalValue = propertyValue.length > 0 && propertyValue === "true";
					this._RMV2ResourceType.checked = this._RMV2OriginalValue;
					this._RMV2ResourceType.disabled = false;
				});
				def.addErrback(this, function(error) {
					if (error.status === 404) {
						this._RMV2ResourceType.disabled = false;	
					}
				});						
			}
			
			// Initialize default space name
			this.connect(this.editor.name, "oninput", function() {
				if (this.spaceEditor) {
					this.spaceEditor.defaultSpaceNameUpdate(this.editor.name.value);
				}
			});
			/*
			 * On other browsers onkeypress and onpaste need to be tracked too
			 */
			if (!dojo.isFF && !dojo.isChrome) {
				this.connect(this.editor.name, "onpaste", function() {
					/*
					 * Current value is without the editing changes, hence it needs
					 * to be looked at after a minimal timeout time (0 is actually 4ms)
					 */
					setTimeout(dojo.hitch(this, function() {
						if (this.spaceEditor) {
							this.spaceEditor.defaultSpaceNameUpdate(this.editor.name.value);
						}
					}), 0);
				});
				this.connect(this.editor.name, "onkeypress", function() {
					/*
					 * Current value is without the editing changes, hence it needs
					 * to be looked at after a minimal timeout time (0 is actually 4ms)
					 */
					setTimeout(dojo.hitch(this, function() {
						if (this.spaceEditor) {
							this.spaceEditor.defaultSpaceNameUpdate(this.editor.name.value);
						}
					}), 0);
				});
			}
			this.spaceEditor.defaultSpaceNameUpdate(this.editor.name.value);
		},
		
		_initDataManagementSection: function() {
			var self = this;
			this.dataManagementEditor = new rmps.app.ui.internal.editors.views.DataManagementSection({
				projectId: this.editor.isNew ? undefined : this.editor.projectAreaItemId,
				_updateDirty: function(originalValue, newValue, dirtyKey) {
					rmps.app.ui.internal.editors.views.DataManagementSection.prototype._updateDirty.apply(this, arguments);
					if (originalValue !== newValue) {
						self.editor.setDirty(self.editor.changesPending());
					}
				},
				changesPending: function() {
					return this.isDirty;
				},
				aboutToBeSaved: function(){},
				saved: function(){},
			});
			this.dataManagementEditor.startup();
			this.dataManagementConatiner.appendChild(this.dataManagementEditor.domNode);
			if (!this.editor.isNew) {
				this.editor.projectConfigurationsInfo.getDspInfo(dojo.hitch(this, function(isDsp, isSystem, canCreateDsp) {
					if (isDsp || isSystem) {
						this.dataManagementEditor.setEnabled(false);
					}
				}));
			}
		},
		
		_modifyDefaultOslcContext: function(e) {
			e = e || window.event;
			if (e) {
				if (dojo.isFunction(e.preventDefault)) {
					e.preventDefault();
				} else {
					e.returnValue = false;
				}
			}

			if (this.oslcContextEditor) {
				this.oslcContextEditor.contentWidget.modify();
			}
		},
		
		_clearDefaultOslcContext: function(e) {
			e = e || window.event;
			if (e) {
				if (dojo.isFunction(e.preventDefault)) {
					e.preventDefault();
				} else {
					e.returnValue = false;
				}
			}
			
			if (this.oslcContextEditor) {
				this.oslcContextEditor.contentWidget.clear();
			}
		},
		
		_assignDomains: function(e) {
			e = e || window.event;
			if (e) {
				if (dojo.isFunction(e.preventDefault)) {
					e.preventDefault();
				} else {
					e.returnValue = false;
				}
			}
			this.domainsEditor.modify();
		},
		
		canSave: function() {
			return true;
		},

		changesPending: function() {
			return (this.oslcContextEditor && this.oslcContextEditor.isDirty())
				|| (this.spaceEditor && this.spaceEditor.isDirty())
				|| (this.dataManagementEditor && this.dataManagementEditor.isDirty)
				|| (this.domainsEditor && this.domainsEditor.changesPending())
				|| this._isRMV2SettingDirty();
		},
		
		postData: function() {
			if (this.editor.isNew) {
				var data = {};
				var empty = true;
				if (this.spaceEditor && this.spaceEditor.isDirty()) {
					this.spaceEditor.appendChanges(data);
				}
				for(var key in data) {
					empty = false;
					break;
				}
				if (!empty) {
					var uri = VVC_QUERY_PATH + "/initProjectArea/" + encodeURIComponent(this.editor.name.value); //$NON-NLS-1$
					
					var args = {
						url: uri,
						putData: dojo.toJson(data),
						handleAs: 'json',
						headers: {
							"Accept" : "application/json",
							"Content-Type" : "application/json"
						},
					};
					return rmps.core.client.xhrPost(args);
				}
			}
		},
		
		_createSpaceAndStreamDependentRequests: function(projectId, taskMonitor) {
			var request = new dojo.Deferred();
			if (this.editor.isNew) {
				/*
				 * In this case space data is sent to server along with the foundation project area creation request.
				 * For project area creation space data need to be present for ProjectAreaInitializer to create the
				 * space and stream. At this point it's assumed the space and stream have been created
				 */
				this._createStreamDependentRequest(projectId, request)
			} else {
				this.spaceEditor.doSave(taskMonitor, projectId).addCallback(this, function(result) {
					return this._createStreamDependentRequest(projectId, request);
				});
			}
			return request;
		},

		_isRMV2SettingDirty: function() {
			return this._RMV2OriginalValue === true && !this._RMV2ResourceType.checked ||
					this._RMV2OriginalValue !== true && this._RMV2ResourceType.checked;
		},
		
		_createStreamDependentRequest: function(projectId, request) {
		    // If either the project is DM managed (domainsEditor exists) or
		    // the user wants the default workspace used for LQE indexing
			if (this.domainsEditor || (this._indexingAllowed && this._indexingAllowed.checked)) {
				var streamDeferred = StreamClient.getDefaultStream(projectId);
				streamDeferred.addCallback(this, function(defaultStream) {
					var moreDeferreds = [];
					// LQE indexing is wanted .. set the defaultOsclContext project property
					if (this._indexingAllowed && this._indexingAllowed.checked) {
						moreDeferreds.push(ProjectClient.setProjectProperty(projectId, "defaultOslcContext", defaultStream, true)); //$NON-NLS-1$
					}
					
					// Project is DM managed ... set dependencies to the lastest versions of the domain projects
					if (this.domainsEditor) {
						var defaultVersions = this.domainsEditor.defaultDomainVersions(defaultStream);
						if (defaultVersions) {
							moreDeferreds.push(defaultVersions);
						}
					}
					if (moreDeferreds.length > 0) {
						var dl = new dojo.DeferredList(moreDeferreds);
						dl.then(dojo.hitch(this, function(results) {
							var errors = [];
							var errorsOccurred = false;
							for (var i = 0; i < results.length && !errorsOccurred; i++) {
								if (!results[i][0]) {
									if (typeof results[i][1] === 'string') {
										errors.push(results[i][1]);
									} else if (results[i][1].message) {
										errors.push(results[i][1].message);
									}
									errorsOccurred = true;
								}
							}
							if (errorsOccurred) {
								request.reject(errors.length > 0 ? errors : messages.errorSavingStreamSettings);
							} else {
								request.resolve();
							}
						}));
						return dl;
					} else {
						request.reject(messages.errorSavingStreamSettings);
					}
				});
				return streamDeferred;
			} else {
				request.resolve();
			}
		},
		
		doSave: function(callback) {
			var msg = this.validateRequired();
			if (msg) {
				callback.call(this.editor, DmProjectAreaEditorUtils.handleErrors(this.tabTitle, [msg]));
			} else {
				return this.save(null, callback);
			}
		},
		
		save: function(response, handleSuccess) {
			var taskMonitor = new rmps.core.TaskMonitor(messages.dmSave);

			var projectId = this.editor.isNew ? response : this.editor.projectAreaItemId;
			var deferreds = [];
			var spaceRequest, oslcContextRequest, dataManagmentRequest, domainsRequest;
			var dl;
			var self = this;

			this._clearSuccessMsg();

			taskMonitor.setCanComplete(false);
			
			if (this.spaceEditor && this.spaceEditor.isDirty()) {
				spaceRequest = this._createSpaceAndStreamDependentRequests(projectId, taskMonitor);
				deferreds.push(spaceRequest);
			}

			// OSLC RM V2 support is wanted. set the oslcRMV2Support project property
			if (this._isRMV2SettingDirty()) {
				var def = ProjectClient.setProjectProperty(projectId, "oslcRMV2Support", this._RMV2ResourceType.checked ? "true" : "false", false);
				deferreds.push(def);
			}
			
			if (this.oslcContextEditor && this.oslcContextEditor.isDirty()) {
				oslcContextRequest = this.oslcContextEditor.doSave(taskMonitor);
				deferreds.push(oslcContextRequest);
			}

			if (this.dataManagementEditor && this.dataManagementEditor.isDirty) {
				dataManagmentRequest = this.dataManagementEditor.doSave(taskMonitor, projectId);
				deferreds.push(dataManagmentRequest);
			}
			
			if (this.domainsEditor && this.domainsEditor.changesPending()) {
				domainsRequest = this.domainsEditor.doSave(taskMonitor, this.editor.isNew ? response : undefined);
				deferreds.push(domainsRequest);
			}
			
			taskMonitor.setCanComplete(true);
			
			if (deferreds.length > 0) {
				var dl = new dojo.DeferredList(deferreds);
				dl.then(dojo.hitch(this, function(results) {
					var errors = [];
					for (var i = 0; i < results.length; i++) {
						if (!results[i][0]) {
							if (results[i][1].message) {
								errors.push(results[i][1].message);
							} else if (typeof results[i][1] === 'string') {
								errors.push(results[i][1]);
							} else if (Array.isArray(results[i][1])) {
								for (var j = 0; j < results[i][1].length; j++) {
									errors.push(results[i][1][j]);
								}
							} else {
								errors.push(messages.errorSavingDmSettings);
							}
						}
					}
					if (errors.length > 0) {
						// Show warnings for DM properties save errors, because JTS properties might be saved, i.e. partial save
						if (this.editor.isNew) {
							dojo.cookie(this.editor.getDmContributionErrorCookieName(), dojo.toJson(DmProjectAreaEditorUtils.handleErrors(null, errors)));
						} else {
							this.editor.errObj = dojo.mixin({priority: ProcessConstants.ERROR_PRIORITY_LOW}, DmProjectAreaEditorUtils.handleErrors(this.tabTitle, errors));
						}
					} else {
						// Contribute to success message once the whole save is completed
						if (this.domainsEditor && this.domainsEditor.changesPending()) {
							if (this.domainsEditor.areDomainsAdded()) {
								var msg = this.editor.isNew ? dojo.cookie(this.editor.getDmContributionMessageCookieName()) : this._successMsg;
								var appendMsg = dojo.string.substitute(this.editor.isNew ? messages.latestVersions : messages.setVersions, [PROJECT_DASHBOARD_URL_PREFIX + this.editor.name.value]);
								msg = msg ? msg + " " + appendMsg : appendMsg;
								if (this.editor.isNew) {
									dojo.cookie(this.editor.getDmContributionMessageCookieName(), msg);
								} else {
									this._successMsg = msg;
								}
							}
						}
						/*
						 *  Refresh the tab if the DM contribution is hosted in a tab. 
						 *  JTS editor doesn't refresh tabs after the save automatically
						 */
						if (this.tabContainer) {
							this.clearState(false);
						}
					}
					if (handleSuccess && handleSuccess.call) {
						handleSuccess.call(this.editor, response);
					}
				}));
				return dl;
			}
		},
		
		getSuccessContributionMessage: function() {
			var msg = this._successMsg;
			this._clearSuccessMsg();
			return msg;
		},
		
		_clearSuccessMsg: function() {
			if (this._successMsg) {
				delete this._successMsg;
			}
		},
		
		uninitialize: function(){
			if (this.oslcContextEditor) {
				this.oslcContextEditor.destroyRecursive();
				delete this.oslcContextEditor;
			}
			if (this.dataManagementEditor) {
				this.dataManagementEditor.destroyRecursive();
				delete this.dataManagementEditor;
			}
			if (this.spaceEditor) {
				this.spaceEditor.destroyRecursive();
				delete this.spaceEditor;
			}
			if (this.domainsEditor) {
				this.domainsEditor.destroyRecursive();
				delete this.domainsEditor;
			}
			if (this._dmModeHandle) {
				dojo.disconnect(this._dmModeHandle);
			}
			this.inherited(arguments);
		},
		
		clearState: function(refreshClicked) {
			this.editor.projectConfigurationsInfo.reset();
			if (this.oslcContextEditor) {
				this.oslcContextEditor.lightRefresh();
			}
			if (this.dataManagementEditor) {
				this.dataManagementEditor.initDataManaged();
				this.dataManagementEditor.isDirty = false;
			}
			if (this.spaceEditor) {
				this.spaceEditor.initSpaceSelection();
			}
			if (this.domainsEditor) {
				this.domainsEditor.refresh();
			}
		},
		
		/*
		 * Called from ProjectAreaEditor#customRefresh()
		 */
		refresh: function() {
			this.clearState(false);
		},
		
		validateRequired: function(saveObj) {
			var msg;
			if (this.domainsEditor) {
				msg = this.domainsEditor.validateRequired(saveObj);
				if (msg) {
					return msg;
				}
			}			
			if (this.spaceEditor) {
				msg = this.spaceEditor.validateRequired(saveObj);
				if (msg) {
					return msg;
				}
			}
			if (this.dataManagementEditor) {
				msg = this.dataManagementEditor.validateRequired(saveObj);
				if (msg) {
					return msg;
				}
			}
		},
			
	});

})();
