/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
dojo.provide("dm.app.reports.ui.internal.pages.ReportWelcome");

/** This widget provides the actual content for the Reports
 *  section of the main Analysis welcome page.
 *  
 *  @author Kevin Cornell
 */

dojo.require("dm.app.reports.ui.internal.application.ReportActions");

dojo.require("dojo.i18n");
dojo.requireLocalization("dm.app.reports.ui.internal", "ReportMessages");
var messages  = dojo.i18n.getLocalization("dm.app.reports.ui.internal", "ReportMessages");


var ReportActions = dm.app.reports.ui.internal.application.ReportActions;

dojo.declare("dm.app.reports.ui.internal.pages.ReportWelcome", [dijit._Widget, dijit._Templated], {

	"class": "reportWelcome",

	messages: messages, 
	
	widgetsInTemplate: true,
	templateString: 
		'<div>' +
			'<div class="task1">' +
				'<div class="task1Left">' +
					'<div class="task1Image">' +
						'<a dojoAttachPoint="task1ImageHref" href="#">${messages.viewTemplatesTitle}</a>' +
					'</div>' +
				'</div>' +
				'<div class="task1Right">' +
					'<div class="task1Action">' +
						'<a dojoAttachPoint="task1ActionHref" href="#">${messages.viewTemplatesTitle}</a>' +
					'</div>' +
					'<div class="task1Text">${messages.viewTemplatesText}</div>' +
				'</div>' +
			'</div>' +
			
			'<div class="task2">' +
				'<div class="task2Left">' +
					'<div class="task2Image">' +
						'<a dojoAttachPoint="task2ImageHref" href="#">${messages.viewReportsTitle}</a>' +
					'</div>' +
				'</div>' +
				'<div class="task2Right">' +
					'<div class="task2Action">' +
						'<a dojoAttachPoint="task2ActionHref" href="#">${messages.viewReportsTitle}</a>' +
					'</div>' +
					'<div class="task2Text">${messages.viewReportsText}</div>' +
				'</div>' +
			'</div>' +
		'</div>',
		
	constructor: function(args) {
		this.messages = messages;
	},

	/** Perform the final widget creation steps by calculating the
	 *  actions and inserting them into the appropriate paragraphs in
	 *  the welcome page contents.
	 */
	postCreate: function() {
		this.inherited(arguments);
		
		// Set the action hrefs for the tasks
		var action = ReportActions.getActionUri(ReportActions.ACTION_VIEW_TEMPLATES);
		this.task1ImageHref.href  = action;
		this.task1ActionHref.href = action;
		
		action = ReportActions.getActionUri(ReportActions.ACTION_VIEW_REPORTS);
		this.task2ImageHref.href  = action;
		this.task2ActionHref.href = action;
	}
});

})();
