/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2013.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
(function() {
dojo.provide("dm.app.reports.ui.internal.pages.ReportWelcomeInitializer");

/** This widget extends the base Analysis welcome page in order to 
 *  add the Reports welcome content into the appropriate section of
 *  that welcome page.
 *  
 *  @author Kevin Cornell
 */

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");
dojo.require("dm.app.analysis.ui.internal.pages.AnalysisWelcome");

dojo.require("dm.app.reports.ui.internal.pages.ReportWelcome");

var AnalysisActions = dm.app.analysis.ui.internal.application.AnalysisActions;

/** Add the reports content to the analysis welcome page */
dojox.lang.aspect.advise(dm.app.analysis.ui.internal.pages.AnalysisWelcome, "addExtendedSectionContent", {
	after: function() {
		var editor = dojox.lang.aspect.getContext().instance;

		// If this call is for the Reports section to be initialzied
		if (editor.getCurrentSection() === AnalysisActions.SECTION_REPORTS) {
			// Create the widget for the Reports welcome page content
			var containerNode = editor.getSectionContainer();
			var reportWelcome = new dm.app.reports.ui.internal.pages.ReportWelcome();
			
			// Connect the content into the Analysis welcome page
			containerNode.appendChild(reportWelcome.domNode);
		}
	}
});

})();
