/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.ui.internal.pages.ReviewComponentMenu");

dojo.require("dojo.i18n");

dojo.require("dm.review.app.util.ReviewUtil");
dojo.require("rmps.app.ui.internal.common.ImageService");
dojo.require("rmps.core.review.util.ReviewImageService");
dojo.require("rmps.app.ui.ReviewEditorUtil");
dojo.require("rmps.ui.editor.CapabilityComponentMenu");
dojo.require("rmps.ui.editor.PageHelper");
dojo.require("rmps.ui.editor.EditorMRU");

dojo.requireLocalization("dm.review.app.ui.internal.pages", "ReviewComponentMenuMessages");
var messages = dojo.i18n.getLocalization("dm.review.app.ui.internal.pages", "ReviewComponentMenuMessages");


var PAGE_ID = dm.review.app.util.ReviewUtil.PAGE_ID;
var wrapHint = jazz.ui.internal.MegaMenu.wrapHint;
var ImageService= rmps.app.ui.internal.common.ImageService;

dojo.declare("dm.review.app.ui.internal.pages.ReviewComponentMenu", rmps.ui.editor.CapabilityComponentMenu, {

	addCapabilityComponentMenuItems: function() {
		var ReviewImageService= rmps.core.review.util.ReviewImageService;
		this.addItemByArgs({
			label: messages.welcomeToReviews,
			href: dm.review.app.util.ReviewUtil.getWelcomeUri(),
			icon: ReviewImageService.REVIEWS
		});
		this.addTitle(messages.browse);
		this.addItemByArgs({
			label: messages.reviews,
			href: rmps.app.ui.ReviewEditorUtil.getReviewViewerEditorUri(),
			icon: ReviewImageService.REVIEWS
		});
		
		this.addTitle(messages.create);
		
		this.addItemByArgs({
			label: messages.createReview,
			onClick: function(){
				rmps.app.ui.ReviewEditorUtil.startNewReviewEditor();
			},
			icon: ImageService.REVIEW_EDITOR_ICON
		});
		
		this.inherited(arguments);
	},

	getPageId: function(){
		return PAGE_ID;
	}
});

})();