/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.SettingsComponentMenu");

dojo.require("rmps.ui.editor.EditorUtil");

dojo.require("jazz.app._ComponentMenu");
dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("jazz.app.context");

dojo.require("rmps.app.ui.internal.ProjectLinkingEditorInput");
dojo.require("dojo.i18n");
dojo.require("rmps.app.util.ProjectConfigurationsInfo");

dojo.requireLocalization("rmps.app.ui.internal.pages", "SettingsPageMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages", "SettingsPageMessages");	
var PAGE_ID = "rmps.app.settings";

dojo.declare("rmps.app.ui.internal.pages.SettingsComponentMenu", jazz.app._ComponentMenu, {
	
	_editorUtil: null,
	
	postCreate: function() {
		this.addTitle(messages.linkManagement);
		
		var projectId = jazz.app.context.get().itemId;
		var editorInput = new rmps.app.ui.internal.ProjectLinkingEditorInput(undefined, new rmps.app.util.ProjectConfigurationsInfo(projectId));
		this.addItemByArgs({
			editorInput: editorInput,
			label: editorInput.getName(),
			/*icon: editorInput.getIconUri(),*/	
			href: editorInput.getPresentationUri()
		});
		
	},
	
	getSelected: function() {
		var sel = [];
		if (net.jazz.ajax.ui.PlatformUI.getWorkbench().currentPageId == PAGE_ID) {
			var editorUtil = rmps.ui.editor.EditorUtil.getInstance(PAGE_ID);
			var aei = editorUtil.getActiveEditorInput();
			var items = this.getItems();
			for (var i = 0; i < items.length; i++) {
				var item = items[i];
				if (item && (item.editorInput && item.editorInput.getId() === aei.getId() || (item.href && aei.getPresentationUri().indexOf(item.href) > 0))) {
					sel.push(item);
				}
			}
		}
		return sel;
	}
});
})();