/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.SettingsPageController");

dojo.declare("rmps.app.ui.internal.pages.SettingsPageController", null, {

	// private properties
	_page: null,

	_defaultUrl: null,

	constructor: function(page) {
		this._page = page;
	},

	_default: function(args) {
		if (this._defaultUrl) {
			setTimeout(dojo.hitch(this, function() {
				window.location.href = this._defaultUrl;
			}), 0);
			return;
		}
		this.projectManagement(args);
	},

	projectManagement: function(args) {
		var linkType= args.linkType;
		if(linkType){
			this._page.createProjectManagement(args);
		}else{
			this._defaultUrl = window.location.href;
			this._page.showProjectManagement(this._getEditorArgs(args));
		}
	},

	_getEditorArgs: function(args) {
		var rest = dojo.clone(args);
		delete rest.action;
		delete rest.id;
		return rest;
	}


});

})();
