/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.design.ConvertClient");

dojo.require("jazz.client.xhr");

dojo.require("rmps.core.RootServices");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");

var CONVERT_PATH = rmps.core.RootServices.getUri(rmps.core.Namespaces.RMPS, "metamodelconverter");

var CONVERT_REQUEST_PATH = CONVERT_PATH + "/requests/";

var BASELINE_PARAM = "rmps.context";

rmps.app.ui.internal.pages.design.ConvertClient = {
		
	_handleRead: function (theFileReader, tempi, contentPairs, data, deferred, loaded) {
		
		theFileReader.onload = function(result) {
			contentPairs[tempi + " Filename"] = data[tempi].name;
			contentPairs[tempi + " Content"] = result.target.result;
			loaded[0]++;
			
			if (loaded[0] >= data.length) {
				deferred.callback(contentPairs);
			}
			
		};
		theFileReader.onerror = function() {
			var err = new Error(dojo.string.substitute(messages.convertClientReadError, [data[tempi].fileName]));
			err.responseText = dojo.string.substitute(messages.convertClientReadError, [data[tempi].fileName]);
			deferred.errback(err); 
		};
		
	},
	
	readData: function(data) {
		var deferred = new dojo.Deferred();
		
		var contentPairs = [];
		var loaded = [0];
		
		for (var i = 0; i < data.length; i++) {
			var theFileReader = new FileReader();
			
			this._handleRead(theFileReader, i, contentPairs, data, deferred, loaded);
			
			theFileReader.readAsText(data[i]); //default second parameter is utf-8
		}
		
		return deferred;
	},
	
	requestConvert: function(contentPairs, projectId, overwrite, pathMaps, ignoreNsURIs) {
		var query = {};
		if (overwrite) {
			query.overwrite = true;
		}
		
		var i = 0;
		for (i = 0; i < pathMaps.length; i++) {
			contentPairs[i + " PathMapVariable"] = pathMaps[i].variable;
			contentPairs[i + " PathMapValue"] = pathMaps[i].value;
		} 		

		var theUrl = CONVERT_REQUEST_PATH + projectId + "?" + dojo.objectToQuery(query);
		if (ignoreNsURIs) {
			theUrl += "&retry=true";
			for (i = 0; i < ignoreNsURIs.length; i++) {
				theUrl += "&ignore" + i + "=" + encodeURIComponent(ignoreNsURIs[i]);
			}
		}
		
		var baseline = jazz.app.context.get().baseline;
		if (baseline) {
			theUrl += "&" + BASELINE_PARAM + "=" + encodeURIComponent(baseline);
		}
		
		var args = {
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "json",
			url: theUrl,
			content: contentPairs,
			hasBody: false,
			load: dojo.hitch(this, function(response, ioArgs) {
				return response;
			})
		};
		
		//since metamodels are text, we do not need dojo.io.iframe.send
		return jazz.client.xhrPost(args);

	}
};

})();