/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2011, 2013. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

/**
 * The Explorer Editor
 * 
 * @author Adam R. Neal
 */
(function () {
	
	dojo.provide("rmps.app.ui.internal.pages.design.ExploreEditor");

	// Our base class
	dojo.require("rmps.app.ui.internal.editors.BaseEditor");
	
	// Our content
	dojo.require("rmps.app.ui.internal.pages.design.ExploreContent");
	
	dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
	var designUtil = rmps.app.ui.internal.pages.design.DesignUtil;
	
	var UA_KEY = "com.ibm.xtools.rmps.web.app.page_DesignExplorer001";
	
	dojo.declare("rmps.app.ui.internal.pages.design.ExploreEditor", [rmps.app.ui.internal.editors.BaseEditor], {

		isRefreshable: true, // Allow users to refresh
		isReadOnly: true, // no Save button required
		uaKey: UA_KEY,
		_requiresRefresh: false,
		
		startup: function() {
			this.inherited(arguments);
			this.showLoading();
			this.domNode.style.overflow="auto"; // allow scrolling
			dojo.subscribe("rmps.ui.explorer.Explorer.resourceAdded", this, "onLazyRefresh");
		},
		
		createContentWidget: function() {
			return new rmps.app.ui.internal.pages.design.ExploreContent({
				parent: this
			});
		},
		
		addButtons: function(toolbar) {
			this.contentWidget.initializeToolBar(toolbar);
			this.inherited(arguments);
		},
		
		activate: function() {
			if (!this.contentWidget._started) {
				this.contentWidget.startup();
			}
			if ((designUtil.focusingResults && this.contentWidget.readyToFocus) || this.editorInput.getParams().viewpoint !== this.contentWidget.viewpointInURL || this._requiresRefresh) {
				this.contentWidget.refresh();
				this._requiresRefresh = false;
			}
			
		},
		
		refresh: function() {
			this.contentWidget.refresh();
		},
		
		onLazyRefresh: function(){
		    this._requiresRefresh = true;
		}
		
    }); // end declare
    
})(); // end function()
