/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.design.ExplorerEditorInput");


dojo.require("dojox.encoding.digests.MD5");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
var util = rmps.app.ui.internal.pages.design.DesignUtil;

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.ui.explorer", "ExplorerMessages");
var messages = dojo.i18n.getLocalization("rmps.ui.explorer", "ExplorerMessages");

dojo.declare("rmps.app.ui.internal.pages.design.ExplorerEditorInput", rmps.ui.editor.EditorInput, {
	
	mode: util.exploreMode,
	__actions: {},
	_hasSidebarExplorer: false,
	focusUri: null,
	
	constructor: function(params) {
		if (params.uri) {
			this.focusUri = params.uri;			
		}
	},
	
	getName: function() {
		return messages.explore;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.app", "graphics/icons/allDesigns.gif");
	},
	
	getTooltip: function() {
		return messages.explore;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	},
	
	getBasePresentationUri: function() {
		return util.getExploreResourceUri(this.focusUri);
	},
	
	getBreadcrumbUri: function(/*String?*/ uri) {
		return util.getExploreResourceUri(uri);
	}
});

}());
