/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.design.MetamodelImportEditorInput");

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");

dojo.declare("rmps.app.ui.internal.pages.design.MetamodelImportEditorInput", rmps.ui.editor.EditorInput, {
	
	resourceInfo: null,
	
	constructor: function(params) {
		this.resourceInfo = { uri: params.uri };
	},
	
	getBreadcrumbUri: function(uri) {
		return rmps.app.ui.internal.pages.design.DesignUtil.getImportResourceUri(uri);
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',metamodelImportEditorInput');
	},
	
	getName: function() {
		return messages.editorInputName;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.importer", "graphics/icons/ecoreImport.gif");
	},	
	
	isRecentlyViewedSupported: function() {
		return false;
	}
	
});

}());
