/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.pages.design.OwlImportEditor");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.form.CheckBox");

dojo.require("rmps.app.ui.internal.editors.BaseEditor");
dojo.require("rmps.app.ui.internal.pages.design.ConvertClient");
dojo.require("rmps.app.ui.internal.pages.design.OwlImportEditorInput");
dojo.require("rmps.app.ui.internal.pages.design.OwlImportDefinition");

dojo.require("rmps.core.util.ContextUtils");

dojo.require("rmps.ui.EditableCollapsibleSection");
dojo.require("rmps.ui.pathmaps.PathmapsSection");
dojo.require("dojox.form.Uploader");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.Form");
dojo.require("dijit.form.Select");
dojo.require("jazz.ui.StyledTable");
dojo.require("dojo.i18n");
dojo.require("dojo.io.iframe");
dojo.require("dojox.form.uploader.FileList");
dojo.requireLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages.design", "ImportMessages");

var projectId;

var ContextUtils = rmps.core.util.ContextUtils;


var connectOnInput = function(obj, widget, method) {
	widget.connect(obj, "onchange", method);
};

dojo.declare("rmps.app.ui.internal.pages.design.OwlImportEditor", rmps.app.ui.internal.editors.BaseEditor, {
	"class": "rmps-owl-importer",
	
	_definition: null,
	
	_requestButton: null,
	
	createContentWidget: function() {
		this._definition = new rmps.app.ui.internal.pages.design.OwlImportDefinition();
		this.content = new rmps.app.ui.internal.pages.design.OwlImportEditor._SubContent({_editor :this});
		
		this.containerNode.appendChild(this.content.domNode);
		this.content.startup();
		return this.content;
	},
	
	addButtons: function(toolbar) {
		var disable = false;

		if (ContextUtils.getContextType(jazz.app.context.get().baseline) === rmps.core.util.ContextTypes.SNAPSHOT) {
			disable = true;
			this.showMessage({
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: messages.editorDisabledSnapshot,
				closable: false
			});			
		}

		this._requestButton = new rmps.ui.SimpleButton({
			label: messages.editorInputButton,
			onClick: dojo.hitch(this, this._requestImport)
		});
		
		if (disable) {
			this._requestButton.setEnabled(false);
		}
		toolbar.addWidget(this._requestButton);
	},
	
	_requestImport: function(){
		if (this.content._children.length<1){
			this.showMessage(
			{
				type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
				summary: messages.clickAdd,
				closable: true
			});
			return;
		}
		this.showMessage(
				{
					type: jazz.ui.MessageBox.STATUS_TYPES.INFO,
					summary: messages.importing,
					closable: true
				});
		var uri = net.jazz.ajax._contextRoot + "/owlInput";
		var context = jazz.app.context.get();
		var query;
		var val = this.content.vCb.attr("value")=='on' ? true : false;
		if (context.baseline!==undefined) {
			uri +='?rmps.context='+context.baseline+'&replaceURI='+val;
		}
		var formData = this.content.form;
		dojo.io.iframe.send({
			url: uri,
			form: formData.domNode,
			headers: {
				"X-ibm-rmps-internal": "true"
			},
			handleAs: "text",
			error: function(error, ioargs) {
				console.error(error);
	        }
		}).then( dojo.hitch(this, function(result) {
			if (result!=null && result.length > 0) {
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.WARNING,
					summary: result,
					closable: true
				});
			} else {
				this.showMessage({
					type: jazz.ui.MessageBox.STATUS_TYPES.OK,
					summary: messages.owlImportCompleted,
					closable: true
				});
			}
		}) );
		
	},
	resize: function() {
		//override: do not resize
	}
});
dojo.declare("rmps.app.ui.internal.pages.design.OwlImportEditor._SubContent", [dijit._Widget, dijit._Templated], {
	
	messages: messages,
	
	widgetsInTemplate: true,
	
	templateString: '<div class="container">' +
			'<div dojoAttachPoint="_incompatible" class="hidden">' +
				'<span>${messages.editorIncompatbileBrowserMessage}</span>' +
			'</div>' +
			'<div dojoType="rmps.ui.CollapsibleSection" dojoAttachPoint="_section" readOnly="false" uaKey="com.ibm.xtools.rmps.web.importer.page_OwlImportEditor001">' +
				 '<div class="metamodelImporterElement">' +
					'<span>${messages.owlEditorTableMessage}</span>' +
				 '</div>' +
			'</div>' +
			'<div class="metamodelImporterElement">' +
				'<input dojoType="dijit.form.CheckBox" dojoAttachPoint="vCb"/>' +
				'<span>${messages.replaceCheckbox}</span>' +
			'</div>' +
		'</div>',
				
	_editor: null,
	_help: null,
	
	postCreate: function() {
		this._children = [];
		
		this.vCb.attr("value", this._editor._definition.stdVersion);
		
		//this.stdvCb.attr("value", this._editor._definition.replaceURI);
		this._section.setPrimaryTitle(messages.owlEditorBarTitle);
		var uri = net.jazz.ajax._contextRoot + '/owlInput';
		var context = jazz.app.context.get();
		if (context.baseline!==undefined) {
			uri +='?rmps.context='+context.baseline;
		}
		
		this.form = new dijit.form.Form({encType:"multipart/form-data",
			action:uri, method:"post" });
		this.form.action=uri;
		this._section.containerNode.appendChild(this.form.domNode);
		this._table = new jazz.ui.StyledTable({
			columns: [
					{label: messages.owleditorTableColumn1, className: "colOne"},
					{label: "", className: "actions"}
				]
		});
		this.form.domNode.appendChild(this._table.domNode);
		this._table.startup();
		
		this._section.addAction(messages.editorAddLink, messages.editorAddLinkTooltip, dojo.hitch(this, function() {
			this._addMetamodelRow();
		}));
		
		if (dojo.isIE <= 9) {
			dojo.removeClass(this._incompatible, "hidden");
		}
	},
	
	_addMetamodelRow: function() {
		var row = new rmps.app.ui.internal.pages.design.OwlImportEditor._WorkspaceRow({
			_editor: this._editor
		});
		this._table.tbody.insertBefore(row.domNode, this._table.tbody.firstChild);
		row.startup();
		
		this._children.push(row);
		var handle = this.connect(row, "uninitialize", function() {
			this.disconnect(handle);
			jazz.util.array.removeByReference(this._children, row);
		});
		
		row.focus();
	},	
	
	_onValidate: function() {
		this._editor._definition.overwrite = !!this.vCb.attr("value");
		this._editor._saveCookie();
	},
	
	_toggleChoice: function(e) {
	},
	
	startup: function() {
		this.inherited(arguments);	
		
		this._section.startup();		
		
		dojo.forEach(this._help, function(help) {
			help.startup();
		});
	}
	
});
dojo.declare("rmps.app.ui.internal.pages.design.OwlImportEditor._WorkspaceRow", [dijit._Widget, dijit._Templated], {
	
	widgetsInTemplate: true,
	
	templateString: '<tr>' +
			'<td>' +
				'<div>' +
					'<span class="preview" dojoAttachPoint="_pathPreview"></span>' +
					//the width:100% does not work in Firefox
					'<input class="editable" type="file" name="thefile" style="width:100%;" size="80" dojoAttachPoint="_pathInput"></input>' +
				'</div>' +
			'</td>' +
			'<td class="actions" style="width: 26px;">' +
				'<div dojoType="jazz.ui.SimpleToolbar" dojoAttachPoint="toolbar"></div>' +
			'</td>' +
		'</tr>',
	
	_editor: null,
	_filename: null,
	_definition: null,
	_originalWorkspace: null,
	
	postCreate: function() {
		connectOnInput(this._pathInput, this, function() {
			this._filename.path = this._pathInput.files;
		});
		
		this._definition = this._editor._definition;
		this._children = [];
		
		this._filename = {
			path: ""
		};
		this._definition.filenamesList.push(this._filename);
		
		this.toolbar.addButton(this, function(e) {
					dojo.stopEvent(e);
					this.remove();
					this.destroyRecursive();
				}, {
				label: messages.removeWorkspace,
				imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/remove.gif")
			});
	},
	
	focus: function() {
		this._pathInput.focus();
	},
	
	getChildren: function() {
		return this._children.slice();
	},
	
	remove: function() {
		dojo.forEach(this._children, function(row) {
			row.remove();
		});
		jazz.util.array.removeByReference(this._definition.filenamesList, this._filename);
	},
	
	pruneEmpty: function() {
		dojo.forEach(this.getChildren(), function(row) { 
			if (!row.project.directoryName) {
				row.remove();
				row.destroyRecursive();
			}
		});
	}
});


})();
