/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

/**
 * Dialog to display short link URI
 * 
 * @author sshaw
 */

(function() {
dojo.provide("rmps.app.ui.internal.pages.design.ShortLinkDialog");

dojo.require("jazz.ui.Dialog");

dojo.require("dojo.i18n");
dojo.requireLocalization("rmps.app.ui.internal.pages.design", "BreadCrumbMessages");

var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages.design", "BreadCrumbMessages");

dojo.declare("rmps.app.ui.internal.pages.design.ShortLinkDialog", [dijit._Widget, dijit._Templated], {
   templateString: "<div dojoAttachPoint='contentNode' style='margin-left: 8px; margin-right: 8px; margin-top: 5px'>" +
   						"<p style='margin-left: 10px'>" + 
   							"<div dojoAttachPoint='_displayLinkText'></div>" +
   							"<div style='margin-top: 5px'>" +
   								"<textarea id='shortLinkText' rows='2' cols='70' readOnly=true dojoAttachPoint='_shortLinkText' >" + this.shortLinkWithContext + "</textarea>" +
   							'</div>' +
   							"<div style='margin-top: 5px'>" +
   								"<input type='checkbox' value=true dojoAttachPoint='_includeContextCheckbox'><span style='margin-left: 10px'>" + messages.includeContext + "</span></input>" +
   							'</div>' +
   						"</p>" +
						"<p style='margin-right: 10px; text-align: right'><input type='button' style='width:70px' dojoAttachPoint='_button' value=" + messages.close + "></p>" +
					"</div>",
	
	constructor: function(args) {
		this.shortLink = args.shortLink;
		this.shortLinkWithContext = args.shortLinkWithContext;
		this.displayLink = args.displayLink;
	},
	
	postCreate: function() {
		dojo.connect(this._includeContextCheckbox, "onclick", dojo.hitch(this, this.setIncludeContext));
		dojo.connect(this._button, "onclick", dojo.hitch(this, this.onClose));
		
		this.dialog = new jazz.ui.Dialog({
			contentNode: this.contentNode,
			primaryTitle: messages.shortLink,
			destroyContents: true,
			style: 'width: 200px',
			isClosable: false
		});
		
		this._includeContextCheckbox.checked = true;
		this.setIncludeContext();
   },
   
   setIncludeContext: function() {
		if (this._includeContextCheckbox.checked) {
			this._shortLinkText.value = this.shortLinkWithContext;
		}
		else {
			this._shortLinkText.value = this.shortLink;
		}
		
		this._displayLinkText.innerHTML = "<a href=" + this._shortLinkText.value + ">" + this.displayLink + "</a>";
		
		this._shortLinkText.select();
   },
	
	onClose: function() {
		this.dialog.close();
	},
      
   uninitialize: function() {
	   if (this.dialog) {
		   this.dialog.destroy();
	   }
   }   
});
})();