/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
 
dojo.provide("rmps.app.ui.internal.pages.design.ValidationEditorInput");

dojo.require("rmps.app.ui.internal.pages.design.DesignUtil");
dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.app.ui.internal.pages.design", "ValidationMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.pages.design", "ValidationMessages");

dojo.declare("rmps.app.ui.internal.pages.design.ValidationEditorInput", rmps.ui.editor.EditorInput, {

	projectId: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	getName: function() {
		return messages.editorInputName;
	},
	
	getTooltip: function() {
		return messages.editorInputTooltip;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	},
	
	getBreadcrumbUri: function(uri) {
		return rmps.app.ui.internal.pages.design.DesignUtil.getValidationResourceUri(uri);
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.app", "graphics/icons/validation.gif");
	}
});

}());
