/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
	
	dojo.provide("rmps.app.ui.internal.pages.design.widgets.ViewpointSelector");
	
	dojo.require("jazz.ui.toolbar.MenuButton");
	dojo.require("jazz.ui.menu.MenuItem");
	dojo.require("jazz.util.html");
	
	dojo.require("rmps.core.explorer.ExplorerMainState");	
	var explorerMainState = rmps.core.explorer.explorerMainState;
	
	dojo.declare("rmps.app.ui.internal.pages.design.widgets.ViewpointSelector", jazz.ui.toolbar.MenuButton, {
		// mixin
		onViewpointChange: null,
		onGetViewpoint: null,
		showViewpointLabel: true,
		
		// props
		imgSrc: dojo.moduleUrl("rmps.app", "graphics/icons/show_viewpoint_co.gif").toString(),
		_ems: null,
		_emsDef: null,
				
		postCreate: function() {
			this.inherited(arguments);
			
			this.refreshState();
		},
		
		refreshState: function() {
			this._ems = null;
			this._emsDef = explorerMainState(false, this.projectUri, this.userUri);
			this._emsDef.addCallback(this, function(ems) {
				this._ems = ems;
				if (this.showViewpointLabel) {
					var viewpoint = this.onGetViewpoint(ems);
					this.set("label", viewpoint?viewpoint.label:"");
				}
			});
		},
		
		menuProvider: function() {
			if (!this._ems) {
				return this._emsDef;
			}
			
			var menu = new jazz.ui.Menu();			
			// Add selectable class to get bullets
			dojo.addClass(menu.domNode, "selectable");
			var currentVP = this.onGetViewpoint(this._ems);
			dojo.forEach(this._ems.getProjectAssociatedViewpoints(), function(viewpoint) {
				menu.addChild(new jazz.ui.menu.MenuItem({
					icon: dojo.moduleUrl("rmps.app", "graphics/icons/show_viewpoint_co.gif").toString(),
					label: jazz.util.html.escape(viewpoint.label),
					onClick: dojo.hitch(this, function() {
						this.onViewpointChange(viewpoint);
						if (this.showViewpointLabel) {
							this.set("label", viewpoint.label);	
						}
						this.close();
					}),
					selected: currentVP === viewpoint
				}));
			}, this);
			return menu;
		}		
	});
	
}());