/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2012.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("rmps.app.ui.internal.sections.LinksMenuHeader");

dojo.require("rmps.ui.sections.UAHeader");
dojo.require("rmps.ui.MenuSection");
dojo.require("rmps.app.ui.internal.editors.views.link.LinkClient");
dojo.require("rmps.app.ui.internal.editors.views.link.LinkEventManager");
dojo.require("rmps.core.util.ILinksConstants");

dojo.requireLocalization("rmps.app.ui.internal.sections", "LinksMenuHeaderMessages");
var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.sections", "LinksMenuHeaderMessages");

var LinkEventManager= rmps.app.ui.internal.editors.views.link.LinkEventManager;
var ILinksConstants = rmps.core.util.ILinksConstants;

dojo.declare("rmps.app.ui.internal.sections.LinksMenuHeader", rmps.ui.sections.UAHeader, {
	
	createHeader: function(table, scope, args){
		var section= args.section;
		var menuSection = new rmps.ui.MenuSection({
			postCreate: function(){
				this.inherited("postCreate", arguments);
				LinkEventManager.addTrackerAndNotify(this, ["fillMenu"],this.types);
				LinkEventManager.addTracker(this, ["addAction","removeAction", "modifyAction","modifyIdentifier"],this.types);
			},
			destroy: function(){
				LinkEventManager.removeTracker(this);
				this.inherited("destroy", arguments);
			},
			addMenuAction: function(linkType){
				return {
					linkName: linkType.title,
					identifier: linkType.about,
					label: linkType.title,
					description: linkType.description,
					iconUrl: ""
				};
			},
			fillMenuActions: function(linkTypes){
				var actions = [];

				var action;
				for (var i = 0; i < linkTypes.length; i++) {
		            var linkType = linkTypes[i];
					if(linkType.userCreatable){
						action = {
			                linkName: linkType.title,
			                identifier: linkType.about,
			                label: linkType.title,
			                description: linkType.description,
			                iconUrl: ""
			            };
			            actions.push(action);
					}
		        }
		        return actions;
			},

            parentWidget: section,
            actionSelector: "_handleAddLinkButtonPressed",
            label: "linkName", //$NON-NLS-1$
            menuLabel: messages.addMenuLabel,
            table: table,
            types: scope._types,
            uaKey: this.getUAKey()
        });
        return menuSection;
	}
	
});
    
})();
