/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("dm.review.app.ui.internal.sections.ReviewParticipantsTabSection");

dojo.require("rmps.ui.sections.TableData");
dojo.require("dm.review.app.util.ReviewActionsRegistery");
dojo.require("rmps.core.review.ReviewController");

var ReviewController =  rmps.core.review.ReviewController;
var ReviewActionsRegistery= dm.review.app.util.ReviewActionsRegistery;

dojo.declare("dm.review.app.ui.internal.sections.ReviewParticipantsTabSection", rmps.ui.sections.TableData, {
	
	userUri: null,
	
    constructor: function(params){
		if(!params.reviewController){
			ReviewController.getCurrentInstance(dojo.hitch(this, function(reviewController){
				this.reviewController= reviewController;
			}));			
		}
    },

    addColumnDescriptors: function(){
    	this.addColumnDescriptor(ReviewActionsRegistery.getModelElementForParticipantCellDescriptor("artifactId", "50%"));
    	this.addColumnDescriptor(ReviewActionsRegistery.getParticipantResultsCellDescriptor("participantResultStatus", "50%"));
    },
    
    enableDynamicActionsWidth: function(){
		return true;
	},
	
	insertBefore: function(){
		return false;
	},

    fillTable: function(section, table, onCall){
    	if(!onCall||!this.userUri){
        	return;
        }
		onCall(section, table, this.reviewController.review.getUserResults(this.userUri, true).artifactResults);
    }
});


})();
