/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("dm.review.app.ui.internal.sections.ReviewParticipantsTableSection");

dojo.require("rmps.core.review.util.ReviewTypes");
dojo.require("rmps.ui.sections.TableData");
dojo.require("rmps.core.review.util.ReviewUtil");
dojo.require("rmps.core.review.ReviewController");
dojo.require("dm.review.app.util.ReviewActionsRegistery");

/*Required import, so the actions registery won't add this require and add uncessary loads in case we have not used this section yet */
dojo.require("dm.review.app.ui.internal.controls.ReviewResultsStatusBar");

var ReviewController = rmps.core.review.ReviewController;
var ReviewActionsRegistery= dm.review.app.util.ReviewActionsRegistery;
var ReviewTypes= rmps.core.review.util.ReviewTypes;

dojo.declare("dm.review.app.ui.internal.sections.ReviewParticipantsTableSection", rmps.ui.sections.TableData, {

    constructor: function(params){
		if(!params.reviewController){
			ReviewController.getCurrentInstance(dojo.hitch(this, function(reviewController){
				this.reviewController= reviewController;
			}));			
		}
    },

    startup: function(div){
        this.addHeader("rmps.ui.sections.CollapsibleSectionHeader", ReviewActionsRegistery.getParticipantsTableHeaderArguments(this.reviewController));
    	var section= this.inherited(arguments);
        this.connect(this.sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"], "toggle", this._toggle);
    	if (this.reviewController.review.getReviewAttribute("reviewStatus") == ReviewTypes.REVIEW_STATE_TYPES.Finalized?true:false){
    		this.sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"].collapse();
    	}
    	return section;
    },

    addActionDescriptors: function(){
    	if(this.reviewController.allowModify&& this.reviewController.review.isModerator()){
    		if(this.reviewController.isEditable()){
				this.addActionDescriptor(ReviewActionsRegistery.getChangeParticipantActionDescriptor());
				this.addActionDescriptor(ReviewActionsRegistery.getDeleteReviewParticipantDescriptor());        			
    		}
    		this.addActionDescriptor(ReviewActionsRegistery.getReviewParticipantRedirectionAction());
    	}
    },

    addColumnDescriptors: function(){
    	this.addColumnDescriptor(ReviewActionsRegistery.getUserDefaultCellDescriptor("contributor", "25%"));
    	this.addColumnDescriptor(ReviewActionsRegistery.getTypeDefaultCellDescriptor("reviewRole", "25%"));
		this.addColumnDescriptor(ReviewActionsRegistery.getParticipantResultDefaultCellDescriptor("result", "35%"));
		this.addColumnDescriptor(ReviewActionsRegistery.getParticipantCompletedValueDefaultCellDescriptor("artifactInfo", "15%"));
    },

    insertBefore: function(){
		return false;
	},
	
	enableDynamicActionsWidth: function(){
    	return true;
    },

    appendTableAndHeaders: function(sectionHeaders, scope, table){
    	var	section= sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"];
		var tableDomNode= table.domNode;
    	scope.appendChild(section.domNode);
    	dojo.addClass(section.containerNode, "rmps-web-sections-table-data");
        section.containerNode.appendChild(tableDomNode?tableDomNode:table);
    },
    
    //TODO
	refreshTableData: function(collapsed){
    	this.headers= [];
    	this.addHeader("rmps.ui.sections.CollapsibleSectionHeader", ReviewActionsRegistery.getParticipantsTableHeaderArguments(this.reviewController));
    	this.inherited(arguments);
        this.connect(this.sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"], "toggle", this._toggle);
    	if (this.reviewController.review.getReviewAttribute("reviewStatus") == ReviewTypes.REVIEW_STATE_TYPES.Finalized?true:false){
    		this.sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"].collapse();
    	}
	},

    fillTable: function(section, table, onCall){
    	onCall(section, table, this.reviewController.review.model.participants);
    },
        
    _toggle: function(){
    	var collapsibleSection = this.sectionHeaders["rmps.ui.sections.CollapsibleSectionHeader"];
		collapsibleSection.setPrimaryTitle(ReviewActionsRegistery.getParticipantsDescription(this.reviewController, collapsibleSection.isCollapsed));
    }
});
})();
