/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("dm.review.app.ui.internal.sections.ReviewResourcesTabSection");
dojo.require("rmps.ui.sections.TableData");
dojo.require("rmps.core.review.ReviewController");
dojo.require("dm.review.app.util.ReviewActionsRegistery");

var ReviewController = rmps.core.review.ReviewController;
var ReviewActionsRegistery= dm.review.app.util.ReviewActionsRegistery;

dojo.declare("dm.review.app.ui.internal.sections.ReviewResourcesTabSection", rmps.ui.sections.TableData, {
	
	/*If resource uri is not determined by caller, nothing will be rendered */
	resourceUri: null,

    constructor: function(params){
		if(!params.reviewController){
			ReviewController.getCurrentInstance(dojo.hitch(this, function(reviewController){
				this.reviewController= reviewController;
			}));			
		}
    },

    addColumnDescriptors: function(){
        this.addColumnDescriptor(ReviewActionsRegistery.getUserDefaultCellDescriptor("contributor", "25%"));
        this.addColumnDescriptor(ReviewActionsRegistery.getTypeDefaultCellDescriptor("reviewRole", "25%"));
        this.addColumnDescriptor(ReviewActionsRegistery.getResourceResultsCellDescriptor("resourceResultStatus", "50%"));
    },
    
     insertBefore: function(){
		return false;
	},

    fillTable: function(section, table, onCall){
        if(!onCall|| !this.resourceUri){
        	return;
        }
        var review= this.reviewController.review;
        var def= review.resultDeferred;
    	if(def&&!review._reviewResults){
    		def.addCallback(this, function(){
    			onCall(section, table, review.getReviewResources(this.resourceUri, null, true).userResults);
    		});
    	}else{
    		onCall(section, table, review.getReviewResources(this.resourceUri, null, true).userResults);
    	}
    }
});

})();
