/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.analysis                                       |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */
(function() {
var AnalysisIcons = dojo.provide("dm.app.analysis.ui.internal.util.AnalysisIcons");

/** Define a utility class to encapsulate the icons and images used
 *  by the base analysis service.
 *  
 *  @author Kevin Cornell
 */

dojo.require("dm.app.analysis.ui.internal.application.AnalysisActions");
	
var Analysis_PageId = dm.app.analysis.ui.internal.application.AnalysisActions.PAGE_ID;

/** Get the URL to load an analysis icon.
 * 
 *  @param iconName the name of the icon (GIF) file
 */
AnalysisIcons._getIconUri = function(iconName) {
	 return dojo.moduleUrl(Analysis_PageId, "graphics/icons/" + iconName);
};

/** Get the URL to load an analysis image.
 * 
 *  @param imgName the name of the image (PNG) file
 */
AnalysisIcons._getImageUri = function(imgName) {
	 return dojo.moduleUrl(Analysis_PageId, "graphics/images/" + imgName);
};


/** Define the available icons and images for the base Analysis UI */
AnalysisIcons.WELCOME	= AnalysisIcons._getIconUri("analysis.gif");
AnalysisIcons.INFO		= AnalysisIcons._getIconUri("info_24.gif");
AnalysisIcons.VIDEO		= AnalysisIcons._getIconUri("video_24.gif");

//AnalysisIcons.IMG_XXX			= AnalysisIcons._getImageUri("xxx.png");

})();