/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.analysis                                       |
 *|                                                                        |
 *| Copyright IBM Corporation 2011.  All Rights Reserved.                  |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() { 
dojo.provide("dm.app.analysis.ui.internal.util.AnalysisUtil");

/** Analysis capability utility methods.
*  
*  @author Kevin Cornell
*/

dojo.require("jazz.app.context");

dm.app.analysis.ui.internal.util.AnalysisUtil = {

	/** Return the project area ID. */
	getProjectId: function() {
		var projectArea = jazz.app.context.get();
		return projectArea.itemId;
    },

    
    /** Return the URI for the underlying baseline of
     *  the DM context.
     */ 
    getDMContext: function() {
		var projectArea = jazz.app.context.get();
		var dmContext = null;
		if (projectArea.baseline && projectArea.baseline !== null) {
			dmContext = projectArea.baseline;
		}
		return dmContext;
    }

};

})();