/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	
	dojo.provide("rmps.app.ui.internal.util.DmProjectAreaEditorUtils"); //$NON-NLS-1$
	
	dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$
	
	dojo.require("dojo.i18n");
	dojo.requireLocalization("rmps.app.ui.internal.util", "DmProjectAreaEditorUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$

	var messages = dojo.i18n.getLocalization("rmps.app.ui.internal.util", "DmProjectAreaEditorUtilsMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
	/*
	 * Utility functions to workaround the extension limitations of JTS Foundation ProjectAreaEditor widget
	 */
	rmps.app.ui.internal.util.DmProjectAreaEditorUtils = {
			
		
		/*
		 * Converts DM BaseEditor subclass error-message into the same ProjectAreaEditor error-message 
		 */
		convertMessage: function(tabContainer, msg) {
			if (msg.type === jazz.ui.MessageBox.STATUS_TYPES.WARNING) {
				tabContainer.displayWarningMessage(msg);
			} else if (msg.type === jazz.ui.MessageBox.STATUS_TYPES.INFO) {
				tabContainer.displayPendingMessage(msg);
			} else if (msg.type === jazz.ui.MessageBox.STATUS_TYPES.OK) {
				tabContainer.displaySuccessMessage(msg);				
			} else if (msg.type === jazz.ui.MessageBox.STATUS_TYPES.ERROR) {
				tabContainer.displayErrorMessage(msg);
			}
		},
		
		/*
		 * Creates Foundation ProjectAreaEditor consumable error objects from a list of string errors 
		 */
		handleErrors: function(tabTitle, errors) {
			var error = {
				summary : tabTitle ? messages.errorSavingTab + tabTitle : messages.errorSaving,
				details: tabTitle ? [{message: messages['errorSavingTab.explanation'] + "<br>" + messages['errorSavingTab.useraction']}] : 
				                    [{message: messages['errorSaving.explanation'] + "<br>" + messages['errorSaving.useraction']}]
			};
			for (var i = 0; i < errors.length; i++) {
				error.details.push({message: errors[i]});
			}
			return { errorData: error };
		}
						
	};
	
})();
