/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.xtools.rmps.web.reports                                        |
 *|                                                                        |
 *| Copyright IBM Corporation 2011, 2012.  All Rights Reserved.            |
 *|                                                                        |
 *| US Government Users Restricted Rights - Use, duplication or disclosure |
 *| restricted by GSA ADP Schedule Contract with IBM Corp.                 |
 *+------------------------------------------------------------------------+
 */

(function() {
var Icons = dojo.provide("dm.app.reports.ui.internal.util.Icons");

/** Define the icons and images used by the reports application.
 * 
 * @author Kevin Cornell
 */

dojo.require("dm.app.reports.ui.internal.application.ReportActions");
	
var ReportActions = dm.app.reports.ui.internal.application.ReportActions;

Icons._getIconUri = function(iconName) {
	 return dojo.moduleUrl(ReportActions.REPORTS_APP, "graphics/icons/" + iconName);
};

Icons._getRmpsIconUri = function(iconName) {
	 return dojo.moduleUrl("rmps.ui", "graphics/icons/" + iconName);
};

Icons._getImageUri = function(imgName) {
	 return dojo.moduleUrl(ReportActions.REPORTS_APP, "graphics/images/" + imgName);
};

Icons.ADD				= Icons._getIconUri("add.gif");
Icons.COLLAPSE_ALL		= Icons._getRmpsIconUri("collapse_all.gif");
Icons.CONSTRUCTION		= Icons._getIconUri("construction.gif");
Icons.CREATE_FOLDER		= Icons._getIconUri("create-folder.gif");
Icons.CREATE_REPORT		= Icons._getIconUri("create-report.gif");
Icons.CREATE_TEMPLATE	= Icons._getIconUri("create-template.gif");
Icons.DB_MINI			= Icons._getIconUri("db-mini.gif");
Icons.DELETE			= Icons._getIconUri("delete.gif");
Icons.EDIT				= Icons._getIconUri("edit.gif");
Icons.ERROR				= Icons._getIconUri("error.gif");
Icons.EXPAND_ALL		= Icons._getRmpsIconUri("expand_all.gif");
Icons.EXPORT			= Icons._getIconUri("export.gif");
Icons.FOLDER			= Icons._getIconUri("folder.gif");
Icons.INFO_LARGE		= Icons._getIconUri("info_24.gif");
Icons.INFO				= Icons._getIconUri("info.gif");
Icons.PRINT				= Icons._getIconUri("print.gif");
Icons.REPORT			= Icons._getIconUri("report.gif");
Icons.REPORTS			= Icons._getIconUri("reports.gif");
Icons.TEMPLATE			= Icons._getIconUri("template.gif");
Icons.TEMPLATE_FIND		= Icons._getIconUri("template-find.gif");
Icons.TEMPLATES			= Icons._getIconUri("templates.gif");
Icons.UPLOAD_CONTENT	= Icons._getIconUri("upload-content.gif");
Icons.WARNING			= Icons._getIconUri("warning.gif");

Icons.IMG_BUTTONS		= Icons._getImageUri("reports_buttons.png");

})();