/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.app.reports.ui.internal.util.ReportSimpleButton");

dojo.require("dijit._Widget");

dojo.declare("dm.app.reports.ui.internal.util.ReportSimpleButton", dijit._Widget, {
	
	label: null,
	onClick: null,
	_textNode: null,
	
	buildRendering: function() {
		this.domNode = dojo.create("button");
		this._textNode = dojo.doc.createTextNode(this.label);
		this.domNode.appendChild(this._textNode);
	},
	
	postCreate: function() {
		if (this.onClick) {
			this.connect(this.domNode, "onclick", this.onClick);
		}
	},
	
	setLabel: function(newLabel) {
		this.label = newLabel;
		this._textNode.nodeValue = newLabel;
	},
	
	setEnabled: function(enabled) {
		this.domNode.disabled = !enabled;
	}
});

})();