/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.app.ui.internal.util.UrlUtil");

rmps.app.ui.internal.util.UrlUtil = {

	OWNNING_APPLICATION_KEY: "owningApplicationKey",

	DEBUG: "debug",

	WHOAMI: "whoami",

    getParamater: function(/*String */ url, /*String */ key) {
    	var query= new dojo._Url(url).query;
    	var object= dojo.queryToObject(new dojo._Url(url).query);
    	return object[key];
    },

    getActionArgument: function(argument){
    	/*Checking for argument being string is the caller responsability */
    	var hash= window.location.hash;
    	if(!hash){
    		return null;
    	}
		var index= hash.indexOf(argument+ "=");
		if(index== -1){
			return null;
		}
		var arg= hash.substring(index+argument.length+1, hash.length);
		if(arg){
			index= arg.indexOf("&");
			if(index>-1){
				return arg.substring(0, index);
			}
		}
    	return arg;
    },

	/*Extract the parameters for a given URI, or the current url.  
	 * Note that it is
	 * NOT safe to use this method to extract the rmps.context parameter directly from the URL.
	 * Instead, get the currently selected baseline directly from the jazz.app.context*/
    extractParameter: function(uri){
    	if(!uri){
    		uri = window.location;
    	}
    	var extracted= {};
    	var qstr = uri.search.substr(1);
    	if (qstr.length) {
			var qparts = qstr.split("&");
			for (var x = 0; x < qparts.length; x++) {
				var tp = qparts[x].split("=");
				extracted[tp[0]]= decodeURIComponent(tp[1]);
			}
		}
		return extracted;
    },

    getSegmentsForUri: function(uri){
		var segment = uri.substring(1).indexOf('/');	//$NON-NLS-1$
		if (segment >= 0) {
			return uri.substring(segment + 3).split("/"); //$NON-NLS-1$
		} else {
			return new String[0]();
		}
    },

    getBaseContextForUri: function(uri){
		var segments= rmps.app.ui.internal.util.UrlUtil.getSegmentsForUri(uri);
		var seg1, seg2= "";
		var url= new dojo._Url(uri);
		seg1= segments[0];
		seg2= segments[1];
		return url.scheme+ "://"+ seg1+ "/"+ seg2;
    },

    getWhoamiForUri: function(uri){
        var UrlUtil= rmps.app.ui.internal.util.UrlUtil;
		return UrlUtil.getBaseContextForUri(uri)+ "/"+ UrlUtil.WHOAMI;
    },
    
    isUri: function(string) {
        var regexp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@!\-\/]))?/;
        return regexp.test(string);
    }
};
