/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
dojo.provide("rmps.app.ui.internal.viewers.DiagramViewer");

dojo.require("dijit._Widget");
dojo.require("dojo.html");

dojo.require("dojo.date.locale");

dojo.require("dojo.i18n");
dojo.require("rmps.app.ui.internal.viewers.ResourceLinkView");

(function() {
	var locale= dojo.date.locale;

	dojo.declare("rmps.app.ui.internal.viewers.DiagramViewer", [rmps.app.ui.internal.viewers.ResourceLinkView, dijit._Templated], {
	
	templateString: '<div>' +
			'<table><tr><td nowrap="nowrap"><span>Long Name: </span></td><td nowrap="nowrap"><span dojoAttachPoint="longNameNode" /></td></tr>' +
			'<tr><td nowrap="nowrap"><span>Type: </span></td><td nowrap="nowrap"><span dojoAttachPoint="typeNode" /></td></tr>' +
			'<tr><td nowrap="nowrap"><span>Modified: </span></td><td nowrap="nowrap"><span dojoAttachPoint="modifiedNode" /></td></tr>' +
			'</table><div id="diagramnode" class=\"rmps-graphics-diagram-layout\" dojoAttachPoint="diagramNode"></div>'+
			'</div>',
	isExpanded: false,
		
	renderResource: function(resourceInfo) {
		this.resourceInfo = resourceInfo;
		if (resourceInfo.longName) {
			this.longNameNode.appendChild(dojo.doc.createTextNode(" " + resourceInfo.longName));
		}
		if (resourceInfo.displayType) {
			this.typeNode.appendChild(dojo.doc.createTextNode(" " + resourceInfo.displayType));
		}
		if (resourceInfo.modificationTime) {
			var date = locale.format(this.resourceInfo.modificationTime, {formatLength: "medium"});
			this.modifiedNode.appendChild(dojo.doc.createTextNode(" " + date));
		}
		
		var mb = dojo.marginBox( this.diagramNode );
		this.diagramContainer = document.createElement( "div" );
		this.diagramContainer.style.width = this.width +"px";
		this.diagramContainer.style.height = this.height + "px"; // FIXME temp
		this.diagramContainer.style.background = "white";
		this.diagramContainer.style.overflow = "hidden";
		this.diagramContainer.style.padding = "0px";
		
		var diagramnode = document.createElement( "div" );
	    this.viewer = new rmps.graphics.diagram.renderer.Diagram( diagramnode, resourceInfo.uri, this.isExpanded );
      	this.diagramContainer.appendChild( diagramnode );
        this.diagramNode.appendChild( this.diagramContainer );
		this.viewer.resize({w: this.diagramContainer.style.width, h: this.diagramContainer.style.height });
	},
    
    _resize: function() {
		if (this.viewer && this.viewer.resize) {
			var tableDiv = this.domNode.childNodes[0];
			var parent = this.domNode.offsetParent;
			if(parent && tableDiv) {
				var height = parent.offsetHeight - tableDiv.offsetHeight;
				var width = parent.offsetWidth;
				this.diagramContainer.style.height = height +"px";
				this.viewer.resize({w: width, h: height });
			}
			
		}
	}
});

})();