/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.app.ui.internal.viewers.PropertiesViewer");

dojo.require("dijit._Widget");
dojo.require("dojo.html");

dojo.require("rmps.app.ui.internal.editors.DiagramEditor");
dojo.require("jazz.util.Navigation");
dojo.require("jazz.util.ResizeNotifier");

dojo.require("dojox.collections.Dictionary");
dojo.require("dojo.date.locale");

dojo.require("dojo.i18n");
dojo.require("dojo.string");
dojo.require("rmps.app.ui.internal.viewers.ResourceLinkView");
dojo.require("rmps.app.ui.internal.editors.PropertiesEditor");
dojo.require("rmps.ui.properties.PropertiesViewer");



dojo.declare("rmps.app.ui.internal.viewers.PropertiesViewer", [rmps.app.ui.internal.viewers.ResourceLinkView, dijit._Templated], {
	
	templateString: '<div dojoAttachPoint="container" style="width:100%; height:100%;"></div>',
	isExpanded: false,
		
	renderResource: function(resourceInfo) {
    	this.viewer =  new rmps.ui.properties.PropertiesViewer({
			resourceUri: this.resourceUri
		});
		this.controller = new rmps.app.ui.internal.viewers.FilteredPropertiesController(this.viewer);
		if(this.isExpanded) {
			this.controller.allowedCategories = [{label: "General"}, {label: "Advanced"}];
		}
		else {
			this.controller.allowedCategories = [{label: "General"}];
		}
		this.viewer._controller = this.controller;
		this.viewer.startup();
		if (this.viewer.activate) {
			this.viewer.activate(args);
		}
		this.container.appendChild(this.viewer.domNode);
	}
});

dojo.declare("rmps.app.ui.internal.viewers.FilteredPropertiesController", [rmps.ui.properties.PropertiesController], {
	allowedCategories : [],
	
	isFilteredCategory: function(category) {
		for (var i = 0; i < this.allowedCategories.length; ++i) {
			if(this.allowedCategories[i].label == category.label) {
				return true;
			}
		}
		return false;
	},
	
	_constructSections: function(data) {	
		for (var i = 0; i < data.categories.length; ++i) {
			var category = data.categories[i];
			if (this.isFilteredCategory(category)) {
				var page = this._createPage();
				page.title = category.label;
				
				for (var j = 0; j < category.sections.length; ++j) {
					var section = category.sections[j];
					
					jazz.core.loader.load_sync(section.widget);
					
					var widgetConstructor = dojo.getObject(section.widget);
					var args = section.args || section.mixin;

					if (args.templateString) {
						args.templatePath = null;
					}
					
					var sectionWidget = new widgetConstructor(args);
					page.addSection(sectionWidget);
				}
				
				this._view.addPage(page);
			}
		}
	}
});	


})();