/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.ui.internal.viewers.ReviewParticipantViewer");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dm.review.app.ui.internal.controls.ReviewResultsStatusBar");
dojo.require("dm.review.app.ui.internal.sections.ReviewResourcesTabSection");

var ReviewResultsStatusBar= dm.review.app.ui.internal.controls.ReviewResultsStatusBar;

dojo.requireLocalization("dm.review.app.ui.internal.viewers", "ReviewParticipantViewerMessages");

/**
 * 
 * * Used to display a review reviewer rendering information
 */
dojo.declare("dm.review.app.ui.internal.viewers.ReviewParticipantViewer", [dijit._Widget, dijit._Templated], {
	
	templateString: dojo.cache("dm.review.app", "ui/internal/viewers/templates/ReviewParticipantViewer.html"),
	
	messages: dojo.i18n.getLocalization("dm.review.app.ui.internal.viewers", "ReviewParticipantViewerMessages"),
	
	resourceName: null,
	resourceUri: null,
	reviewController: null,
		
	startup: function() {
		this.inherited(arguments);
		this.nameNode.appendChild(dojo.doc.createTextNode(" " + this.resourceName));
		
		this.resultStatusBar = new ReviewResultsStatusBar();
		this.resultStatusBar.renderResourceResults(this.reviewController.review, this.resourceUri);
		this.reviewResultsNode.appendChild(this.resultStatusBar.domNode);
		this.table = new dm.review.app.ui.internal.sections.ReviewResourcesTabSection({
	            	reviewController: this.reviewController,
	            	reviewParser: this.reviewController.review,
            		scope: this,
            		resourceUri: this.resourceUri
	    });
	    this.containerNode= this.domeNode;
	    this.table.startup(this.tableNode);
	    this.tableNode.appendChild(this.table.domNode);
	},
	
	destroy: function(){
		if(this.table){
			this.table.destroyRecursive();			
		}
		this.inherited(arguments);
	}
});

})();
