/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.ui.internal.viewers.ReviewRenderingViewer");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.date");
dojo.require("rmps.core.user.UserClient");
dojo.require("jazz.util.iframe");
dojo.require("dojo.i18n");

dojo.requireLocalization("dm.review.app.ui.internal.viewers", "ReviewRenderingViewerMessages");

var messages = dojo.i18n.getLocalization("dm.review.app.ui.internal.viewers", "ReviewRenderingViewerMessages");

/*
 * Used to display review compact rendering information
 */
dojo.declare("dm.review.app.ui.internal.viewers.ReviewRenderingViewer", [dijit._Widget, dijit._Templated], {

	templateString: dojo.cache("dm.review.app", "ui/internal/viewers/templates/ReviewRenderingViewer.html"),

	title: null,
	state: null,
	dueDate: null,
	moderator: null,
	lastModified: null,
	role: null,
	messages: messages,

	startup: function() {
		this.inherited(arguments);
		var args= this.args;
		this.nameNode.appendChild(dojo.doc.createTextNode(" " + this.title));

		var state= rmps.core.review.util.ReviewTypes.getReviewStateDisplayName(this.state);

		this.statusNode.appendChild(dojo.doc.createTextNode(" " + state));

		this.dueDateNode.appendChild(dojo.doc.createTextNode(" " + this.getShortDate(this.dueDate)));
		
		/*No need to add an error callback here, as it will be obvious that something wnet wrong
		 * if the user name is not appeneded in the user's span
		 */
		rmps.core.user.UserClient.getUser(this.moderator).addCallback(this, function (user) {
			this.moderatorNode.appendChild(dojo.doc.createTextNode(" " + user.name));			
		});
		
		this.lastModifiedNode.appendChild(dojo.doc.createTextNode(" " + this.getShortDate(this.lastModified)));
		this.myRoleNode.appendChild(dojo.doc.createTextNode(" " + this.role));
		
		
		if (window.postMessage && window.parent) {
			var newPreviewHeight = jazz.util.iframe.getDocumentHeight();
			var resizeMessage = "oslc-preview-height:" + newPreviewHeight;
			window.parent.postMessage(resizeMessage, "*");
			resizeMessage = "jazz-compact-rendering-preview-height:" + newPreviewHeight;
			window.parent.postMessage(resizeMessage, "*");
			} 

	},

	getShortDate: function(value){
		return dojo.date.locale.format(value, { formatLength:"medium", selector:"date"});
	}
});

})();
