/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("dm.review.app.ui.internal.viewers.ReviewResourceViewer");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dm.review.app.ui.internal.controls.ReviewResultsStatusBar");
dojo.require("dm.review.app.ui.internal.sections.ReviewParticipantsTabSection");
dojo.require("dojo.date");

/*Required if the module is going to be used at other servers. So, if the user is
 * not already logged into our server, then, we will show the login dialog */
dojo.require("jazz.app.auth");

dojo.requireLocalization("dm.review.app.ui.internal.viewers", "ReviewResourceViewerMessages");

var ReviewResultsStatusBar= dm.review.app.ui.internal.controls.ReviewResultsStatusBar;

/*
 * Used to display a review resource rendering information
 */
dojo.declare("dm.review.app.ui.internal.viewers.ReviewResourceViewer", [dijit._Widget, dijit._Templated], {
	
	templateString: dojo.cache("dm.review.app", "ui/internal/viewers/templates/ReviewResourceViewer.html"),
	
	userName: null,
	userUri: null,
	reviewController: null,
	
	messages: dojo.i18n.getLocalization("dm.review.app.ui.internal.viewers", "ReviewResourceViewerMessages"),
	
	startup: function() {
		this.inherited(arguments);
		this.nameNode.appendChild(dojo.doc.createTextNode(" " + this.userName));
		
		var reviewRole = this.reviewController.review.getParticipant(this.userUri).reviewRole;
		this.resultStatusBar = new ReviewResultsStatusBar();
		this.resultStatusBar.role = reviewRole;
		this.resultStatusBar.setUserUri(this.reviewController.review, this.userUri);
		this.reviewResultsNode.appendChild(this.resultStatusBar.domNode);
		this.table = new dm.review.app.ui.internal.sections.ReviewParticipantsTabSection({
	            	reviewController: this.reviewController,
	            	reviewParser: this.reviewController.review,
            		scope: this,
            		userUri: this.userUri
	    });
	    this.containerNode= this.domeNode;
	    this.table.startup(this.tableNode);
	    this.tableNode.appendChild(this.table.domNode);
	},
	
	destroy: function(){
		if(this.table){
			this.table.destroyRecursive();			
		}
		this.inherited(arguments);
	}
});

})();
