/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	'stepTitle': "Finalize Application",
	'step1Label': "Step 1:",
	'step1Title': "Initiate Finalization Process",
	'step2Label': "Step 2:",
	'step2Title': "View Progress",
	'finish': "Finish",
	'next': "Next",
	'startButtonLabel': "Finalize Application Setup",
	'description': "In order to finish the configuration of this application, there are a few operations that need to be completed. This step will provide feedback regarding the status of these operations. Once this step is complete, the application setup will be complete.",
	'startInstructions': "The finalization process is composed of two parts: Storing Consumer Key and Secret, and User Synchronization. To begin, click the button below.",
	'finalizePending': "Please wait while the application is being finalized. This may take a minute.",
	'allComplete': "The finalization process is complete. Click \"${0}\" to continue.",
	'operationError': "An error occurred while trying to perform this operation. Please see the error message at the top of this page for more information.", //!SERVICE
	'finalizeError': "CRJAZ1850E Unable to save the consumer key and secret into the application's database. See details for more information.",
	'userSyncError': "CRJAZ1752E Unable to perform the User Sync operation. See details for more information.",
	'licenseError': "Unable to apply internal license. See details for more information.", //!SERVICE
	'createStorageError': "Unable to create storage areas. See details for more information.", //!SERVICE
	'finalizeCheckError': "CRJAZ1787E An error occurred while trying to determine if the Finalize operation is required for this application.",
	'loginPopupBlocked': 'It appears that your browser has blocked the log in pop-up for the server. Verify that pop-up windows are not blocked for this server, refresh the browser page and return to this Finalize Application page to continue.',
	'noFinalizeNeeded' : "Finalization is not required or has already been completed for this application.",
	'operation1title': "Finish Registration",
	'operation1desc': "Now that this application's database has been configured, this operation will complete the application's registration with the Jazz Team Server.",
	'operation2title': "Perform User Synchronization",
	'operation2desc': "This operation will synchronize the user records stored in the Jazz Team Server into this application.",
	'finalizeApplyLicense': 'Apply Functional User License',
	'finalizeApplyLicenseDescription': 'The functional user is given a license to be able to execute requests in Jazz Team Server.',
	'finalizeImportProcessTemplate': 'Import Process Templates',
	'finalizeImportProcessTemplateDescription': 'Import blank and basic process templates recommended for new project areas.',
	'finalizeConfigureVVC': 'Configure Versioning',
	'finalizeConfigureVVCDescription': 'This application requires VVC for version control.',
	'finalizeProvision': 'Provision Applications',
	'finalizeProvisionDescription': 'Find and configure registered application extensions.',
	'finalizeStorageAreasCreation': 'Create Storage Areas',
	'finalizeStorageAreasCreationDescription': 'This application requires configuring Jazz Team Server with areas for storing resources.',
	'projectAreasCreationCore': 'Create Core System Domains Project Area',
	'projectAreasCreationCoreDescription': 'Set up project area for core system domains.',
	'projectAreasCreationOther': 'Create Extension System Domains Project Areas',
	'projectAreasCreationOtherDescription': 'Set up project areas for extension system domains. This operation can take several minutes to complete.',
	'projectAreasCreationUser': 'Create User Domains Project Area',
	'projectAreasCreationUserDescription': 'Set up project area for user domains.',
	'deploySystemLinkTypes': 'Deploy System Link Types',
	'deploySystemLinkTypesDescription': 'Set up system link types.',
	'disablingAdmin': "The finalization process is complete. ADMIN access on this application will be disabled and you will be automatically logged out of this application. Once setup is complete, you will need to log in to this application using the new admin user that you created on the Jazz Team Server.",
	'appNotRegistered': "This application needs to be registered with a Jazz Team Server to function correctly. To proceed, use the Setup Wizard located on the Jazz Team Server (For example: https://servername.domain.com:9443/jts/setup).",
	'discoverRenderingServers': "Discover Domain Extension Servers",
	'discoverRenderingServersDescription' : "Configure Design Management Domain Extension Servers if they are already running.",
	'discoverRenderingServersWarning' : "Setup could not find any Domain Extension Servers. You can set it up later via Domain Extension Servers menu of Design Management Application Administration page." //!SERVICE
})	
