/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function(){
	dojo.provide("com.ibm.team.vvc.shared.web.ui.notifications.notificationViews.VvcNotificationObjectView");
	dojo.require("com.ibm.team.vvc.shared.web.ui.gc.VvcGarbageCollector");
	var ncConstants = com.ibm.team.vvc.shared.web.ui.notifications.VvcNotificationConstants;
	
	dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.notifications.notificationViews", "VvcNotificationViewMessages");
	
	dojo.declare("com.ibm.team.vvc.shared.web.ui.notifications.notificationViews.VvcNotificationObjectView", [dijit._Widget, dijit._Templated], {
				
			templatePath: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'ui/notifications/notificationViews/templates/VvcNotificationView.html'),
			messages: dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.notifications.notificationViews", "VvcNotificationViewMessages"),
			
			notification: null,
			
			/*
			 *  Add new attributes to this map, make sure there is a place for it in the templated DOM, 
			 *  must have a name like xxxNode, ex: "titleNode", "subtitleNode"
			 */
			myAttrNames: ["title", "subtitle", "description", "cause", "solution", "seeAlso", "devel"],
			
			// garbage collector
			gc: null,
						
			
			_setconstructorAttr: function(){return;},
			
			constructor: function(args){
				this.notification = args.notification;				
				this.gc = new com.ibm.team.vvc.shared.web.ui.gc.VvcGarbageCollector();
				
//				Fills in the template with data 
				dojo.forEach(this.myAttrNames, dojo.hitch(this, function(attrName){
					if(this.notification[attrName]){
						this["_set" + attrName + "Attr"] = dojo.hitch(this, function(value){
							this.__setAttr(attrName, value);
						});
						this["_set" + attrName + "Attr"](this.notification[attrName]);
					}
				}));
			},
			
			postCreate: function(){
				this.gc.disconnects(dojo.connect(this.showDevelNode, "onclick", dojo.hitch(this, this.onShowDevel)));
				this.gc.disconnects(dojo.connect(this.hideDevelNode, "onclick", dojo.hitch(this, this.onHideDevel)));
			},
			
			destroy: function(){
				this.gc.destroy();
			},
			
			/**
			 * Event handler for when the notification changes size
			 */
			onShowDevel: function(){
				dojo.addClass(this.develRow, "develOn");
				dojo.removeClass(this.develRow, "develOff");
				this.onSizeChanged();
			},
			
			/**
			 * Event handler for when the notification changes size
			 */
			onHideDevel: function(){
				dojo.addClass(this.develRow, "develOff");
				dojo.removeClass(this.develRow, "develOn");
				this.onSizeChanged();
			},
			
			/**
			 * Event handler for when the notification changes size
			 */
			onSizeChanged: function(){
				// Stub
			},
			
			__setAttr: function(attr, value){
				var node = this[attr + "Node"];
				var row = this[attr + "Row"];
				if(node){
					this._set(attr, value);
					node.innerHTML = value;
					dojo.setAttr(row, "enabled", "true");
				} else {
					var handle = dojo.connect(this, "postCreate", this,  function(){
						this.__setAttr(attr, value);
						dojo.disconnect(handle);
					});
				}
			}
							
	}); // end declare
})(); // end object