/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
// NLS_CHARSET=UTF-8
({
	/*
	 * ------------------------------------------------------------------------
	 * VvcNotificationObjectView has become hooked onto this messages file, 
	 * until that is resolved these messages need to stay here.  Do not rely
	 * on these messages being here, modifications to these messages MUST be
	 * reflected in ui.notifications.notificationViews.nls.VvcNotificationViewMessages
	 */
	titleLabel: "Title:",
	subtitleLabel: "Subtitle:",
	descriptionLabel: "Description:",
	causeLabel: "Cause:",
	solutionLabel: "Solution:",
	seeAlsoLabel: "See Also:",
	develLabel: "Debug information:",
	showDevel: "Show information",
	hideDevel: "Hide information",
	/* ------------------------------------------------------------------------ */

	// Note: use the new http 400 error codes below
	// XHR Error messages
	xhrError: "CRMVC0009E There was a problem communicating with the server.",
	xhrErrorSubtitle: "${statusCode}", //!SERVICE
	'xhrError.explanation': "An error occurred while communicating with the server.", 
	xhrErrorCause: "${statusCode}: ${statusMessage}", //!SERVICE
	'xhrError.useraction': "Try to complete the operation again, or clear the history in the web browser and then refresh the page. If the problem persists, contact your system administrator.", 
	xhrErrorSeeAlso: "", //!SERVICE
	xhrErrorDevel: "Request args:\n${args}\n\nRequest response:\n${response}", //!SERVICE
	
	httpCodes: {
		// Defaults are derived from the 400 code.  Keep in sync with the xhrError above
		400: {
			title: "CRMVC0009E There was a problem communicating with the server.",
			description: "An error occurred while communicating with the server.", 
			cause: "${statusCode}: ${statusMessage}", //!SERVICE
			solution: "Try to complete the operation again, or clear the history in the web browser and then refresh the page. If the problem persists, contact your system administrator.", 
			// You do not need to propogate this 'devel' into other error codes.
			devel: "Request args:\n${args}\n\nRequest response:\n${response}" //!SERVICE
		},
		
		403: {
			title: "You do not have the correct permissions to perform the requested action.",
			subtitle: "Forbidden",
			description: "The server has responded with a 403 (Forbidden) error.  You do not have permission to perfrom the requested action.",
			cause: "",
			solution: "Refresh the browser page and try again.  Ensure you have sufficient privleges to perform the requested operation."
		}
	}
});
