/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.dsv.editor.owl.ui.ntriple");

dojo.require("dojox.highlight._base");

/**
 * Ruleset to highlight n-triple format.
 * 
 * @author mgobeil
 */
dojo.provide("dojox.highlight.languages.ntriple");
dojox.highlight.languages.ntriple = {
	defaultMode: {
		contains: [
			"statement literal",
			"statement datatype",
			"statement url",
			"statement blank",
			"statement terminator"
		]
	},
	
	modes: [
		{
			className: "statement datatype",
			begin: '\\^\\^', end: "\\>",
			illegal: "\\n",
			relevance: 0
		},
		{
			className: "statement literal",
			begin: '".+"', end: "^",
			illegal: "\\n",
			relevance: 0
		},
		{
			className: "url hash",
			begin: "#\\w+", end: "^",
			relevance: 0
		},
		{
			className: "url domain",
			begin: "[\\w\\-\\.:/]+", end: "^",
			relevance: 0
		},
		{
			className: "statement url",
			begin: "\\<", end: "\\>",
			illegal: "\\n",
			contains: ["url hash", "url domain"],
			relevance: 0
		},
		{
			className: "statement blank",
			begin: "_:\\w+", end: "^",
			relevance: 0
		},
		{
			className: "statement terminator",
			begin: "\\.", end: "^",
			relevance: 0
		}
	]
};
