/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationSpace");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.VvcObject");

	dojo.declare("com.ibm.team.vvc.shared.core.ui.objects.ConfigurationSpace",
			com.ibm.team.vvc.shared.core.ui.objects.VvcObject, {

		getFrontServiceId: function() {
			return "spaces";
		},

		getTitle: function() {
			return this.getProperty(Constants.TITLE);
		},

		getDescription: function() {
			return this.getProperty(Constants.DESCRIPTION);
		},
		
		getDimensions: function() {
			return this.getProperty(Constants.DIMENSION);
		},

		getSubspaces: function() {
			return this.getProperty(Constants.SUBSPACE);
		},

		getDependencyResources: function() {
			return this.getProperty(Constants.DEPENDENCY_RESOURCE);
		},

		getContexts: function() {
			return this.getProperty(Constants.CONTEXT);
		},
		
		setDimensions: function(value) {
			return this.setProperty(Constants.DIMENSION, value);
		},
		
		setSubspaces: function(value) {
			return this.setProperty(Constants.SUBSPACE, value);
		},
		
		setDependencyResources: function(value) {
			return this.setProperty(Constants.DEPENDENCY_RESOURCE, value);
		},
		
		setContexts: function(value) {
			return this.setProperty(Constants.CONTEXT, value);
		}

	});
})();