/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;

	var RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
	var VVC = "http://jazz.net/ns/vvc#";
	var DC_TERMS = "http://purl.org/dc/terms/";
	var XMLS = "http://www.w3.org/2001/XMLSchema#";
	
	Constants.XMLS_BOOLEAN = XMLS + "boolean";
	
	Constants.TITLE = DC_TERMS + "title";
	Constants.DESCRIPTION = DC_TERMS + "description";
	Constants.MUTABLE = VVC + "mutable";
	Constants.POINT = VVC + "point";
	Constants.CONCEPT = VVC + "concept";
	Constants.VERSION = VVC + "version";
	Constants.CONTEXT = VVC + "context";
	Constants.VALUE_TYPE = VVC + "valueType";
	Constants.SPACE = VVC + "space";
	Constants.SUBSPACE = VVC + "subspace";
	Constants.DOMAIN = VVC + "domain";
	Constants.PATH = VVC + "path";
	Constants.SELECTS = VVC + "selects";
	Constants.DEPENDENCY_RESOURCE = VVC + "dependencyResource";
	Constants.DIMENSION = VVC + "dimension";
	Constants.ONE_GREATER_THAN = VVC + "oneGreaterThan";
	Constants.MAX_VALUE_OF_NEXT_LESSER_DIMENSION = VVC + "maxValueOfNextLesserDimension";
	Constants.BASE = VVC + "base";
	Constants.SPACE_MAP_DATA = VVC + "jsondata";
	
	Constants.TIME_ORDER_DIMENSION_NAME = "TimeOrder";
	Constants.PURPOSE_DIMENSION_NAME = "Purpose";

	Constants.CREATED = "created";
	Constants.CREATOR = "creator";
	
	Constants.CHANGESET_CREATOR = DC_TERMS + Constants.CREATOR;
	Constants.CHANGESET_CREATED = DC_TERMS + Constants.CREATED;
	
	Constants.PARENT_NAME = "parentName";
	
	Constants.COMPLETION_TIME = VVC + "completionTime";
	Constants.STATE = VVC + "state";
	Constants.STATE_COMMITTED = "COMMITTED";
	Constants.STATE_COMPLETED = "COMPLETED";
	Constants.STATE_IN_PROGRESS = "IN_PROGRESS";
	
	Constants.COMMIT_CHANGE_SET = VVC + "commitChangeSet";
	
	// constants for DELIVER operations
	Constants.DELIVER_FRONT_SERVICE_PATH = "/deliver";
	Constants.DELIVER_UI_FRONT_SERVICE_PATH = "/deliverui";
	
	Constants.DELIVER_SESSION_STATE_UNINITIALIZED = "UNINITIALIZED";
	Constants.DELIVER_SESSION_STATE_PENDING = "PENDING";
	Constants.DELIVER_SESSION_STATE_FINISHED = "FINISHED";
	Constants.DELIVER_NAMESPACE = "http://jazz.net/ns/vvc/deliver#";
	Constants.DELIVER_SESSION = Constants.DELIVER_NAMESPACE + "Session";
	Constants.DELIVER_STATE = Constants.DELIVER_NAMESPACE + "state";
	Constants.DELIVER_APPLY_COMPLETED_CHANGESETS_ONLY = Constants.DELIVER_NAMESPACE + "applyCompletedChangesetsOnly";
	Constants.DELIVER_OPERATION = Constants.DELIVER_NAMESPACE + "operation";
	Constants.DELIVER_OPERATION_DELIVER = "deliver";
	Constants.DELIVER_OPERATION_COMPARE = "compare";
	Constants.DELIVER_OPERATION_REBASE = "rebase";
	Constants.DELIVER_EXPIRATION_DATE = Constants.DELIVER_NAMESPACE + "expirationDate";
	Constants.DELIVER_CREATED_DATE = Constants.DELIVER_NAMESPACE + "createdAt";
	Constants.DELIVER_REFERER = Constants.DELIVER_NAMESPACE + "referer";
	Constants.DELIVER_SOURCE = Constants.DELIVER_NAMESPACE + "source";
	Constants.DELIVER_TARGET = Constants.DELIVER_NAMESPACE + "target";
	Constants.DELIVER_SELECTED_CHANGESETS = Constants.DELIVER_NAMESPACE + "selectedChangesets";
	Constants.DELIVER_ACCEPTED_OUTGOING = Constants.DELIVER_NAMESPACE + "acceptedOutgoing";;
	Constants.DELIVER_RESOLVED_CONFLICTS = Constants.DELIVER_NAMESPACE + "resolvedConflicts";;
	Constants.DELIVER_GAP_DEPENDENT_CHANGESETS = Constants.DELIVER_NAMESPACE + "gapDependentChangesets";
	Constants.DELIVER_DELIVERABLE_CHANGESETS = Constants.DELIVER_NAMESPACE + "deliverableChangesets";
	Constants.DELIVER_ORDER = Constants.DELIVER_NAMESPACE + "order";
	
	Constants.DELIVER_COMPARE_PROVIDER = VVC + "compareProvider";
	Constants.DELIVER_COMPARE_PROVIDER_CAN_PROVIDE_WEB_FUNCTIONALITY = VVC + "canProvideWebFunctionality";
	Constants.DELIVER_COMPARE_PROVIDER_COMPARE_WEB_URI = VVC + "compareWebUri";
	Constants.DELIVER_COMPARE_PROVIDER_HAS_SEPARATE_MERGE_PROVIDER = VVC + "hasSeparateMergeWebUri";
	Constants.DELIVER_COMPARE_PROVIDER_MERGE_WEB_URI = VVC + "mergeWebUri";
	Constants.DELIVER_COMPARE_PROVIDER_URI = VVC +  "compareProviderUri";
	Constants.DELIVER_COMPARE_PROVIDER_ORDERING = VVC +  "compareProviderOrdering";
	
})();
