/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
	dojo.provide("com.ibm.team.vvc.shared.core.ui.objects.ResolvedConflict");

	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
	var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;
	
	dojo.require("com.ibm.team.vvc.shared.core.ui.objects.VvcObject");

	/**
	 * A resolved conflict tells VVC how to resolve a CONFLICT delta type.
	 * <p>
	 * See deliver spec for more details: <a href=
	 * "https://w3-connections.ibm.com/wikis/home?lang=en-us#!/wiki/VVC%20Development%20Guidance/page/Specs%20and%20Reference%20Guide"
	 * >VVC Deliver Spec.</a>
	 * 
	 */
	dojo.declare("com.ibm.team.vvc.shared.core.ui.objects.ResolvedConflict",
			com.ibm.team.vvc.shared.core.ui.objects.VvcObject, {		

		concept: null,
		
		version: null,
		
		constructor: function(concept, version) {
			this.setConcept(concept);
			this.setVersion(version);
		},


		/**
		 * Sets the concept resource that is in conflict.
		 */
		setConcept: function(value) {
			this.setProperty(Constants.CONCEPT, value);
		},

		/**
		 * Gets the concept resource that is in conflict.
		 */
		getConcept: function() {
			return this.getProperty(Constants.CONCEPT);
		},

		/**
		 * Sets the version to resolve the conflict with.
		 */
		setVersion: function(value) {
			this.setProperty(Constants.VERSION, value);
		},

		/**
		 * Gets the version to resolve the conflict with.
		 */
		getVersion: function() {
			return this.getProperty(Constants.VERSION);
		},
		
	});
})();