/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ChangesetResourceUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ChangesetResourceUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	
	_data: null,

    constructor: function(args, parentDomNode){
    	this._data = args.data;
    },
         
    _getContent: function(){
		var def = new dojo.Deferred();
		
    	var titleText;    	
    	if(this._data.displayName){
    		titleText = this._data.displayName
		} else if(this._data.concept){
			titleText = this._data.concept;
		} else {
			titleText = this._data.version;
		}
    	   	    	
		dojo.attr(this.domNode, "title", titleText);

		var contentNode = dojo.create("span", {
			"class": "changesetResource"
		});
		
		var iconNode = dojo.create("span", {
			"class": "iconNode",
			innerHTML: "&nbsp;"
		});
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: titleText
		});
		
		contentNode.appendChild(iconNode);
		contentNode.appendChild(titleNode);
		dojo.empty(this.domNode);

    	if(this._data.displayNameHref && this._data.displayNameHref !== "null"){
        	var resourceLink = new ResourceLink({
    			uri: this._data.displayNameHref,
    			label: this._data.displayName,
    			"iconNode": iconNode 
        	});
        	this.domNode.appendChild(iconNode);
        	this.domNode.appendChild(resourceLink.domNode);
    	} else {
    		this._includeLink = false;
    		this.domNode.appendChild(contentNode);
    	}
				
		def.resolve();
		return def;
    }
    
});

})();
