/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ChangesetUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
var VvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ChangesetUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	
	_changeset: null,
	_parentDomNode: null,

    constructor: function(args, containerNode){
   		this._changeset = args.changeset;
    	    	
    	if(containerNode){
    		this._parentDomNode = containerNode;
    	}
    },
             
    _getContent: function(){
		var def = new dojo.Deferred();
		
    	var title = dojox.html.entities.encode(this._changeset.title);
    	
    	var state = this._changeset.state;
		var iconClass = "changeset" + (state ? "-" + state.toLowerCase() : "");
		dojo.attr(this.domNode, "title", "");
		dojo.attr(this.domNode, "href", this._changeset.uri);

		var contentNode = dojo.create("span", {
			"class": iconClass
		});
		
		var iconNode = dojo.create("span", {
			"class": "iconNode"
		});
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: title
		});
		
		contentNode.appendChild(iconNode);
		contentNode.appendChild(titleNode);
		
    	if(this._includeHover){
    		this.getHover(this._changeset.uri, title, this.domNode);
    	}
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		if(this._parentDomNode){
			this._parentDomNode.appendChild(this.domNode);
		}
		
		def.resolve();
		return def;
    },
    
    getHover: function(uri, title, titleNode){
    	var resourceLink = new ResourceLink({
			uri: uri,
			label: title,
			around: titleNode
    	});
    }
    
});

})();
