/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");
	
dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcCache");
var VvcCache = com.ibm.team.vvc.shared.web.ui.util.VvcCache;

dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
var VvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ConfigurationSpaceUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	
	constructor: function(){
		this._includeLink = false;
		this._includeHover = false;
	},
	
    _getCache: function(){
    	return new VvcCache({
    		target : VvcUtils.getVvcUri() + "/client/space",
    		bulkTarget : VvcUtils.getVvcUri() + "/client/spaces",
			storageKey: VvcConstants.CONFIGURATION_CACHE_KEY	// It's OK to store spaces and configurations together.
    	});
    },
    
    getEditorLink: function(conf){
        // No configuration space editors yet
		return null;
    }
    
});

})();
