/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ControllingAreaUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	
	_title: null,

    constructor: function(args, parentDomNode){
    	this._title = args.title;
    },
    
    destroy: function(){
    	this._title = null;
    	this.inherited(arguments);
    },
         
    _getContent: function(){
		var def = new dojo.Deferred();
		
    	var title = dojox.html.entities.encode(this._title);
    	
		var iconClass = this._uri.indexOf("/team-areas/") >= 0 ? "teamArea" : "projectArea";
		dojo.attr(this.domNode, "title", "");
		dojo.attr(this.domNode, "href", this._uri);

		var contentNode = dojo.create("span", {
			"class": iconClass
		});
		this._gc.destroys(contentNode);
		
		var iconNode = dojo.create("span", {
			"class": "iconNode"
		});
		this._gc.destroys(iconNode);
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: title
		});
		this._gc.destroys(titleNode);
		
		contentNode.appendChild(iconNode);
		contentNode.appendChild(titleNode);
		
    	if(this._includeHover){
    		this.getHover(this._uri, title, this.domNode);
    	}
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		def.resolve();
		return def;
    },
    
    getHover: function(areaUri, areaTitle, titleNode){
    	var resourceLink = new ResourceLink({
			uri: areaUri,
			label: areaTitle,
			around: titleNode,
			lazyFetch: true
    	});
    	this._gc.destroys(resourceLink);
    }
    
});

})();
