/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.GlobalConfigurationUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.require("com.ibm.team.vvc.shared.web.ui.VvcConstants");
var VvcConstants = com.ibm.team.vvc.shared.web.ui.VvcConstants;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.GlobalConfigurationUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	
    constructor: function(args, parentDomNode){
    	this.inherited(arguments);
    },
         
    _buildContentNode: function(conf){
    	var contentNode = dojo.create("span", {
    		"class": (conf.mutable) ? "global-configuration-mutable" : "global-configuration-immutable"
    	});
    	
    	var iconNode = dojo.create("span", {
    		"class": "iconNode"
    	});
    	
    	var titleNode = dojo.create("span", {
    		"class": "titleNode",
    		innerHTML: this.buildTitleNode(dojox.html.entities.encode(conf.title))
    	});
    	
		this.getHover(conf, this.domNode);
    	
    	contentNode.appendChild(iconNode);
    	contentNode.appendChild(titleNode);
    	
    	return contentNode;
    },
    
    getEditorLink: function(conf){
    	var queryParams = {
    		contextUri: conf.uri,
    	};
    	
    	if(dojo.config.isDebug){
    		queryParams.debug = true;
    	}
    	
    	var actionParams = {
    		action: VvcConstants.EDIT_GLOBAL_CONFIGURATION
    	};
    	
    	return VvcUtils.getVvcUri() + "/web?" +  dojo.objectToQuery(queryParams) + "#" + dojo.objectToQuery(actionParams);
    }
    
});

})();
