/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2009, 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.vvc.shared.web.ui.util.InfoContent");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dojo.i18n");
    dojo.require("jazz.ui.Dialog");
    
    dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.util", "InfoContentMessages");
    
    dojo.declare("com.ibm.team.vvc.shared.web.ui.util.InfoContent", [dijit._Widget, dijit._Templated], {
    	templatePath: dojo.moduleUrl('com.ibm.team.vvc.shared.web', 'ui/util/templates/InfoContent.html'),
        
        constructor: function(params){
        	dojo.safeMixin(this, params);        	
            this.messages= dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.util", "InfoContentMessages");
            this.buttonOk = this.messages.buttonOK;
            this.setInfo();
        },

        setInfo: function(){
        	/*Abstract Method */
        },
        
        destroy: function(){
            dojo.forEach(this._childWidgets, function(widget){
                widget.destroy();
            });
            this.inherited(arguments);
        },
        
        _handleOk: function(){
            this.onCancel();
        }
    });
    
})();
