/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils");
dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContent");
dojo.require("com.ibm.team.vvc.shared.web.ui.util.SimpleDialogContent");
dojo.require("com.ibm.team.vvc.shared.web.ui.util.QuestionDialogContent");
dojo.require("com.ibm.team.vvc.shared.web.ui.util.ThreeButtonQuestionDialogContent");
dojo.require("jazz.ui.Dialog");

	com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils = {
	    
	    showSimpleContentDialog: function(title, messageContent){
	    	var extraParams = {
	    		message: messageContent
	    	};
	    	this.showDialog(com.ibm.team.vvc.shared.web.ui.util.SimpleDialogContent, title, extraParams);
	    },
	    
	    showQuestionDialog: function(title, messageContent, okContent, cancelContent, okFunction, cancelFunction) {
	    	var extraParams = {
	    		message: messageContent,
	    		okMessage: okContent,
	    		cancelMessage: cancelContent,
	    		okFunction: okFunction,
	    		cancelFunction: cancelFunction
	    	};
	    	this.showDialog(com.ibm.team.vvc.shared.web.ui.util.QuestionDialogContent, title, extraParams);
	    },
	    
	    showThreeButtonQuestionDialog: function(title, messageContent, firstButtonContent, secondButtonContent, cancelContent, firstButtonFunction, secondButtonFunction, cancelFunction) {
	    	var extraParams = {
	    		message: messageContent,
	    		okMessage: firstButtonContent,
	    		secondButtonMessage: secondButtonContent,
	    		cancelMessage: cancelContent,
	    		okFunction: firstButtonFunction,
	    		secondButtonFunction: secondButtonFunction,
	    		cancelFunction: cancelFunction
	    	};
	    	this.showDialog(com.ibm.team.vvc.shared.web.ui.util.ThreeButtonQuestionDialogContent, title, extraParams);
	    },
	    
	    showWaitingDialog: function(title, message) {
			var root =  new dijit.layout.BorderContainer({
				region: "center",
				style: "margin-left: 16px; height:100%;"
			});
			this.root = root;
			
			var dialogMessageNode = dojo.create("div", { innerHTML: "<p>" + message + "</p>" });
			root.domNode.appendChild(dialogMessageNode);

			return new jazz.ui.Dialog({
				primaryTitle: title,
	            destroyContents: true,
				contentNode: root.domNode,
				closable: false
			});
	    },
	    
	    showDialog: function(clazz, title, extraParams, closeHook){
	        var floatingPane;
	        var onOk = dojo.hitch(this, function(){
	            floatingPane.close();
	            floatingPane.destroy();
	        });
	        
	        var onClose = dojo.hitch(this, function(){
	            floatingPane.content.destroy();
	            delete floatingPane.content;
	        });

	        var params= this._getFloatingPaneParams(clazz, title, onOk, onClose, extraParams);
	        if (closeHook) {
	        	params.onClose = closeHook;
	        }
	        floatingPane= new jazz.ui.Dialog(params);

	        var content= params.content;
	        if (content && content.setFocus){
	            content.setFocus();
	        }
	    },

	    //extraParams is optional
	    _getFloatingPaneParams: function(clazz, title, contentCloseCallback, dialogCloseCallback, extraParams){
	        var contentParams = {
	            onOk: dojo.hitch(this, contentCloseCallback),
	            onCancel: dojo.hitch(this, contentCloseCallback)
	        };
	        
	        if (extraParams) {
		        for (var param in extraParams) {
		        	contentParams[param] = extraParams[param];
		        }
	        }
	        var content = new clazz(contentParams);

	        var floatingPaneParams = {
	            contentNode: content.domNode,
	            content: content,
	            onClose: dialogCloseCallback
	        };
	        floatingPaneParams.primaryTitle = title;
	        return floatingPaneParams;
	    }
	
	};
	
	

}());