/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ListDialogContent");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("dijit.form.MultiSelect");
    dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContent");

    /**
     * Constructor params: message and list
     * message: a string message for the dialog content (mandatory)
     * list: list of strings to be shown in the list portion of the dialog (optional)
     */
    dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ListDialogContent", com.ibm.team.vvc.shared.web.ui.util.InfoContent, {
		message: null,
		list: null,
		
        constructor: function(params){
        	this.contentNode = params.message;
        	//having no message results in a pointless dialog
        	if (!this.contentNode) {
        		throw new Error("ListDialogContent invoked with no message");
        	}
        	this.list = params.list;
        	if (!this.list) {
        		this.list = [];
        	}
        },
        
        postCreate: function() {
          var textarea = dojo.create("textarea", { "class":"vvc-ui-ListDialogContent-textarea" });
          
          var textContent = "";
          var first = true;
          for (var i = 0; i < this.list.length; i++) {
        	  textContent = textContent + (first ? "" : ",\n") + this.list[i];
        	  first = false;
          }
          
          //to avoid incompatibility with IE8, do not use textarea.textContent
          textarea.innerHTML = textContent;
          textarea.rows = 10;
          textarea.readOnly = true;
          this._dialogContent.appendChild(textarea);
        }
    });
    
})();
