/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2013. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.vvc.shared.web.ui.util.QuestionDialogContent");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContent");
    
    dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.util", "QuestionDialogContentMessages");

    /**
     * To use this class in a simple way, you may use com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showQuestionContentDialog()
     */
    dojo.declare("com.ibm.team.vvc.shared.web.ui.util.QuestionDialogContent", com.ibm.team.vvc.shared.web.ui.util.InfoContent, {
		message: null,
		
		setInfo: function(){
            this.contentNode = this.message;
        },
    
	    postCreate: function() {
	      var Messages = dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.util", "QuestionDialogContentMessages");    

	  	  var cancelButton = dojo.create("button", {id: "cancelButton"}, this._buttonSection);
	  	  cancelButton.innerHTML = this.cancelMessage ? this.cancelMessage : Messages.no;
	  	  this.okCmd.innerHTML = this.okMessage ? this.okMessage : Messages.yes;
	  	  dojo.addClass(cancelButton, "Button");
	  	  dojo.connect(cancelButton, "onclick", dojo.hitch(this, this._handleCancel));
	    },
	    
        _handleOk: function(){
            this.inherited(arguments);
            
            if (this.okFunction) {
            	this.okFunction();
            }
        },
	    
        _handleCancel: function(){
            this.onCancel();
            
            if (this.cancelFunction) {
            	this.cancelFunction();
            }
        }	    
        
    });
    
})();
