/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2013, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils");

dojo.require("net.jazz.ajax.contextRoot");

dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
var NCFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

dojo.require("com.ibm.team.vvc.shared.core.ui.objects.Constants");
var Constants = com.ibm.team.vvc.shared.core.ui.objects.Constants;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.SecurityConstants");
var SecurityConstants = com.ibm.team.vvc.shared.web.ui.util.SecurityConstants;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.util", "SecurityServiceUtilsMessages");

com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils = {
	   
		messages: dojo.i18n.getLocalization("com.ibm.team.vvc.shared.web.ui.util", "SecurityServiceUtilsMessages"),
		
	    canModifyChangeset: function(changeset, context) {
	    	if (changeset.getProperty(Constants.CHANGESET_CREATOR) === jazz.app.currentApplication.config.user.uri) {
	    		return true;
	    	}
	    	
	    	return context.permissions && dojo.indexOf(context.permissions, SecurityConstants.permissions.modifyChangesets) >= 0;
	    },
	    
	    canAdministerChangeset: function(changeset, context) {
	    	if (changeset.getProperty(Constants.CHANGESET_CREATOR) === jazz.app.currentApplication.config.user.uri) {
	    		return true;
	    	}
	    	
	    	return context.permissions && dojo.indexOf(context.permissions, SecurityConstants.permissions.adminChangesets) >= 0;
	    },
	    
	    canAdministerOrModifyChangeset: function(changeset, context) {
	    	if (changeset.getProperty(Constants.CHANGESET_CREATOR) === jazz.app.currentApplication.config.user.uri) {
	    		return true;
	    	}
	    	
	    	return context.permissions && (dojo.indexOf(context.permissions, SecurityConstants.permissions.adminChangesets) >= 0 || dojo.indexOf(context.permissions, SecurityConstants.permissions.modifyChangesets) >= 0);
	    },	    
	    
	    canModifyTheChangeset: function(configurationUri){
	    	return com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils._canDo("canModifyChangeset", 
	    			"?changesetUri=" + encodeURIComponent(configurationUri));
	    },
	    
	    canAdministerTheChangeset: function(configurationUri){
	    	return com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils._canDo("canAdministerChangeset", 
	    			"?changesetUri=" + encodeURIComponent(configurationUri));
	    },
	    
	    canMerge: function(configurationUri){
	    	return com.ibm.team.vvc.shared.web.ui.util.SecurityServiceUtils._canDo("canMerge", 
	    			"?configurationUri=" + encodeURIComponent(configurationUri));
	    },	    
	    
	    _canDo: function(service, configurationUri){    	
	    	var args = {
	    			handleAs: 'json',
	    			url: VvcUtils.getVvcUri() + "/security/" + service + configurationUri,
	    			headers: {
	    				"Accept":"application/json",
	    			},
	    			load: function(response, ioArgs){
	    				if(response && response.result){
	    					return response.result === "ok";
	    				}
	    				return false;
	    			},
	    			error: function(response){
	    				return false;
	    			}
	    	};
	    	return jazz.client.xhrGet(args);
	    },
	    
	    getNoPermissionMessage: function(teamArea) {
			return dojo.string.substitute(this.messages.noPermissionToPerformAction, [teamArea]);
	    },
	    
	    getNoPermissionChangesetMessage: function(teamArea) {
			return dojo.string.substitute(this.messages.noPermissionToPerformChangesetAction, [teamArea]);
	    },
	    
	    _get: function(service, configurationUri){    	
	    	var args = {
	    			handleAs: 'json',
	    			url: VvcUtils.getVvcUri() + "/security/" + service + encodeURIComponent(configurationUri),
	    			headers: {
	    				"Accept":"application/json",
	    			},
	    			load: function(response, ioArgs){
	    				if(response) {
	    					return response.result;
	    				}
	    				return null;
	    			}
	    	};
	    	return jazz.client.xhrGet(args);
	    },	    
	    
	    getChangesetControllingArea: function(changesetUri) {
	    	return this._get("getChangesetControllingArea?changesetUri=", changesetUri);
	    }	    
	    
};

})(); // end object