/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
    dojo.provide("com.ibm.team.vvc.shared.web.ui.util.ThreeButtonQuestionDialogContent");
    
    dojo.require("dijit._Widget");
    dojo.require("dijit._Templated");
    dojo.require("com.ibm.team.vvc.shared.web.ui.util.InfoContent");
    
    dojo.requireLocalization("com.ibm.team.vvc.shared.web.ui.util", "QuestionDialogContentMessages");

    /**
     * To use this class in a simple way, you may use com.ibm.team.vvc.shared.web.ui.util.InfoContentUtils.showThreeButtonQuestionContentDialog()
     */
    dojo.declare("com.ibm.team.vvc.shared.web.ui.util.ThreeButtonQuestionDialogContent", com.ibm.team.vvc.shared.web.ui.util.QuestionDialogContent, {
		
	    postCreate: function() {
	  	  var secondButton = dojo.create("button", {id: "secondButton",
	  		  innerHTML: this.secondButtonMessage,
	  		  "class": "Button",
	  		  onclick: dojo.hitch(this, this._handleSecondButton)},
	  		  this._buttonSection);
	  	  
	      this.inherited(arguments);
	    },
	    
        _handleSecondButton: function(){
        	this.onClose();
            
            if (this.secondButtonFunction) {
            	this.secondButtonFunction();
            }
        }	    
        
    });
    
})();
