/*
 *+------------------------------------------------------------------------+
 *| Licensed Materials - Property of IBM                                   |
 *|                                                                        |
 *| com.ibm.team.vvc.shared.web                                           |
 *|                                                                        |
 *| Copyright IBM Corporation 2012, 2014.  All Rights Reserved.                  |
 *|                                                                        |
 *| U.S. Government Users Restricted Rights - Use, duplication or          |
 *| disclosure restricted by GSA ADP Schedule Contract with IBM Corp.      |
 *+------------------------------------------------------------------------+
 */
(function() {	

	dojo.provide("com.ibm.team.vvc.shared.web.ui.util.UIUtils");
	
	dojo.require("jazz.ui.PageTemplate");
	
	com.ibm.team.vvc.shared.web.ui.util.UIUtils = {
		
		showPageMessage: function(message, displayPeriod)
	    {
	    	//TODO: Get rid of when jazz.ui.PageTemplate gets fixed
	    	// hack to get around bug in jazz ui status message display which fails to set opacity to 1 when show message event first published
	    	//I should submit a bug to the jazz ui team
	    	var statusMessageNodes = dojo.query(".status-message");
	    	for(var i=0; i < statusMessageNodes.length; i++) {
				var statusMessage = statusMessageNodes[i];
				if (statusMessage.parentNode.id = "content-cell")
					statusMessage.style.opacity = 1;
			}
	    	
	    	dojo.publish(jazz.ui.PageTemplate.StatusMessage.SHOW, [message, true]);
	    	var pageTemplate = dijit.byId("jazz_ui_PageTemplate_0");
	    	if (pageTemplate)
	    	{ //eliminate fading in animation because sometimes loading is too quick to show the message box
	    		pageTemplate._fadeInAnim.gotoPercent(1.0);
	    	}
	    	
	    	if (displayPeriod != null)
	    	{
	    		setTimeout(this.hidePageMessage, displayPeriod);
	    	}
	    },
	    
	    hidePageMessage: function()
	    {
	    	dojo.publish(jazz.ui.PageTemplate.StatusMessage.HIDE);
	    },
	    
	    truncateString: function(str) {
	    	return (!str) ? "" : (str.length > 100 ? str.substring(0, 97) + "..." : str);
 	    }
	};


}());