/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corporation 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.UserUiNode");

dojo.require("com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode");

dojo.require("jazz.ui.ResourceLink");
var ResourceLink = jazz.ui.ResourceLink;

dojo.declare("com.ibm.team.vvc.shared.web.ui.util.UserUiNode", com.ibm.team.vvc.shared.web.ui.util.ConfigurationUiNode, {
	        
    _getContent: function(){
		var def = new dojo.Deferred();
		
		var title = this._uri.substring(this._uri.lastIndexOf('/') + 1);
    	title = dojox.html.entities.encode(title);
    	
    	dojo.attr(this.domNode, "title", "");
    	dojo.attr(this.domNode, "href", this._uri);
    	
		var iconClass = "user";

		var contentNode = dojo.create("span", {
			"class": iconClass
		});
		
		var iconNode = dojo.create("span", {
			"class": "iconNode"
		});
		
		var titleNode = dojo.create("span", {
			"class": "titleNode",
			innerHTML: title
		});
		
		contentNode.appendChild(iconNode);
		contentNode.appendChild(titleNode);
		
    	if(this._includeHover){
    		this.getHover(this._uri, title, this.domNode);
    	}
		
		dojo.empty(this.domNode);
		this.domNode.appendChild(contentNode);
		
		def.resolve();
		return def;
    },
    
    getHover: function(userUri, userTitle, titleNode){
    	var resourceLink = new ResourceLink({
			uri: userUri,
			label: userTitle,
			around: titleNode,
			lazyFetch: true
    	});
    }
    
});

})();
