/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2013, 2014.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

(function() {	
dojo.provide("com.ibm.team.vvc.shared.web.ui.util.interceptors.PreventCSRFInterceptor");

dojo.require("dojo.cookie"); //$NON-NLS-1$
	
var CSRF_COOKIE = "vvc-csrf-prevent"; //$NON-NLS-1$
var CSRF_HEADER = "X-Jazz-CSRF-Prevent"; //$NON-NLS-1$
var SURROUNDING_QUOTES = /^"(.*)".*/; //$NON-NLS-1$

jazz.client.internal.addRequestInterceptor(function(request) {
	if(!(request && request.args)){
		// Something is terribly wrong, attempt to recover by not doing anything...
		return;
	} else if(!request.args.headers){
		// If we have a request, and request.args, but not request.args.headers, initialise it.
		request.args.headers = {};
	}
	
	var headers = request.args.headers;
	var csrfToken = dojo.cookie(CSRF_COOKIE); //$NON-NLS-1$
	if (csrfToken) {
		headers[CSRF_HEADER] = csrfToken.replace(SURROUNDING_QUOTES, "$1"); //$NON-NLS-1$ 
	}
});
})();
 