/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2012, 2013. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

/**
 * Utility for extracting embedded information from errors passed by from server calls.
 * 
 * @author Steve Shaw
 */
(function(){
	
	dojo.provide("com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil");
	
	dojo.require("dojox.html.entities");

	var util = com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil;

	dojo.mixin(util, {
		
		_getTextBetween: function(str, startTag, endTag, again) {
			 var start = str.indexOf(startTag);
			 if (start > 0) {
				 var c = again ? dojox.html.entities.encode('>') : '>';
				 start = str.indexOf(c, start + c.length);
				 var end = str.indexOf(endTag, start + c.length);
				 if (end > start ){
					 return str.substring(start + c.length, end);
				 }
			 } else if (!again) {
				 endTag = dojox.html.entities.encode(endTag);
				 startTag = dojox.html.entities.encode(startTag);
				 return this._getTextBetween(str, startTag, endTag, true);
			 }
			 return null;
		},
		
		getErrorDetails: function(errorObj) {	
			 if ( errorObj.responseText ){
				 var error = errorObj.responseText;
				 var errorSubStatus = com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil._getTextBetween(error, '<err:errorSubStatus', '</err:errorSubStatus>');
				 var errorMessage = com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil._getTextBetween(error, '<err:errorMessage', '</err:errorMessage>');
				 var errorStatus = com.ibm.team.vvc.shared.core.ui.utils.ErrorUtil._getTextBetween(error, '<err:errorStatus', '</err:errorStatus>');
				 return { "errorSubStatus": errorSubStatus, "errorMessage": errorMessage, "errorStatus": Number(errorStatus) } ;
			 }
			 
			 return null;
		 }
		
	});
    
})(); // end function()