/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.dsv.editor.owl.ui.xml");

dojo.require("dojox.highlight._base");

/**
 * Ruleset to highlight xml, making sure to cover the xml features used in rdf/xml generated by Jena.
 * Note: Modified from dojox.highlight.languages.pygments.xml
 * 
 * @author mgobeil 
 */
dojo.provide("dojox.highlight.languages.xml");
dojox.highlight.languages.xml = {
	defaultMode: {
		contains: [
			"name entity",
			"comment", "comment preproc",
			"_tag", "tag value"
		]
	},
	modes: [
		// comments
		{
			className: "comment",
			begin: "<!--", end: "-->"
		},
		{
			className: "comment preproc",
			begin: "\\<\\!\\[CDATA\\[", end: "\\]\\]\\>"
		},
		{
			className: "comment preproc",
			begin: "\\<\\!", end: "\\>"
		},
		{
			className: "comment preproc",
			begin: "\\<\\?", end: "\\?\\>",
			relevance: 5
		},

		// strings
		{
			className: "string",
			begin: "'", end: "'",
			illegal: "\\n",
			relevance: 0
		},
		{
			className: "string",
			begin: '"', end: '"',
			illegal: "\\n",
			relevance: 0
		},
		
		// names
		{
			className: "name entity",
			begin: "\\&[a-z]+;", end: "^"
		},
		{
			className: "tag namespace",
			begin: "/?[\\w\\.]+\\:", end: "^",
			relevance: 0
		},		
		{
			className: "name attribute",
			begin: "\\b[\\w\\.\\-]+=", end: "^",
			relevance: 0
		},
		{
			className: "tag name",
			begin: "/?[a-zA-Z0-9\\.\\-]+\\b", end: "^"
		},
		
		// tags
		{
			className: "_tag",
			begin: "\\<", end: "\\>",
			contains: ["tag namespace", "name attribute", "string", "tag name"]
		},
		{
			className: "_tag",
			begin: "\\</", end: "\\>",
			contains: ["tag name"]
		},
		
		{
			className: "tag value",
			begin: "[^\\<\\>\\s]+[^\\<\\>]+", end: "^",
			illegal: "\\n"
		}
	]
};
