/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmps.core.user.User");

dojo.require("rmps.core.resource.Resource");

// TODO
//rmps.core.user.User.XMLNS = "";

dojo.declare("rmps.core.user.User", rmps.core.resource.Resource, {
	
	// serialized properties
	
	// TODO
	id: null,
	
	name: null,
	
	email: null,
	
	photoUri: null,
	
	// END serialized properties
	
//	/**
//	 * Return the XML representation of the user.
//	 * 
//	 * @return the XML representation of the user
//	 * @type String
//	 */
//	toXMLString: function() {
//		// TODO
//	},
	
	parse: function(person, ioArgs) {
//		if (ioArgs) {
//			var xhr = ioArgs.xhr;
//			if (xhr.getResponseHeader("Last-Modified")) {
//				this.lastModified = new Date(xhr.getResponseHeader("Last-Modified"));
//			}
//			if (xhr.getResponseHeader("ETag")) {
//				this.eTag = xhr.getResponseHeader("ETag");
//			}
//			if (xhr.getResponseHeader("Location")) {
//				// TODO revision
////				this.revisionUri = xhr.getResponseHeader("Content-Location");
////				this.uri = this.revisionUri.substring(0, this.revisionUri.indexOf("?"));
//				this.uri = xhr.getResponseHeader("Location");
//			}
//		}

		var rdfPrefix = "rdf:";
		var foafPrefix = "foaf:";
		
		for (var key in person.namespaces) {
			var namespace = person.namespaces[key];
			if (namespace == "http://xmlns.com/foaf/0.1/") {
				foafPrefix = key + ":";
			} else if (namespace == "http://www.w3.org/1999/02/22-rdf-syntax-ns#") {
				rdfPrefix = key + ":";
			}
		}
		
		this.uri = person.getElementsByTagName(rdfPrefix + "Description")[0].getAttribute(rdfPrefix + "about");
		
		this.id = person.getElementsByTagName(foafPrefix + "nick")[0].childNodes[0].nodeValue;
		this.name = person.getElementsByTagName(foafPrefix + "name")[0].childNodes[0].nodeValue;
		this.email = decodeURIComponent(person.getElementsByTagName(foafPrefix + "mbox")[0].getAttribute("rdf:resource").substring(7)); // strip "mailto:"
		
		var img = person.getElementsByTagName(foafPrefix + "img")[0];
		if (img) {
			this.photoUri = img.getAttribute(rdfPrefix + "resource");
		}
	}
	
});
