/*******************************************************************************
 * Licensed Materials - Property of IBM 
 * Copyright IBM Corp. 2011. All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.util.AbstractCollection");
dojo.require("rmpw.diagrams.layout.client.util.Object");

createFrom = function(array, length_0){
	  var a, result;
	  a = array;
	  result = createFromSeed(0, length_0);
	  initValues(a.arrayClass$, a.typeId$, a.queryId$, result);
	  return result;
	};

	createFromSeed = function(seedType, length_0){
	  var array = new Array(length_0);
	  if (seedType > 0) {
	    var value = [null, 0, false, [0, 0]][seedType];
	    for (var i = 0; i < length_0; ++i) {
	      array[i] = value;
	    }
	  }
	  return array;
	};

	getClass_4 = function(){
	  return this.arrayClass$;
	};

	initDim = function(arrayClass, typeId, queryId, length_0, seedType){
	  var result;
	  result = createFromSeed(seedType, length_0);
	  $clinit_4();
	  wrapArray(result, expandoNames_0, expandoValues_0);
	  result.arrayClass$ = arrayClass;
	  result.typeId$ = typeId;
	  result.queryId$ = queryId;
	  return result;
	};

	initValues = function(arrayClass, typeId, queryId, array){
	  $clinit_4();
	  wrapArray(array, expandoNames_0, expandoValues_0);
	  array.arrayClass$ = arrayClass;
	  array.typeId$ = typeId;
	  array.queryId$ = queryId;
	  return array;
	};

	setCheck = function(array, index, value){
	  if (value != null) {
	    if (array.queryId$ > 0 && !canCastUnsafe(value.typeId$, array.queryId$)) {
	      throw new ArrayStoreException();
	    }
	    if (array.queryId$ < 0 && (value.typeMarker$ == nullMethod || value.typeId$ == 2)) {
	      throw new ArrayStoreException();
	    }
	  }
	  return array[index] = value;
	};

	Array_0 = function(){
	};

	_ = Array_0.prototype = new Object_0();
	_.getClass$ = getClass_4;
	_.typeId$ = 0;
	_.arrayClass$ = null;
	_.length = 0;
	_.queryId$ = 0;
	
arraycopy = function(src, srcOfs, dest, destOfs, len){
	  var destArray, destEnd, destTypeName, destlen, srcArray, srcTypeName, srclen;
	  if (src == null || dest == null) {
	    throw 'NullPointerException';
	  }
	  srcTypeName = (src.typeMarker$ == nullMethod || src.typeId$ == 2?src.getClass$():Lcom_google_gwt_core_client_JavaScriptObject_2_classLit).typeName;
	  destTypeName = (dest.typeMarker$ == nullMethod || dest.typeId$ == 2?dest.getClass$():Lcom_google_gwt_core_client_JavaScriptObject_2_classLit).typeName;
	  if (srcTypeName.charCodeAt(0) != 91 || destTypeName.charCodeAt(0) != 91) {
	    throw 'Must be array types';
	  }
	  if (srcTypeName.charCodeAt(1) != destTypeName.charCodeAt(1)) {
	    throw 'Array types must match';
	  }
	  srclen = src.length;
	  destlen = dest.length;
	  if (srcOfs < 0 || destOfs < 0 || len < 0 || srcOfs + len > srclen || destOfs + len > destlen) {
	    throw 'IndexOutOfBoundsException';
	  }
	  if ((srcTypeName.charCodeAt(1) == 76 || srcTypeName.charCodeAt(1) == 91) && !$equals_0(srcTypeName, destTypeName)) {
	    srcArray = src;
	    destArray = dest;
	    if ((src == null?null:src) === (dest == null?null:dest) && srcOfs < destOfs) {
	      srcOfs += len;
	      for (destEnd = destOfs + len; destEnd-- > destOfs;) {
	        setCheck(destArray, destEnd, srcArray[--srcOfs]);
	      }
	    }
	     else {
	      for (destEnd = destOfs + len; destOfs < destEnd;) {
	        setCheck(destArray, destOfs++, srcArray[srcOfs++]);
	      }
	    }
	  }
	   else {
	    Array.prototype.splice.apply(dest, [destOfs, len].concat(src.slice(srcOfs, srcOfs + len)));
	  }
	};

	$addAll = function(this$static, c){
	  var changed, iter;
	  iter = c.iterator();
	  changed = false;
	  while (iter.hasNext()) {
	    if (this$static.add_0(iter.next())) {
	      changed = true;
	    }
	  }
	  return changed;
	};

	$advanceToFind = function(iter, o){
	  var t;
	  while (iter.hasNext()) {
	    t = iter.next();
	    if (o == null?t == null:equals__devirtual$(o, t)) {
	      return iter;
	    }
	  }
	  return null;
	};

	$removeAll = function(this$static, c){
	  var changed, iter;
	  iter = $AbstractList$IteratorImpl(new AbstractList$IteratorImpl(), this$static);
	  changed = false;
	  while (iter.i < iter.this$0_0.size_0()) {
	    if (c.contains($next_0(iter))) {
	      $remove_1(iter);
	      changed = true;
	    }
	  }
	  return changed;
	};

	$toString_0 = function(this$static){
	  var comma, iter, sb;
	  sb = $StringBuffer(new StringBuffer());
	  comma = null;
	  sb.impl.string += '[';
	  iter = this$static.iterator();
	  while (iter.hasNext()) {
	    if (comma != null) {
	      sb.impl.string += comma;
	    }
	     else {
	      comma = ', ';
	    }
	    $append_0(sb, '' + iter.next());
	  }
	  sb.impl.string += ']';
	  return sb.impl.string;
	};

	add_0 = function(o){
	  throw 'Add not supported on this collection';
	};

	addAll = function(c){
	  return $addAll(this, c);
	};

	contains = function(o){
	  var iter;
	  iter = $advanceToFind(this.iterator(), o);
	  return !!iter;
	};

	getClass_23 = function(){
	  return Ljava_util_AbstractCollection_2_classLit;
	};

	isEmpty = function(){
	  return this.size_0() == 0;
	};

	remove = function(o){
	  var iter;
	  iter = $advanceToFind(this.iterator(), o);
	  if (iter) {
	    iter.remove();
	    return true;
	  }
	   else {
	    return false;
	  }
	};

	toArray = function(){
	  return this.toArray_0(initDim(_3Ljava_lang_Object_2_classLit, 114, 0, this.size_0(), 0));
	};

	toArray_0 = function(a){
	  var i, it, result, size;
	  size = this.size_0();
	  if (a.length < size) {
	    a = createFrom(a, size);
	  }
	  result = a;
	  it = this.iterator();
	  for (i = 0; i < size; ++i) {
	    setCheck(result, i, it.next());
	  }
	  if (a.length > size) {
	    setCheck(a, size, null);
	  }
	  return a;
	};

	toString_9 = function(){
	  return $toString_0(this);
	};

	AbstractCollection = function(){
	};

	_ = AbstractCollection.prototype = new Object_0();
	_.add_0 = add_0;
	_.addAll = addAll;
	_.contains = contains;
	_.getClass$ = getClass_23;
	_.isEmpty = isEmpty;
	_.remove_1 = remove;
	_.toArray = toArray;
	_.toArray_0 = toArray_0;
	_.toString$ = toString_9;
	_.typeId$ = 21;

dojo.declare("rmpw.diagrams.layout.client.util.AbstractCollection", null, {

});