/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.util.AbstractList");
dojo.require("rmpw.diagrams.layout.client.util.AbstractCollection");

$listIterator = function(this$static, from){
	  return $AbstractList$ListIteratorImpl_0(new AbstractList$ListIteratorImpl(), from, this$static);
	};

	add_2 = function(obj){
	  this.add(this.size_0(), obj);
	  return true;
	};

	add_1 = function(index, element){
	  throw 'Add not supported on this list';
	};

	checkIndex = function(index, size){
	  if (index < 0 || index >= size) {
	    indexOutOfBounds(index, size);
	  }
	};

	clear = function(){
	  this.removeRange(0, this.size_0());
	};

	equals_5 = function(o){
	  var elem, elemOther, iter, iterOther, other;
	  if ((o == null?null:o) === this) {
	    return true;
	  }
	  if (!(o != null)) {
	    return false;
	  }
	  other = o;
	  if (other.size_0 === undefined || this.size_0() != other.size_0()) {
	    return false;
	  }
	  iter = this.iterator();
	  iterOther = other.iterator();
	  while (iter.i < iter.this$0_0.size_0()) {
	    elem = $next_0(iter);
	    elemOther = iterOther.next();
	    if (!(elem == null?elemOther == null:equals__devirtual$(elem, elemOther))) {
	      return false;
	    }
	  }
	  return true;
	};

	getClass_31 = function(){
	  return Ljava_util_AbstractList_2_classLit;
	};

	hashCode_6 = function(){
	  var iter, k, obj;
	  k = 1;
	  iter = this.iterator();
	  while (iter.i < iter.this$0_0.size_0()) {
	    obj = $next_0(iter);
	    k = 31 * k + (obj == null?0:hashCode__devirtual$(obj));
	    k = ~~k;
	  }
	  return k;
	};

	indexOutOfBounds = function(index, size){
	  throw 'IndexOutOfBoundsException' + 'Index: ' + index + ', Size: ' + size;
	};

	iterator_0 = function(){
	  return $AbstractList$IteratorImpl(new AbstractList$IteratorImpl(), this);
	};

	listIterator = function(){
	  return $AbstractList$ListIteratorImpl(new AbstractList$ListIteratorImpl(), this);
	};

	remove_3 = function(index){
	  throw 'Remove not supported on this list';
	};

	removeRange = function(fromIndex, endIndex){
	  var i, iter;
	  iter = $AbstractList$ListIteratorImpl_0(new AbstractList$ListIteratorImpl(), fromIndex, this);
	  for (i = fromIndex; i < endIndex; ++i) {
	    iter.next();
	    iter.remove();
	  }
	};

	set_0 = function(index, o){
	  throw 'Set not supported on this list';
	};

	AbstractList = function(){
	};

	_ = AbstractList.prototype = new AbstractCollection();
	_.add_0 = add_2;
	_.add = add_1;
	_.clear = clear;
	_.equals$ = equals_5;
	_.getClass$ = getClass_31;
	_.hashCode$ = hashCode_6;
	_.iterator = iterator_0;
	_.listIterator = listIterator;
	_.remove_0 = remove_3;
	_.removeRange = removeRange;
	_.set = set_0;
	_.typeId$ = 29;
	$AbstractList$IteratorImpl = function(this$static, this$0){
	  this$static.this$0_0 = this$0;
	  return this$static;
	};

	$hasNext = function(this$static){
	  return this$static.i < this$static.this$0_0.size_0();
	};

	$next_0 = function(this$static){
	  if (this$static.i >= this$static.this$0_0.size_0()) {
	    throw 'NoSuchElementException';
	  }
	  return this$static.this$0_0.get(this$static.last = this$static.i++);
	};

	$remove_1 = function(this$static){
	  if (this$static.last < 0) {
	    throw 'IllegalStateException';
	  }
	  this$static.this$0_0.remove_0(this$static.last);
	  this$static.i = this$static.last;
	  this$static.last = -1;
	};

	getClass_29 = function(){
	  return Ljava_util_AbstractList$IteratorImpl_2_classLit;
	};

	hasNext_0 = function(){
	  return this.i < this.this$0_0.size_0();
	};

	next_1 = function(){
	  return $next_0(this);
	};

	remove_2 = function(){
	  $remove_1(this);
	};

	AbstractList$IteratorImpl = function(){
	};

	_ = AbstractList$IteratorImpl.prototype = new Object_0();
	_.getClass$ = getClass_29;
	_.hasNext = hasNext_0;
	_.next = next_1;
	_.remove = remove_2;
	_.typeId$ = 0;
	_.i = 0;
	_.last = -1;
	_.this$0_0 = null;
	$AbstractList$ListIteratorImpl = function(this$static, this$0){
	  this$static.this$0 = this$0;
	  this$static.this$0_0 = this$0;
	  return this$static;
	};

	$AbstractList$ListIteratorImpl_0 = function(this$static, start, this$0){
	  var size;
	  this$static.this$0 = this$0;
	  this$static.this$0_0 = this$0;
	  size = this$static.this$0.size_0();
	  if (start < 0 || start > size) {
	    indexOutOfBounds(start, size);
	  }
	  this$static.i = start;
	  return this$static;
	};

	$previous = function(this$static){
	  if (this$static.i <= 0) {
	    throw 'NoSuchElementException';
	  }
	  return this$static.this$0.get(this$static.last = --this$static.i);
	};

	$set = function(this$static, o){
	  if (this$static.last == -1) {
	    throw 'IllegalStateException';
	  }
	  this$static.this$0.set(this$static.last, o);
	};

	getClass_30 = function(){
	  return Ljava_util_AbstractList$ListIteratorImpl_2_classLit;
	};

	AbstractList$ListIteratorImpl = function(){
	};

	_ = AbstractList$ListIteratorImpl.prototype = new AbstractList$IteratorImpl();
	_.getClass$ = getClass_30;
	_.typeId$ = 0;
	_.this$0 = null;
	
dojo.declare("rmpw.diagrams.layout.client.util.AbstractList", rmpw.diagrams.layout.client.util.AbstractCollection, {

});