/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.layout.client.util.ArrayList");
dojo.require("rmpw.diagrams.layout.client.util.AbstractList");

$ArrayList = function(this$static){
	  this$static.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
	  this$static.size = 0;
	  return this$static;
	};

	$ArrayList_1 = function(this$static, c){
	  this$static.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
	  this$static.size = 0;
	  $addAll_0(this$static, c);
	  return this$static;
	};

	$ArrayList_0 = function(this$static, initialCapacity){
	  this$static.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
	  this$static.size = 0;
	  $ensureCapacity(this$static, initialCapacity);
	  return this$static;
	};

	$add_0 = function(this$static, o){
	  setCheck(this$static.array, this$static.size++, o);
	  return true;
	};

	$add = function(this$static, index, o){
	  if (index < 0 || index > this$static.size) {
	    indexOutOfBounds(index, this$static.size);
	  }
	  this$static.array.splice(index, 0, o);
	  ++this$static.size;
	};

	$addAll_0 = function(this$static, c){
	  if (c.isEmpty()) {
	    return false;
	  }
	  Array.prototype.splice.apply(this$static.array, [this$static.size, 0].concat(c.toArray()));
	  this$static.size += c.size_0();
	  return true;
	};

	$clear = function(this$static){
	  this$static.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
	  this$static.size = 0;
	};

	$ensureCapacity = function(this$static, capacity){
	  if (capacity > this$static.size) {
	    this$static.array.length = capacity;
	  }
	};

	$get_0 = function(this$static, index){
	  checkIndex(index, this$static.size);
	  return this$static.array[index];
	};

	$indexOf = function(this$static, o, index){
	  for (; index < this$static.size; ++index) {
	    if (equalsWithNullCheck(o, this$static.array[index])) {
	      return index;
	    }
	  }
	  return -1;
	};

	$remove_2 = function(this$static, index){
	  var previous;
	  checkIndex(index, this$static.size);
	  previous = this$static.array[index];
	  this$static.array.splice(index, 1);
	  --this$static.size;
	  return previous;
	};

	$remove_3 = function(this$static, o){
	  var i;
	  i = $indexOf(this$static, o, 0);
	  if (i == -1) {
	    return false;
	  }
	  $remove_2(this$static, i);
	  return true;
	};

	$removeRange = function(this$static, fromIndex, endIndex){
	  var count;
	  checkIndex(fromIndex, this$static.size);
	  if (endIndex < fromIndex || endIndex > this$static.size) {
	    indexOutOfBounds(endIndex, this$static.size);
	  }
	  count = endIndex - fromIndex;
	  this$static.array.splice(fromIndex, count);
	  this$static.size -= count;
	};

	$set_0 = function(this$static, index, o){
	  var previous;
	  checkIndex(index, this$static.size);
	  previous = this$static.array[index];
	  setCheck(this$static.array, index, o);
	  return previous;
	};

	$toArray = function(this$static){
	  var a, result;
	  return a = this$static.array , result = a.slice(0, this$static.size) , initValues(a.arrayClass$, a.typeId$, a.queryId$, result) , result;
	};

	$toArray_0 = function(this$static, out){
	  var i, a, result;
	  if (out.length < this$static.size) {
		a = out;
		result = createFromSeed(0, this$static.size);
		initValues(a.arrayClass$, a.typeId$, a.queryId$, result);
	    out = result;
	  }
	  for (i = 0; i < this$static.size; ++i) {
	    setCheck(out, i, this$static.array[i]);
	  }
	  if (out.length > this$static.size) {
	    setCheck(out, this$static.size, null);
	  }
	  return out;
	};

	add_4 = function(o){
	  return setCheck(this.array, this.size++, o) , true;
	};

	add_3 = function(index, o){
	  $add(this, index, o);
	};

	addAll_0 = function(c){
	  return $addAll_0(this, c);
	};

	clear_0 = function(){
	  this.array = initDim(_3Ljava_lang_Object_2_classLit, 114, 0, 0, 0);
	  this.size = 0;
	};

	contains_3 = function(o){
	  return $indexOf(this, o, 0) != -1;
	};

	get = function(index){
	  return checkIndex(index, this.size) , this.array[index];
	};

	getClass_39 = function(){
	  return Ljava_util_ArrayList_2_classLit;
	};

	isEmpty_0 = function(){
	  return this.size == 0;
	};

	remove_6 = function(index){
	  return $remove_2(this, index);
	};

	remove_7 = function(o){
	  return $remove_3(this, o);
	};

	removeRange_0 = function(fromIndex, endIndex){
	  $removeRange(this, fromIndex, endIndex);
	};

	set_1 = function(index, o){
	  var previous;
	  checkIndex(index, this.size);
	  return previous = this.array[index] , setCheck(this.array, index, o) , previous;
	};

	size_5 = function(){
	  return this.size;
	};

	toArray_1 = function(){
	  var a, result;
	  return a = this.array , result = a.slice(0, this.size) , initValues(a.arrayClass$, a.typeId$, a.queryId$, result) , result;
	};

	toArray_2 = function(out){
	  return $toArray_0(this, out);
	};

	ArrayList = function(){
		dojo.mixin(this, new rmpw.diagrams.layout.client.util.ArrayList());
	};

	_ = ArrayList.prototype = new AbstractList();
	_.add_0 = add_4;
	_.add = add_3;
	_.addAll = addAll_0;
	_.clear = clear_0;
	_.contains = contains_3;
	_.get = get;
	_.getClass$ = getClass_39;
	_.isEmpty = isEmpty_0;
	_.remove_0 = remove_6;
	_.remove_1 = remove_7;
	_.removeRange = removeRange_0;
	_.set = set_1;
	_.size_0 = size_5;
	_.toArray = toArray_1;
	_.toArray_0 = toArray_2;
	_.typeId$ = 32;
	_.array = null;
	_.size = 0;
	
	reverse_0 = function(l){
		  var t, previous;
		  var head, headElem, iBack, iFront, tail, tailElem;
		  if (l) {
		    for (iFront = 0 , iBack = l.size - 1; iFront < iBack; ++iFront , --iBack) {
		      checkIndex(iFront, l.size);
		      t = l.array[iFront];
		      checkIndex(iBack, l.size);
		      $set_0(l, iFront, l.array[iBack]);
		      checkIndex(iBack, l.size);
		      previous = l.array[iBack];
		      setCheck(l.array, iBack, t);
		    }
		  }
		   else {
		    head = $AbstractList$ListIteratorImpl(new AbstractList$ListIteratorImpl(), l);
		    tail = $listIterator(l, l.size);
		    while (head.i < tail.i - 1) {
		      headElem = head.next();
		      tailElem = $previous(tail);
		      $set(head, tailElem);
		      $set(tail, headElem);
		    }
		  }
		};
		
		insertionSort = function(array, low, high, comp){
			  var i, j, t;
			  for (i = low + 1; i < high; ++i) {
			    for (j = i; j > low && comp.compare(array[j - 1], array[j]) > 0; --j) {
			      t = array[j];
			      setCheck(array, j, array[j - 1]);
			      setCheck(array, j - 1, t);
			    }
			  }
			};
		
		merge = function(src, srcLow, srcMid, srcHigh, dest, destLow, destHigh, comp){
			var topIdx;
			topIdx = srcMid;
			while (destLow < destHigh) {
				if (topIdx >= srcHigh || srcLow < srcMid && comp.compare(src[srcLow], src[topIdx]) <= 0) {
					setCheck(dest, destLow++, src[srcLow++]);
				}
				else {
					setCheck(dest, destLow++, src[topIdx++]);
				}
			}
		};

		mergeSort = function(x, fromIndex, toIndex, comp){
			var temp, a, result;
			a = x;
			result = a.slice(fromIndex, toIndex);
			temp = initValues(a.arrayClass$, a.typeId$, a.queryId$, result) , result;
			mergeSort_0(temp, x, fromIndex, toIndex, -fromIndex, comp);
		};

		mergeSort_0 = function(temp, array, low, high, ofs, comp){
			var length_0, tempHigh, tempLow, tempMid;
			length_0 = high - low;
			if (length_0 < 7) {
				insertionSort(array, low, high, comp);
				return;
			}
			tempLow = low + ofs;
			tempHigh = high + ofs;
			tempMid = tempLow + (tempHigh - tempLow >> 1);
			mergeSort_0(array, temp, tempLow, tempMid, -ofs, comp);
			mergeSort_0(array, temp, tempMid, tempHigh, -ofs, comp);
			if (comp.compare(temp[tempMid - 1], temp[tempMid]) <= 0) {
				while (low < high) {
					setCheck(array, low++, temp[tempLow++]);
				}
				return;
			}
			merge(temp, tempLow, tempMid, tempHigh, array, low, high, comp);
		};

dojo.declare("rmpw.diagrams.layout.client.util.ArrayList", rmpw.diagrams.layout.client.util.AbstractList, {

});