/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.render.util.Dimension");

dojo.declare("rmpw.diagrams.render.util.Dimension", null, {
	
	constructor: function(width, height) {
		this.width = width;
		this.height = height;
	},
	
	performScale: function(amount) {
		this.width = this.width * amount;
		this.height = this.height * amount;
		return this;
	},
	
	transform: function (surfaceMatrix) {
		if (surfaceMatrix) {
			this.width = this.width * surfaceMatrix.xx;
			this.height = this.height * surfaceMatrix.yy;
		}
		return this;
	},
	
	getCopy: function() {
		return new rmpw.diagrams.render.util.Dimension(this.width, this.height);
	},
	
	union: function (d){
		this.width = Math.max(this.width, d.width);
		this.height = Math.max(this.height, d.height);
		return this;
	},
	
	equals$: function (o){
		if (o && o.width && o.height) {
			return o.width === this.width && o.height === this.height;
		}
		return false;
	},

	getClass$: function (){
		return this.declaredClass;
	},

	hashCode$: function (){
		return this.width * this.height ^ this.width + this.height;
	},

	toString$: function (){
		return 'Dimension(' + this.width + ', ' + this.height + ')';
	}
});