/*******************************************************************************
 * Licensed Materials - Property of IBM Copyright IBM Corp. 2012. All
 * Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 ******************************************************************************/

/**
 * Utility for extracting embedded information from errors passed by from server calls.
 * 
 * @author Steve Shaw
 */
(function(){
	
	dojo.provide("rmpw.common.util.ErrorUtil");

	var util = rmpw.common.util.ErrorUtil;
	dojo.requireLocalization("rmpw.common", "JfsStoreMessages");
	var messages = dojo.i18n.getLocalization("rmpw.common", "JfsStoreMessages");

	dojo.mixin(util, {
		
		getTextBetween: function(str, startTag, endTag) {
			 var start = str.indexOf(startTag);
			 if (start > 0) {
				 start = str.indexOf('>', start + 1);
				 var end = str.indexOf(endTag, start + 1);
				 if (end > start ){
					 return str.substring(start + 1, end);
				 }
			 }
			 return null;
		},
		
		getErrorMessage: function(errorObj) {	
			 if ( errorObj.responseText!=null ){
				 var isValidationError = false;
				 var error = errorObj.responseText;
				 var subStatus = rmpw.common.util.ErrorUtil.getTextBetween(error, '<err:errorSubStatus', '</err:errorSubStatus>');
				 if (subStatus === 'INVALID') {
					 isValidationError = true;
				 }
				 var status = rmpw.common.util.ErrorUtil.getTextBetween(error, '<err:errorMessage', '</err:errorMessage>');
				 return isValidationError ? dojo.string.substitute(messages.validationErrorChanges, [status]) : status;
			 }
				 
			 return errorObj.message;
		 }
		
	});
    
})(); // end function()