/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2014. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	/*
 	 * Useful constants across the web application
 	*/
	dojo.provide("rmps.core.util.IRmpsConstants");
	var IRmpsConstants = rmps.core.util.IRmpsConstants;

	/*Compact Rendering Constants */
	var CT_COMPACT_RENDERING = "application/x-jazz-compact-rendering";
    var CT_OSLC_COMPACT = "application/x-oslc-compact+xml";

	/*RMPS internal namespace handling */
	IRmpsConstants.RMPS_XML_NAMESPACE = "http://jazz.net/xmlns/rmps/1.0/";	//$NON-NLS-1$
	IRmpsConstants.RMPS_PREFIX = "rmps";	//$NON-NLS-1$
	
	IRmpsConstants.PROJECT_NAME = "projectName";	//$NON-NLS-1$
	IRmpsConstants.PROJECT_ID = "projectId";	//$NON-NLS-1$

	/*common HTTP content types*/
	IRmpsConstants.OSLC_AM_LINK_TYPE_CONTENT_TYPE = "application/x-oslc-am-linktype+xml"; //$NON-NLS-1$

	/*Standard or JFS namespaces */
	IRmpsConstants.OSLC_AM2_XML_NAMESPACE = "http://open-services.net/ns/am#"; //$NON-NLS-1$

	/*Common Format, tags, etc */
	IRmpsConstants.RDF_TAG= "rdf:RDF";	//$NON-NLS-1$
	IRmpsConstants.RDF_ABOUT= "rdf:about";	//$NON-NLS-1$
	IRmpsConstants.ABOUT= "about";	//$NON-NLS-1$

	/*Delegate ProcessConstants to IRmpsConstants*/
	dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants"); //$NON-NLS-1$
	IRmpsConstants.ProcessConstants= com.ibm.team.process.web.common.internal.ProcessConstants;

	/************************************************************************* */

	/*Baseline Constants */
	IRmpsConstants.BASELINE = "rmps.context"; //$NON-NLS-1$
	IRmpsConstants.CURRENT = "CURRENT_DATA"; //$NON-NLS-1$
	IRmpsConstants.CURRENT_URI = "current"; //$NON-NLS-1$

	/************************************************************************* */
	/*Changeset Constants */
	IRmpsConstants.CHANGESET = "changeset"; //$NON-NLS-1$
	
	
	/*******************Admin common constants********************************* */
	/*
	 * TODO: We do not need to have these constants here, but the problem that the editors used 
	 * here are implemented in a plugin, and referenced in another plugin. Afer we move
	 * all editors to their proper locations, we can remove these constants and use them
	 * in their plugin only
	 * 
	 */
	IRmpsConstants.ADMIN_BASIC_PREFIX= "#action=dm.app.admin.";
	IRmpsConstants.ADMIN_IMPORT_VIEW_DEFINITION= IRmpsConstants.ADMIN_BASIC_PREFIX+ "viewDefinition";
	IRmpsConstants.ADMIN_IMPORT_STATUS= IRmpsConstants.ADMIN_BASIC_PREFIX+ "status";
	IRmpsConstants.ADMIN_IMPORT_REQUEST= IRmpsConstants.ADMIN_BASIC_PREFIX+ "request";
	IRmpsConstants.ADMIN_BASELINE_STATUS= IRmpsConstants.ADMIN_BASIC_PREFIX+ "baselineStatus";
	IRmpsConstants.ADMIN_REQUEST_BASELINE= IRmpsConstants.ADMIN_BASIC_PREFIX+ "requestBaseline";
	IRmpsConstants.ADMIN_REQUEST_STREAM= IRmpsConstants.ADMIN_BASIC_PREFIX + "requestStream"
	IRmpsConstants.ADMIN_STREAM_VIEWER= IRmpsConstants.ADMIN_BASIC_PREFIX + "streamViewer";
	IRmpsConstants.ADMIN_METAMODEL_IMPORT=IRmpsConstants.ADMIN_BASIC_PREFIX + "importMetamodel";
	IRmpsConstants.ADMIN_ECORE_EXPORT=IRmpsConstants.ADMIN_BASIC_PREFIX + "ecoreExport";
	IRmpsConstants.ADMIN_EXPORT_STATUS=IRmpsConstants.ADMIN_BASIC_PREFIX + "exportStatus";
	IRmpsConstants.ADMIN_PROFILE_IMPORT=IRmpsConstants.ADMIN_BASIC_PREFIX + "importProfile";
	IRmpsConstants.ADMIN_PLUGIN_PROFILE_IMPORT=IRmpsConstants.ADMIN_BASIC_PREFIX + "importPluginProfile";
	/************************************************************************* */
	IRmpsConstants.DOMAINS_PROJECT_NAME = "Domains";
			
})();
