/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.render.util.Insets");

dojo.declare("rmpw.diagrams.render.util.Insets", null, {
	constructor: function(top, left, bottom, right) {
		this.top = top;
		this.left = left;
		this.bottom = bottom;
		this.right = right;
	},
	
	performScale: function (amount) {
		this.top *= amount;
		this.left *= amount;
		this.bottom *= amount;
		this.right *= amount;
		return this;
	},
	
	transform: function (surfaceMatrix) {
		if (surfaceMatrix) {
			this.top *= surfaceMatrix.yy;
			this.left *= surfaceMatrix.xx;
			this.bottom *= surfaceMatrix.yy;
			this.right *= surfaceMatrix.xx;
		}
		return this;
	},
	
	equals$: function (o){
		var i;
		if (o && o.top && o.left && o.bottom && o.right) {
			return o.top === this.top && o.bottom === this.bottom && o.left === this.left && o.right === this.right;
		}
		return false;
	},

	getClass$: function (){
		return this.declaredClass;
	},

	hashCode$: function (){
		return this.top_0 * 7 + this.left * 2 + this.bottom * 31 + this.right * 37;
	},

	toString$: function (){
		return 'Insets(t=' + this.top_0 + ', l=' + this.left + ', b=' + this.bottom + ', r=' + this.right + ')';
	}
});