/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.render.util.Ray");

dojo.declare("rmpw.diagrams.render.util.Ray", null, {
	
	constructor: function(start, end) {
		this.x = end.x - start.x;
		this.y = end.y - start.y;
	},
	
	performScale: function (factor){
		this.x = this.x * factor;
		this.y = this.y * factor;
		return this;
	},
	
	transform: function (surfaceMatrix){
		if (surfaceMatrix) {
			this.x = this.x * surfaceMatrix.xx;
			this.y = this.y * surfaceMatrix.yy;
		}
		return this;
	},
	product: function(ray){
		return (this.x * ray.x + this.y *ray.y);
	},
	length: function(){
		return Math.sqrt(this.product(this));
	},
	equals$: function (obj){
		if ((!obj ? null:obj) === this){
			return true;
		}
		if (obj && obj.x && obj.y) {
			return this.x === obj.x && this.y === obj.y;
		}
		return false;
	},

	getClass$: function (){
		return this.declaredClass;
	},

	hashCode$: function (){
		return this.x * this.y ^ this.x + this.y;
	},

	toString$: function (){
		return '(' + this.x + ',' + this.y + ')';
	}

});