
/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010.  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("rmpw.diagrams.edit.util.Search");
/**
 * Some util functions for traversing/searching the model 
 * Each element must have an id, else search may gets called recursively
 */
dojo.declare("rmpw.diagrams.edit.util.Search", null, {
	model : null,
	visitedIds : null,
	foundElements : null,
	constructor: function(model) {
		this.model = model;
		
	},
	/**
	 * return from 'model' key-value pair hierarchy which matches
	 * the key of 'type' and one of 'values' in the value 
	 */
	getElements: function(type, values){
		this.visitedIds = [];
		this.foundElements = [];
		this._traverse(this.model, type, values);
		this.visitedIds = null;
		return this.foundElements;
	},	
	/**
	 * return element which has a property 'type' in tree
	 */
	_traverse: function(tree, type, values){
		if(tree.id && tree.hasOwnProperty('id') && 
		   -1===dojo.indexOf(this.visitedIds, tree.id)){
			this.visitedIds.push(tree.id);			
		}
		if(type in tree && tree.hasOwnProperty(type)){
			for(var i=0; i<values.length; i++){
				if(values[i]===tree[type]){
					this.foundElements.push(tree);
			     }
			}
		}
		for(var element in tree){
			if(tree.hasOwnProperty(element) && typeof element === "string" && typeof tree[element] ==='object'){
				var child = tree[element];
				if( child!==null && !(child.id && child.hasOwnProperty('id') && -1!== dojo.indexOf(this.visitedIds, child.id)) &&
					!((element.length>1 && element.charAt(0) === '_' && element.charAt(1) === '_'))){// we skip private properties
					this._traverse(child, type, values);
				}
			}
		}
	}	
});
