/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.ui.util.UIUtil");

dojo.require("net.jazz.ajax.ui.PlatformUI");

dojo.requireLocalization("rmps.ui.util", "UIUtilMessages");
var messages = dojo.i18n.getLocalization("rmps.ui.util", "UIUtilMessages");

var PlatformUI= net.jazz.ajax.ui.PlatformUI;

rmps.ui.util.UIUtil = {
	
	/*If the value if not defined, then we return an alternative value. If there is not alternative
	 * defined, then we returned a space string. If we specify a warningMessage, we could log it
	 * in the console to show that the passed value was undefined */
    associateParamValue: function(value, warningMessage, alternative){
		var assigment= value;
		if(!assigment){
			if(alternative){
				assigment= alternative;
			}else{
				assigment=" ";	/*We have to make sure to assign space string to avoid substitue errors */
			}
			
			if(warningMessage){
				console.warn(warningMessage);	
			}
			
		}
		return assigment;
	},
	
	/* 
	 * Load and run a given clazz asynchronously, and pass in the "args" in the constructor, and then make a callback for the given "func"
	 * 
	 * It is used to ensure avoiding using dojo.require for the classes that we do not use right away (such as dialogs)
	 *   
	 */
	loadAndRun: function(clazz, args, func){
		var loader= function(classConstructor){
			var load = new classConstructor(args);
			if(dojo.isFunction(func)){
				func(load);
			}
		};
		var classConstructor= dojo.getObject(clazz);
		if(classConstructor){
			loader(classConstructor);
		}else{
			PlatformUI.getWorkbench().showMessage(messages.loadingMessage);
			jazz.core.loader.load_async(clazz, dojo.hitch(this, function(){
				PlatformUI.getWorkbench().hideMessageArea();
				loader(dojo.getObject(clazz));
			}));			
		}
	}
	
};
}());