/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2010.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/

dojo.provide("rmpw.diagrams.edit.util.Utils");
dojo.require("rmpw.diagrams.render.util.Rectangle");
dojo.require("rmpw.diagrams.render.util.Workarounds");
rmpw.diagrams.edit.util.Utils = {
	getGlobalCoords: function(figure) {
		var b = this.getTransformedBounds(figure);
		var dx = 0;
		var dy = 0;
		
		var parent = figure.getParent();
		while (parent.getParent) {
			var t = parent.getTransform();
			if (t) {
				if (t.dx) {
					dx += t.dx;
				}
				if (t.dy) {
					dy += t.dy;
				}
			}
			parent = parent.getParent();
		}
		var c = dojo.position(parent.rawNode.parentNode);
		return {x: b.x + c.x + dx,
				y: b.y + c.y + dy,
				width: b.width,
				height: b.height
			};
	},
	
	getTransformedBounds: function(figure) {
		var bbox = figure.getBoundingBox();
		var bounds = new rmpw.diagrams.render.util.Rectangle(bbox.x, bbox.y, bbox.width, bbox.height);
		var scale = 1;
		if(figure.getParent){
			var parent = figure.getParent();
			while (parent) {
				if (parent.getScale) {
					scale *= parent.getScale();
				}
				if(parent.getParent){
					parent = parent.getParent();
				}else{
					parent = null;	
			    }
			}
		}
		return bounds.performScale(scale);
	},
	
	/* Returns the class name of the argument or undefined if 
	   it's not a valid JavaScript object. 
	*/  
	getObjectClass: function(obj) {  
	    if (obj && obj.constructor && obj.constructor.toString) {  
	        var arr = obj.constructor.toString().match(  
	            /function\s*(\w+)/);  
	  
	        if (arr && arr.length === 2) {  
	            return arr[1];  
	        }  
	    }  
	  
	    return undefined;  
	},  
	
	/* Want to make sure that gestures ( multi-touches ) are not
	 * confused with touch drag-pan intentions. This function 
	 * will also return true for mouse clicks.
	 */
	
	singleHit: function(e){
		
		var singleHit = true;
		
		if (e.touches && e.touches.length > 1) {
			singleHit = false;
		}
		
		return singleHit;
	}
};
