/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2012, 2014. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function() {	
dojo.provide("com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils");
dojo.require("com.ibm.team.process.web.ui.internal.admin.projects.UIHelper");
dojo.require("com.ibm.team.process.web.common.internal.ProcessConstants");
dojo.require("com.ibm.team.vvc.shared.oslc.web.utils.RootServices");
dojo.require("jazz.client.xhr");
dojo.require("net.jazz.ajax.contextRoot");

dojo.require("com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory");
var ncFactory = com.ibm.team.vvc.shared.web.ui.notifications.notifications.VvcNotificationFactory;

dojo.require("com.ibm.team.vvc.shared.web.ui.util.VvcUtils");
var VvcUtils = com.ibm.team.vvc.shared.web.ui.util.VvcUtils;

dojo.requireLocalization("com.ibm.team.vvc.shared.oslc.web.utils", "CLMUtilsMessages");

var providers= [/*"rmServiceProviders","amServiceProviders",*/ "cmServiceProviders" /*,"qmServiceProviders", "rmps:linkServiceProviderCatalogs"*/];

var UIHelper= com.ibm.team.process.web.ui.internal.admin.projects.UIHelper;

var ProcessConstants = com.ibm.team.process.web.common.internal.ProcessConstants;

	com.ibm.team.vvc.shared.oslc.web.utils.CLMUtils = {
			
		messages: dojo.i18n.getLocalization("com.ibm.team.vvc.shared.oslc.web.utils", "CLMUtilsMessages"),
						
		doOSLCQuery: function(results, changesetUri, callback) {
			
	        var theDeferreds = [];

			for (var i = 0; i < results.length; i++) {
				if (results[i].res) {
            		var deferredServices = jazz.client.xhrGet({
            			url: results[i].res,
            			headers: {
            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML
            			},
            			handleAs: "xml"
            		});
            		theDeferreds.push(deferredServices);
				}
			}
			
	        var dl = new dojo.DeferredList(theDeferreds);
	        
	        var queryUrls = [];
	        
	        /*all(theDeferreds)*/ dl.then(dojo.hitch(this, function(result, ioArgs) {
	        	var secondDeferreds = [];

                //Example: queryUrl + "?oslc.prefix=oslc_cm=<http://open-services.net/ns/cm%23>&oslc.where=oslc_cm:tracksChangeSet=<" + changesetUri + ">";
	        	var urlArgs = dojo.objectToQuery({
	        		"oslc.prefix" : "oslc_cm=<http://open-services.net/ns/cm#>",
	        		"oslc.where" : "oslc_cm:tracksChangeSet=<" + changesetUri + ">"
	        	});
	        	
	        	for (var i = 0; i < result.length; i++) {
	        		
	        		if (result[i][0]) {
			        	var serviceDescriptor = UIHelper.getNode(this._getChildNodes(result[i][1]), "ServiceDescriptor", ProcessConstants.NAMESPACE_OSLC_CM);
			        	
			        	if (serviceDescriptor) {
				        	var changeRequests = UIHelper.getNode(this._getChildNodes(serviceDescriptor), "changeRequests", ProcessConstants.NAMESPACE_OSLC_CM);
				        	
				        	if (changeRequests) {
					        	var simpleQuery = UIHelper.getNode(this._getChildNodes(changeRequests), "simpleQuery", ProcessConstants.NAMESPACE_OSLC_CM);

					        	if (simpleQuery) {
						        	var url = UIHelper.getNode(this._getChildNodes(simpleQuery), "url", ProcessConstants.NAMESPACE_OSLC_CM);

						        	if (url) {
							        	var queryUrl = url.textContent ? url.textContent : url.text; //IE8
							        	queryUrls.push(queryUrl);
							        	
							        	var deferredOSLCQuery = jazz.client.xhrGet({
					            			url: queryUrl + "?" + urlArgs,
					            			headers: {
					            				"accept": "application/rdf+xml"
					            			},
					            			handleAs: "xml"
					            		});
					            		secondDeferreds.push(deferredOSLCQuery);
						        		
						        	}
					        		
					        	}
				        		
				        	}
			        		
			        	}
			        	
		        	} /*else { Notifications from the banner are not supported yet
		        		if (theDeferreds.length >= i && theDeferreds[i] && theDeferreds[i].ioArgs) {
			        		VvcNotificationFactory.createXhrError(theDeferreds[i].ioArgs);
		        		}
		        	}*/
	        			
        		}
	        		
	        	
        		var dl2 = new dojo.DeferredList(secondDeferreds);
        		
    	        /*all(secondDeferreds)*/ dl2.then(dojo.hitch(this, function(result) {
    	        	var ccmItems = [];

    	        	for (var i = 0; i < result.length; i++) {
    	        		
    	        		if (result[i][0]) {
            		        var rdfNode = UIHelper.getNode(this._getChildNodes(result[i][1]), "RDF", ProcessConstants.NAMESPACE_RDF);
            		        
            		        if (rdfNode) {
            		            var rdfDescriptions = UIHelper.getNodes(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);
            		            
            		            if (rdfDescriptions) {
                		            for (var j = 0; j < rdfDescriptions.length; j++) {
                		            	var rdfDescription = rdfDescriptions[j];
                		            	
                		            	var about = rdfDescription.getAttribute("rdf:about");
                                		//use this approximate check instead if worried about performance: about.indexOf(urlArgs) < 0
                                		if (about && dojo.indexOf(queryUrls, about) >= 0) {
                        		            var members = UIHelper.getNodes(this._getChildNodes(rdfDescription), "member", "http://www.w3.org/2000/01/rdf-schema#");

                        		            for (var k = 0; k < members.length; k++) {
                        		            	var member = members[k];
                            		            if (member) {
                                		            var resUrl = member.getAttribute("rdf:resource");
                                            		
                                            		ccmItems.push( { target: resUrl } );
                            		            }
                        		            	
                        		            }
                                		}
                		            	
                		            }
            		            }
            		        }
    	        			
    	        		} /* else { Notifications from the banner are not supported yet
    		        		if (secondDeferreds.length >= i && secondDeferreds[i] && secondDeferreds[i].ioArgs) {
			        			VvcNotificationFactory.createXhrError(secondDeferreds[i].ioArgs);
    		        		}
    	        		}*/
    	        		
    	        	}
    	        	
    	        	callback.resolve(ccmItems);
    	        	
    	        }));
	        }));
			
			
		},
			
		idSorter: function(first,second){
			var one = first.id, two = second.id;
			var oneNumber = Number(one), twoNumber = Number(two);
			if (!isNaN(oneNumber) && !isNaN(twoNumber)) {
				return oneNumber - twoNumber; 
			} else {
				return (one.toUpperCase() < two.toUpperCase()) ? -1 : 1;
			}
		},

	    _getChildNodes: function(source) {
	        if (dojo.isArray(source)) {
	            return source;
	        }

	        if (dojo.isIE > 8) {
	            var childNodes = [];
	            var node = source.firstChild;
	            while (node) {
	                childNodes.push(node);
	                node = node.nextSibling;
	            }
	            return childNodes;
	        }

	        return source.childNodes;
	    },
	    
	    extractValue: function(doc, elementName, elementNamespace, attributeName) {
	        var rdfNode = UIHelper.getNode(this._getChildNodes(doc), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
	        
	        if (rdfNode) {
	            var rdfDescription = UIHelper.getNode(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);
	            
	            if (rdfDescription) {
	                var element = UIHelper.getNode(this._getChildNodes(rdfDescription), elementName, elementNamespace);
	                
	                if (element) {
	                    return element.getAttribute(attributeName);
	                }
	            }
	        }	
	    },
	    
	    extractTitle: function(doc) {
	        var rdfNode = UIHelper.getNode(this._getChildNodes(doc), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
	        
	        if (rdfNode) {
	            var rdfDescription = UIHelper.getNode(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);
	            
	            if (rdfDescription) {
	                var title = UIHelper.getNode(this._getChildNodes(rdfDescription), "title", ProcessConstants.NAMESPACE_DC);
	                
	                if (title) {
	                    return title.textContent ? title.textContent : title.text; //IE8
	                }
	            }
	        }	
	    },
	    
	    getServiceProviders: function(resourceUri){
	        var args = {
	            url: net.jazz.ajax._contextRoot + "/linkServiceProviders?" + dojo.objectToQuery({"resourceUri": resourceUri?resourceUri: ""}),
	            handleAs: "xml",
	            headers: {"X-ibm-rmps-internal": "true"},
	            load: function(response, ioArgs){
	                var serversDict= [];
	                for(var index=0;index<providers.length;index++){
	                    var provider= providers[index];
	                    var entries = response.getElementsByTagName(provider);
	                    if(entries){
	                        var entriesLength= entries.length;
		                    if (entriesLength > 0) {
		                        for (var i = 0; i < entriesLength; i++) {
		                            var catalog = entries[i].getAttribute("rdf:resource");
		                            if(!catalog){
		                                continue;
		                            }
		                            
		                            var title = entries[i].getAttribute("dcterms:title");
		                            if(!title){
		                                continue;
		                            }
		                            
		                            serversDict[title]= catalog;
		                        }
		                    }
	                    }
	                }
	                return serversDict;
	            }
	        };
	        return jazz.client.xhrGet(args);
	    },
	    
	    getVVCLinks: function(callback) {
	    	
	    	var context = {
	    		callback: callback
	    	};
	    	
	    	var deferredList = new dojo.Deferred();
	    	this.authenticate(deferredList);
	    	deferredList.addCallback(context, function(result){

	    		var outerProjectLinkObject = [];
	    		
	    		for (var i = 0; i < result.length; i++) {
	    			
		    		//expected undefined for unsupported types of projects
	    			if (result[i][1]) {
	    				
	    				for (var j = 0; j < result[i][1].length; j++) {
	    		    		var vvcLinks = [];
	    		    		
	    		    		var dojoUrl = new dojo._Url(result[i][1][j].details);
		    				var linkObj = {
	    						details: dojoUrl,
	    						isImplicit: false,
	    						presentationLabel: result[i][1][j].title + " (" + dojoUrl.authority + ")",
	    						serviceUrl: result[i][1][j].res,
	    						title: result[i][1][j].title
		    				};
		    				vvcLinks.push(linkObj);
		    				
				    		var projectLinkObject = {
				    			linkType: "architects",
				    			serviceProviders: vvcLinks
				    		};
				    		
				    		outerProjectLinkObject.push(projectLinkObject);
				    		
	    				}
	    				
	    			}
	    			
	    			
	    		}
	    		
	    		this.callback.resolve(outerProjectLinkObject);
	    	});
	    },
	    
	    /*Callback being null or not is the caller responsibility, so, we do not check for is. callback is not optional in this method */
	    getProjectLinks: function(projectAreaUri, contextForImplicitLinks, data, acceptableLinkTypes, callback) {
	        var dpls = [];
	        if (data) {
	            if (dojo.isArray(data)) {
	                for (var u = 0; u < data.length; u++) {
	                    dpls.push(this._getExplicitProjectLinks(projectAreaUri, data[u]));
	                }
	            } else {
	                dpls.push(this._getExplicitProjectLinks(projectAreaUri, data));
	            }
	            if (contextForImplicitLinks) {
		            dpls.push(this._getImplicitProjectLinks(contextForImplicitLinks)); //$NON-NLS-1$
	            }
	        } else {
	            dpls.push(this._getExplicitProjectLinks(projectAreaUri));
	            if (contextForImplicitLinks) {
	            	dpls.push(this._getImplicitProjectLinks(contextForImplicitLinks)); //$NON-NLS-1$
	            }
	        }

	        var dl = new dojo.DeferredList(dpls);
	        dl.then(dojo.hitch(this, function(result) {
	            var linkNodes = result[0][1];
	            for (var r = 1; r < result.length; r++) {
	                linkNodes = linkNodes.concat(result[r][1]);
	            }
	            if (!linkNodes) {
	                return;
	            }

	            var processed = {};
	            var projectLinks = [];
	            var deferreds = [];
	            for (var index = 0; index < linkNodes.length; index++) {
	                var current = linkNodes[index];
	                var plNodes = this._getChildNodes(current);

	                var linkTypeNode = UIHelper.getNode(plNodes, "link-type", ProcessConstants.NAMESPACE_JP);
	                var linkType = linkTypeNode.textContent ? linkTypeNode.textContent : linkTypeNode.text;
	                var jpUrlNode = UIHelper.getNode(plNodes, "url", ProcessConstants.NAMESPACE_JP);
	                var jpUrl = jpUrlNode.textContent ? jpUrlNode.textContent : jpUrlNode.text;
	                var isImplicit = (jpUrl && jpUrl.substring(jpUrl.lastIndexOf("/") + 1, jpUrl.length) === "implicit");
	                var projectLink = {
	                    url: jpUrl,
	                    linkType: linkType,
	                    serviceProviders : []
	                };

	                var serviceProviderNodes = UIHelper.getNodes(plNodes, "ServiceProvider", ProcessConstants.NAMESPACE_OSLC);
	                
	                for (var sp = 0; sp < serviceProviderNodes.length; sp++) {
	                    var spNodes = this._getChildNodes(serviceProviderNodes[sp]);
	                    var servicesNode = UIHelper.getNode(spNodes, "services", ProcessConstants.NAMESPACE_OSLC);
	                    var serviceUrl = servicesNode.getAttribute("rdf:resource");
	                    var servicesPath = new dojo._Url(serviceUrl).path;
	                    var applicationType = servicesPath.substring(0, servicesPath.indexOf("/", 1));

	                    var details = UIHelper.getNode(spNodes, "details", ProcessConstants.NAMESPACE_OSLC);
	                    var projectUrl = new dojo._Url(details.getAttribute("rdf:resource"));

	                    var titleNode = UIHelper.getNode(spNodes, ProcessConstants.XMLELEMENT_TITLE, ProcessConstants.NAMESPACE_DC);
	                    var projectName = titleNode.textContent ? titleNode.textContent : titleNode.text ? titleNode.text : "";
	                    var presentationLabel = projectName + " (" + applicationType + ": " + projectUrl.authority + ")";
	                    
	                    
	                    if (acceptableLinkTypes) {
		                    var rootservices = projectUrl.scheme + "://" + projectUrl.authority + applicationType + "/rootservices";

	                        var def = new dojo.Deferred(function(reason){});
	                		def.index = index;
	                		deferreds.push(def);

		            		var context = {
			            			 def: def,
			            			 projectName: projectName,
			            			 serviceUrl: serviceUrl,
			            			 projectUrl: projectUrl,
			            			 presentationLabel: presentationLabel,
			            			 isImplicit: isImplicit,
			            			 projectLink: projectLink,
			            			 self: this
			            		};
	                		
		            		var deferredRootservices = jazz.client.xhrGet({
		            			url: rootservices,
		            			headers: {
		            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
		            			},
		            			handleAs: "xml", //$NON-NLS-1$
		            			error: dojo.hitch(context, function(error){
		            				//this is perfectly fine; the server may be
		            				//down
		            				//make sure to resolve the def in order not
		            				//to prevent this from completing and
		            				//successful servers from being added to the
		            				//result
		            				context.def.resolve();
		            				console.error(error);
		            			})
		            		});
		            		
		            		deferredRootservices.addCallback(context, function(result){
		            			
		            			if(!result){
		            				this.def.resolve();
		            				return;
		            			}
		            			
		            			var d = this.def;
		            			
		                        var descriptionNode = UIHelper.getNode(this.self._getChildNodes(result), "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
		                        
			                        if (descriptionNode) {
			                        	
			                        var provider = UIHelper.getNode(this.self._getChildNodes(descriptionNode), "cmServiceProviders", ProcessConstants.NAMESPACE_OSLC_CM);
			                        
			                        if (provider) {
			                        	
			                        var res = provider.getAttribute("rdf:resource");
			                        
			                        if (res) {
			                    		var deferredCatalog = jazz.client.xhrGet({
			                    			url: res,
			                    			headers: {
			                    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
			                    				"OSLC-Core-Version": "2.0",
			                    				"X-rmps-internal": "true"
			                    			},
			                    			handleAs: "xml", //$NON-NLS-1$
			                    			error: dojo.hitch(this, function(error){
			                    				console.error(error);
			                    				return error;
			                    			})
			                    		});
		
			                    		deferredCatalog.addCallback(this, function(result){
			                    			
					            			if(!result){
					            				this.def.resolve();
					            				return;
					            			}
			                    			
			                    			var def = this.def;
			                    			
			                                var rdfNode = UIHelper.getNode(this.self._getChildNodes(result), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
			
			                                
			                                if (rdfNode) {
				                                var catalog = UIHelper.getNode(this.self._getChildNodes(rdfNode), "ServiceProviderCatalog", ProcessConstants.NAMESPACE_OSLC_CORE);
				                                
				                                if (catalog) {
					                                var provider = UIHelper.getNode(this.self._getChildNodes(catalog), "domain", ProcessConstants.NAMESPACE_OSLC_CORE);
					                                
					                                if (provider) {
						                                var res = provider.getAttribute("rdf:resource");

						                                if (dojo.indexOf(acceptableLinkTypes, res) >= 0) {
						                                	//add this link type since it is one of the acceptable ones, for example: http://open-services.net/ns/cm#
						                                	
						                                    if (processed[this.presentationLabel]) {
						                                        /* 19030: Duplicated projects appear in link provider selection dialog
						                                         * TEMP solution till we support linking based on link types. 
						                                         */
						                                        if (this.isImplicit) {
						                                            var indexes = processed[this.presentationLabel];
						                                            var serviceProvider = projectLinks[indexes[0]].serviceProviders[indexes[1]];
						                                            serviceProvider.isImplicit = true;
						                                        }
						                                        //continue;
						                                        def.resolve();
						                                        return;
						                                    }
		
						                                    this.projectLink.serviceProviders.push({
						                                        title: this.projectName,
						                                        serviceUrl: this.serviceUrl,
						                                        details: this.projectUrl,
						                                        presentationLabel: this.presentationLabel,
						                                        isImplicit: this.isImplicit                        
						                                    });
		
						                                    processed[this.presentationLabel] = [ projectLinks.length, this.projectLink.serviceProviders.length - 1 ];
						                                    
						        	                        if (this.projectLink.serviceProviders.length > 0) {
						        	                            projectLinks.push(this.projectLink);
						        	                        }
						                                	
						                                } else {
						                                	//don't bother adding
						                                }
						                                
						                                def.resolve(this.projectLink);
					                                	
					                                } else {
					                                	//no provider
					                                	def.resolve();
					                                }
				                                } else {
				                                	//no catalog
				                                	def.resolve();
				                                }
				                            	
			                                } else {
			                                	//no rdfnode
			                                	def.resolve();
			                                }
			                            });
			                        } else {
			                        	//no res
			                        	d.resolve();
			                        }
			                        } else {
			                        	//no provider
			                        	d.resolve();
			                        }
			            		} else {
			            			//no DescriptionNode
			            			d.resolve();
			            		}

		
		                    });
	                    
	                    } else {

	                        if (processed[presentationLabel]) {
	                            /* 19030: Duplicated projects appear in link provider selection dialog
	                             * TEMP solution till we support linking based on link types. 
	                             */
	                            if (isImplicit) {
	                                var indexes = processed[presentationLabel];
	                                var serviceProvider = projectLinks[indexes[0]].serviceProviders[indexes[1]];
	                                serviceProvider.isImplicit = true;
	                            }
	                            continue;
	                        }

	                        projectLink.serviceProviders.push({
	                            title: projectName,
	                            serviceUrl: serviceUrl,
	                            details: projectUrl,
	                            presentationLabel: presentationLabel,
	                            isImplicit: isImplicit                        
	                        });

	                        processed[presentationLabel] = [ projectLinks.length, projectLink.serviceProviders.length - 1 ];
	                        
	                        if (projectLink.serviceProviders.length > 0) {
	                            projectLinks.push(projectLink);
	                        }
	                    	
	                    }

	                }

	            }
	            
	            if (acceptableLinkTypes) {
	            	var dl = new dojo.DeferredList(deferreds);
	            	
	            	var contextObj = {
	            		deferreds: deferreds,
	            		projectLinks: projectLinks,
	            		callback: callback
	            	};
	            	
	            	 dl.then(dojo.hitch(contextObj, function(result){
	                     if (this.callback) {
	                    	 this.callback(projectLinks);
	                     }
	            	 }));
	            } else {
	                if (callback) {
	                    callback(projectLinks);
	                }
	            }
	        }));
	    },

	    _getExplicitProjectLinks: function(projectAreaUri, url) {
	    
	        if (!url) {
	        	var jazzContext = jazz.app.context.get();
	        	if (jazzContext.itemId) {
	        		url = projectAreaUri + "/" + jazzContext.itemId + "/links"; //$NON-NLS-1$
	        	} else {
	        		url = jazzContext.uri + "/links"; //$NON-NLS-1$
	        	}
	        }
	        
	        var epl = new dojo.Deferred();
	        var deferred = jazz.client.xhrGet({
	            url: url,
	            headers: {
	                "accept": "application/xml" //$NON-NLS-1$
	            },
	            handleAs: "xml", //$NON-NLS-1$
	            error: dojo.hitch(this, function(error){
	                console.error(error);
	            })
	        });
	        deferred.addCallback(this, function(result) {
	            var nodes = this._getChildNodes(result);
				var links = UIHelper.getNode(nodes, "links", ProcessConstants.NAMESPACE_JP);
				if (links) {
					linkNodes = UIHelper.getNodes(this._getChildNodes(links), "link", ProcessConstants.NAMESPACE_JP);
				} else {
					linkNodes= UIHelper.getNodes(nodes, "link", ProcessConstants.NAMESPACE_JP);
				}
	            if (!linkNodes) {
	                linkNodes = [];
	            }
	            
//	            for (var i = 0; i < linkNodes.length; i++) {
//	                var serviceProvider = UIHelper.getNodes(this._getChildNodes(linkNodes[i]), "ServiceProvider", ProcessConstants.NAMESPACE_OSLC);
//	                
//	                for (var j = 0; j < serviceProvider.length; j++) {
//	                    var services = UIHelper.getNodes(this._getChildNodes(serviceProvider[j]), "services", ProcessConstants.NAMESPACE_OSLC);
//	                    if (services) {
//	                    	for (var k = 0; k < serviceProvider.length; k++) {
//	                    		 var service = services[k];
//	                    		 //service.attributes
//	                    	} 
//	                    }
//	                }
//	            }
	            
	            epl.resolve(linkNodes);
	        });
	        return epl;
	    },

	    _getImplicitProjectLinks: function(contextForImplicitLinks) {
	        var ipl = new dojo.Deferred();        
	        contextForImplicitLinks.addCallback(this, function(linkNodes) {
	            ipl.resolve(linkNodes);
	        });
	        return ipl;
	    },
	    
	    getAuthneticationUrl: function(serviceProviders, serviceUrl){
	        var _Url= new dojo._Url(serviceUrl);

	        var segment= this.getContext(_Url.path);
	        var authority= _Url.authority;
	        for(var att in serviceProviders){
	            var current= serviceProviders[att];
	            if(current){
	                var url= new dojo._Url(current);
	                var urlSegment= this.getContext(url.path);
	                if (url.authority === authority && urlSegment === segment){
	                    return current;
	                }
	            }
	        }
	        return null;
	    },
	    
	    getContext: function(path){
			var segments= path.split("/");
			for(var index=0; index<segments.length; index++){
				var current= segments[index];
				if(current){
					return current;
				}
			}
	    },
	    
	    _getFriends: function(contextRoot) {
    		var deferredFriends = jazz.client.xhrGet({
    			url: contextRoot + '/friends?right_now='+new Date().getTime(),
    			headers: {
    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
    			},
    			handleAs: "xml" //$NON-NLS-1$
    		});
    		deferredFriends.addErrback(this, function(result, args){
				//if we can't load the friend document, CLM will not work at all
				ncFactory.createXhrError({xhrError: result, ioArgs: args}).dispatch();
    		});
    		
    		return deferredFriends;
	    },
	    
	    
	    /**
	     *  <p>Makes authentication popups appear if necessary so that the user can log in to friend servers</p>
	     *  
	     *   @Deprecated 5.0
	     */
	    authenticate: function(callback, urlsOnly, mode /* vvc for vvc friends; default is cm */) {
	    	if(dojo.config.isDebug){
	    		console.warn("CLMUtils.authenticate is deprecated in 5.0.");
	    	}	    	
	    	var outerContext = {
	    		callback: callback,
	    		context: this
	    	};
	    	
	    	var deferredFriends = this._getFriends(net.jazz.ajax._contextRoot);
	    	
	    	deferredFriends.then(dojo.hitch(outerContext, function(result) {
	    		
                var rdfNode = this.context._getChildNodes(result);
                var rdfChildNodes = this.context._getChildNodes(rdfNode[0]);
                var friendNodes = UIHelper.getNodes(rdfChildNodes, "Friend", ProcessConstants.NAMESPACE_JD);
    	        var friendRootServices = [];
                for (var index = 0; index < friendNodes.length; index++) {
	                var rootServicesNode = UIHelper.getNode(this.context._getChildNodes(friendNodes[index]), "rootServices", ProcessConstants.NAMESPACE_JD);
	                if (rootServicesNode) {
	                	var rootServicesUrl = rootServicesNode.getAttribute("rdf:resource");
	                	if (rootServicesUrl) {
		                	friendRootServices.push(rootServicesUrl);
	                	}
	                	
	                }
                }
                
                var vvcMode = (mode === "vvc");
                if (vvcMode) {
                	friendRootServices.push(VvcUtils.getVvcUri() + "/rootservices");
                }
                
                result = friendRootServices;
	    		
		    	var deferreds = []; 
	    		
	            for (var index = 0; index < result.length; index++) {
	                var rootServicesUrl = result[index];

    				var deferred = new dojo.Deferred(function(reason){});
    				deferreds.push(deferred);
	                
	                var context = {
	                		deferreds: deferreds,
	                		context: this.context,
	                		deferred: deferred
	                };
	                
            		var deferredRootservices = jazz.client.xhrGet({
            			url: rootServicesUrl,
            			headers: {
            				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
            			},
            			handleAs: "xml", //$NON-NLS-1$
            			error: dojo.hitch(context, function(error){
            				//this is perfectly fine; the server may be
            				//down
            				//make sure to resolve the def in order not
            				//to prevent this from completing and
            				//successful servers from being added to the
            				//result
            				console.error(error);
            			})
            		});
            		
            		deferredRootservices.addCallback(context, function(result){
            			
            			if(!result){
            				this.deferred.resolve();
            				return;
            			}
            			
            			var d = this.deferred;
            			var context2 = {
            				d: d,
            				context: this.context
            			};
            			
                        var descriptionNode = UIHelper.getNode(this.context._getChildNodes(result), "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
                        
	                        if (descriptionNode) {
	                        	var namespace = ProcessConstants.NAMESPACE_OSLC_CM;
	                        	var elementName = "cmServiceProviders";
	                        	if (vvcMode) {
	                       			namespace = "http://open-services.net/ns/config#";
	                        	}
	                        		
		                        var provider = UIHelper.getNode(this.context._getChildNodes(descriptionNode), elementName, namespace);
		                        
		                        if (provider) {
		                        	
			                        var res = provider.getAttribute("rdf:resource");
			                        
			                        if (res) {
			                        	
			                        	if (urlsOnly) {
			                        		
			                        		var resAndTitle = {
			                        			res: res
			                        		};
			                        		
			                        		var _Url= new dojo._Url(res);
			                        		
			                        		var titleNode = UIHelper.getNode(this.context._getChildNodes(descriptionNode), "title", ProcessConstants.NAMESPACE_DC);
			                        		if (titleNode) {
				                        		resAndTitle.title = titleNode.textContent ? titleNode.textContent : titleNode.text; //IE8
				                        		resAndTitle.title = resAndTitle.title + " (" + _Url.authority + ")";
			                        		} else {
			                        			resAndTitle.title = _Url.authority;
			                        		}
				                        		
				                    		d.resolve(resAndTitle);
			                        	} else {

				                        	context2.res = res;
				                        	
				                    		var deferredCatalog = jazz.client.xhrGet({
				                    			url: res,
				                    			headers: {
				                    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
				                    				"OSLC-Core-Version": "2.0",
				                    				"X-rmps-internal": "true"
				                    			},
				                    			handle: dojo.hitch(context2, function(result){
				                    				//this.d.resolve(this.res);
				                    			}),		                    			
				                    			handleAs: "xml", //$NON-NLS-1$
				                    			error: dojo.hitch(context2, function(error){
				                    				this.d.resolve();
				                    				console.error(error);
				                    				return error;
				                    			})
				                    		});
				                    		
				                    		deferredCatalog.addCallback(context2, function(result){
				                    			
				                    			if(!result){
				                    				this.deferred.resolve();
				                    				return;
				                    			}
				                    			
				                    			var rdfNode = UIHelper.getNode(this.context._getChildNodes(result), "RDF", ProcessConstants.NAMESPACE_RDF);
				                    			
				                    			var resolved = false;
				                    			
				                    			if (rdfNode) {
					                                var serviceProviderCatalogNode = UIHelper.getNode(this.context._getChildNodes(rdfNode), "ServiceProviderCatalog", ProcessConstants.NAMESPACE_OSLC_CORE);
					                                
					                                if (serviceProviderCatalogNode) {
			
						                                var serviceProviderNodes = UIHelper.getNodes(this.context._getChildNodes(serviceProviderCatalogNode), "serviceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
						                                
						                                if (serviceProviderNodes) {
			
						                                	var list = [];
						                                	for (var index = 0; index < serviceProviderNodes.length; index++) {
						                                		var serviceProviderNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNodes[index]), "ServiceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
						                                		if (serviceProviderNode) {
							                                		var res = serviceProviderNode.getAttribute("rdf:about");
							                                		
							                                		var titleNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNode), "title", ProcessConstants.NAMESPACE_DC);
							                                		var detailsNode = UIHelper.getNode(this.context._getChildNodes(serviceProviderNode), "details", ProcessConstants.NAMESPACE_OSLC_CORE);
							                                		
							                                		
							                                		if (res) {
								                                		var title, details;
								                                		if (titleNode) {
								                                			title = titleNode.textContent;
								                                		}
								                                		
								                                		if (detailsNode) {
								                                			details = detailsNode.getAttribute("rdf:resource");
								                                		}
								                                		
								                                		//title and details could be undefined, but res is mandatory
								                                		var resAndTitleAndDetails = {
								                                			res: res,
								                                			title: title,
								                                			details: details
								                                		};
							                                			
								                                		list.push(resAndTitleAndDetails);
							                                		}
						                                		}
						                                	}
				                                			this.d.resolve(list);
				                                			resolved = true;
						                                }
					                                	
					                                }
				                    			} 
				                    			
				                    			if (!resolved) {
				                    				d.resolve();
				                    			}
				                                
				                    		});
				                        } //get authentication urls only
		
			                        } else {
			                        	//no res
			                        	d.resolve();
			                        }
		                        } else {
		                        	//no provider
		                        	d.resolve();
		                        }
	            		} else {
	            			//no DescriptionNode
	            			d.resolve();
	            		}

                    });
                    
	            }
	            
        		if (this.callback) {
	            	var dl = new dojo.DeferredList(deferreds);
	            	dl.then(dojo.hitch(this, function(result){
	                         this.callback.resolve(result);
	            	 }));
        		}

	        }));
	    	
	    },
	    
	    extractNodeResource: function(doc, property, namespace) {
	        var rdfNode = UIHelper.getNode(this._getChildNodes(doc), "RDF", ProcessConstants.NAMESPACE_RDF);
	        
	        if (rdfNode) {
	            var rdfDescription = UIHelper.getNode(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);

	            if (rdfDescription) {
	                var requestedNode = UIHelper.getNode(this._getChildNodes(rdfDescription), property, namespace);

	                if (requestedNode) {
    		            return requestedNode.getAttribute("rdf:resource");
		            }
                }
            }
	    },
	    
	    /**
	     * Locates the actions (oslc:action) from the XML doc and checks each
	     * located action see if its identifier matches the actionIdentifier. 
	     * 
	     * @param doc XML document
	     * @param actionIdentifier action identifier, such as BASELINE or STREAM
	     * (case sensitive)
	     */ 
		extractAction: function(doc, actionIdentifier) {
			var dl = [];
	        var rdfNode = UIHelper.getNode(this._getChildNodes(doc), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
	        
	        if (rdfNode) {
	            var rdfDescription = UIHelper.getNode(this._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);

	            if (rdfDescription) {
	                var actionNodes = UIHelper.getNodes(this._getChildNodes(rdfDescription), "action", ProcessConstants.NAMESPACE_OSLC_CORE);

	                if (actionNodes) {
	                	
			            for (var k = 0; k < actionNodes.length; k++) {
	    		            var resUrl = actionNodes[k].getAttribute("rdf:resource");
	    		            
                    		var deferredAction = jazz.client.xhrGet({
                    			url: resUrl,
                				handleAs: "xml",
                    			headers: {
                    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
                    			}});
                    		
                    		var dfd = new dojo.Deferred();
	    		            dl.push(dfd);
                    		
	    		            var context = {
	    		            	resUrl: resUrl,
	    		            	self: this,
	    		            	dfd: dfd
	    		            };
	    		            
                    		deferredAction.then(dojo.hitch(context, function(actionDoc) {
                    	        var rdfNode = UIHelper.getNode(this.self._getChildNodes(actionDoc), "RDF", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$
                    	        
                    	        if (rdfNode) {
                    	            var rdfDescription = UIHelper.getNode(this.self._getChildNodes(rdfNode), "Description", ProcessConstants.NAMESPACE_RDF);

                    	            if (rdfDescription) {
                    	                var identifierNode = UIHelper.getNode(this.self._getChildNodes(rdfDescription), "identifier", "http://purl.org/dc/terms/");
                    	                
                            			if (identifierNode.textContent === actionIdentifier || identifierNode.text === actionIdentifier) {
                            				this.dfd.resolve(this.resUrl);
                            				return;
                            			}

                    	            }
                    	            
                    	        }
                				this.dfd.resolve();
                				return;
                    		}), dojo.hitch(context, function(actionDoc) {
                    			this.dfd.resolve();
                    		}));
                    		
                    		}
	    		            
			            }
	                }
	            }
	    	return new dojo.DeferredList(dl);
	    },	    
	    
	    getSelectionDialogURL: function(result) {
	    	var selectionDialogNode = UIHelper.getNode(this._getChildNodes(result), "SelectionDialog", ProcessConstants.NAMESPACE_OSLC_CORE);
	    	
	    	if (selectionDialogNode) {
		    	var outerDialogNode = UIHelper.getNode(this._getChildNodes(selectionDialogNode), "Dialog", ProcessConstants.NAMESPACE_OSLC_CORE);
		    	
		    	if (outerDialogNode) {
		    		var innerDialogNode = UIHelper.getNode(this._getChildNodes(outerDialogNode), "dialog", ProcessConstants.NAMESPACE_OSLC_CORE);
		    		
		    		return innerDialogNode.getAttribute("rdf:resource");
		    	}
	    	}
		    return undefined;
	    },
	    

	    /**
		 * Authenticates to all of the friend servers.
		 * 
		 * @return A <code>dojo.Deferred</code> which will resolve
		 *         when authentication is complete. The result of the
		 *         deferred will be a list of servers which could not be
		 *         authenticated to, and a copy of the response.
		 */
	    authenticateToFriends: function(){
	    	var authenticationDeferred = new dojo.Deferred();
	    	var problemServers = {};
	    	
	    	// Get the root services for the friends
	    	this.getFriendRootServices().promise.always(dojo.hitch(this, function(results){
	    		var deferreds = [];
	    		for(var friendUri in results){
	    			var authDef = jazz.client.xhrGet({
	    				url: friendUri,
						headers: {
							"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
						}
	    			});
	    			
	    			// Oddly enough, we only care about errors this time
	    			authDef.then(null, dojo.hitch(this, function(error){
	    				problemServers[friendUri] = error;
	    			}));
	    			
	    			deferreds.push(authDef);
	    		}
	    		
	    		var doneDef = new dojo.DeferredList(deferreds, false, false, true);
	    		doneDef.then(authenticationDeferred.resolve(problemServers));
	    	}));
	    	return authenticationDeferred;
	    },
	    

	    /**
		 * Finds all the global-configuration-enabled friends and their
		 * catalogs. These friends are capable of making contributions
		 * to global configurations.
		 * 
		 * @see #findGcContributions
		 * 
		 * @return A <code>dojo.Deferred</code> which resolves when
		 *         the method is done. The result of the call will be an
		 *         array of friends which support GC's and their
		 *         catalogs.
		 */
		findGcFriends: function(){
			var resultDeferred = new dojo.Deferred();
			
			// Get all the root service documents
			this.getFriendRootServices().then(dojo.hitch(this, function(results){
				var gcFriends = {};
				for(var result in results){
					var rootDoc = results[result];
					if(rootDoc){
	                    var descriptionNode = UIHelper.getNode(rootDoc.childNodes, "Description", ProcessConstants.NAMESPACE_RDF); //$NON-NLS-1$

	                    /*
	                     * Provider can be either contributed by the friend or, if a provider isn't found in the
	                     * normal namepsace, then check in the VVC namespace.
	                     */
	                    var provider = UIHelper.getNode(descriptionNode.childNodes, "cmServiceProviders", "http://open-services.net/ns/config#"); //$NON-NLS-1$
	                    
	                    if(provider){
	                    	// Map the root services doc to the CM catalog, and add it to the results array. 	
                    		var url = new dojo._Url(result);
                    		var path = url.path;
                    		var serverPath = url.authority + path.substring(0, path.lastIndexOf('/')); // Must exist since we just got /<root context>/rootservices
		                    var titleText = UIHelper.getNode(descriptionNode.childNodes, "title", ProcessConstants.NAMESPACE_DC).textContent;
		                    gcFriends[result] = {
	                    		catalog: provider.getAttribute("rdf:resource"),
	                    		title: titleText,
	                    		"serverPath": serverPath
	                    	};
	                    }
					}
				}
				
				resultDeferred.resolve(gcFriends);
			}), dojo.hitch(this, function(error){
				resultsDeferred.reject(error);
			}));
			
			return resultDeferred;
		},

				
		/**
		 * Finds the available contributions in catalogs of each of the GC
		 * friends. If <code>friendsToSearch</code> is <code>null</code>,
		 * then all global-configuration enabled friends will be searched.
		 * 
		 * @param friendsToSearch
		 *            An optional array of friends to search.
		 * 
		 * @see #findGcFriends
		 * 
		 * @return A <code>dojo.Deferred</code> which resolves when the search
		 *         is done. The result will be a map of friends to their
		 *         contributions.
		 */
		findGcContributions: function(/* optional */ friendsToSearch){
			var resultDeferred = new dojo.Deferred();
			
			var contributions = {};
			var getCatalogDeffereds = [];
			
			// Search all friends (default behaviour)
			if(!friendsToSearch){
				friendsToSearch = this.findGcFriends();
			}
			
			// Wait for friendstoSearch to resolve if its a promise, or immediately, continue.
			dojo.when(friendsToSearch, dojo.hitch(this, function(friends){
				for(var friend in friends){
					dojo.hitch(this, function(friend){
						var f = friends[friend];
						
						// Setup the results
						contributions[friend] = {
							title: f.title,
							serverPath: f.serverPath,
							catalog: {},
							contributions: {}
						};
						
						var catalog = f.catalog;
						var getCatalogDef = jazz.client.xhrGet({
							url: catalog,
		        			headers: {
		        				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
		        				"OSLC-Core-Version": "2.0"
		        			},
		        			handleAs: "xml" //$NON-NLS-1$
						});
						getCatalogDeffereds.push(getCatalogDef);
						getCatalogDef.then(dojo.hitch(this, function(result){
							var catalogRdf = UIHelper.getNode(result.childNodes, "RDF", ProcessConstants.NAMESPACE_RDF);
							var catalogNode = UIHelper.getNode(catalogRdf.childNodes, "ServiceProviderCatalog", ProcessConstants.NAMESPACE_OSLC_CORE);					
							var serviceProviders = UIHelper.getNodes(catalogNode.childNodes, "serviceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
							
							var catalogTitle = UIHelper.getNode(catalogNode.childNodes, "title", ProcessConstants.NAMESPACE_DC);
							var catalogDescription = UIHelper.getNode(catalogNode.childNodes, "description", ProcessConstants.NAMESPACE_DC);
							
							contributions[friend].catalog = {
								title: catalogTitle ? catalogTitle.textContent : "",
								description: catalogDescription ? catalogDescription.textContent : "",
							};
							
							for(var i = 0; i < serviceProviders.length; i++){
								var serviceProvider = UIHelper.getNode(serviceProviders[i].childNodes, "ServiceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
								
								var resource = serviceProvider.getAttribute("rdf:about");
								var title = UIHelper.getNode(serviceProvider.childNodes, "title", ProcessConstants.NAMESPACE_DC);
								var details = UIHelper.getNode(serviceProvider.childNodes, "details", ProcessConstants.NAMESPACE_OSLC_CORE);
								
								contributions[friend].contributions[resource] = {
									"title" : title ? title.textContent : resource,
									"details" : details ? details.textContent : null
								};
							}
							
						}), dojo.hitch(this, function(error){
							ncFactory.createXhrError({
								xhrError: error, 
								ioArgs: error.response.options.ioArgs
							}).dispatch();
							resultsDeferred.reject(error);
						}));
					}, friend)();
				}
				var getCatalogDeferredsList = new dojo.DeferredList(getCatalogDeffereds);
				getCatalogDeferredsList.then(dojo.hitch(this, function(){
					resultDeferred.resolve(contributions);
				}));
			}), dojo.hitch(this, function(error){
				resultsDeferred.reject(error);
			}));
			
			return resultDeferred;
		},
		

		/**
		 * Gets the information about the location of the contribution
		 * 
		 * @param oslcUrl
		 *            The URL of the contribution
		 * 
		 * @return A <code>dojo.Deferred</code> which will resolve
		 *         with the details of the widget to load
		 */
		getGcContributionSelectionDialogArgs: function(oslcUrl){
			var resultsDeferred = new dojo.Deferred();
			
			var getDef = jazz.client.xhrGet({
				url: oslcUrl,
    			headers: {
    				"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML,
    				"OSLC-Core-Version": "2.0"
    			},
    			handleAs: "xml" //$NON-NLS-1$
			});
			
			getDef.then(dojo.hitch(this, function(results){
		        var rdfNode = UIHelper.getNode(results.childNodes, "RDF", ProcessConstants.NAMESPACE_RDF);
		        
		        if (rdfNode) {
		        	var serviceProvider = UIHelper.getNode(rdfNode.childNodes, "ServiceProvider", ProcessConstants.NAMESPACE_OSLC_CORE);
		        	
		        	if (serviceProvider) {
			        	var service = UIHelper.getNode(serviceProvider.childNodes, "service", ProcessConstants.NAMESPACE_OSLC_CORE);
			        	
			        	if (service) {
				        	var Service = UIHelper.getNode(service.childNodes, "Service", ProcessConstants.NAMESPACE_OSLC_CORE);
				        	
				        	if (Service) {
								var selectionDialog = UIHelper.getNode(Service.childNodes, "selectionDialog", ProcessConstants.NAMESPACE_OSLC_CORE);
								
								if (selectionDialog) {
									var dialog = UIHelper.getNode(selectionDialog.childNodes, "Dialog", ProcessConstants.NAMESPACE_OSLC_CORE);
									
									if (dialog) {
										var dialogArgs = {
											title: UIHelper.getNode(dialog.childNodes, "label", ProcessConstants.NAMESPACE_OSLC_CORE).textContent,
											url: UIHelper.getNode(dialog.childNodes, "dialog", ProcessConstants.NAMESPACE_OSLC_CORE).getAttribute("rdf:resource"),
											hintWidth: UIHelper.getNode(dialog.childNodes, "hintWidth", ProcessConstants.NAMESPACE_OSLC_CORE).textContent,
											hintHeight: UIHelper.getNode(dialog.childNodes, "hintHeight", ProcessConstants.NAMESPACE_OSLC_CORE).textContent
										};
										resultsDeferred.resolve(dialogArgs);
										return;
									}
									
								}
				        		
				        	}
			        		
			        	}
		        		
		        	}
					
		        }
		        
				ncFactory.createError({
					title: this.messages.errorParsingXMLMessage, 
					description: this.messages["errorParsingXMLMessage.explanation"],
					solution: this.messages["errorParsingXMLMessage.useraction"]
				}).dispatch();
	        	resultsDeferred.reject(this.messages.errorParsingXMLMessage);
				
			}), dojo.hitch(this, function(error){
				resultsDeferred.reject(error);
			}));
			
			return resultsDeferred;
		},
		

		/**
		 * Finds the location of the root service documents for each of
		 * the friends in a number of steps:
		 * <ol>
		 * <li>Gets the VVC friends document (RDF XML)</li>
		 * <li>Parses the friends XML for the location of each friends'
		 * root service document</li>
		 * <li>Adds itself to the list of root services doc locations</li>
		 * </ol>
		 * 
		 * @see #getFriendRootServices
		 * 
		 * @return A <code>dojo.Deferred</code> which will resolve
		 *         with an list of root service document locations.
		 */
		findFriendRootServices: function(){
			var resultsDeferred = new dojo.Deferred();
			
			// Get all friends
			var deferredFriends = jazz.client.xhrGet({
				url: VvcUtils.getVvcUri() + '/friends',
				headers: {
					"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
				},
				preventCache: true,
				handleAs: "xml" //$NON-NLS-1$
			});
			
			// Discover all friends
			deferredFriends.then(dojo.hitch(this, function(resultsXml){
	            var friendRootServices = [];
	            friendRootServices.push(VvcUtils.getVvcUri() + "/rootservices");
				
	            // Start parsing...
				var resultsArray = resultsXml.childNodes[0];
				var resultsRdfNodes = resultsArray.childNodes;
	            var friendNodes = UIHelper.getNodes(resultsRdfNodes, "Friend", ProcessConstants.NAMESPACE_JD);
	            
	            for(var i = 0; i < friendNodes.length; i++){
	                var rootServicesNode = UIHelper.getNode(friendNodes[i].childNodes, "rootServices", ProcessConstants.NAMESPACE_JD);
	                if(rootServicesNode){
	                	var rootServicesUrl = rootServicesNode.getAttribute("rdf:resource");
	                	if (rootServicesUrl) {
		                	// Yay, finally have the root services location
	                		friendRootServices.push(rootServicesUrl);
	                	}
	                }
	            }
	            
	            resultsDeferred.resolve(friendRootServices);
			}), dojo.hitch(this, function(error){
				ncFactory.createXhrError({
					xhrError: error, 
					ioArgs: error.response.options.ioArgs
				}).dispatch();
				resultsDeferred.reject(error);
			}));
			
			return resultsDeferred;
		},
			
		

		/**
		 * Gets the root service documents for each of the friend
		 * servers
		 * 
		 * @see #findFriendRootServices
		 * 
		 * @return A <code>dojo.Deferred</code> which will resolve
		 *         with an list of root service document locations.
		 */
		getFriendRootServices: function(){
			var resultsDeferred = new dojo.Deferred();
			
			// Find all the friend root services
			this.findFriendRootServices().then(dojo.hitch(this, function(friendRootServiceDocLocations){
				var rootServiceDeferreds = [];
				var rootServiceDocMap = {};

				dojo.forEach(friendRootServiceDocLocations, dojo.hitch(this, function(rootServiceDocUrl){
					var rootServiceDocDeferred = jazz.client.xhrGet({
						url: rootServiceDocUrl,
						headers: {
							"accept": ProcessConstants.CONTENT_TYPE_APPLICATION_XML //$NON-NLS-1$
						},
						handleAs: "xml", //$NON-NLS-1$
					});
					
					rootServiceDeferreds.push(rootServiceDocDeferred);
					
					rootServiceDocDeferred.then(dojo.hitch(this, function(doc){
						rootServiceDocMap[rootServiceDocUrl] = doc;
					}), dojo.hitch(this, function(error){
						ncFactory.createXhrError({
							xhrError: error, 
							ioArgs: error.response.options.ioArgs
						}).dispatch();
					}));
				}));
				
				/*
				 *  Wait for the root servive docs to resolve, then return the map.  Errors will
				 *  be consumed in the deferredList because notifications are dispatched in the 
				 *  rootServiceDocDeferred error handler.
				 */
				var defList = new dojo.DeferredList(rootServiceDeferreds, false, false, true);
				defList.then(dojo.hitch(this, function(){
					resultsDeferred.resolve(rootServiceDocMap);
				}));
			}));
			
			return resultsDeferred;
		}
	    
	};	
}());